//---------------------------------------------------------------------------
//
//    common definitions used by Wyman digital communications programs
//
//    Copyright (C) 2002  Barry D. Sanderson
//    Copyright (C) 2002  Carl A. Harcourt
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//
//    Mailing addresses for the authors:
//
//    Barry D. Sanderson
//    1725 N. Bolton Ave.
//    Indianapolis, IN 46218  USA
//
//    Carl A. Harcourt
//    4937 W. 900 S.
//    Milroy, IN 46156  USA
//
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//
//    Rev 30 Aug 2002 (CAH) - version 2.0, for initial PC/DOS release
//                            Developed using MS Visual C++ 6.0
//                            as a 'Win32 Console Application', ie a DOS .exe program
//                            Requires a Win32 environment for proper DOS execution
//                            This version will also build and execute unmodified on a Linux system
//
//    Rev 25 Nov 2001 (BDS) - version 1.1.0, for initial public release
//
//---------------------------------------------------------------------------

#ifndef _WYMAN_COMMON_
#define _WYMAN_COMMON_

//---------------------------------------------------------------------------
// common defines

#define FALSE                   0
#define TRUE                    1

#define MAX_FILENAME_LENGTH     80                          // max file name length
#define MAX_FILE_LENGTH         65535                       // 2^16 -1 max file length

// rev 15 Nov 2001    for systems that don't define PI and PI2 (in math.h)

#ifndef PI
#define PI          3.14159265358979323846    // pi
#endif

#ifndef PI2
#define PI2         (PI + PI)
#endif

//---------------------------------------------------------------------------
// variable type defines

#define ftype                   float

#define SYM_TYPE_1              unsigned short int
#define SYM_TYPE_2              unsigned int
#define SYM_TYPE_I              int
#define SYM_TYPE_CH             unsigned int

#define SYM_TYPE_SC             unsigned short int
#define SYM_TYPE_CH             unsigned int

//---------------------------------------------------------------------------
#endif      // ifndef _WYMAN_COMMON_
