//---------------------------------------------------------------------------
//
//    definitions used by Wyman digital communications programs
//
//    Copyright (C) 2002  Barry D. Sanderson
//    Copyright (C) 2002  Carl A. Harcourt
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//
//    Mailing addresses for the authors:
//
//    Barry D. Sanderson
//    1725 N. Bolton Ave.
//    Indianapolis, IN 46218  USA
//
//    Carl A. Harcourt
//    4937 W. 900 S.
//    Milroy, IN 46156  USA
//
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//
//    Rev 30 Aug 2002 (CAH) - version 2.0, for initial PC/DOS release
//                            Developed using MS Visual C++ 6.0
//                            as a 'Win32 Console Application', ie a DOS .exe program
//                            Requires a Win32 environment for proper DOS execution
//                            This version will also build and execute unmodified on a Linux system
//
//    Rev 25 Nov 2001 (BDS) - version 1.1.0, for initial public release
//
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// application include files

#include "Wcommon.h"

//---------------------------------------------------------------------------

#ifndef _CODE_DEF_
#define _CODE_DEF_

//---------------------------------------------------------------------------
// defines

#define NUM_INFO_SC             4                           // number of information sub-carriers
#define NUM_REDUNDANT_SC        4                           // number of redundancy sub-carriers
#define NUM_TOTAL_SC            (NUM_INFO_SC + NUM_REDUNDANT_SC)       // total number of sub-carriers

#define NUM_GF_EL_1             307                         // number of elements in GF
#define MAX_GF_EL_1             (NUM_GF_EL_1 - 1)           // number of symbols per codeblock

#define NUM_GF_EL_2             9                           // number of elements in GF
#define MAX_GF_EL_2             (NUM_GF_EL_2 - 1)           // number of symbols per codeword

#define MAX_CORR_ERRORS         2                           // max number of correctable errors
#define FIELD_CHAR              3                           // characteristic of field

#define leader_len              74                          // # of symbols in leader (0.60408 seconds)
#define trailer_len             37                          // # of symbols in trailer (0.30204 seconds)
#define mode_len                3                           // # of pairs of symbols in mode specifier
#define frame_len               4                           // # of symbols in frame sequence
#define blks_per_frame          1                           // # of code blocks between frame sequences
#define num_modes               4                           // number of modes supported by this program
#define num_ec_lvls             num_modes                   // number of error corrections levels
#define num_freqs               NUM_TOTAL_SC                // number of sub-carrier frequencies
#define SYMBOLS_PER_CODEBLOCK   (NUM_GF_EL_1 - 1)           // # of symbols per code block
#define MAX_INFO_INDEX          (SYMBOLS_PER_CODEBLOCK-1)   // information index max

#define k05                     32
#define k10                     (2*k05)
#define k20                     (2*k10)
#define k40                     (214)

#define bytes_per_ch_sym        (sizeof(SYM_TYPE_2))

//---------------------------------------------------------------------------
// variable declarations

SYM_TYPE_I  ch_sym_buf_i[NUM_INFO_SC];
SYM_TYPE_I  ch_sym_buf_r[NUM_REDUNDANT_SC];

//---------------------------------------------------------------------------

#endif  //_CODE_DEF_
