//---------------------------------------------------------------------------
//
//    definitions used by Wyman digital communications programs
//
//    Copyright (C) 2002  Barry D. Sanderson
//    Copyright (C) 2002  Carl A. Harcourt
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//
//    Mailing addresses for the authors:
//
//    Barry D. Sanderson
//    1725 N. Bolton Ave.
//    Indianapolis, IN 46218  USA
//
//    Carl A. Harcourt
//    4937 W. 900 S.
//    Milroy, IN 46156  USA
//
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//
//    Rev 30 Aug 2002 (CAH) - version 2.0, for initial PC/DOS release
//                            Developed using MS Visual C++ 6.0
//                            as a 'Win32 Console Application', ie a DOS .exe program
//                            Requires a Win32 environment for proper DOS execution
//                            This version will also build and execute unmodified on a Linux system
//
//    Rev 25 Nov 2001 (BDS) - version 1.1.0, for initial public release
//
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// application include files

#include "Wcommon.h"

//---------------------------------------------------------------------------

#ifndef _CODE_VEC_
#define _CODE_VEC_

//---------------------------------------------------------------------------
// table of vectors used as codewords

ftype   code2_vectors [NUM_GF_EL_1] [NUM_TOTAL_SC] =
{
    { -4., -4., -4., -4., -4., -4., -4., -4.,},
    {  2.,  4., -3., -1., -4., -4., -4.,  4.,},
    {  0.,  0.,  4.,  0., -4., -4.,  4., -4.,},
    { -3., -4.,  2.,  3., -4., -4.,  4.,  4.,},
    { -3.,  0.,  1., -1., -4.,  4., -4., -4.,},
    {  3., -4., -1.,  2., -4.,  4., -4.,  4.,},
    {  1.,  4., -3.,  3., -4.,  4.,  4., -4.,},
    { -2.,  0., -2., -3., -4.,  4.,  4.,  4.,},
    {  2.,  0.,  2.,  3.,  4., -4., -4., -4.,},
    { -1., -4.,  3., -3.,  4., -4., -4.,  4.,},
    { -3.,  4.,  1., -2.,  4., -4.,  4., -4.,},
    {  3.,  0., -1.,  1.,  4., -4.,  4.,  4.,},
    {  3.,  4., -2., -3.,  4.,  4., -4., -4.,},
    {  0.,  0., -4.,  0.,  4.,  4., -4.,  4.,},
    { -2., -4.,  3.,  1.,  4.,  4.,  4., -4.,},
    {  4.,  4.,  4.,  4.,  4.,  4.,  4.,  4.,},
    { -1.,  0., -2.,  2., -4., -4., -4.,  0.,},
    {  4.,  4.,  0.,  4., -4., -4.,  0., -4.,},
    {  1.,  0.,  1., -2., -4., -4.,  0.,  4.,},
    {  3.,  4.,  3., -3., -4., -4.,  4.,  0.,},
    { -2.,  4.,  3.,  2., -4.,  0., -4., -4.,},
    {  4.,  0.,  4., -4., -4.,  0., -4.,  4.,},
    { -1., -4., -1., -3., -4.,  0.,  4., -4.,},
    { -4.,  4.,  0.,  0., -4.,  0.,  4.,  4.,},
    {  0.,  4.,  0., -4., -4.,  4., -4.,  0.,},
    {  2., -4.,  2., -2., -4.,  4.,  0., -4.,},
    { -1.,  4.,  3.,  1., -4.,  4.,  0.,  4.,},
    {  4., -4., -4.,  0., -4.,  4.,  4.,  0.,},
    { -1.,  4., -1.,  1.,  0., -4., -4., -4.,},
    { -4.,  0.,  0.,  4.,  0., -4., -4.,  4.,},
    {  3., -4., -2.,  2.,  0., -4.,  4., -4.,},
    {  0.,  4., -4., -4.,  0., -4.,  4.,  4.,},
    {  0., -4.,  4.,  4.,  0.,  4., -4., -4.,},
    { -3.,  4.,  2., -2.,  0.,  4., -4.,  4.,},
    {  4.,  0.,  0., -4.,  0.,  4.,  4., -4.,},
    {  1., -4.,  1., -1.,  0.,  4.,  4.,  4.,},
    { -4.,  4.,  4.,  0.,  4., -4., -4.,  0.,},
    {  1., -4., -3., -1.,  4., -4.,  0., -4.,},
    { -2.,  4., -2.,  2.,  4., -4.,  0.,  4.,},
    {  0., -4.,  0.,  4.,  4., -4.,  4.,  0.,},
    {  4., -4.,  0.,  0.,  4.,  0., -4., -4.,},
    {  1.,  4.,  1.,  3.,  4.,  0., -4.,  4.,},
    { -4.,  0., -4.,  4.,  4.,  0.,  4., -4.,},
    {  2., -4., -3., -2.,  4.,  0.,  4.,  4.,},
    { -3., -4., -3.,  3.,  4.,  4., -4.,  0.,},
    { -1.,  0., -1.,  2.,  4.,  4.,  0., -4.,},
    { -4., -4.,  0., -4.,  4.,  4.,  0.,  4.,},
    {  1.,  0.,  2., -2.,  4.,  4.,  4.,  0.,},
    {  4., -2.,  2., -1., -2., -2., -4., -4.,},
    {  1.,  3.,  3.,  2., -2., -2., -4.,  4.,},
    { -4., -1.,  1.,  3., -2., -2.,  4., -4.,},
    {  2., -2., -1., -3., -2., -2.,  4.,  4.,},
    { -1., -2.,  0.,  2., -2., -4., -2., -4.,},
    { -4.,  3.,  1., -4., -2., -4., -2.,  4.,},
    {  3., -4.,  4., -1., -2., -4., -4., -2.,},
    {  2.,  3., -4.,  0., -2., -4., -4.,  2.,},
    {  4.,  0., -2., -2., -2., -4.,  2., -4.,},
    {  1., -4., -4.,  1., -2., -4.,  2.,  4.,},
    { -2.,  0.,  0.,  3., -2., -4.,  4., -2.,},
    { -3., -2.,  4.,  4., -2., -4.,  4.,  2.,},
    { -4.,  0., -1.,  0., -2.,  2., -4., -4.,},
    {  2., -4.,  0.,  3., -2.,  2., -4.,  4.,},
    {  0.,  4., -2.,  4., -2.,  2.,  4., -4.,},
    { -3.,  0., -4., -2., -2.,  2.,  4.,  4.,},
    {  0., -1.,  2., -4., -2.,  4., -2., -4.,},
    { -3., -2.,  3., -1., -2.,  4., -2.,  4.,},
    {  4.,  0., -3.,  2., -2.,  4., -4., -2.,},
    {  3., -2.,  1.,  3., -2.,  4., -4.,  2.,},
    {  2.,  4.,  0.,  1., -2.,  4.,  2., -4.,},
    { -1.,  0.,  1.,  4., -2.,  4.,  2.,  4.,},
    { -4.,  4.,  2., -3., -2.,  4.,  4., -2.,},
    { -2., -1., -3., -2., -2.,  4.,  4.,  2.,},
    {  0., -2., -1.,  4., -4., -2., -2., -4.,},
    { -3.,  3.,  0., -2., -4., -2., -2.,  4.,},
    {  4., -4.,  3.,  1., -4., -2., -4., -2.,},
    {  3.,  3., -2., -1., -4., -2., -4.,  2.,},
    {  2.,  0., -3., -3., -4., -2.,  2., -4.,},
    { -1., -4., -2.,  0., -4., -2.,  2.,  4.,},
    { -4.,  0., -1.,  2., -4., -2.,  4., -2.,},
    { -2., -2.,  3.,  3., -4., -2.,  4.,  2.,},
    { -1., -4.,  1.,  4., -4., -4., -2., -2.,},
    {  1.,  3.,  2.,  2., -4., -4., -2.,  2.,},
    { -2., -4., -1.,  1., -4., -4.,  0.,  0.,},
    {  4.,  1., -4., -3., -4., -4.,  2., -2.,},
    {  3., -4.,  0., -2., -4., -4.,  2.,  2.,},
    {  1., -4.,  2., -1., -4.,  0., -4.,  0.,},
    {  3.,  0., -2.,  1., -4.,  0.,  0., -4.,},
    { -3.,  4., -3., -2., -4.,  0.,  0.,  0.,},
    {  0., -4., -4.,  4., -4.,  0.,  0.,  4.,},
    {  2.,  0.,  1.,  3., -4.,  0.,  4.,  0.,},
    {  4.,  0., -4.,  2., -4.,  2., -2., -4.,},
    {  1., -4., -3., -4., -4.,  2., -2.,  4.,},
    { -4.,  1.,  0., -1., -4.,  2., -4., -2.,},
    { -2., -4.,  4.,  0., -4.,  2., -4.,  2.,},
    { -3.,  2.,  3., -2., -4.,  2.,  2., -4.,},
    {  3.,  1.,  4.,  1., -4.,  2.,  2.,  4.,},
    {  0.,  2., -4.,  3., -4.,  2.,  4., -2.,},
    { -1.,  0.,  0.,  4., -4.,  2.,  4.,  2.,},
    {  0.,  0.,  3., -2., -4.,  4., -2., -2.,},
    { -1., -2., -2., -4., -4.,  4., -2.,  2.,},
    { -4.,  0.,  4.,  4., -4.,  4.,  0.,  0.,},
    {  2.,  2.,  1.,  0., -4.,  4.,  2., -2.,},
    {  4.,  0.,  2.,  1., -4.,  4.,  2.,  2.,},
    {  2., -4.,  1., -2.,  0., -4., -4.,  0.,},
    { -2.,  0.,  3., -3.,  0., -4.,  0., -4.,},
    {  1.,  4.,  2.,  3.,  0., -4.,  0.,  0.,},
    {  4., -4.,  4.,  0.,  0., -4.,  0.,  4.,},
    { -3.,  0., -3., -1.,  0., -4.,  4.,  0.,},
    {  1.,  0., -3., -2.,  0.,  0., -4., -4.,},
    {  4.,  4., -4.,  4.,  0.,  0., -4.,  0.,},
    { -2., -4., -2.,  1.,  0.,  0., -4.,  4.,},
    { -3., -4.,  1.,  3.,  0.,  0.,  0., -4.,},
    {  3.,  4., -1., -3.,  0.,  0.,  0.,  4.,},
    {  2.,  4.,  2., -1.,  0.,  0.,  4., -4.,},
    { -4., -4.,  4., -4.,  0.,  0.,  4.,  0.,},
    { -1.,  0.,  3.,  2.,  0.,  0.,  4.,  4.,},
    {  3.,  0.,  3.,  1.,  0.,  4., -4.,  0.,},
    { -4.,  4., -4.,  0.,  0.,  4.,  0., -4.,},
    { -1., -4., -2., -3.,  0.,  4.,  0.,  0.,},
    {  2.,  0., -3.,  3.,  0.,  4.,  0.,  4.,},
    { -2.,  4., -1.,  2.,  0.,  4.,  4.,  0.,},
    {  3.,  0.,  4.,  2.,  2., -2., -4., -4.,},
    {  0., -4.,  2., -4.,  2., -2., -4.,  4.,},
    { -2.,  4.,  0., -3.,  2., -2.,  4., -4.,},
    {  4.,  0.,  1.,  0.,  2., -2.,  4.,  4.,},
    {  1.,  0., -1., -4.,  2., -4., -2., -4.,},
    { -2., -4.,  0., -1.,  2., -4., -2.,  4.,},
    {  2.,  1.,  3.,  2.,  2., -4., -4., -2.,},
    {  4., -4., -2.,  3.,  2., -4., -4.,  2.,},
    {  3.,  2., -3.,  1.,  2., -4.,  2., -4.,},
    {  0.,  1., -2.,  4.,  2., -4.,  2.,  4.,},
    { -3.,  2., -1., -3.,  2., -4.,  4., -2.,},
    { -4.,  0.,  3., -2.,  2., -4.,  4.,  2.,},
    { -2.,  2.,  1.,  3.,  2.,  2., -4., -4.,},
    {  4.,  1., -1., -3.,  2.,  2., -4.,  4.,},
    { -1., -3., -3., -2.,  2.,  2.,  4., -4.,},
    { -4.,  2., -2.,  1.,  2.,  2.,  4.,  4.,},
    { -1.,  4.,  4., -1.,  2.,  4., -2., -4.,},
    { -4.,  0.,  2.,  2.,  2.,  4., -2.,  4.,},
    {  3.,  2., -4., -4.,  2.,  4., -4., -2.,},
    {  2.,  0.,  0., -3.,  2.,  4., -4.,  2.,},
    {  4., -3., -1.,  4.,  2.,  4.,  2., -4.,},
    {  1.,  2.,  0., -2.,  2.,  4.,  2.,  4.,},
    { -2., -3.,  4.,  0.,  2.,  4.,  4., -2.,},
    { -3.,  4., -4.,  1.,  2.,  4.,  4.,  2.,},
    { -3., -1., -4., -1.,  4., -2., -2., -4.,},
    {  3., -2., -3.,  2.,  4., -2., -2.,  4.,},
    {  1.,  0.,  0., -4.,  4., -2., -4., -2.,},
    {  0., -2.,  4., -3.,  4., -2., -4.,  2.,},
    { -1.,  4.,  3.,  4.,  4., -2.,  2., -4.,},
    { -4.,  0.,  4., -2.,  4., -2.,  2.,  4.,},
    {  2.,  4., -4.,  0.,  4., -2.,  4., -2.,},
    {  4., -1.,  0.,  1.,  4., -2.,  4.,  2.,},
    { -4.,  0., -2., -1.,  4., -4., -2., -2.,},
    { -2., -2., -1.,  0.,  4., -4., -2.,  2.,},
    {  4.,  0., -4., -4.,  4., -4.,  0.,  0.,},
    {  1.,  2.,  2.,  4.,  4., -4.,  2., -2.,},
    {  0.,  0., -3.,  2.,  4., -4.,  2.,  2.,},
    { -2.,  0., -1., -3.,  4.,  0., -4.,  0.,},
    {  0.,  4.,  4., -4.,  4.,  0.,  0., -4.,},
    {  3., -4.,  3.,  2.,  4.,  0.,  0.,  0.,},
    { -3.,  0.,  2., -1.,  4.,  0.,  0.,  4.,},
    { -1.,  4., -2.,  1.,  4.,  0.,  4.,  0.,},
    {  1.,  4.,  2.,  0.,  4.,  2., -2., -4.,},
    { -2.,  0.,  3.,  3.,  4.,  2., -2.,  4.,},
    {  2.,  2., -3., -3.,  4.,  2., -4., -2.,},
    {  4.,  0.,  1., -2.,  4.,  2., -4.,  2.,},
    {  3., -3.,  0.,  2.,  4.,  2.,  2., -4.,},
    {  0.,  2.,  1., -4.,  4.,  2.,  2.,  4.,},
    { -3., -3.,  2.,  1.,  4.,  2.,  4., -2.,},
    { -4.,  4., -3., -1.,  4.,  2.,  4.,  2.,},
    { -3.,  4.,  0.,  2.,  4.,  4., -2., -2.,},
    { -4., -1.,  4.,  3.,  4.,  4., -2.,  2.,},
    {  2.,  4.,  1., -1.,  4.,  4.,  0.,  0.,},
    { -1., -3., -2., -2.,  4.,  4.,  2., -2.,},
    {  1.,  4., -1., -4.,  4.,  4.,  2.,  2.,},
    {  0.,  3., -3., -2., -2., -2.,  0., -4.,},
    { -3., -1., -2.,  1., -2., -2.,  0.,  4.,},
    { -1.,  3.,  0.,  0., -2., -2.,  4.,  0.,},
    {  2., -1., -1., -1., -2., -4., -2.,  0.,},
    { -1.,  4., -4., -2., -2., -4.,  0., -2.,},
    { -2.,  4., -3.,  4., -2., -4.,  2.,  0.,},
    {  1.,  3., -2., -1., -2.,  0., -2., -4.,},
    { -2., -1., -4.,  2., -2.,  0., -2.,  4.,},
    {  2.,  4., -1., -4., -2.,  0., -4., -2.,},
    {  4., -1.,  3., -3., -2.,  0., -4.,  2.,},
    {  0.,  4.,  3., -2., -2.,  0.,  2.,  4.,},
    { -3., -4., -2.,  0., -2.,  0.,  4., -2.,},
    { -4.,  3., -1.,  1., -2.,  0.,  4.,  2.,},
    { -1.,  4.,  1., -3., -2.,  2., -4.,  0.,},
    {  4., -4.,  3., -4., -2.,  2.,  0., -4.,},
    {  3., -4., -3.,  1., -2.,  2.,  4.,  0.,},
    {  3.,  3.,  4.,  2., -2.,  4., -2.,  0.,},
    {  0., -4.,  1.,  1., -2.,  4.,  0., -2.,},
    { -1.,  3.,  2., -1., -2.,  4.,  0.,  2.,},
    { -4., -4., -1., -2., -2.,  4.,  2.,  0.,},
    {  0.,  4., -2., -3., -4., -2.,  0., -2.,},
    { -1., -1., -1., -2., -4., -2.,  0.,  2.,},
    { -4.,  4., -4.,  3., -4., -2.,  2.,  0.,},
    {  1.,  4., -4.,  1., -4.,  0., -2., -2.,},
    {  0., -1.,  0., -1., -4.,  0., -2.,  2.,},
    {  2.,  4., -2.,  4., -4.,  0.,  2.,  2.,},
    { -2.,  4., -2., -1., -4.,  2., -2.,  0.,},
    {  4., -3.,  4., -2., -4.,  2.,  0., -2.,},
    {  3.,  4., -4., -4., -4.,  2.,  0.,  2.,},
    {  0., -3.,  2.,  4., -4.,  2.,  2.,  0.,},
    {  0., -1.,  3.,  0.,  0., -2., -2.,  4.,},
    { -2.,  4., -3.,  3.,  0., -2., -4., -2.,},
    { -3., -1.,  1.,  4.,  0., -2., -4.,  2.,},
    { -4., -4.,  0., -1.,  0., -2.,  2., -4.,},
    {  2.,  4.,  1.,  2.,  0., -2.,  2.,  4.,},
    {  1.,  3., -3., -4.,  0., -2.,  4.,  2.,},
    {  2.,  4.,  4., -3.,  0., -4., -2., -2.,},
    {  4., -1., -4., -2.,  0., -4., -2.,  2.,},
    { -2., -3., -1., -1.,  0., -4.,  2., -2.,},
    { -3.,  4.,  3.,  0.,  0., -4.,  2.,  2.,},
    {  4.,  4.,  0.,  1.,  0.,  2., -2.,  4.,},
    { -1., -3.,  3.,  4.,  0.,  2., -4., -2.,},
    {  1.,  4., -2.,  2.,  0.,  2., -4.,  2.,},
    {  0.,  1., -3.,  0.,  0.,  2.,  2., -4.,},
    { -3., -3., -2.,  3.,  0.,  2.,  2.,  4.,},
    {  2., -4.,  3., -3.,  0.,  2.,  4.,  2.,},
    {  3., -4., -3.,  0.,  0.,  4., -2., -2.,},
    {  2.,  3.,  1.,  1.,  0.,  4., -2.,  2.,},
    { -4.,  1.,  4.,  2.,  0.,  4.,  2., -2.,},
    { -2., -4., -4.,  3.,  0.,  4.,  2.,  2.,},
    { -1., -4., -4.,  1.,  2., -2.,  0., -4.,},
    { -4.,  4., -3.,  4.,  2., -2.,  0.,  4.,},
    {  1., -4., -1.,  3.,  2., -2.,  4.,  0.,},
    {  4.,  4.,  1.,  2.,  2., -4., -2.,  0.,},
    {  1., -3., -2.,  1.,  2., -4.,  0., -2.,},
    { -3., -3., -4., -2.,  2., -4.,  2.,  0.,},
    {  0., -4., -3.,  2.,  2.,  0., -2., -4.,},
    { -3.,  4., -2., -4.,  2.,  0., -2.,  4.,},
    {  4., -3.,  1., -1.,  2.,  0., -4., -2.,},
    {  3.,  4.,  2.,  0.,  2.,  0., -4.,  2.,},
    { -1., -3.,  2.,  1.,  2.,  0.,  2.,  4.,},
    { -4.,  1., -3.,  3.,  2.,  0.,  4., -2.,},
    { -2., -4.,  1.,  4.,  2.,  0.,  4.,  2.,},
    {  1., -3.,  0.,  0.,  2.,  2., -4.,  0.,},
    {  3.,  1.,  2., -1.,  2.,  2.,  0., -4.,},
    {  2.,  1., -4.,  4.,  2.,  2.,  4.,  0.,},
    {  2., -4.,  3., -4.,  2.,  4., -2.,  0.,},
    { -1.,  1.,  0.,  4.,  2.,  4.,  0., -2.,},
    {  1., -4.,  4.,  2.,  2.,  4.,  0.,  2.,},
    { -2.,  1.,  1.,  1.,  2.,  4.,  2.,  0.,},
    { -3., -4.,  4.,  4.,  4., -2.,  0., -2.,},
    { -4.,  3., -4.,  2.,  4., -2.,  0.,  2.,},
    {  2., -4.,  2.,  1.,  4., -2.,  2.,  0.,},
    { -2., -4.,  2., -4.,  4.,  0., -2., -2.,},
    { -3.,  3., -3., -3.,  4.,  0., -2.,  2.,},
    { -1., -4.,  4., -1.,  4.,  0.,  2.,  2.,},
    {  4., -4.,  4., -3.,  4.,  2., -2.,  0.,},
    {  1.,  1.,  1.,  2.,  4.,  2.,  0., -2.,},
    {  0., -4.,  2.,  3.,  4.,  2.,  0.,  2.,},
    { -3.,  1., -1., -1.,  4.,  2.,  2.,  0.,},
    { -3.,  2., -1., -4., -2., -2., -2.,  2.,},
    {  0.,  0.,  2.,  0., -2., -2.,  2., -2.,},
    { -1., -2., -3.,  1., -2., -2.,  2.,  2.,},
    { -1.,  0.,  4., -4., -2.,  2., -2., -2.,},
    {  1., -2., -4., -3., -2.,  2., -2.,  2.,},
    {  4.,  2., -1.,  1., -2.,  2.,  2., -2.,},
    {  3.,  0.,  3., -1., -2.,  2.,  2.,  2.,},
    { -3.,  0., -3.,  1.,  2., -2., -2., -2.,},
    { -4., -2.,  1., -1.,  2., -2., -2.,  2.,},
    { -1.,  2.,  4.,  3.,  2., -2.,  2., -2.,},
    {  1.,  0., -4.,  4.,  2., -2.,  2.,  2.,},
    {  1.,  2.,  3., -1.,  2.,  2., -2., -2.,},
    {  0.,  0., -2.,  0.,  2.,  2., -2.,  2.,},
    {  3., -2.,  1.,  4.,  2.,  2.,  2., -2.,},
    {  3., -2., -4.,  4., -2., -2.,  0.,  0.,},
    {  4., -2., -3., -4., -2.,  0., -2.,  0.,},
    {  1.,  0.,  3.,  4., -2.,  0.,  0., -2.,},
    {  0., -2., -2.,  2., -2.,  0.,  0.,  2.,},
    { -3.,  0.,  4.,  1., -2.,  0.,  2.,  0.,},
    { -2.,  0.,  2.,  2., -2.,  2.,  0.,  0.,},
    { -3., -2.,  4.,  3.,  0., -2., -2.,  0.,},
    {  3.,  0.,  1., -1.,  0., -2.,  0., -2.,},
    { -1.,  0., -1., -4.,  0., -2.,  2.,  0.,},
    {  4.,  0., -1.,  3.,  0.,  0., -2., -2.,},
    {  3., -2.,  3.,  4.,  0.,  0., -2.,  2.,},
    { -3.,  2., -3., -4.,  0.,  0.,  2., -2.,},
    { -4.,  0.,  1., -3.,  0.,  0.,  2.,  2.,},
    {  1.,  0.,  1.,  4.,  0.,  2., -2.,  0.,},
    { -3.,  0., -1.,  1.,  0.,  2.,  0.,  2.,},
    {  3.,  2., -4., -3.,  0.,  2.,  2.,  0.,},
    {  2.,  0., -2., -2.,  2., -2.,  0.,  0.,},
    {  0.,  2.,  2., -2.,  2.,  0.,  0., -2.,},
    { -1.,  0., -3., -4.,  2.,  0.,  0.,  2.,},
    { -4.,  2.,  3.,  4.,  2.,  0.,  2.,  0.,},
    { -3.,  2.,  4., -4.,  2.,  2.,  0.,  0.,},
    { -2., -1.,  4., -4., -2., -2., -4.,  0.,},
    {  1., -1.,  0., -4., -2., -4.,  0.,  2.,},
    {  3., -4.,  2.,  4., -2.,  0.,  2., -4.,},
    {  1.,  4.,  4., -1., -2.,  2.,  0.,  4.,},
    {  3., -1.,  1.,  1., -4., -2., -2.,  0.,},
    {  3., -3.,  3.,  3., -4.,  0.,  2., -2.,},
    {  3.,  3.,  2., -3.,  0., -2., -2., -4.,},
    { -1., -4.,  2., -2.,  0., -2.,  4., -2.,},
    { -2., -4., -1., -2.,  0.,  2., -2., -4.,},
    {  3.,  1., -1., -4.,  0.,  2.,  4., -2.,},
    { -3.,  4.,  3., -1.,  2., -2., -4.,  0.,},
    {  0.,  4., -1., -1.,  2., -4.,  0.,  2.,},
    {  2.,  1.,  4., -2.,  2.,  0.,  2., -4.,},
    {  0., -3.,  3.,  2.,  2.,  2.,  0.,  4.,},
    {  0.,  3., -2., -4.,  4., -2., -2.,  0.,},
    {  0.,  1.,  0.,  1.,  4.,  0.,  2., -2.,},
};

//---------------------------------------------------------------------------
#endif  //_CODE_VEC_
