//---------------------------------------------------------------------------
//
//    definitions used by Wyman digital communications programs
//
//    Copyright (C) 2002  Barry D. Sanderson
//    Copyright (C) 2002  Carl A. Harcourt
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//
//    Mailing addresses for the authors:
//
//    Barry D. Sanderson
//    1725 N. Bolton Ave.
//    Indianapolis, IN 46218  USA
//
//    Carl A. Harcourt
//    4937 W. 900 S.
//    Milroy, IN 46156  USA
//
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//
//    Rev 30 Aug 2002 (CAH) - version 2.0, for initial PC/DOS release
//                            Developed using MS Visual C++ 6.0
//                            as a 'Win32 Console Application', ie a DOS .exe program
//                            Requires a Win32 environment for proper DOS execution
//                            This version will also build and execute unmodified on a Linux system
//
//    Rev 25 Nov 2001 (BDS) - version 1.1.0, for initial public release
//
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// application include files

#include "Wcommon.h"

//---------------------------------------------------------------------------

#ifndef _CODE_WE_
#define _CODE_WE_

//---------------------------------------------------------------------------
// defines

#define   c8t1   8
#define   c8t2   28
#define   c8t3   56
#define   c8t4   70

                                    // mode distances updated 31 May 2001 (for pm8a case)
#define mode1dthld      13.0000     // distance threshold for mode 1, no erasures
#define mode2dthld      13.60147    // distance threshold for mode 2, no erasures

//---------------------------------------------------------------------------
// variable declarations

unsigned int   code2_comb1e [c8t1][1] =
{
    {0}, {1}, {2}, {3}, {4}, {5}, {6}, {7}
};

unsigned int code2_comb1em [c8t1] =    // this array added 29 July 2001
{
      1,      2,      4,      8,
     16,     32,     64,    128
};


ftype   code2_comb1edthld [c8t1] =
{
    10., 10., 10., 10., 7., 7., 7., 7.
};


unsigned int   code2_comb2e [c8t2] [2] =
{
    {0, 1}, {0, 2}, {0, 3}, {0, 4}, {0, 5}, {0, 6}, {0, 7}, {1, 2},
    {1, 3}, {1, 4}, {1, 5}, {1, 6}, {1, 7}, {2, 3}, {2, 4}, {2, 5},
    {2, 6}, {2, 7}, {3, 4}, {3, 5}, {3, 6}, {3, 7}, {4, 5}, {4, 6},
    {4, 7}, {5, 6}, {5, 7}, {6, 7},
};

unsigned int code2_comb2em [c8t2] =    // this array added 29 July 2001
{
      3,   5,   9,  17,  33,  65, 129,   6,  10,  18,  34,  66,
    130,  12,  20,  36,  68, 132,  24,  40,  72, 136,  48,  80,
    144,  96, 160, 192
};

ftype   code2_comb2edthld [c8t2] =
{
    9., 9., 9., 6., 6., 6., 6., 9., 9., 6., 6., 3., 3., 3., 6., 6.,
    6., 6., 6., 6., 6., 6., 3., 6., 3., 3., 3., 6.
};

unsigned int   code2_comb3e [c8t3] [3] =
{
    {0, 1, 2}, {0, 1, 3}, {0, 1, 4}, {0, 1, 5}, {0, 1, 6}, {0, 1, 7}, {0, 2, 3}, {0, 2, 4},
    {0, 2, 5}, {0, 2, 6}, {0, 2, 7}, {0, 3, 4}, {0, 3, 5}, {0, 3, 6}, {0, 3, 7}, {0, 4, 5},
    {0, 4, 6}, {0, 4, 7}, {0, 5, 6}, {0, 5, 7}, {0, 6, 7}, {1, 2, 3}, {1, 2, 4}, {1, 2, 5},
    {1, 2, 6}, {1, 2, 7}, {1, 3, 4}, {1, 3, 5}, {1, 3, 6}, {1, 3, 7}, {1, 4, 5}, {1, 4, 6},
    {1, 4, 7}, {1, 5, 6}, {1, 5, 7}, {1, 6, 7}, {2, 3, 4}, {2, 3, 5}, {2, 3, 6}, {2, 3, 7},
    {2, 4, 5}, {2, 4, 6}, {2, 4, 7}, {2, 5, 6}, {2, 5, 7}, {2, 6, 7}, {3, 4, 5}, {3, 4, 6},
    {3, 4, 7}, {3, 5, 6}, {3, 5, 7}, {3, 6, 7}, {4, 5, 6}, {4, 5, 7}, {4, 6, 7}, {5, 6, 7}
};

unsigned int code2_comb3em [c8t3] =    // this array added 29 July 2001
{
      7,     11,     19,     35,     67,    131,     13,     21,
     37,     69,    133,     25,     41,     73,    137,     49,
     81,    145,     97,    161,    193,     14,     22,     38,
     70,    134,     26,     42,     74,    138,     50,     82,
    146,     98,    162,    194,     28,     44,     76,    140,
     52,     84,    148,    100,    164,    196,     56,     88,
    152,    104,    168,    200,    112,    176,    208,    224
};


ftype   code2_comb3edthld [c8t3] =
{
    8., 8., 5., 5., 2., 2., 8., 5.,
    5., 5., 5., 5., 5., 2., 2., 2.,
    2., 2., 2., 2., 2., 8., 5., 2.,
    2., 2., 2., 5., 2., 2., 2., 2.,
    2., 2., 2., 2., 5., 2., 2., 5.,
    2., 2., 2., 2., 2., 2., 2., 2.,
    2., 2., 2., 2., 2., 2., 2., 2.
};

unsigned int   code2_comb4e [c8t4] [4] =
{
    {0, 1, 2, 3}, {0, 1, 2, 4}, {0, 1, 2, 5}, {0, 1, 2, 6},
    {0, 1, 2, 7}, {0, 1, 3, 4}, {0, 1, 3, 5}, {0, 1, 3, 6},
    {0, 1, 3, 7}, {0, 1, 4, 5}, {0, 1, 4, 6}, {0, 1, 4, 7},
    {0, 1, 5, 6}, {0, 1, 5, 7}, {0, 1, 6, 7}, {0, 2, 3, 4},
    {0, 2, 3, 5}, {0, 2, 3, 6}, {0, 2, 3, 7}, {0, 2, 4, 5},
    {0, 2, 4, 6}, {0, 2, 4, 7}, {0, 2, 5, 6}, {0, 2, 5, 7},
    {0, 2, 6, 7}, {0, 3, 4, 5}, {0, 3, 4, 6}, {0, 3, 4, 7},
    {0, 3, 5, 6}, {0, 3, 5, 7}, {0, 3, 6, 7}, {0, 4, 5, 6},
    {0, 4, 5, 7}, {0, 4, 6, 7}, {0, 5, 6, 7}, {1, 2, 3, 4},
    {1, 2, 3, 5}, {1, 2, 3, 6}, {1, 2, 3, 7}, {1, 2, 4, 5},
    {1, 2, 4, 6}, {1, 2, 4, 7}, {1, 2, 5, 6}, {1, 2, 5, 7},
    {1, 2, 6, 7}, {1, 3, 4, 5}, {1, 3, 4, 6}, {1, 3, 4, 7},
    {1, 3, 5, 6}, {1, 3, 5, 7}, {1, 3, 6, 7}, {1, 4, 5, 6},
    {1, 4, 5, 7}, {1, 4, 6, 7}, {1, 5, 6, 7}, {2, 3, 4, 5},
    {2, 3, 4, 6}, {2, 3, 4, 7}, {2, 3, 5, 6}, {2, 3, 5, 7},
    {2, 3, 6, 7}, {2, 4, 5, 6}, {2, 4, 5, 7}, {2, 4, 6, 7},
    {2, 5, 6, 7}, {3, 4, 5, 6}, {3, 4, 5, 7}, {3, 4, 6, 7},
    {3, 5, 6, 7}, {4, 5, 6, 7}
};

unsigned int code2_comb4em[c8t4] =    // this array added 29 July 2001
{
     15,     23,     39,     71,    135,     27,     43,     75,
    139,     51,     83,    147,     99,    163,    195,     29,
     45,     77,    141,     53,     85,    149,    101,    165,
    197,     57,     89,    153,    105,    169,    201,    113,
    177,    209,    225,     30,     46,     78,    142,     54,
     86,    150,    102,    166,    198,     58,     90,    154,
    106,    170,    202,    114,    178,    210,    226,     60,
     92,    156,    108,    172,    204,    116,    180,    212,
    228,    120,    184,    216,    232,    240
};

ftype   code2_comb4edthld[c8t4] =
{
    8., 4., 1., 1., 1., 1., 4., 1.,
    1., 1., 1., 1., 1., 1., 1., 1.,
    1., 1., 1., 1., 1., 1., 1., 1.,
    1., 1., 1., 1., 1., 1., 1., 1.,
    1., 1., 1., 1., 1., 1., 1., 1.,
    1., 1., 1., 1., 1., 1., 1., 1.,
    1., 1., 1., 1., 1., 1., 1., 1.,
    1., 1., 1., 1., 1., 1., 1., 1.,
    1., 1., 1., 1., 1., 1.,
};


ftype   mode1_comb1edthld [c8t1] =
{
    11.74734,  12.40967,  2.84523,  11.53256,    10.24695,  10.48809,  10.24695,  12.40967
};

ftype   mode2_comb1edthld [c8t1] =
{
    13.00000,  11.70470,  13.00000,  12.64911,   11.00000,  11.00000,  11.70470,  11.70470
};

ftype   mode1_comb2edthld [c8t2] =
{
    11.74734,  11.35782,  11.35782,  10.04988,    8.60233,   8.60233,  11.74734,  12.00000,
    11.35782,   9.48683,  10.24695,  10.24695,    9.48683,  11.48913,  10.19804,  10.04988,
    10.04988,  12.00000,   8.30662,   9.79796,    8.30662,  11.35782,   7.54983,   6.40312,
     9.48683,   6.78233,  10.24695,  10.24695
};

ftype   mode2_comb2edthld [c8t2] =
{
    11.53256,  12.36932,  12.00000,  10.24695,   10.24695,  11.53256,  11.53256,  11.53256,
    11.66190,  11.00000,  11.00000,   8.54400,    8.54400,  12.00000,  10.24695,  10.24695,
    11.53256,  11.53256,   9.79796,   9.79796,   11.66190,  11.66190,   7.54983,  11.00000,
    11.00000,  11.00000,  11.00000,   8.54400
};

//---------------------------------------------------------------------------
#endif  //_CODE_WE_
