//---------------------------------------------------------------------------
//
//    definitions used by Wyman digital communications programs
//
//    Copyright (C) 2002  Barry D. Sanderson
//    Copyright (C) 2002  Carl A. Harcourt
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//
//    Mailing addresses for the authors:
//
//    Barry D. Sanderson
//    1725 N. Bolton Ave.
//    Indianapolis, IN 46218  USA
//
//    Carl A. Harcourt
//    4937 W. 900 S.
//    Milroy, IN 46156  USA
//
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//
//    Rev 30 Aug 2002 (CAH) - version 2.0, for initial PC/DOS release
//                            Developed using MS Visual C++ 6.0
//                            as a 'Win32 Console Application', ie a DOS .exe program
//                            Requires a Win32 environment for proper DOS execution
//                            This version will also build and execute unmodified on a Linux system
//
//    rev 25 Nov 2001 (BDS) - version 1.1.0, for initial public release
//
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// application include files

#include "Wcommon.h"

//---------------------------------------------------------------------------

#ifndef _DCOM_
#define _DCOM_

//---------------------------------------------------------------------------
// defines

#define frevt       23
#define Qt          12
#define frevr       21
#define Qr          4
#define pm_step     230.0

// rev 26 Feb 2001    pmc0 changed from 590 to 575
// rev 23 Jan 2001    pmc0 changed from 600 to 590

#define pmc0        575.0
#define pmc1        (pmc0 + pm_step)
#define pmc2        (pmc1 + pm_step)
#define pmc3        (pmc2 + pm_step)
#define pmc4        (pmc3 + pm_step)
#define pmc5        (pmc4 + pm_step)
#define pmc6        (pmc5 + pm_step)
#define pmc7        (pmc6 + pm_step)


#define soff0       0       // clock period offsets to effect staggering of phase transitions
#define soff1       11
#define soff2       22
#define soff3       34
#define soff4       45
#define soff5       56
#define soff6       67
#define soff7       79

//---------------------------------------------------------------------------

#endif  // _DCOM_
