//---------------------------------------------------------------------------
//
//    definitions used by Wyman digital communications programs
//
//    Copyright (C) 2002  Barry D. Sanderson
//    Copyright (C) 2002  Carl A. Harcourt
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//
//    Mailing addresses for the authors:
//
//    Barry D. Sanderson
//    1725 N. Bolton Ave.
//    Indianapolis, IN 46218  USA
//
//    Carl A. Harcourt
//    4937 W. 900 S.
//    Milroy, IN 46156  USA
//
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//
//    Rev 30 Aug 2002 (CAH) - version 2.0, for initial PC/DOS release
//                            Developed using MS Visual C++ 6.0
//                            as a 'Win32 Console Application', ie a DOS .exe program
//                            Requires a Win32 environment for proper DOS execution
//                            This version will also build and execute unmodified on a Linux system
//
//    Rev 25 Nov 2001 (BDS) - version 1.1.0, for initial public release
//
//---------------------------------------------------------------------------

#ifndef _FRAME_
#define _FRAME_

//---------------------------------------------------------------------------
// application include files

#include "Wcommon.h"

//---------------------------------------------------------------------------
// defines

#define    PM_FRAME_LENGTH    271

//---------------------------------------------------------------------------
// variable declarations

float pm_frame [PM_FRAME_LENGTH] =
{
    -0.027947,    -0.027875,    -0.027184,    -0.025871,    -0.023925,
    -0.021256,    -0.017870,    -0.013735,    -0.008797,    -0.003000,
     0.003718,     0.011361,     0.020003,     0.029730,     0.040608,
     0.052716,     0.066122,     0.080920,     0.097209,     0.115103,
     0.134713,     0.156155,     0.179567,     0.205030,     0.232653,
     0.262688,     0.295162,     0.330215,     0.367988,     0.408598,
     0.452132,     0.498595,     0.548028,     0.600445,     0.655800,
     0.714000,     0.774920,     0.838410,     0.904270,     0.972278,
     1.042175,     1.113775,     1.186750,     1.260675,     1.335300,
     1.410400,     1.485600,     1.560575,     1.634950,     1.708550,
     1.781025,     1.852000,     1.921250,     1.988600,     2.053750,
     2.116500,     2.176800,     2.234500,     2.289475,     2.341750,
     2.391300,     2.438175,     2.482425,     2.524125,     2.563325,
     2.600175,     2.634875,     2.667400,     2.697925,     2.726600,
     2.753575,     2.778875,     2.802650,     2.824925,     2.845900,
     2.865625,     2.884175,     2.901625,     2.918050,     2.933525,
     2.948075,     2.961825,     2.974775,     2.986975,     2.998450,
     3.009300,     3.019525,     3.029175,     3.038250,     3.046800,
     3.054950,     3.062575,     3.069775,     3.076525,     3.082950,
     3.089000,     3.094650,     3.100025,     3.105100,     3.109850,
     3.114275,     3.118550,     3.122575,     3.126325,     3.129850,
     3.133150,     3.136300,     3.139225,     3.142025,     3.144650,
     3.147200,     3.149525,     3.151725,     3.153850,     3.155925,
     3.157850,     3.159700,     3.161525,     3.163250,     3.164975,
     3.166600,     3.168275,     3.169950,     3.171575,     3.173075,
     3.174650,     3.176150,     3.177600,     3.178975,     3.180325,
     3.181600,     3.182775,     3.183725,     3.184650,     3.185500,
     3.186100,     3.186625,     3.186950,     3.187225,     3.187225,
     3.187025,     3.186625,     3.186125,     3.185375,     3.184350,
     3.183125,     3.181725,     3.180125,     3.178225,     3.176200,
     3.173975,     3.171475,     3.168800,     3.165975,     3.162950,
     3.159800,     3.156400,     3.152875,     3.149225,     3.145325,
     3.141250,     3.137025,     3.132625,     3.128050,     3.123250,
     3.118275,     3.113075,     3.107700,     3.102050,     3.096225,
     3.090125,     3.083775,     3.077100,     3.070200,     3.062975,
     3.055475,     3.047575,     3.039375,     3.030825,     3.021875,
     3.012525,     3.002700,     2.992525,     2.981825,     2.970650,
     2.958900,     2.946625,     2.933725,     2.920175,     2.905950,
     2.891000,     2.875225,     2.858650,     2.841150,     2.822750,
     2.803275,     2.782700,     2.760950,     2.737950,     2.713525,
     2.687600,     2.660100,     2.630950,     2.599950,     2.567000,
     2.531975,     2.494750,     2.455200,     2.413225,     2.368725,
     2.321600,     2.271800,     2.219275,     2.164125,     2.106450,
     2.046175,     1.983525,     1.918725,     1.851925,     1.783275,
     1.713150,     1.641825,     1.569550,     1.496700,     1.423550,
     1.350375,     1.277550,     1.205350,     1.134100,     1.064125,
     0.995718,     0.929113,     0.864570,     0.802390,     0.742765,
     0.685833,     0.631705,     0.580445,     0.532235,     0.486930,
     0.444515,     0.405020,     0.368322,     0.334313,     0.302875,
     0.273840,     0.247073,     0.222435,     0.199795,     0.179003,
     0.159941,     0.142462,     0.126424,     0.111774,     0.098386,
     0.086159,     0.074972,     0.064751,     0.055467,     0.046969,
     0.039209,     0.032151,     0.025735,     0.019914,     0.014645,
     0.009852,     0.005495,     0.001524,    -0.002062,    -0.005315,
    -0.008267
};

//---------------------------------------------------------------------------
#endif // _FRAME_
