//---------------------------------------------------------------------------
//
//    initialized arrays used by Wyman digital communications programs
//
//    Copyright (C) 2002  Barry D. Sanderson
//    Copyright (C) 2002  Carl A. Harcourt
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//
//    Mailing addresses for the authors:
//
//    Barry D. Sanderson
//    1725 N. Bolton Ave.
//    Indianapolis, IN 46218  USA
//
//    Carl A. Harcourt
//    4937 W. 900 S.
//    Milroy, IN 46156  USA
//
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//
//    Rev 30 Aug 2002 (CAH) - version 2.0, for initial PC/DOS release
//                            Developed using MS Visual C++ 6.0
//                            as a 'Win32 Console Application', ie a DOS .exe program
//                            Requires a Win32 environment for proper DOS execution
//                            This version will also build and execute unmodified on a Linux system
//
//    Rev 25 Nov 2001 (BDS) - version 1.1.0
//    Rev 12 May 2001 (BDS) - version 1.0.0 for initial release
//
//---------------------------------------------------------------------------

#ifndef _GF_307_
#define _GF_307_

//---------------------------------------------------------------------------
// application include files

#include "Wcommon.h"

//---------------------------------------------------------------------------
// variable declarations

// powers of primitive element 5

int expa1 [307] =
{
        1,   5,  25, 125,  11,  55, 275, 147, 121, 298, 262,  82, 103, 208, 119, 288, 212, 139,
       81,  98, 183, 301, 277, 157, 171, 241, 284, 192,  39, 195,  54, 270, 122, 303, 287, 207,
      114, 263,  87, 128,  26, 130,  36, 180, 286, 202,  89, 138,  76,  73,  58, 290, 222, 189,
       24, 120, 293, 237, 264,  92, 153, 151, 141,  91, 148, 126,  16,  80,  93, 158, 176, 266,
      102, 203,  94, 163, 201,  84, 113, 258,  62,   3,  15,  75,  68,  33, 165, 211, 134,  56,
      280, 172, 246,   2,  10,  50, 250,  22, 110, 243, 294, 242, 289, 217, 164, 206, 109, 238,
      269, 117, 278, 162, 196,  59, 295, 247,   7,  35, 175, 261,  77,  78,  83, 108, 233, 244,
      299, 267, 107, 228, 219, 174, 256,  52, 260,  72,  53, 265,  97, 178, 276, 152, 146, 116,
      273, 137,  71,  48, 240, 279, 167, 221, 184, 306, 302, 282, 182, 296, 252,  32, 160, 186,
        9,  45, 225, 204,  99, 188,  19,  95, 168, 226, 209, 124,   6,  30, 150, 136,  66,  23,
      115, 268, 112, 253,  37, 185,   4,  20, 100, 193,  44, 220, 179, 281, 177, 271, 127,  21,
      105, 218, 169, 231, 234, 249,  17,  85, 118, 283, 187,  14,  70,  43, 215, 154, 156, 166,
      216, 159, 181, 291, 227, 214, 149, 131,  41, 205, 104, 213, 144, 106, 223, 194,  49, 245,
      304, 292, 232, 239, 274, 142,  96, 173, 251,  27, 135,  61, 305, 297, 257,  57, 285, 197,
       64,  13,  65,  18,  90, 143, 101, 198,  69,  38, 190,  29, 145, 111, 248,  12,  60, 300,
      272, 132,  46, 230, 229, 224, 199,  74,  63,   8,  40, 200,  79,  88, 133,  51, 255,  47,
      235, 254,  42, 210, 129,  31, 155, 161, 191,  34, 170, 236, 259,  67,  28, 140,  86, 123,
        1,
};

// multiplicative inverses of field elements


int inve1 [307] =
{
        0,   1, 154, 205,  77, 123, 256,  44, 192, 273, 215,  28, 128, 189,  22,  41,  96, 289,
      290,  97, 261, 117,  14, 267,  64,  86, 248,  91,  11, 180, 174, 208,  48, 214, 298, 193,
      145,  83, 202,  63, 284,  15, 212,  50,   7, 116, 287,  98,  32,  94,  43, 301, 124, 168,
      199,  67, 159, 237,  90, 281,  87, 151, 104,  39,  24, 222, 107,  55, 149,  89, 250, 160,
      226, 143, 195, 131, 101,   4, 185, 171, 142, 235, 161,  37, 106, 242,  25,  60, 157,  69,
       58,  27, 297, 274,  49, 265,  16,  19,  47, 276, 175,  76, 304, 155,  62, 269,  84,  66,
      253, 169, 187, 130, 233, 144, 272, 299,  45,  21, 294, 129, 197, 170, 229,   5,  52, 140,
      173, 278,  12, 119, 111,  75, 207, 277, 181, 141, 228, 186, 198, 254, 125, 135,  80,  73,
      113,  36, 225, 236, 251,  68, 219,  61, 204, 305,   2, 103, 246,  88, 239,  56,  71,  82,
      271, 194, 234, 227, 172, 182,  53, 109, 121,  79, 166, 126,  30, 100, 232, 196, 188, 295,
       29, 134, 167, 255, 302,  78, 137, 110, 178,  13, 286, 262,   8,  35, 163,  74, 177, 120,
      138,  54, 241, 223,  38, 245, 152,   3, 231, 132,  31, 260, 288, 291,  42, 258,  33,  10,
      280, 249, 238, 150, 247, 282,  65, 201, 270, 146,  72, 165, 136, 122, 303, 206, 176, 112,
      164,  81, 147,  57, 218, 158, 252, 200,  85, 283, 268, 203, 156, 220,  26, 217,  70, 148,
      240, 108, 139, 183,   6, 264, 213, 275, 209,  20, 191, 300, 257,  95, 292,  23, 244, 105,
      224, 162, 114,   9,  93, 259,  99, 133, 127, 296, 216,  59, 221, 243,  40, 293, 190,  46,
      210,  17,  18, 211, 266, 285, 118, 179, 279,  92,  34, 115, 263,  51, 184, 230, 102, 153,
      306,
};

// multiplicative inverses of primitive element 5

int inva1 [307] =
{
        0, 123,  86, 140,  28,  67, 259, 236, 170,  34, 191, 161, 155,  31, 129, 210,  42, 254,
      235,  47, 255,  51, 133,  88,  79, 200,  40,   8,  63,  74, 199, 224, 229, 230,  46, 132,
      272, 300,  60,  12, 248, 111, 145,  29, 190,  38,  69, 198, 101, 143,  90,  18,  65,  13,
       64, 197, 285,  57, 257, 297, 305,  61, 135,  27, 251, 173,  96, 142, 274, 239, 232, 292,
      304, 245,  49, 194, 223, 106, 144, 213, 104, 205,  41, 131, 149, 214, 227, 291, 181, 159,
      216, 166, 156, 154, 215,  43,  70,  14, 187, 283, 118,  85,  17, 249, 234, 231, 169, 218,
      105,  21, 127, 271, 177, 281, 179, 220,  44, 193, 100,  20,   4, 185,  37, 253, 112, 268,
      115,  23,  66, 136, 150,  30,   6, 124, 209, 226, 168,  95,  19, 188,  99, 204, 225,  45,
        9, 186, 160,  32, 252, 296, 182, 282, 302, 306, 184, 221, 167, 279, 240,  48,  71, 137,
      273, 116, 146, 152, 276, 178,  97, 265,  53,  72, 260,  52, 256, 174, 219, 228, 107, 267,
      299, 244, 233, 108,  83,  78,  77, 261, 175,  35,   7, 247, 295,  59, 196, 162, 278, 117,
      269, 238, 109, 206, 164, 217, 289, 242, 294, 243, 110,  22, 250,  50,  10,   2, 246, 172,
      280,  56, 134, 211, 165,  33,  68,  75,  15,   3,  62, 258, 113,  84, 201, 163,  94, 203,
      102, 266, 176, 158,  93,  80,  16, 126, 148,  91, 141, 151, 153,  92, 264, 237, 293, 120,
       24, 189, 222, 290,  58,  73,  76, 138,  89, 202, 286, 180,  36, 130,  26, 128,  87, 263,
      114, 207, 287, 303, 122, 270,  54, 195,  39, 192, 284, 241, 171, 157, 277, 301, 183,  98,
       81, 139, 212, 288, 119, 208, 103,  82, 262, 298, 121, 147, 275,  55,  11, 125,  25,   5,
        1,
};

//---------------------------------------------------------------------------
#endif  // _GF_307_

