//---------------------------------------------------------------------------
//
//    Reed-Solomon variable header file
//
//    Copyright (C) 2002  Barry D. Sanderson
//    Copyright (C) 2002  Carl A. Harcourt
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//
//    Mailing addresses for the authors:
//
//    Barry D. Sanderson
//    1725 N. Bolton Ave.
//    Indianapolis, IN 46218  USA
//
//    Carl A. Harcourt
//    4937 W. 900 S.
//    Milroy, IN 46156  USA
//
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//
//    Rev 30 Aug 2002 (CAH) - version 2.0, for initial PC/DOS release
//                            Developed using MS Visual C++ 6.0
//                            as a 'Win32 Console Application', ie a DOS .exe program
//                            Requires a Win32 environment for proper DOS execution
//                            This version will also build and execute unmodified on a Linux system
//
//    Rev 25 Nov 2001 (BDS) - version 1.1.0, for Wyman initial public release
//
//---------------------------------------------------------------------------

#ifndef _RS_VAR_HDR_
#define _RS_VAR_HDR_

//---------------------------------------------------------------------------
// application include files

#include "Wcommon.h"
#include "code_def.h"

//---------------------------------------------------------------------------
// variable declarations

// arithemtic tables for Galois Field of 9 elements
// rev 14 Dec 2000  gf9mul fixed

int    gf9add [9] [9] =
{
    {0, 1, 2, 3, 4, 5, 6, 7, 8},
    {1, 2, 0, 4, 5, 3, 7, 8, 6},
    {2, 0, 1, 5, 3, 4, 8, 6, 7},
    {3, 4, 5, 6, 7, 8, 0, 1, 2},
    {4, 5, 3, 7, 8, 6, 1, 2, 0},
    {5, 3, 4, 8, 6, 7, 2, 0, 1},
    {6, 7, 8, 0, 1, 2, 3, 4, 5},
    {7, 8, 6, 1, 2, 0, 4, 5, 3},
    {8, 6, 7, 2, 0, 1, 5, 3, 4}
};

int    gf9mul [9] [9] =
{
    {0, 0, 0, 0, 0, 0, 0, 0, 0},
    {0, 1, 2, 3, 4, 5, 6, 7, 8},
    {0, 2, 1, 6, 8, 7, 3, 5, 4},
    {0, 3, 6, 7, 1, 4, 5, 8, 2},
    {0, 4, 8, 1, 5, 6, 2, 3, 7},
    {0, 5, 7, 4, 6, 2, 8, 1, 3},
    {0, 6, 3, 5, 2, 8, 7, 4, 1},
    {0, 7, 5, 8, 3, 1, 4, 2, 6},
    {0, 8, 4, 2, 7, 3, 1, 6, 5}
};

int    gf9addi [9] = {0, 2, 1, 6, 8, 7, 3, 5, 4};
int    gf9muli [9] = {0, 1, 2, 4, 3, 7, 8, 5, 6};

    // powers of a2
int    expa2 [9] = {1, 3, 7, 8, 2, 6, 5, 4, 1 };

    // multiplicative inverses of field elements
int    inve2 [9] = {0, 1, 2, 4, 3, 7, 8, 5, 6 };

    // multiplicative inverses of element a2
int    inva2 [9] = {0, 4, 5, 6, 2, 8, 7, 3, 1 };

int    rgm2 [4] [4] =
{
    {7, 6, 2, 7},
    {2, 2, 2, 1},
    {7, 8, 1, 6},
    {4, 5, 2, 5}
};

//---------------------------------------------------------------------------
#endif  // _RS_VAR_HDR_



