//---------------------------------------------------------------------------
//
//    definitions used by Wyman digital communications programs
//
//    Copyright (C) 2002  Barry D. Sanderson
//    Copyright (C) 2002  Carl A. Harcourt
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//
//    Mailing addresses for the authors:
//
//    Barry D. Sanderson
//    1725 N. Bolton Ave.
//    Indianapolis, IN 46218  USA
//
//    Carl A. Harcourt
//    4937 W. 900 S.
//    Milroy, IN 46156  USA
//
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//
//    Rev 30 Aug 2002 (CAH) - version 2.0, for initial PC/DOS release
//                            Developed using MS Visual C++ 6.0
//                            as a 'Win32 Console Application', ie a DOS .exe program
//                            Requires a Win32 environment for proper DOS execution
//                            This version will also build and execute unmodified on a Linux system
//
//    Rev 25 Nov 2001 (BDS) - version 1.1.0, for initial public release
//
//---------------------------------------------------------------------------

#ifndef _SYM_CODE_
#define _SYM_CODE_

//---------------------------------------------------------------------------
// application include files

#include "Wcommon.h"
#include "sys_def.h"

//---------------------------------------------------------------------------
// variable declarations

unsigned short int sym_to_phi [] [NUM_INFO_SC] =
{

    {0, 0, 0, 0},  {0, 0, 0, 8},  {0, 0, 8, 0},  {0, 0, 8, 8},  // this entry is for symbol #     0
    {0, 8, 0, 0},  {0, 8, 0, 8},  {0, 8, 8, 0},  {0, 8, 8, 8},
    {8, 0, 0, 0},  {8, 0, 0, 8},  {8, 0, 8, 0},  {8, 0, 8, 8},
    {8, 8, 0, 0},  {8, 8, 0, 8},  {8, 8, 8, 0},  {8, 8, 8, 8},

    {0, 0, 0, 4},  {0, 0, 4, 0},  {0, 0, 4, 8},  {0, 0, 8, 4},  // this entry is for symbol #    16
    {0, 4, 0, 0},  {0, 4, 0, 8},  {0, 4, 8, 0},  {0, 4, 8, 8},
    {0, 8, 0, 4},  {0, 8, 4, 0},  {0, 8, 4, 8},  {0, 8, 8, 4},
    {4, 0, 0, 0},  {4, 0, 0, 8},  {4, 0, 8, 0},  {4, 0, 8, 8},

    {4, 8, 0, 0},  {4, 8, 0, 8},  {4, 8, 8, 0},  {4, 8, 8, 8},  // this entry is for symbol #    32
    {8, 0, 0, 4},  {8, 0, 4, 0},  {8, 0, 4, 8},  {8, 0, 8, 4},
    {8, 4, 0, 0},  {8, 4, 0, 8},  {8, 4, 8, 0},  {8, 4, 8, 8},
    {8, 8, 0, 4},  {8, 8, 4, 0},  {8, 8, 4, 8},  {8, 8, 8, 4},

    {2, 2, 0, 0},  {2, 2, 0, 8},  {2, 2, 8, 0},  {2, 2, 8, 8},  // this entry is for symbol #    48
    {2, 0, 2, 0},  {2, 0, 2, 8},  {2, 0, 0, 2},  {2, 0, 0, 6},
    {2, 0, 6, 0},  {2, 0, 6, 8},  {2, 0, 8, 2},  {2, 0, 8, 6},
    {2, 6, 0, 0},  {2, 6, 0, 8},  {2, 6, 8, 0},  {2, 6, 8, 8},

    {2, 8, 2, 0},  {2, 8, 2, 8},  {2, 8, 0, 2},  {2, 8, 0, 6},  // this entry is for symbol #    64
    {2, 8, 6, 0},  {2, 8, 6, 8},  {2, 8, 8, 2},  {2, 8, 8, 6},
    {0, 2, 2, 0},  {0, 2, 2, 8},  {0, 2, 0, 2},  {0, 2, 0, 6},
    {0, 2, 6, 0},  {0, 2, 6, 8},  {0, 2, 8, 2},  {0, 2, 8, 6},

    {0, 0, 2, 2},  {0, 0, 2, 6},  {0, 0, 4, 4},  {0, 0, 6, 2},  // this entry is for symbol #    80
    {0, 0, 6, 6},  {0, 4, 0, 4},  {0, 4, 4, 0},  {0, 4, 4, 4},
    {0, 4, 4, 8},  {0, 4, 8, 4},  {0, 6, 2, 0},  {0, 6, 2, 8},
    {0, 6, 0, 2},  {0, 6, 0, 6},  {0, 6, 6, 0},  {0, 6, 6, 8},

    {0, 6, 8, 2},  {0, 6, 8, 6},  {0, 8, 2, 2},  {0, 8, 2, 6},  // this entry is for symbol #    96
    {0, 8, 4, 4},  {0, 8, 6, 2},  {0, 8, 6, 6},  {4, 0, 0, 4},
    {4, 0, 4, 0},  {4, 0, 4, 4},  {4, 0, 4, 8},  {4, 0, 8, 4},
    {4, 4, 0, 0},  {4, 4, 0, 4},  {4, 4, 0, 8},  {4, 4, 4, 0},

    {4, 4, 4, 8},  {4, 4, 8, 0},  {4, 4, 8, 4},  {4, 4, 8, 8},  // this entry is for symbol #   112
    {4, 8, 0, 4},  {4, 8, 4, 0},  {4, 8, 4, 4},  {4, 8, 4, 8},
    {4, 8, 8, 4},  {6, 2, 0, 0},  {6, 2, 0, 8},  {6, 2, 8, 0},
    {6, 2, 8, 8},  {6, 0, 2, 0},  {6, 0, 2, 8},  {6, 0, 0, 2},

    {6, 0, 0, 6},  {6, 0, 6, 0},  {6, 0, 6, 8},  {6, 0, 8, 2},  // this entry is for symbol #   128
    {6, 0, 8, 6},  {6, 6, 0, 0},  {6, 6, 0, 8},  {6, 6, 8, 0},
    {6, 6, 8, 8},  {6, 8, 2, 0},  {6, 8, 2, 8},  {6, 8, 0, 2},
    {6, 8, 0, 6},  {6, 8, 6, 0},  {6, 8, 6, 8},  {6, 8, 8, 2},

    {6, 8, 8, 6},  {8, 2, 2, 0},  {8, 2, 2, 8},  {8, 2, 0, 2},  // this entry is for symbol #   144
    {8, 2, 0, 6},  {8, 2, 6, 0},  {8, 2, 6, 8},  {8, 2, 8, 2},
    {8, 2, 8, 6},  {8, 0, 2, 2},  {8, 0, 2, 6},  {8, 0, 4, 4},
    {8, 0, 6, 2},  {8, 0, 6, 6},  {8, 4, 0, 4},  {8, 4, 4, 0},

    {8, 4, 4, 4},  {8, 4, 4, 8},  {8, 4, 8, 4},  {8, 6, 2, 0},  // this entry is for symbol #   160
    {8, 6, 2, 8},  {8, 6, 0, 2},  {8, 6, 0, 6},  {8, 6, 6, 0},
    {8, 6, 6, 8},  {8, 6, 8, 2},  {8, 6, 8, 6},  {8, 8, 2, 2},
    {8, 8, 2, 6},  {8, 8, 4, 4},  {8, 8, 6, 2},  {8, 8, 6, 6},

    {2, 2, 4, 0},  {2, 2, 4, 8},  {2, 2, 8, 4},  {2, 0, 2, 4},  // this entry is for symbol #   176
    {2, 0, 4, 2},  {2, 0, 6, 4},  {2, 4, 2, 0},  {2, 4, 2, 8},
    {2, 4, 0, 2},  {2, 4, 0, 6},  {2, 4, 6, 8},  {2, 4, 8, 2},
    {2, 4, 8, 6},  {2, 6, 0, 4},  {2, 6, 4, 0},  {2, 6, 8, 4},

    {2, 8, 2, 4},  {2, 8, 4, 2},  {2, 8, 4, 6},  {2, 8, 6, 4},  // this entry is for symbol #   192
    {0, 2, 4, 2},  {0, 2, 4, 6},  {0, 2, 6, 4},  {0, 4, 2, 2},
    {0, 4, 2, 6},  {0, 4, 6, 6},  {0, 6, 2, 4},  {0, 6, 4, 2},
    {0, 6, 4, 6},  {0, 6, 6, 4},  {4, 2, 2, 8},  {4, 2, 0, 2},

    {4, 2, 0, 6},  {4, 2, 6, 0},  {4, 2, 6, 8},  {4, 2, 8, 6},  // this entry is for symbol #   208
    {4, 0, 2, 2},  {4, 0, 2, 6},  {4, 0, 6, 2},  {4, 0, 6, 6},
    {4, 6, 2, 8},  {4, 6, 0, 2},  {4, 6, 0, 6},  {4, 6, 6, 0},
    {4, 6, 6, 8},  {4, 6, 8, 6},  {4, 8, 2, 2},  {4, 8, 2, 6},

    {4, 8, 6, 2},  {4, 8, 6, 6},  {6, 2, 4, 0},  {6, 2, 4, 8},  // this entry is for symbol #   224
    {6, 2, 8, 4},  {6, 0, 2, 4},  {6, 0, 4, 2},  {6, 0, 6, 4},
    {6, 4, 2, 0},  {6, 4, 2, 8},  {6, 4, 0, 2},  {6, 4, 0, 6},
    {6, 4, 6, 8},  {6, 4, 8, 2},  {6, 4, 8, 6},  {6, 6, 0, 4},

    {6, 6, 4, 0},  {6, 6, 8, 4},  {6, 8, 2, 4},  {6, 8, 4, 2},  // this entry is for symbol #   240
    {6, 8, 4, 6},  {6, 8, 6, 4},  {8, 2, 4, 2},  {8, 2, 4, 6},
    {8, 2, 6, 4},  {8, 4, 2, 2},  {8, 4, 2, 6},  {8, 4, 6, 6},
    {8, 6, 2, 4},  {8, 6, 4, 2},  {8, 6, 4, 6},  {8, 6, 6, 4},

    {2, 2, 2, 6},  {2, 2, 6, 2},  {2, 2, 6, 6},  {2, 6, 2, 2},  // this entry is for symbol #   256
    {2, 6, 2, 6},  {2, 6, 6, 2},  {2, 6, 6, 6},  {6, 2, 2, 2},
    {6, 2, 2, 6},  {6, 2, 6, 2},  {6, 2, 6, 6},  {6, 6, 2, 2},
    {6, 6, 2, 6},  {6, 6, 6, 2},  {2, 2, 4, 4},  {2, 4, 2, 4},

    {2, 4, 4, 2},  {2, 4, 4, 6},  {2, 4, 6, 4},  {2, 6, 4, 4},  // this entry is for symbol #   272
    {4, 2, 2, 4},  {4, 2, 4, 2},  {4, 2, 6, 4},  {4, 4, 2, 2},
    {4, 4, 2, 6},  {4, 4, 6, 2},  {4, 4, 6, 6},  {4, 6, 2, 4},
    {4, 6, 4, 6},  {4, 6, 6, 4},  {6, 2, 4, 4},  {6, 4, 4, 2},

    {6, 4, 4, 6},  {6, 4, 6, 4},  {6, 6, 4, 4},  {2, 2, 0, 4},  // this entry is for symbol #   288
    {2, 0, 4, 6},  {2, 4, 6, 0},  {2, 6, 4, 8},  {0, 2, 2, 4},
    {0, 4, 6, 2},  {4, 2, 2, 0},  {4, 2, 8, 2},  {4, 6, 2, 0},
    {4, 6, 8, 2},  {6, 2, 0, 4},  {6, 0, 4, 6},  {6, 4, 6, 0},

    {6, 6, 4, 8},  {8, 2, 2, 4},  {8, 4, 6, 2},                  // this entry is for symbol #   304
                                    // rev 06 Mar 2001    frame4 and frame4r introduced, also mode id assignments changed
                                    // rev 23 Jan 2001    frame[123] and frame[123]r changed, so all sub-carriers produce the same waveform for the framing sequence
    {4, 4, 4, 4},       // no modulation                             // this entry is for symbol #   307
    {4, 4, 4, 4},       // frame1
    {7, 7, 7, 7},       // frame2
    {7, 7, 7, 7},       // frame3
    {4, 4, 4, 4},       // frame4
    {4, 4, 4, 4},       // frame1r
    {7, 7, 7, 7},       // frame2r
    {7, 7, 7, 7},       // frame3r
    {4, 4, 4, 4},       // frame4r
    {8, 8, 0, 0},       // id1x05
    {0, 8, 8, 0},       // id2x05
    {0, 8, 8, 0},       // id1x10
    {0, 8, 0, 8},       // id2x10
    {8, 0, 8, 0},       // id1x20
    {8, 0, 0, 8},       // id2x20
    {0, 0, 8, 8},       // id1x40
    {8, 0, 8, 0},       // id2x40
    {6, 6, 4, 4},       // lead_i
    {4, 4, 2, 2}        // lead_r
};

//---------------------------------------------------------------------------
#endif  // _SYM_CODE_

