//---------------------------------------------------------------------------
//
//    definitions used by Wyman digital communications programs
//
//    Copyright (C) 2002  Barry D. Sanderson
//    Copyright (C) 2002  Carl A. Harcourt
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//
//    Mailing addresses for the authors:
//
//    Barry D. Sanderson
//    1725 N. Bolton Ave.
//    Indianapolis, IN 46218  USA
//
//    Carl A. Harcourt
//    4937 W. 900 S.
//    Milroy, IN 46156  USA
//
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//
//    Rev 30 Aug 2002 (CAH) - version 2.0, for initial PC/DOS release
//                            Developed using MS Visual C++ 6.0
//                            as a 'Win32 Console Application', ie a DOS .exe program
//                            Requires a Win32 environment for proper DOS execution
//                            This version will also build and execute unmodified on a Linux system
//
//    Rev 25 Nov 2001 (BDS) - version 1.1.0, for initial public release
//
//---------------------------------------------------------------------------

#ifndef _SYS_DEF_
#define _SYS_DEF_

//---------------------------------------------------------------------------
// application include files

#include "Wcommon.h"

//---------------------------------------------------------------------------
// defines

//efine NUM_INFO_SC         4                       // number of information sub-carriers
//efine NUM_REDUNDANT_SC    4                       // number of redundancy sub-carriers
//efine NUM_TOTAL_SC        (NUM_INFO_SC + NUM_REDUNDANT_SC)

//---------------------------------------------------------------------------
// include files

#include "Wcommon.h"
#include "code_def.h"

//---------------------------------------------------------------------------
// defines

//efine SYM_TYPE_SC     unsigned short int      // total number of sub_carriers
//efine SYM_TYPE_CH     unsigned int

#define soh             0x100                   // symbol # for start of header
#define sod             0x101                   // symbol # for start of data
#define dummy1          0x102                   // symbol # for dummy data (filler)
#define app1            0x103                   // symbol # for app_symbol1
#define app2            0x104                   // symbol # for app_symbol2

#define phased2         72.2                    // square of divisor determining unit phase step

// NOTE: the #defines below specify where the phase change patterns for the indicated cases must be stored

#define no_mod          NUM_GF_EL_1                      // symbol # for no modulation
#define frame1          (NUM_GF_EL_1+1)                  // symbol # for frame 1 symbol
#define frame2          (NUM_GF_EL_1+2)                  // symbol # for frame 2 symbol
#define frame3          (NUM_GF_EL_1+3)                  // symbol # for frame 3 symbol
#define frame4          (NUM_GF_EL_1+4)                  // symbol # for frame 3 symbol
#define frame1r         (NUM_GF_EL_1+5)                  // symbol # for frame 1 redundancy symbol
#define frame2r         (NUM_GF_EL_1+6)                  // symbol # for frame 2 redundancy symbol
#define frame3r         (NUM_GF_EL_1+7)                  // symbol # for frame 3 redundancy symbol
#define frame4r         (NUM_GF_EL_1+8)                  // symbol # for frame 3 redundancy symbol

#define id1x05          (NUM_GF_EL_1+9)                  // symbol # for mode_id1, ~10% redundancy symbols
#define id2x05          (NUM_GF_EL_1+10)                 // symbol # for mode_id2, ~10% redundancy symbols
#define id1x10          (NUM_GF_EL_1+11)                 // symbol # for mode_id1, ~20% redundancy symbols
#define id2x10          (NUM_GF_EL_1+12)                 // symbol # for mode_id2, ~20% redundancy symbols
#define id1x20          (NUM_GF_EL_1+13)                 // symbol # for mode_id1, ~40% redundancy symbols
#define id2x20          (NUM_GF_EL_1+14)                 // symbol # for mode_id2, ~40% redundancy symbols
#define id1x40          (NUM_GF_EL_1+15)                 // symbol # for mode_id1, ~70% redundancy symbols
#define id2x40          (NUM_GF_EL_1+16)                 // symbol # for mode_id2, ~70% redundancy symbols

#define lead_i          (NUM_GF_EL_1+17)                 // symbol # for leader information symbols
#define lead_r          (NUM_GF_EL_1+18)                 // symbol # for leader redundancy symbols


//---------------------------------------------------------------------------
#endif  // _SYS_DEF_
