//---------------------------------------------------------------------------
//
//    definitions used by Wyman digital communications programs
//
//    Copyright (C) 2002  Barry D. Sanderson
//    Copyright (C) 2002  Carl A. Harcourt
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//
//    Mailing addresses for the authors:
//
//    Barry D. Sanderson
//    1725 N. Bolton Ave.
//    Indianapolis, IN 46218  USA
//
//    Carl A. Harcourt
//    4937 W. 900 S.
//    Milroy, IN 46156  USA
//
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//
//    Rev 30 Aug 2002 (CAH) - version 2.0, for initial PC/DOS release
//                            Developed using MS Visual C++ 6.0
//                            as a 'Win32 Console Application', ie a DOS .exe program
//                            Requires a Win32 environment for proper DOS execution
//                            This version will also build and execute unmodified on a Linux system
//
//    Rev 25 Nov 2001 (BDS) - version 1.1.0, for initial public release
//
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// application include files

#include "Wcommon.h"
#include "code_def.h"

//---------------------------------------------------------------------------
// variable declarations

int rgm1xx [num_modes] [k40] [MAX_GF_EL_1-k05] =
{

//-----------------------------------------------------------------------------------------------
//  Redundancy generating matrix for (306,274) Reed-Solomon code
//-----------------------------------------------------------------------------------------------

{
{ 149, 202,  71,  81,  54, 258, 252, 288, 296, 291, 211,  20,  25, 181,  56, 303, 246, 228, 105,
   11, 143, 276,  19, 260, 296,  61, 122,  62, 193, 294, 152, 270,  40, 260,  10, 102,  74, 301,
  138, 199, 109, 203,  25, 185, 138,  13,   2, 174,  34, 289,  13, 120, 112,  82, 170,  75, 276,
  299,  50, 112,  16, 233, 107, 207,  38, 182,  46,  22, 276,   6,  15,  12, 104, 143, 117,  83,
   85, 111, 213,  25, 189, 191,  97,  60, 153, 201, 272, 162,  60, 275, 133,  46,  19, 243, 263,
   78, 191, 157,  97, 239,  35, 203,  87, 108, 271, 164,  26,  41, 274, 289, 146, 196, 145,  23,
  143, 176,  37, 244, 206,  20, 241,  49,   9, 293, 119, 260,  96, 109, 226,  95, 182, 271, 294,
  172, 226, 202,  78, 208, 302, 162, 272, 131, 111, 211,   3, 267,   9, 219,  34,  41, 265, 215,
  202, 240,  40,  95,  77, 124, 111,  37, 110, 189, 226, 222, 247, 269,  74, 191, 137, 251, 153,
  301, 224, 263, 295,  12, 231, 261, 261,  88,  49, 301, 108,  69, 123, 153,  73, 194,  35, 190,
    8, 156,  35,  25, 110,  62, 122, 217, 201, 284,  89, 213, 106, 140, 221, 199, 224, 111, 188,
   68, 149, 195, 282,  37,  32,  25,  65, 103,  92, 207,  88, 195, 245, 178, 148,  64,   6, 130,
  114, 106, 293, 213,  84, 268, 297, 273,  65,  38, 135, 102, 267, 169, 203,  45,   1, 170, 295,
   87, 157, 300, 156,  41, 210, 191, 276, 104,  48, 162, 238,   3, 168, 284, 279, 151, 259,  32,
  219, 301,  21, 221,  72, 182,  82,  57
,},
{ 204, 304, 258,  83,  89,  24, 193,  90, 275, 305,  38, 123, 217, 211, 303, 135, 203,  41,  73,
  118, 180, 218, 131, 103, 247,  89, 261, 279,  11,  66,  55, 192,  94, 124, 216, 298,  22,  39,
  185, 122, 272,  14,  93, 132,  69, 265, 127,  96, 270, 236, 109,  99,  57, 181, 255, 147, 150,
  127,  79, 294, 103,  96, 192, 240, 224, 281,  41,  72,  97,   4, 247,  85, 107, 273,  58, 243,
   16, 272, 279, 103,  53,  24, 194, 140, 185, 251,  48, 296, 205,  78, 181, 299, 208,  55, 191,
  104, 220, 237, 160, 212,  85, 247, 250, 103, 205, 102, 111, 214,   2, 169,  15, 266, 172, 228,
  192,  44, 136, 130,  13, 118, 249, 271, 255, 132,  15, 203, 206, 169,  97, 115,  31, 279, 144,
  274, 160,  74,  43, 268, 230,  19,   9,  64,  11, 165,  75, 179, 166, 212,   8, 222, 103, 240,
   63,  67,  64, 236, 186,  84,   4,  71, 167, 138, 177, 293, 179, 230, 189, 216,  18,  15,  69,
  118, 175, 172, 193,  58, 285,  65,  95,  58, 118,  14,  10,  50,  19, 248,  16,  79,  40, 120,
   32, 304,   2, 232, 155, 267, 262, 211,   8, 118, 138, 257, 115, 104, 150, 205,  73, 104,  82,
   73, 272, 212, 305, 242,  19, 229,  46, 103, 128, 225,   4, 151,  38, 260,  18, 112,  99,  48,
  181,  16, 229, 154,  89,  10,   5, 201, 294,  82,  58, 116, 278,  76,  74,   5, 102, 174, 100,
   35, 133,  65, 289,  37,  38,  45, 266,  64,  77,  72, 220, 102,  62,  85, 223, 290, 178, 241,
  235, 184, 270,  31,  27,   8, 251, 261
,},
{ 207, 122, 108, 216,  55, 194,  98, 146, 289,  90, 116,  39, 201, 180,  91, 180, 178, 153, 123,
  181, 294,  71, 265, 144, 302, 204,   3, 172, 304, 302, 135, 222, 194, 107, 278, 129, 271, 298,
  138, 241,  20, 144,  92, 179, 231,  85, 173, 105,  67, 177, 252, 115, 166, 276,  36, 182,  38,
  211, 283, 146, 172, 130,  86, 187,  27, 141,   7, 257, 270, 128, 235,   2, 213, 283, 110, 231,
   17, 129, 298,  50,   5, 170, 167, 197, 163, 149,  19, 271, 299, 142, 100, 214,  39,  82, 237,
  287, 221,  59,  73, 218, 137, 264, 236, 194, 224,  29, 134,  67, 197, 216, 207, 209,  43,  35,
   97,  78, 184, 271, 171,  14,  84, 144, 164, 285, 184,  28,  85, 104, 211,  25,  32, 152, 263,
  214,   9,  78, 170, 299, 191, 146,  94, 123, 177, 129,  27,  73,  72, 223, 183, 271,   5,  37,
  158,  75,  69, 299,  71,   8, 197, 144, 230,  69, 180,  96, 290,  85, 203, 306,  54, 138,  38,
   38, 252,  50, 110, 255, 177, 252,  32,  38, 260,  87, 265, 213, 225,  42, 267, 302,   4, 203,
   59, 224, 229,  80,  84,  66, 181, 104, 175, 145,  15, 164, 293, 122,  69, 206,  32, 186,  52,
   24, 280, 205, 134, 138, 305,  97,   2, 220, 169, 123, 168, 244, 240, 139, 206, 144, 143, 259,
   23, 217,  46, 255, 281,  41, 163,  34, 281,  81,  12, 278, 114, 179, 255, 153, 266, 264, 112,
   89, 181, 148, 257, 245, 201, 155, 243,  87,   5, 300, 176,  82,  49, 199, 145,  31,  42, 241,
  298, 204, 139, 235,  96, 251, 227,  85
,},
{  78, 185,  17, 239, 201, 188, 124,  18, 132, 157, 219, 281,  15, 236,  28,  58, 214, 217, 175,
  137,  56, 115, 151, 261, 130, 268, 136,  54, 306, 120,  21,  60, 245, 190,  36,  45, 279,  68,
   55, 168, 296,  83, 120, 160, 243, 108, 255, 227, 232,  72,  54,  14, 118,  75, 297, 271,   3,
  279, 163, 286, 278,  22,  15, 182,  40, 147,  60,  35,  78, 166, 175,  27, 246,  88,  97, 104,
   88, 242, 121, 274, 151, 276, 126,  48,   1,  56, 244, 281, 152,  35,  88,  19, 294, 125,  26,
  113, 251,  58,  15, 126, 123, 200, 291, 206, 204,  42,  90, 242,  25, 202,  39, 289, 254, 156,
  217,  14, 153,  48, 282,  29, 237, 258, 295, 202, 269, 180, 206, 140, 280, 304, 145,  42, 275,
  147,  83, 294, 261,  44, 181, 146, 241, 177,  41, 306,  77,   4, 224, 267,  43, 291,  78, 167,
   15, 296,  98, 162,  90, 173, 233, 272, 284,  24, 245,  16, 215, 130, 235, 167, 285, 206, 249,
  142,  44, 196, 258, 209, 242, 258,  26, 144, 212,  57,  57, 297, 230,  29, 107, 179, 207, 190,
  269, 118, 129, 205, 220, 135, 305, 206, 304,  62,  35,   7, 271, 220, 180,  99, 212, 257, 202,
  306, 102, 277, 229, 209,  95, 281,  96, 161,  58, 265, 235, 165, 193,  20, 132, 120,  40, 141,
  125, 130, 255,  38,  27,  36, 112,  36,  33, 134, 197,  86, 255,  50, 242,  89, 238, 287, 165,
  139, 233, 200, 207,  58, 289, 165, 283, 180, 176, 267, 268, 124, 240, 243, 275,  86, 249, 306,
  129,  95, 147, 197, 215, 216, 160, 160
,},
{ 201, 163, 186,  83, 283,  36, 291, 154, 100,  28, 147,  42, 290, 117, 293,   2, 122, 161, 132,
   93, 299,   8,  85, 306,  36,  66, 140, 232, 234,  68, 187, 241,  13,  93, 255,  85, 219, 240,
   44, 274, 109, 234,  92, 248, 136, 174, 121, 158, 141, 115,   3, 220, 128,  37, 259,  17, 223,
  258, 297, 277,  83, 104, 257, 286, 122, 302, 139, 203, 294, 117, 110, 253,  89, 101,  81, 176,
  196,  42, 245, 130, 121,  11, 139, 209, 275, 233, 289,  69,  57, 251, 132,  80, 296, 185, 146,
  226, 280, 197, 228, 187, 200,  61, 305,  72, 279,  42, 211, 203, 181, 215, 230,  85, 157, 250,
   11, 133, 101, 204, 159, 105, 214,  95, 163, 204, 208, 117, 190, 147,  74, 130, 259, 218, 111,
  165,  81, 168, 187,  78, 165,   6,  72,  18, 131,  31, 172, 124, 216, 266, 181, 156,  18,  94,
  252,  40, 249, 255, 202, 282, 127,  13,  66, 131, 265, 153, 240, 275, 304,  95, 290, 228, 126,
  210,  63,  65, 118,  29,  22, 250, 266, 291,   2, 173, 145,  45,  22, 150,  43, 140, 253, 214,
  242,  55, 192, 138, 306,   9,   7,  27, 131,   1, 180,  38,  82, 260, 275,  92,  20, 166, 251,
   30, 200, 295, 268,   9, 110, 104, 243, 305, 145,  22, 223, 121,  69, 122,  61, 241, 159, 271,
  268, 200,  39, 258, 277, 234, 278, 198, 305, 280, 244, 246, 133, 279, 295,  74, 249, 115, 209,
  270,  85,  34, 293,  13, 195, 149, 117,  38, 185,   1, 279, 134, 295, 244,  61, 182,  81, 150,
   41,  90,  78, 202,  51, 170, 135,  70
,},
{ 299, 219, 221,  23, 179, 230, 177, 189, 305, 208,  62,  12, 257,  66,  46,  13,  30, 118, 143,
  288, 279, 278, 110, 172, 150,   8,  10, 182, 234, 245, 270,  53, 278, 100, 179,  27,  46, 106,
   76, 159, 229, 197, 142, 148,  84, 125,   7,  21,  82, 109, 104, 114,  78,  35, 271, 290, 303,
  277,  74, 155, 169, 122, 226,  11, 183, 275, 145, 144, 182, 100, 246,  29, 165, 275,   2,  58,
  293, 291, 216, 153, 159, 290,  47,  41, 174, 223, 239, 270, 278, 273,  44, 282, 182, 114, 175,
   80,  88, 218, 233,  73, 181, 288,  11, 190,   8,  93,  20,  11,  42, 149, 304, 135, 104, 232,
  129,  51, 267, 296, 195,  24,  90, 267, 111, 104, 245, 295,  83, 145,   3, 277, 283, 195, 229,
  178,  21,  99, 102,  11,  35, 146,  12,  32, 113, 165, 241, 135, 140, 196, 190, 288, 286,  25,
  112, 167,  77, 145, 119, 286,  70, 261,  38,  95, 294, 148, 251,  36, 236, 166, 168,  54, 193,
   13, 233,  53, 146,  37, 235, 179, 100, 286,  37, 196,  58,  63,  59, 294,  41, 115, 134,  45,
  160, 110,  49, 100, 163,  41, 260, 154, 282,  56,  91,  47,  90,  58,  73,  83, 115, 115, 125,
   99,  22,  35,  80,  95, 100,  18,  49,  85, 298, 206,  42,  58,  79, 249,  44, 243,  47,  49,
  269,  13, 141, 213, 305,   3, 148,  47, 143, 202, 213,  16, 209, 297,  60,  68, 144, 176, 196,
  159, 208, 209, 209,  93, 284,  57, 128,  29,  21, 166,  83, 182, 228, 220, 126, 193, 199, 172,
  130, 235,  25, 198,  23, 204,  77, 134
,},
{  11,  44, 216,  23, 198,  60, 228,  87, 250,   3, 238, 286, 292, 258, 202, 124, 128, 189,  66,
   82, 109, 116,  61, 259, 233,  35,  85,  29, 256,  27,  44, 224, 194, 120, 212,  32, 119, 163,
  178,  33,  29, 108, 170,  65, 220, 291,  86, 298, 279, 126,   9, 220,  79,  14,  97, 190, 127,
  152, 223,  39, 150,  77,  31,  27, 191,  11, 299,  23, 288,  65, 268,  12, 150, 293, 296,  72,
   89, 124, 282, 189, 305, 272,  87, 105, 281,  92, 138, 150,  21, 288, 289,  68,  65, 202,  51,
  189, 193, 250,  15,  24, 158,  60, 280,  54, 278, 187, 200, 295, 194,  86,  65, 166, 224, 116,
   53,  74,  97, 114, 270, 112,  83, 209, 245,  77,  86,  87, 265, 260,  36, 146, 105,  64, 295,
  252,  69,  73, 113,  37, 262, 253,  61,  67, 170, 143, 260, 100, 113,  14, 147, 158, 186, 238,
   77,  37,   1, 220,  25, 157, 117, 116, 265, 190, 293, 263,  90,  71, 128,  42, 104,  32, 294,
    3, 250, 170, 287, 219, 291, 211, 155, 226,  98, 154, 239,  94, 274, 299, 252, 249, 200, 113,
  196, 188, 195,  22, 104, 182, 118, 173,  72, 270,   9,  82, 129, 123, 200,  30,  13, 253, 133,
   27, 110,  57,  62, 126,  85,  73, 132,  36, 133,  99,  25,  77,  39, 292, 126,  24, 126, 275,
  282,  44, 286, 132, 110, 298, 198, 197, 161,  16, 179,  66, 182, 137, 176, 257, 202, 206, 103,
  188,  14, 191, 237, 177, 296,  90, 201, 249,  14, 239, 130, 178, 283, 216, 152,  98, 208, 189,
   46, 247, 286, 167,  22, 158, 140,  40
,},
{ 127, 109, 121,  79,  34,  80,   9,  82, 261, 224, 154, 117,  58, 164,  42,  42, 140,  38,  91,
  199, 276,  97, 262,  23, 126, 217,   3, 109,  74,  43, 274,  99, 289, 156, 213, 301, 229, 186,
  157, 156,  95, 167, 187, 202,  59, 126,  64, 292, 123, 173,  32, 204,  95, 289,  60,  27, 178,
  114,   3,  98,  65, 260,  59,  22,  12, 103,   9, 258,  11, 221,  51, 134, 181,  37,  61, 239,
   95, 231,  48,  54,  74, 270, 161,  31,  85,  32, 227, 171,  94, 276,  82, 287, 214, 268, 284,
  101, 154,  26, 139,  58, 196, 296, 163, 302, 149,  84, 306, 305, 203,  88,  93, 230, 133, 223,
    3,  32,  19,  33,  65, 149, 235, 201, 262, 299, 232,  48, 243,  20,  90, 152,  58, 200, 158,
  114,  82, 167, 123, 144, 144, 295,  81,  82, 209,  14, 263, 195, 153, 277, 146, 252,  13, 190,
   29, 160, 102, 117, 230,  73, 299,  62, 218, 150,  20, 270,  12, 105, 268,  93, 303,  13,  12,
   54,  60,  25, 304, 153, 249, 293, 213, 298,  37, 165, 176, 236, 102, 254, 149,  30, 114, 125,
  126, 296,  53, 274, 124, 128, 150, 202, 231,  73, 146, 240,  24, 203,  60, 178,  87, 155,  98,
   90, 154, 235, 285,   7, 178, 164, 217, 261,  32, 124, 242, 150,  53,  98,  72, 230, 264, 107,
  230, 224,  98, 210, 115,  85, 205,  66,  34, 146, 197, 268,   1, 188, 275, 134, 297, 248,  33,
  206,  21,  41, 291,  35, 288, 261,  78,  63,  20,  47, 242, 250, 144, 284,  17,  52,  20, 260,
   46, 113, 166, 223, 284, 241,  61, 271
,},
{ 162, 223,   9, 275, 284, 263, 218,  79, 171, 223, 303,  48, 138, 296, 297, 186,  89, 221, 249,
    2, 270, 164,  27, 112, 112,  79, 123, 227, 222, 235,  97,  71, 194, 139, 103, 225,  93, 138,
  130,  54, 223, 155, 188, 281, 146, 205,  54, 247, 296, 157,  12,  10, 163, 213,   2, 123, 222,
  159, 156, 269, 136, 273,  92, 282, 189, 214, 289, 138, 146, 102, 295, 233,  74, 252, 123, 143,
  249,  90, 238,  69,   4, 259, 155, 150,  49, 217,  64, 228, 160,  18,  93, 268, 217,  62,  10,
  239, 286,  28, 218, 131,  26, 256, 234, 266,  63,  78,  69,  58, 265, 237,  51,  98, 229, 226,
  294, 114, 235, 138, 292, 266,  69,   6, 184, 152,   6,  82, 276,   3, 173,  47,  47, 126,  54,
  106, 267, 178, 122,   3,  17, 145,  20, 277,  77, 288, 213, 168, 178, 251, 281, 205, 229, 255,
  286, 292, 255,  59, 108,  64,  68, 195,  93, 168, 303,  10, 281, 152, 204, 146,  73, 170,  31,
  228, 279, 109, 150, 179, 126,  63, 107, 115,  69, 253, 268, 148, 106, 120,  82, 226, 305,  28,
  144,  36, 264,  74, 305,  41,  34,  13,  27, 138, 246, 153, 108, 203, 229, 264,  96,  82, 141,
  106, 252, 195, 214, 181,  83, 199, 280, 193,  19, 255,  26, 283, 233,  92, 296, 224,  14, 189,
  301,  98, 114, 105, 256, 291, 138, 201, 182, 201, 198, 209, 173,  57, 248, 190,  98,  10,  66,
  278,  80, 273, 258,  43, 150, 166, 149,  18, 177,  21,  75, 134,  35,  51,  64, 107, 245,  96,
   51, 262, 278, 192,  87, 179,  52, 158
,},
{ 210, 150,  82, 220, 211, 217, 169, 286, 183,  99,  98,  86,   7, 185, 241, 279,  65, 194, 233,
  145, 185, 284,  96, 276, 216, 233,  14,  95,  21,  10, 305,  84, 251, 136, 184, 255, 251,  66,
  145, 258,  84,  62, 114, 253, 288,  51, 214, 223,  93, 215,  62, 245, 207, 225,  57, 186, 137,
  186,  77,  46,  34, 110, 294, 256, 146,  87, 114,  81, 152, 173,  16,  42,  87, 257,  11,  36,
   65, 288, 281, 197, 152,  96, 235, 118,  71, 186, 213, 179, 191,  16, 156, 300, 200, 236, 171,
   54,  24, 225,   4, 219, 135, 172, 187, 106, 104, 187, 195, 100,  63, 184, 280,  12, 290, 179,
  102, 165, 127, 105, 144,  75, 276, 136, 200, 121, 227, 255, 207, 306,  99, 140, 252, 192, 221,
  214, 202, 255, 222, 137, 134, 132, 141, 149,   9, 259, 148,  33,  55,  89,  97,   5,  16, 122,
  243, 138, 165, 222, 252,  52, 103,  81,  76, 176, 264,  74,  47, 110, 178, 296, 302, 128,  91,
    4,   8,  81,  55, 204, 144, 226, 163, 196, 182,  42, 125, 118, 241,  27, 295,  34, 230, 239,
   64, 232,  40, 223, 262, 277, 283, 243, 150,  77,  78, 130,  16, 124, 123,  50,  44, 135,   7,
  140,   9,  55, 236, 227,  18,  42,  31, 283, 300, 183,  37, 136,   4, 113, 144, 277, 251, 292,
   88, 164,  35, 305, 176, 234, 246, 292,  33,  46,  41,  43,  29, 166, 203, 297,  41, 249, 263,
  304, 217, 202,  54, 289,  67, 242, 180,   3, 234, 292, 171, 242, 276,  85, 232, 283, 198,  82,
    7,  24, 203, 198, 209, 292, 241, 155
,},
{  70, 206, 103,  50, 301, 291, 288, 294, 116, 159, 262, 128, 277, 125, 269, 235,  34, 100, 198,
   96, 206, 292, 159, 179, 106, 154, 109, 107, 231, 155, 238,  96, 144,  27, 151,  30,  59, 242,
  273, 290, 268, 235, 253, 238, 153, 154,  54, 168, 274,  66,  81, 242, 106,  23, 173,  16, 293,
  125, 261, 245,  70, 230, 117, 144,   6, 112, 156, 147, 188, 161,  42,  34, 198, 148, 279, 289,
   10,  78, 147, 165,  20, 285,  88,  18, 194, 219, 287, 149, 269, 143,  62, 225, 175, 104, 170,
  288, 187, 106, 217, 209, 118, 286, 149,  42,  52,  43, 226, 103, 204,  36,  96, 267,  76, 171,
  240,  59,  67, 186, 107, 174, 283, 196, 303, 179, 146,   3,  92, 217,  31,  88, 106, 198,  19,
  172, 246, 198,  65, 227, 283,  70, 233, 184, 162, 172, 110,  88, 200, 230, 140,   5, 249, 185,
  118, 296, 198, 154, 184, 131,  65,   5, 246, 206, 208, 290, 291, 297, 221,   4,  41, 218, 204,
   82,  33, 249,  63,  73,  90,  75, 157, 295, 116, 173, 204,  75, 149,  10, 290, 279, 240, 208,
  251, 298, 131, 231,  81,  48, 153, 148,  84, 269,  57, 244, 289, 226, 302, 268,  79,  57, 110,
  109, 210, 148, 171, 138, 275, 209, 293,  32, 114, 150,   8, 176,  43, 271,  28, 240, 286, 139,
  156, 247, 143, 201, 124, 271, 219, 195, 236,  90,  95, 194, 290, 129,  10, 117, 145, 296, 231,
  240,  79,  53, 129, 269, 297, 200,  42,  29,  75, 170,  35,  22, 187,  88,  43, 305, 211, 246,
  257, 305, 209,  74, 306, 175, 108, 173
,},
{ 296,  18, 209, 301, 182, 113, 293,  71, 233, 111, 129,  38, 155, 276, 296, 191, 120, 182, 152,
  259, 275,  62, 202,  10, 118, 221,  77,  90,  33, 131,  49, 284, 262, 302, 222, 298, 245, 249,
  170,   9, 113,  82, 262,  23, 166, 253, 193,  70, 217, 230, 166, 272, 277, 170, 268, 254, 179,
  137, 179, 296, 250, 162,  14,   9, 271, 178,  88, 278,   3, 305, 300, 276, 220,  70, 127, 209,
  258, 179,  87, 174,  13, 214, 181,  30,  85, 276, 304,  69,  91, 259, 127,  38, 135, 155, 167,
  156, 175,  25,   2, 119, 124, 239, 294, 106, 261, 180, 243, 258, 227, 160, 120, 234, 178,  64,
   43, 295,  13, 220, 212, 190, 115, 164, 218,  30, 197, 304,  33, 222,  19, 195, 260,  18,  98,
  303, 281, 194, 184, 130, 283,  65, 155, 178,  46, 132,  77, 251, 110,  19, 279, 172, 107, 297,
  133, 193, 155,  55, 274, 146, 300,  19,   1,  94,   8, 239,  41, 164, 205, 108,  66, 177, 285,
   87, 152,  96,  15, 297, 126, 114,  99,  31, 176, 306, 130, 168, 171, 216,  52,  82, 194, 261,
   57, 223, 213, 158, 227,  62, 278, 240, 230,  96,   9,  66, 162, 256,  84,  38,  31, 248,  39,
  208,  98, 175, 121, 125, 148, 302,  95, 306, 291,   6,  24, 280, 195, 137,  87,  48,  50,  58,
  213,  74, 281, 152, 304, 131,  76, 170,  81,  56, 113, 242,  28,  55, 250, 120, 290,  83,  62,
  239,  78,  96,  25, 161,  66, 184,  56, 228,  44, 164, 206, 247, 228, 199, 156,  71, 290, 221,
   65, 140, 254,  67, 250, 171, 239, 145
,},
{ 115, 114, 182, 288, 149, 138, 120, 301,  11,  62,   6, 266, 286, 305, 107,  23, 249,  24,  57,
  212, 118,  78,  54, 141, 257,  60, 105, 164, 138, 297,  67, 210, 251, 201, 217, 276, 283, 296,
  304, 167, 157,  76,  23,  71,  78, 209, 236, 249,  88,  63, 273,  67, 241, 194, 260,  91,  57,
  247,  19, 148, 160, 265,  20, 250, 300, 259,  94, 208,  81, 259,  24, 198,   6,  79, 150, 189,
  254,  82,  57,  28, 256,  78, 157, 285, 111,  65, 113, 155, 173,  56, 203,  43,  30,  65, 222,
  118, 221, 222, 275, 273, 282,  87, 267, 297, 105,  95, 266,  48,  78,  73, 147, 296,  76, 136,
  230,  82, 134,  88,   4,  42, 137, 159, 241,  30,  93, 136, 102, 181, 143, 286, 183, 259, 282,
  171, 224,  99, 145, 258,  19, 134, 209, 116,   2, 248, 260, 110,  21, 244,  37,  84, 222, 275,
  115, 242, 160, 115, 168, 141, 277, 139,   5,  83,  15, 270, 135,  57, 149, 270,  18, 235, 258,
   29,  25, 219, 198, 220,  22, 210, 198, 272,  75, 227,   2,   4, 197, 252,  56, 245, 245, 114,
  193, 266,  79, 154, 144,   7, 253, 122, 220, 272, 107, 194,  86, 200,  66,  81, 283, 162, 185,
   75,  16, 129, 234, 267, 160,  89, 210, 294, 138, 220, 179,  55, 193, 217, 107, 157, 304, 173,
   10, 233, 193, 159,  52, 175, 216,  58,  78,  65, 290, 167, 275, 280,  18,  21, 265,  73, 185,
   90, 286, 291, 305, 137, 218, 131, 294,  93, 127, 202, 290,  27,  47, 270, 130, 254, 172,  18,
   48, 116, 115,  64,  69, 238,  88, 215
,},
{ 107, 258,  29,  98, 232,  52, 286,  26,  85, 255, 298,   8, 115, 212,  65, 168, 109, 149, 188,
  273, 257, 207, 172,  80, 232, 171, 195, 234, 214, 106, 128,  94, 214, 277, 202,  43, 222, 221,
  187, 109, 270, 208, 232, 195, 269, 110,  25, 192, 191, 209,  95, 285, 201,  65, 211, 114, 180,
  179, 252, 153, 211, 214, 245,  10, 131, 134,  18, 219, 297, 143, 107, 148, 147,  51,  60, 189,
   44, 173, 134, 213, 139, 183,  57, 163,  24,  39, 215, 252, 161,  47, 100, 269, 137,  85, 122,
  107,  45, 206, 201,  84, 123,  26,  65, 155, 232,  60, 159, 178,  14, 199, 149, 228, 157, 109,
  181,   2,  55,  97, 170,   6, 281, 234, 252, 301, 134, 119, 207, 205, 265, 306, 120, 118, 227,
  115, 255,  60, 291,  43, 104, 158, 284, 130,  35, 238, 279, 256, 203, 135, 186, 256, 264,  90,
  111, 139, 246,  16,  92, 119,  60, 250, 150, 116, 167, 160, 264, 254,   3,  76, 253, 258, 281,
  196, 297,  82,  95,  15, 151, 263, 144,  84,  62,  13, 115, 101,  47, 243, 290,  14,  95, 264,
  299, 270, 116, 235, 165, 273, 142, 244,  50, 187,  66, 159, 266, 100, 130, 178,  42, 202,  58,
   69, 182, 189, 280, 207,  86,   9, 249, 251, 119, 128, 106,  45, 233,  88, 109,  52, 219,  10,
  123,  82, 293, 245, 106, 263, 174, 274, 218, 266, 232, 116, 163,  77,  24, 176, 236, 282, 256,
  163,  75,   9,  61, 217, 158, 145, 220, 243, 282, 266, 103,  14, 228,  14,  83,  53,  65, 298,
  132, 293,  26,  45, 194, 210,  62,  63
,},
{ 177, 246, 126, 220, 123, 215, 271,  10, 254, 305,  40,  23,  48, 159,  56, 120,   9,  44,  10,
  267,  72, 146, 176, 281,   1,  84, 182, 110, 113,   9, 165, 253, 158,  16, 293, 181, 100, 151,
   12, 137, 222, 165, 248, 221, 293, 167, 236, 242, 185, 285, 107, 287, 280, 148,  30,  24,   3,
  290, 259, 247, 240, 154, 201,  85, 255, 238, 269, 176, 108,  61, 167, 249, 253, 253,  54,  70,
   18, 283,  84, 174, 147, 199, 154, 153, 285, 100, 290, 290,  41, 294, 137, 235, 238,  96,  76,
  124, 167, 112, 177, 215, 140,  18, 288, 115,  36, 126, 163, 286, 248, 108, 187, 217, 153,  71,
  215, 217, 184,  77, 181, 202, 146, 298, 187, 291, 123, 243,  27,  13,  14, 110, 106,   1, 220,
   11, 231,  87,  62, 194,  35, 179, 102, 248,  62, 127, 120, 215, 209, 185, 128,   6,  66, 301,
  229, 188, 203,  91, 262, 229,  51, 242, 119,  84, 232,  31,  64,  19,   4,  63, 111, 102,  73,
  210, 186, 288, 247, 237, 139,  16, 128, 162, 101, 298,  63, 164, 175, 169, 237, 232,  70,  92,
  154, 303,  19, 156, 104,  80, 284, 305,  13, 136, 268, 284,  83, 183, 208,  80, 168, 281,  73,
   44, 246, 187, 149, 155,  74, 126, 113, 291, 214, 266, 146, 111, 130,  88, 202, 150, 123, 120,
  131,  47, 121, 204,  11, 105, 247, 181,  71, 156, 175, 211,  52,  65, 279,  96, 239, 201, 140,
  211, 230, 248,  13, 188, 246, 218,  34,  18, 197,  50, 217, 292, 160,   7,  92,  79,  99, 239,
  280,  61,  81, 134, 283, 301, 157, 276
,},
{ 293,  55, 194,  71,  81, 107,  78, 246,  44, 136, 211,  34, 169, 270, 265, 180, 169,   2, 166,
  283, 132, 112, 171,  98,   8, 259, 293, 102, 267, 209, 209,  84, 241,  80,  13, 201,  36, 286,
  171, 290, 135,  69,   4,  39, 241, 197, 105,  61, 109, 129, 189,  71, 192, 194,  97, 161,  64,
  251, 275, 164,  58,  78, 214, 231, 135, 139,  40, 201, 216, 229, 210, 102,  95, 118,   3, 244,
  198, 261, 127, 230, 148,  59, 262, 136,  15, 194, 264, 180, 272, 112, 162, 246, 260,  73, 232,
  114,  36, 212, 175, 136,  51, 294,  84,  10,   3, 171, 241, 120,  81, 192, 187, 251,  20,  54,
  243, 285, 298, 295, 138, 175,  99, 162,  19,   7, 286,  45,  30,  25,  68, 139, 301, 301,  97,
  107,  66, 109, 125,  61,  42, 232,  36,  32, 184, 275,  34, 132, 243, 174,  52,  85,  80, 155,
  179, 157, 176,  21, 160, 102, 165, 132, 209,  93, 139, 104,  49,  14, 181, 223, 114,   5, 271,
  259,  20,  15,  46, 182, 137,  30, 214, 163, 178, 287,  20,  73,  35,  37,  55,  56,  68,  13,
  151, 230, 139, 165, 123,  24, 289,   4, 214, 112, 140, 112,  68,  41,  86, 179, 197, 104, 286,
  114,  30,  34,  41, 230,  84, 220, 260, 297, 202, 244, 301, 241, 191, 138, 105,  60, 271,  84,
  270, 222, 174, 272,  56, 299, 108,  73,   8, 121, 269,  83, 223,  32, 219, 112,  65, 188, 266,
  206, 256, 140,  17, 277, 125, 158, 258, 187,  65,  87,  40, 124, 303, 259, 261,  16,  32,  28,
  204, 159,  24, 291,  51, 167, 215, 232
,},
{ 184, 186, 256, 259,  12,  72, 241, 275, 150,  16, 275, 246,   1, 102,  61, 258, 150, 261, 109,
  262, 303,   1, 222,  12,   2,  38,  12, 248,  56,  14, 168, 221, 154,  82, 251,  38, 177, 179,
   67, 289,  97, 260,  36, 251, 127, 187,  47, 256, 274, 231,  75,  92, 267, 182,  31, 305,  30,
   50, 185, 164, 192,  82,  35,  39, 144, 300,  66, 232,  70,  73,  25, 231, 284, 115, 246, 225,
    9, 162, 250,  94, 177, 252, 152,  60,  20, 290,  56,  87, 285, 216, 268,  89,  49, 148, 303,
  215, 218, 234, 305,  56, 274, 176, 216, 273, 254, 290,  63, 236, 139, 203, 294, 223, 121, 137,
   74, 244, 273, 111, 195, 173, 213, 108, 101, 148, 292, 127, 213, 144, 267,   4, 304, 238,  48,
   91,  42, 266,  92, 182, 129, 172,  94,  35, 303,  16,  50, 271,  71,  89,  80,  47, 165, 226,
   48, 292, 227, 112,  79,  70,  66, 153, 171, 156,  28,  67, 306, 136, 297, 285,  79,  16, 196,
  107,  37, 250, 301,  67,  49, 210, 103,  61, 172,  14, 169,  64,  58, 226,  88, 241, 194, 247,
   27, 117,  61, 106, 204,  78,  84, 285, 279,  97, 191, 129, 144,   6,  44, 204, 264, 161, 126,
   98, 298, 141,  67,  29, 286,  51, 257, 210, 151,  27,  91, 105, 286,  42,  90, 217, 224,  38,
  130, 302,  44, 163, 112, 218, 128, 202, 110, 228, 127, 294,  13, 135, 157, 221,  37, 209, 167,
  188,  97, 167, 106,  12, 184, 229,  27, 133, 271, 195,  43, 122, 111, 186, 210, 295, 239,  88,
  181,  40, 119,  27, 110, 216, 157, 238
,},
{ 157,  61, 199, 193, 217,  16, 183,  17, 113,  26, 193, 123,  56,  99, 229,  30, 169,  75,  77,
  271, 219, 293, 225,  88, 157,  91, 216,  32, 132,  32, 271, 265, 224,  20,   6, 274, 151, 284,
  174, 151, 136, 212,  70, 165, 246, 151,  49,  14,  59, 288, 255,  84,  39, 135, 118,  75, 295,
  275, 284, 132, 288,  79,  67, 181, 180, 173, 196,  83, 222, 270, 266, 118, 116, 241,  24,  45,
  193,  25, 201,  60, 254, 199,   6,   3, 248, 273, 249, 237, 245,  37, 249, 164,   6, 167, 114,
  140, 237, 130, 295,  85,  97,  82,   6, 132, 301, 297,  31, 304,  57, 153, 260, 278,  42,  69,
   94, 210, 147,  15,  19,  43, 122, 209, 101, 146, 226, 158, 257,  60, 207, 159,  33,  25, 214,
  153, 154, 226, 103, 169, 220,   3, 131, 265,  51, 173, 116,  47, 264,   3, 199,  14, 182,  66,
  103,  66, 295, 119,  18, 119,  86, 276, 238,  24, 219,  60, 216, 165, 249,  12,  42, 259, 204,
  303,   1,   3, 157,  87,  92, 153,   7, 171,  57, 279, 237,  13, 173, 246, 101, 210, 282, 285,
    2,   8, 158, 178, 191, 224, 256, 154, 231,  24,  96, 230, 183,   1, 107, 128,  98, 280,  83,
   39, 255,  44,  24, 277, 277,  96, 171, 211,   2, 297,  95, 144,  85, 284, 268, 279, 110, 157,
  154, 184,  40,  83, 200,  40, 294,  18,  15, 251, 123, 150, 291,  18, 250, 122, 152, 280, 116,
  304, 100, 273, 148,  40, 258, 206, 219, 219, 198, 145,  44, 143, 196, 163, 276, 229, 230, 180,
   20, 288, 126, 220, 278, 139,  84, 215
,},
{ 107, 300, 283, 115, 137, 120, 164,  89, 108,  50, 262, 195, 279, 289, 166, 290, 116,  69, 239,
  293,   9,   1,  80, 251, 179,  71, 226,  38,  82, 100, 170, 298, 269, 250,  21, 139, 220,  89,
  175, 286, 254, 187,  61, 242,  56, 278, 274,   5, 263, 180,  13, 267, 218, 170, 152, 279, 164,
  110, 280, 111, 195,  35,  59,  57,  62,  14, 239,  14, 172, 284, 118,  83,  67, 161, 222,  63,
  207, 112,  77,  50, 171, 181, 178,  12,  49, 176, 116,  81, 243, 119,  81,   8, 258,  61, 224,
  306,  67, 222, 109, 104, 242, 148,  60, 201,  67, 256,  54, 250, 270, 178, 229,  34, 139,  75,
  114, 173, 183, 110,  97,  21, 282, 219, 302, 161, 250, 252, 229,  53, 144,  63, 300, 275, 300,
   47, 237, 297, 111,   1,  15,  52, 153,  52, 184, 287, 204, 112, 140,  71, 252, 111, 194,  50,
  209, 127,  70, 151,  96, 276,  38,  59, 287,  42, 108,  57,  54,  28, 111, 176, 302, 282, 305,
  142, 264,  58, 186, 281,  18,  26,  87, 200, 268, 302, 167,  29,  56, 219, 284,  59,  60, 301,
  163,  79, 165,   7, 189,  13,  52, 247,  82, 198, 125, 148, 302, 197, 238, 219,  89,  17, 176,
  274, 146, 121, 195, 304,  96, 126, 256, 212,  36, 299, 183, 268,  15, 287, 176, 213,  34, 123,
  107, 226, 244,  92,  30, 104,  39,  45, 178, 203, 111, 256, 146,  93,  69, 101,  30, 169, 156,
   94, 289, 130,  43,  60,  61, 185, 295, 168, 101,  30,  46,  75,  37, 163, 283, 199,  40,  49,
  294, 265, 198,  56,  43, 112, 270,  59
,},
{ 195,  52, 191, 150, 231,   9, 252, 271,  54,  85, 219, 214, 135, 213, 216, 237,  68,  60, 124,
  274, 134,  22, 201,  70, 216,  94, 208, 200,  66, 236, 165, 136, 202, 259, 226, 206, 207, 173,
  249, 250, 270, 258, 127, 231,  95, 209,  89, 102, 169, 122,  26,  32, 121, 144,  69, 279, 292,
  306, 297, 134, 134, 127, 208, 299, 150,  55, 272,   2,  27, 219, 248, 212,  79, 215,   3, 207,
  166,   2,  92,  17, 149,  81,  71,  34, 136, 242, 260, 157, 244, 197, 291,  32, 208, 166, 228,
  221, 216, 120, 112,  88,  20, 246,  62, 292, 226, 226, 255,  17, 145, 129, 196, 127, 300, 268,
  223,  60, 207, 150, 291,  49, 118, 103, 136,  90, 121, 240,  83, 213, 186, 223,  56,  18, 122,
   10, 180, 182, 294, 103,  13,  56, 136, 207, 154,  46, 157, 300,  29, 167, 235, 215,  89, 292,
  302, 247,  31, 149,  89,  44,  71,  72, 102,  79, 175,   5, 201, 268,  96,  21, 277,  68,  99,
  258, 157, 124, 271, 280,  95,  67,  75,  60,  21, 221, 227, 247, 225, 180, 228,  64, 282, 218,
  159, 157, 302, 105,  50, 163, 150, 268, 133, 260, 230, 105, 262, 273,  35,   6, 234, 191,  57,
  197, 162, 292, 181, 229,  43,  36, 277, 193, 114, 276, 272,  22, 294,  79, 116, 268, 260,  29,
   95, 221,  14, 224, 136, 185, 128, 182, 196, 271, 186, 296,  45, 293,  97, 268, 160, 236,  75,
   70, 147, 183, 124,   6, 170, 278, 198, 291, 237, 142, 257, 223, 163, 215,  46, 289, 130,  86,
   76, 247, 276,  36,   6,  36,  38, 256
,},
{  76,  24, 115,  51, 159, 274,  51, 300, 218, 256,  69, 120, 167, 114, 120, 113, 278, 106, 231,
  177,  42, 180, 281, 142,  17, 175,  12, 116, 181, 115, 159, 210, 245, 143,  56, 243, 116, 206,
  196, 231, 217,  48, 211, 209, 254,  46, 107, 118, 210, 166,  73,  46, 153, 237,  70, 235,  18,
   86, 212, 111, 239, 224, 196,  89, 203,  78, 165,  71,  48,  28,  68, 250, 127, 154,  81,  68,
  170,  31, 191,  45, 202, 232,  46,  81, 213,  16, 185, 287, 167,  34, 168,  94, 291,  95, 261,
  241, 304, 191,  85, 203, 145, 105, 107,  80, 286, 151, 128,   6, 165, 142,  51,  24, 100,  48,
   36, 150,  15,  43,  82, 192,  38,  75, 258, 236, 161,  62, 256,  50,  46, 253, 151,  50,  67,
  253, 150,   9, 195, 124,  51,  40, 306, 209,  72, 138, 200,  48, 148, 219, 275, 293, 208, 176,
  121,  35,  49,  98, 213, 212, 216,  26, 295, 287, 219, 212, 302, 297, 178, 179,  95,  63, 247,
   98, 193, 252, 122, 273, 165, 292, 264, 192,  17,  20, 239,  85, 114,  97, 141, 158, 121, 109,
  117, 185, 214, 255,  21, 265,  81, 135, 148,  78,  19, 112, 225, 183,  54,  17, 248,  99, 120,
  273, 273,  41,  32, 136, 132, 303,  98, 243, 106, 302,  86, 151, 114, 119, 206, 229, 269,  77,
   48, 215,  14, 203, 238, 283,  81,  20, 244, 100, 140, 203, 187,  22,  71, 258, 217,  86, 234,
  243,  45, 197, 209, 182,  41, 253,  17, 113, 299, 264, 284, 104, 251, 108, 108,  20, 281,  33,
  276,  75,  97,  57,  48, 241, 152, 201
,},
{ 170, 154, 173, 125, 160, 134, 271, 223, 238,  72, 301,  98, 233,  15,  11, 237, 132,  56,  28,
  293,  62, 258,   8,  44,  80, 305, 137, 194, 227,  24, 274,  90, 268,   8,   4, 296,  74, 138,
    7, 285,  36, 189, 161, 249,  10, 104, 141,  83, 198, 276,  16, 247, 147,  57,  23, 102, 144,
  252,   5,   6, 257, 101, 241,  51,  52, 252, 114, 289, 287,  26, 280,  24, 278,  12,  32, 186,
  268,  70, 171, 304, 273, 218,  81, 133, 134,  90,  42, 205,  67, 182,  58, 204, 229,  14, 154,
  282, 257, 240,  40, 232, 177, 117,  93,  18, 212,  94, 158,  80, 127, 231,  16, 151,   4, 118,
  240, 107, 219, 246,   4, 111, 127,  63,  42, 207, 209, 231,  17,  61,  40, 107, 302, 283, 200,
  255, 243, 228,  30, 251,  40,  71,  66, 235, 109, 117, 127, 142,  15, 266, 299, 227, 140, 136,
  254, 162,  93, 110, 225, 270, 112, 285,  32, 216, 277,  19, 125,  32, 128, 194,  86, 198, 116,
  269, 300, 252, 296,  78,  40, 129, 256, 146, 217,  39, 238, 293, 248, 167,  34, 146, 132, 243,
  182, 159, 159,  20, 261, 203, 227, 104,  12, 130, 161, 159, 235, 121,  89, 143, 219, 148, 126,
  280, 136, 172, 235, 101, 121, 245, 167, 232,   8, 268, 184, 292, 276, 280,  88, 176, 207, 304,
  273, 171, 164, 154, 202,  74, 115,   1, 191, 207, 219,  73, 145,  79, 301, 213, 152,   3, 130,
  222, 179, 173, 239, 161,  26,  57, 162,  45, 244,  12, 210, 273, 102, 233,   6,  66, 196, 266,
  151, 298, 305,   3, 100,  97, 145, 250
,},
{ 103,  15,  98, 161, 117, 190, 199, 126, 236, 229,  18,  82, 208,  47, 200, 239,  30,  30, 211,
   15, 124, 294,  96, 231,  57, 287, 105, 287, 245,  47, 263, 234, 266, 184,  52,  23,  69, 109,
  254,  23, 212, 131, 299,  54,  58, 190, 297,  47, 294, 303, 149, 237,   3,  78, 191,  46,  27,
  293, 165,  68,  15, 177, 142, 108,  34, 116,  86,  88, 214, 252,  92, 210, 236, 109,  97, 213,
  253,  81, 209, 281, 276, 131, 215,  38,   8,  36, 243,  18, 162,  49, 276, 199,  42, 193,  66,
    6, 140, 211, 237, 232,  79, 272,  70,  77, 228,  74, 147, 277, 119, 232, 198, 203, 175, 228,
  256,  32, 147, 126, 170,  92, 189,  97, 164, 226, 178, 125, 285, 251,  73, 151, 171, 205, 103,
  220, 267,  88,  80, 147, 229,  16, 224, 274,  48,  55, 253, 258, 243, 119, 170, 111, 165, 165,
  288,  82,  31, 204,  19, 218,  83, 152, 155,   4, 228, 210,  62, 142, 112, 293,  60, 208,  73,
  151,  88,  45,  15, 226, 112, 206, 295, 152, 116, 252,  23, 296,  36, 123, 304,  28, 300,  47,
   94, 193,   6, 269, 197, 104,   3, 138,   6,  95, 276, 300, 257, 237, 111, 105, 269,  32, 177,
  241,  76,  73,  62, 275, 119, 231, 224, 129, 207, 182, 164, 121, 142, 261, 133, 124, 141, 165,
  253,  64,  48, 303, 278, 276,  30, 211, 287, 174, 187, 238, 204,  29, 174, 192, 156, 286,  73,
   83, 176, 271, 184,  51, 164, 191, 289,  67,  72, 220, 261,  39, 214, 185, 294, 302,  39, 214,
   63, 186,  22, 295, 197, 164,  28, 273
,},
{ 153, 296,  57, 107, 167, 248, 218, 231, 193, 166, 116, 259, 153, 194, 292,  29, 164, 260, 144,
  144,  65, 257, 262, 159, 298, 132, 130, 146, 172,  73,  98, 293, 102,  22, 151, 268, 270, 273,
   22, 242,   1,  64, 202, 149, 274, 230, 122, 214, 119, 292, 168,  60, 113, 285, 131,  97, 179,
  299, 128,  41, 138,  75, 223, 165,  44, 293,  87, 259, 221,  10,  49, 298,  51, 286, 122,  38,
   86, 163, 207, 280, 302, 229, 210,  17,  55, 235, 305, 261, 127,  22, 132, 247, 167,  69, 154,
  177, 266,  21, 290,  93, 270, 238,  77,  82,  73, 178, 111, 288, 171, 117, 180, 288, 185,   7,
  278, 105,   2, 140, 183, 104, 187,  58,  98,  26, 171, 241, 238, 263, 242, 220, 103, 167,  33,
   88, 211, 153, 199,  69,  10, 247, 285,  68, 184, 242, 260,  78, 259, 165, 191,   4,   4, 223,
   51, 110, 257, 178,  42, 101, 128,  53,  96, 176, 302,  48, 101, 126,  82,  65, 240, 122, 225,
  277, 210,  49, 146, 221,  47, 141, 235,  66,  21,  13, 264, 133, 105,  53,  97, 155,  66, 287,
   82,   9, 231,  77, 213, 238, 254, 300,  58, 174, 139,  95,  73, 102,  91,  99, 164, 179,  87,
   14,  87, 200,   2,  32, 108, 190, 170,  99,  71, 230, 260, 288,  80, 230, 141, 106, 227,  19,
  280,  26, 233, 174, 210,  69,   2, 265, 150, 223, 189,  96,  63, 291, 188, 179, 158, 209,  80,
  185, 271, 107, 186,  18, 279, 117,  17, 130, 277,  90, 110, 159, 160,  75, 216,  72,  92, 179,
  136, 267,  86, 183, 303, 149, 139, 239
,},
{ 306, 232,  73,  75, 119, 122, 304, 282,  58,  53, 247, 291,  94, 125,  70, 257, 186,  10, 181,
   10, 244,  24, 193,  81, 293, 141, 125, 212, 223, 135, 175, 158,  29, 228, 263, 276, 148,  64,
   99, 305, 198,  12, 206, 209, 282,   4,  94, 263,  51, 115,  22, 297, 119,  63,  84, 250,  56,
  109, 276, 187, 181, 258, 167, 269,  37, 255, 235, 126, 218, 120, 218, 154, 287, 151,   5,   4,
   91, 213, 108,  42,  15, 208,  80, 121,  51, 202, 159,  34, 172, 154, 188,  74, 183, 221, 298,
   69,  83,  28, 179,   2, 169, 281, 155, 101,  74, 280, 252,  86,  76, 167,  13,  53, 252, 156,
  107, 283,  45, 295, 254,  51, 294, 232,  60, 129, 223, 297, 160, 194, 245, 229, 124,  95, 130,
    3,  70, 290,  68, 177, 102,  46, 171, 280, 195, 265,  38, 217,  80, 103,   2, 166,  97, 120,
  302,   2, 153, 244, 161, 206, 228,  68, 248, 138, 158, 249, 137, 229,   6, 295, 266,  57, 156,
   19,  88, 132, 251, 251, 170, 105, 199,  84, 111, 122,  37, 177,  58, 139,   1, 106, 231,  40,
   50, 219,  85,  66, 272, 295, 231, 234, 140,  87, 262,  84, 255,  70, 117,  67, 217, 291, 289,
   68,  13,  28,  58, 249,   5, 250,  68, 227, 290, 117,  79, 201, 206, 256, 297,  87,   5, 290,
  249, 133,  57, 178, 295,  99, 135, 165, 143,  22, 253,   7,  53, 237, 302, 198, 111, 264, 104,
  304, 254, 133, 244, 161, 167, 185,  76,   6, 243,   6, 177, 213,  94, 189, 137,  79, 266,  65,
   23, 237,  67, 101, 199, 207,  99, 254
,},
{  85,  38, 153,  78, 283, 260, 274,  83, 251, 292, 229, 108, 194,  18, 227, 282, 113,  75, 278,
  212, 106,  45, 245, 228,  50, 130, 122, 216, 114, 298,  61, 294, 187,  64,   5,  76,  38, 159,
  118, 297,  54, 184, 222, 225, 263, 207, 205,  82, 303,  84,  40, 109, 194,  71, 263, 100,  51,
  173, 222, 173, 260, 112, 113, 248,  97, 215, 273, 297, 234, 207, 246, 196, 168,  76,  90, 211,
  104,  41, 283,  11, 156,  23, 286, 277, 301, 143, 215, 169, 231,  26, 166, 206, 295, 198,  97,
  155,  77,  51, 106,  99, 296, 155, 275, 264, 167, 285, 130, 228, 300, 109, 104,  63,  43, 261,
  252, 296, 164,   7, 122, 115, 172, 153,  62, 188, 269, 258, 121, 216, 189, 122, 100, 190, 170,
  224, 305, 109, 147,  96, 135, 112,  59, 289, 230,  64, 106,   9,  47, 139, 143, 285, 243,  61,
  159, 169,  31,  30, 154,  36, 156, 109,  71,  55, 133,  58,  52,   2, 298,  14,  95, 164, 237,
  167, 120, 271, 154, 229, 288, 152,  87, 140, 250, 122, 231,  64, 105, 238, 261, 157,  93, 292,
  230,  71, 206, 295,  69,  56, 276,  89,  19, 131, 282,  25, 299, 203,  23,   8, 168, 167, 151,
   62, 153, 116, 125, 246,  88, 215, 182, 135, 263,  64,  58, 182, 110, 289,  87, 282,  76, 176,
   81, 157, 261, 127,  24, 213,  15,  95,  97, 278, 235,  66, 285, 306, 223,  66, 145,   4, 286,
   98, 272,  11, 154, 220,  83, 175, 293,  90, 225, 253, 286,  18, 212,  85, 138, 116, 167, 105,
  124,  34,  45,  20, 276,  70, 159, 148
,},
{ 255, 202, 108, 168,  88,  92, 102, 225, 297,  32, 206, 119, 124, 273,  17, 249, 157,  87, 265,
   64, 193, 123,  94,  43, 135, 175,  73,  88, 229,  32,  76, 111,  74, 292,   9,  58, 283,  71,
   14,  98, 158,  12, 200, 279,  80,  38, 196, 169, 202,  95, 166, 301, 107,  50,  57,   4, 117,
   95, 205, 220,  85,  53, 291,  49,  39,  17, 269, 152,   7, 201, 278, 180, 238, 149, 200,  94,
  204, 261, 251, 299,  46, 180, 257, 263, 203, 270, 182, 245, 146, 100,  62, 220, 255,  33, 133,
  282, 179, 288, 285, 173,  60, 254, 137, 295, 155, 186, 142,  58, 256,  92, 227, 254,  33,  70,
  242, 205, 246,  50, 102,  12, 171,  56, 257, 139, 301,  67,  37, 289, 201, 127,  42, 298, 108,
  145, 209, 115, 294, 231, 277, 165, 151, 106, 139, 144, 201,  19, 113, 224, 259,  71, 209, 135,
  178,  67, 256, 276,  67,  86, 193, 106, 118, 106,  40, 140,  81, 261, 209,  15,  28,  96,  90,
  270, 163,  55,  30,  88,  33, 234,  98, 217,  24, 283, 142,   5, 155,  31, 297, 115, 118, 276,
  248, 293,  32, 222, 304,  35, 306, 157,  58, 299, 102, 185,  56, 143,  62,   3,   4,  18,  54,
   84,  10, 155, 100,  75,  70, 104,  11,  76, 243, 199, 194,  60, 216,  52,  89,  42, 249, 282,
  163, 112, 234, 164, 279,  85, 268, 202, 198, 195, 303, 288, 286, 123, 264, 129, 214, 131,  70,
  268,   2, 157,  74,  82, 293, 107, 192,  28, 133, 255, 172, 116,  15, 185, 239,  75,  73, 298,
  282, 157,  72, 211, 238, 196, 233, 306
,},
{ 158,  53, 131,  27, 114, 137, 147, 121, 236,   6, 128, 186,  94, 250, 217,  21,   3, 236, 289,
  254, 228, 224, 104, 141,  54,  74,  53,  11, 202, 242, 187, 113,  71, 121, 282, 214, 291, 289,
  240, 122, 296, 262, 294,  15, 141,  67,  36,  22, 135, 220,  82,  46, 189,  25, 187, 289,  35,
  125,  45,  93, 204, 159, 253,  84,  11, 164, 278, 247, 183,   1, 186, 266,  76,  95,  32, 117,
    9,  93,  48, 226, 110, 162,  83, 197, 110,   2, 305,  20, 185, 178, 274,  16, 201,  12,  77,
   55,  91,  22, 191,  46, 138, 164, 167,  29,  24, 298, 160, 101,  91, 274, 253,  31, 109,  10,
  234,  66, 168,   2, 151,  82,  78, 122,  47, 271,  20,  41, 278, 235,  63, 106, 252,  78,   4,
  243, 226,   7,  37,  86, 236, 115, 200,  20, 302, 235, 141, 241,  10, 201, 190, 218, 113, 301,
  240, 245,  27, 161, 199, 250, 282, 156, 303, 236, 187, 125, 200, 119, 187,  18, 185,  84, 250,
   96,  46, 207,  67,  18, 164,  79, 280,  10, 168,  30, 175,  73, 189,   2, 265, 103,  80, 235,
  268,  92, 258,   7, 112, 242, 220,  89, 263,  81, 210, 196,  79, 223, 229, 170,  86, 200, 137,
  293, 242, 122, 180,  63,  43,  45,  39, 215, 291,  36, 111, 306, 122,  38, 211,  25,  36, 119,
  168,  57, 126,  21,  80,  11,  95, 302, 137, 160,  60, 201,  21, 117, 227, 219, 128,  44, 143,
  290, 111,   9,   1,  33, 179, 102, 138,  88, 287, 278,  17, 169, 255,  38, 213,  88, 123,  41,
   79, 288, 136, 158, 139,  56, 114, 176
,},
{ 129,  98, 269, 265,  14,  86, 281, 180,  27, 183, 302, 271, 288,  22, 282, 127,  30, 221, 296,
   76, 248, 298, 191, 121,  47,  45,  56, 220, 209,  63, 285, 122,  92,  88,  39, 121,  37, 156,
   17, 266, 272, 105,  57,   5,  50, 280, 112, 267, 173,  37,  52,  19, 110, 192, 166, 186,  52,
  162,  22, 109, 146,  74, 264, 152,  18, 115, 278, 159,  10,  11, 185, 149, 150,  70, 118, 211,
   34, 204, 127, 150,  27, 263,  42, 205, 109, 181, 289, 266, 142,  79, 254,  81, 290, 296, 250,
  297, 208,  93, 209, 196,  66, 254, 126, 141, 140,  30, 269,   8, 126, 300, 182,  58,  70, 166,
    4, 203, 131, 132,  32, 294, 132, 106, 171,  39,  32,  37,  52, 121, 101, 205, 210,  56, 246,
  190, 109, 166, 227, 112, 127, 197,  95, 231, 215, 291, 149, 162, 290, 179,  45,  38, 194, 192,
  241, 114, 224, 169, 205, 226, 138,  40, 175, 104, 102, 270,   3, 266, 249,  33, 184, 153, 303,
  115, 224, 284, 244,  30, 150,  50, 272, 111,  38,  33,   4,  39, 231, 101, 263,  25, 123,  57,
  108,  94, 112,  53,  26, 279, 224,  37, 160, 206,  88, 244, 125, 159, 130, 255, 298, 281, 132,
  132, 115, 178,  20, 245, 169, 145, 126,  54, 136, 190, 174,  47, 139, 136, 298, 116, 160, 198,
  228,  97,  49, 160,  69, 277,  93, 251,  76,  71, 281, 206, 222, 293, 233, 165,  88, 269,  81,
  105, 292, 107, 142, 156, 153,  25, 172,  22, 247, 248, 107, 238, 265, 198,  22,  80, 236, 229,
  210, 251, 300,  43, 243, 243,  59,  15
,},
{  86,  89, 242, 256, 154, 200, 182, 303,  15,  94, 278, 295,  32, 240, 248, 222, 133,  73, 261,
  154,  72,  90, 276, 100, 263,  41,  33,  65,  45,  14, 194,  37, 108,   1, 238,  34,   3, 254,
   77, 239,  59, 247, 173,  69, 233, 245,   3, 266, 163, 210, 232,  10, 164, 112, 286,  63,  28,
  239, 298, 167,  42, 264, 144, 299, 108, 292, 191, 301,   1, 100, 236,  58, 174, 146, 290, 135,
  258, 164,  22, 195, 222, 129, 183,  21,  44,  54, 270, 263, 245, 276, 232,  23,  59, 251, 250,
  192,  92, 107,  13, 110, 107,  41,  24, 211, 215, 144, 113, 270, 127, 163,  34,  52,  84, 108,
  162, 188, 144, 107, 152,  25, 225, 253, 241, 268, 289, 248, 249, 152, 134, 298, 172, 284, 168,
   63, 203,  69, 108, 277,  37, 101, 286, 218,  54,   3,  29, 163, 297, 198,  75,  46,  22,  42,
  152, 157, 100, 114,  96, 223,  49,  79, 155, 247, 117,  55, 291,  47, 148,  44, 246, 265, 299,
  213,  98, 178, 104, 117, 118,  74, 281,  57, 232, 255, 118, 118,  42,  70, 275, 103, 243, 210,
  177, 299,   5, 180, 168,  35, 267, 102, 289, 122,   6, 213, 299,  76,  97,  45, 238, 121,  31,
  231, 218, 277, 110, 268, 111, 237, 199, 136, 206, 171, 282,  29,  38,  46, 207,  30, 206, 268,
   66, 283, 194, 174, 192,  98, 127, 197, 305,  32, 254, 276, 220, 301, 268, 294, 180, 182,  89,
  158,   4, 187, 298, 143, 236, 255, 174, 197, 128, 221, 134, 152, 302, 227,  85, 138, 281, 102,
  137, 120, 259, 238, 202, 210, 245, 300
,},
{ 185, 207, 206, 289, 185, 190, 278,   8,  73, 127, 152, 138, 120, 300, 155, 276,  35,  72, 259,
  184,  74, 289, 264, 298, 177, 143, 108, 213, 249, 136, 178, 146,  64, 130, 238, 138, 130,  45,
  209, 219,  90, 173,  72, 106,  24, 142, 231,  13,  28, 289, 119,   6, 147, 204, 150,  68, 280,
   84, 196, 128,  55, 253, 129, 230,  33,  62, 277,  37, 211, 266, 302, 152, 251,  94, 248,  16,
  154,  95, 208, 154, 100, 113,  64,  70, 178, 172, 299,  57, 150, 162, 266, 217, 197, 200, 252,
   11,  83, 221,  42, 182, 172, 221,  46, 189, 156, 295, 269, 133, 194, 253,  62, 197, 265, 230,
   28, 158, 236, 278, 200,  12, 180, 189, 190,  32,  49,   4, 190, 100, 105,  83, 252, 117,  68,
  192,  16,  17, 137, 187,   5, 131,  39, 290,  55, 112, 289,   2, 100, 299, 267,  95,  33,  52,
  163,   7, 184,  49, 189, 149,  60,  97, 230,  60, 200,  98, 168, 250, 143,  39,   6,  24, 115,
   34, 180,  99, 262,  20,  35, 133,  89, 279,  21, 274, 113, 249, 178, 199, 173, 145, 165, 141,
  154,   6,  54, 137,  24,  41, 102, 283, 230, 143, 113,  50,  85, 240,  64, 239,  12,  75,  33,
  169, 109,  81, 145, 158,  44, 243,  89,  92, 106, 292, 169, 145, 156,  20, 238,  66, 295, 217,
   84, 245,  74, 238, 200, 158, 168,  58,  49,  39,   8, 154, 249, 265, 108, 260, 287, 218, 266,
   94, 287,  53,  16,  11, 208, 127, 165,  60, 168, 222,  90, 113, 204, 156, 116, 256, 167,  57,
  104, 179, 280, 247,  41, 156, 250, 153
,},
{  79,  84,  18,  12, 262,  56,  64, 134, 167,  81, 175, 142, 279, 183, 272, 157, 153, 228, 173,
  100, 266, 243, 126, 134, 150, 300,  82,  77, 270, 102,  60,  43, 126, 241, 125, 187, 101, 133,
  283, 263,  11, 142,   7, 133,  37, 171, 141, 144, 303,  37, 129,  59, 257, 106, 119, 266, 237,
  284,  59, 140, 120,  92,  46, 179, 211, 249,  39, 266, 206, 208, 105, 296, 100,  26, 189,  53,
  127, 252, 142,  42, 213, 158, 218,  34, 147, 231,  36, 218,  27, 166, 249, 243,  54, 229, 222,
  213,  69, 158,  19,  76,  11, 224,  24, 299, 207,  74, 282,  95, 303, 203, 180, 271, 278, 100,
    5, 247, 293, 114, 175, 190,  45,   2,  31, 197, 126, 226, 263, 289, 294, 211, 299, 270, 277,
  289,  79, 222, 285,  33,  36, 231, 302, 127,  81, 103, 264,   2, 151, 144, 282,  93, 116,  79,
  258,  43, 294, 290, 164, 127, 247, 195,  42, 289, 254,  89, 128, 187, 213, 201, 124,  34, 101,
  118, 229, 202, 105, 256,  58,  58, 156,  45, 101,  24, 220, 232,  34, 255,   9,  76, 281,  70,
  137,  76, 142, 195,  82, 300, 287, 147,  29,  88, 252, 160, 304,  15, 283, 118, 127, 110, 288,
  306, 248, 165, 247, 280, 142, 185,  57, 191,  46, 156, 248, 225, 176,  67, 253, 206,  63, 230,
  160,  31, 252, 121, 196,  66, 163, 185, 179,  30, 125, 264, 174,  11,  10, 239, 106, 202, 224,
   69, 169, 137, 282, 149, 213, 266, 296, 113,  36,  87, 103, 242,  29,  62, 170, 194, 280, 151,
  101, 107,  15,  16, 211, 257, 115,  68
,},
},


//-----------------------------------------------------------------------------------------------
//Redundancy generating matrix for (306,242) Reed-Solomon code
//-----------------------------------------------------------------------------------------------

{
{ 135,  16, 212,  49, 247, 137, 239, 156,  34, 125, 232,  47, 301,  60, 185,  39,  44,  75, 278,
  112,  86, 270, 290, 257, 251, 203,  66, 122, 289, 206, 199, 241, 285, 259, 240, 167,   6, 214,
   57, 158, 133,  93, 136, 117, 131, 157,  44,  93, 200, 150, 133,  88, 205, 245,  89, 225, 148,
   77,  17, 306, 152, 234, 123,  92, 233, 202,  37, 289,  51,  27, 206, 300, 252, 297, 274, 141,
   79, 188, 138, 148,   1,  66,  48,   3,  93,  48, 302, 258,  31, 125, 242, 243, 153,   8,  49,
   27,  39,  73, 228,  25, 265,  15, 152, 197, 258, 278, 141, 182, 276,  82, 161,  25, 239, 164,
   57, 109,  54, 201, 203,  85, 262, 142, 163, 195,  60,  54,  73,  44, 246, 103,  70,  26, 246,
   23,  80, 240, 261,  49, 248,  21, 184, 252,  63, 187,  10, 258, 108,  22, 221,  29, 117, 154,
   40, 297, 191,  48,  47, 128, 241, 217, 304, 171, 159,  26, 134, 230,  48, 170, 245,   5,  88,
  306,  24, 143, 264, 305, 211, 208, 296, 296,   9, 233, 107,  85, 288,  28,  55, 168,  35,  91,
   77,  27, 125, 248, 219, 235,  95,  80, 284,  88, 278,  16, 130,  21,  53, 124, 220,  49, 161,
  118, 214, 151, 266, 132, 192, 277, 245, 281,  78, 179, 153, 206, 265,  62, 203, 162,  88,   4,
  289, 285,  93,   2, 238,  61, 170,  40, 141, 207, 176,  64, 242, 216
,},
{ 302, 214,  65,  51, 290,  60, 185, 165, 132,  18, 196, 253, 286,  60, 110,  13,  26, 280, 258,
  217, 268,  76, 282, 235, 134, 198,  30,  16, 225, 270, 210,  65,  94,  48, 216,  86, 235, 180,
  246, 108,  28, 266, 304, 234, 169, 273, 144, 177,   6,  58,  20, 107, 160,  14, 128, 183, 265,
  202,  65, 108, 289,  41,  93,  40,  72, 271, 212, 140, 253,  50,   8, 229,  86, 241, 230,  30,
   13, 163, 217, 178,  57, 135, 303,  82, 136,  23, 196, 156, 200,  15, 207, 233, 135,  39, 154,
   48, 162, 150, 201, 102, 163, 128, 305,  31,  51, 134,  34, 157, 240, 182, 167,  35,  73,  51,
  196, 269, 107, 183, 148, 143, 189, 234,  45, 224, 261,  58, 165,  60,  69,  83, 180, 160,  51,
  302, 111,  37, 128, 100, 199, 179, 162, 277,  45, 238, 198, 171, 254, 255, 173,  38, 127, 225,
  198,  29, 108, 121,  69,  65, 301, 142, 183,  93, 131, 249, 112,  80, 160, 235, 286,  97, 286,
  179, 271, 212,  65, 139, 138,  10, 288,  69,  91, 296,  13,  47, 279, 196, 242, 117,  53,  43,
  145,  76,  11, 275, 274,  17, 186, 183,  24, 258, 271,  50, 159,  61, 110, 128,  59,  59, 134,
  168, 292, 288, 198, 227, 159, 159,  86, 155, 244,  60,  71, 134,  37, 149,   9, 197, 136,  31,
  107, 142, 111, 218, 141, 213, 248, 214, 103,  31, 155, 185, 146, 234
,},
{ 276,  55,  88, 172, 133, 113, 112, 156, 139, 217, 274, 142,  77, 204,  63,  26, 178,  77, 248,
   64,  79, 206,  89, 248,  25,  51, 292,  27, 102, 230, 172, 116, 136, 221,  27, 305, 262, 270,
   10,  71, 223, 300, 162,  52, 188,  67, 131, 109,   6, 108, 173,  43, 185,  81, 271, 281, 124,
  170, 189, 138,  64,  92, 272, 131, 223,  62,  26, 298, 101, 124,  55, 212, 253, 202, 194,  68,
   96, 104, 220, 158, 105, 151,   8,  84,  47,   9,  81,  89,  42, 285, 155, 274, 116, 165, 146,
   25, 271,  52,  84, 218,  98, 296,  84,  46, 231,  19, 279, 256, 271,  87,  95, 184,  87,  74,
  188, 221,  11, 170, 100,  83,  51, 261,   1, 239, 142,   3, 255,  23, 215, 225, 192, 124,   8,
  214, 295,  90,  18, 235, 109, 201, 255, 186, 283, 209, 122,  91, 269, 183,  86, 205,  93, 244,
   68,   7, 208, 288,  67, 242, 278, 117,  54, 287, 152,  75, 291, 207, 260,  30, 156, 228, 120,
   52, 269, 270, 281, 211,  86, 304, 199, 170,  26, 274, 160, 255, 206,  77, 172, 258,  18, 164,
  255,  16, 161,  20, 252,   4, 143, 179,  20,  47, 226,  24,  77, 161, 183, 268,  32, 166, 279,
  116, 203,  14, 211,  79,  26, 200,  80, 142, 294,  71, 250,  76, 130, 116,  66, 156, 220, 151,
  117, 178, 107, 272,  36, 293,  83,  91,  52,  35,  77,  88,  18,  35
,},
{ 120, 222, 107, 268, 221,  16, 189,  46, 118, 216,  48,  77, 239,  28, 232, 200,  31,  40, 290,
  177,   4,  12, 225, 181, 130,  69, 212, 264,  11, 251, 134,  11, 267, 298,  25,  39, 208,  77,
  116,  14, 121, 101, 148, 266,  32, 157,  72,   9,  48,  37, 158, 183, 157, 164, 126, 164, 242,
   56, 151, 154, 239, 272,  99, 115, 304, 232, 129,  10, 241, 125, 273, 117, 129, 210, 275, 217,
   70, 229,  22, 181, 193, 266, 296, 113, 269, 192, 141, 208, 253, 119, 159,  64, 103,  89,  38,
  170, 162,  63,  50,  38, 283,   9,  90, 225, 173, 137,  42, 202,  92,  71, 196,  49, 260, 301,
  227,  12, 269, 292, 214,   5,  43, 109, 133,  72, 190, 190, 102, 260,  37, 136, 219, 181, 138,
  199, 251,  99,  15, 198,  12, 230, 194, 172, 242,  74, 252, 249, 187, 118, 243, 180,   2, 264,
  109,  25, 245,  46,  91, 249,  81, 198,  12, 206,  19, 141, 160,  52,  45,  70,   9,  24, 238,
   85, 278,  55, 300, 211, 228, 305, 226, 121, 178, 199,  28,  65, 204, 265, 160, 219, 255, 133,
   96, 279,  93, 245,  10, 188, 259, 180, 295,  30, 260, 172, 276, 198, 174, 225, 293, 212, 275,
  111, 238, 269, 114, 226,  45, 204, 179,  91, 109, 112, 207,  92, 141, 151, 160, 210, 166,  53,
  135, 268,  56, 177,   6,  22, 103, 255, 114, 236,  55, 168, 269, 210
,},
{ 106, 103, 227, 266, 255, 133, 165, 100, 125, 273, 123,  94,  45, 252, 196, 133, 230, 124,  90,
  171, 124, 216, 126, 163,  87,  87, 114,  44, 168, 291, 289,  89, 303,  11,  43,  97,  71,  19,
   74, 140,   7,   3, 110, 158, 146, 153, 187, 261, 257, 234,  30, 218, 253,  31, 127,  98, 237,
  141, 249, 248, 146, 259,   7,  78, 232,  51,  20,  33, 282,  78,  98,  31, 233, 178,  34, 106,
  229, 254,  44,  95,  84, 238, 215,   5, 302, 218,  63, 289, 271, 101, 284, 227, 266, 248, 248,
  182,  71, 142,  51,  81, 121,  56,   1,  15,  66, 223, 275, 194, 139, 120, 111, 227, 198,   9,
  298,  92, 300, 113, 249, 258,  72,  84, 262, 252,  85, 171, 170, 132,  37, 177, 100, 153, 265,
   56, 114, 303, 263, 174,  88, 124, 188,   3, 201, 216,  25,  93, 211, 202, 171, 193, 190, 107,
   68, 158, 225, 194,  92, 262, 204, 215, 182,   3, 133, 260,  37, 261,   1, 133, 251, 138,  84,
   28, 213, 222, 235, 187,   6,   7, 144,  65, 169, 295, 258,  72,  66, 251, 149, 135, 201,  24,
   32, 240, 127, 290, 185, 240, 183, 174, 262,  48,  80, 243, 149,  81, 276, 119,  68, 145, 252,
  188, 229,  20, 255, 204,  22, 192,  78, 245, 200, 245,   7, 180, 175, 267, 108, 103, 270,  85,
  264, 120, 150, 169, 116, 229, 110, 214,  86, 297,  49, 294,  26, 193
,},
{ 267, 124, 188, 167,  45, 294, 210, 187, 215, 304, 227, 291, 164, 266,  38,  48,  29, 276,  53,
  216, 191,  44,   5, 300, 100, 277, 238,  21, 254,  16,  16, 138, 141, 249, 281,  39,  27, 235,
  275, 175,  21, 150, 156, 280, 267,  54,  49,  23, 179,  42, 115, 129, 180, 260,  16, 265, 111,
   55,  45,  56, 112, 179,  52, 264, 225, 229, 131, 230,  52, 274, 233, 282, 161, 145, 256, 231,
    3, 287, 179,  57, 288, 235, 292, 180, 148,  49, 174, 123, 132, 143, 143, 212, 284, 275, 188,
  240,  34,  38, 245, 271, 264, 253, 227, 261,  75, 302, 113,  96,  44,   1, 186,  24, 304, 229,
  265, 152,  76, 104, 303,  76, 169, 155, 229, 136, 166,  69, 138,  66,  25, 268, 179, 206,  46,
   99, 146,  77,  21, 203, 146, 150,  24,  11, 189,  66, 304,  85,  61, 159, 182, 242,  56, 133,
  152, 287, 181, 279,  55, 236, 111,  26, 250,  29, 297, 239,  27, 219,   8, 269, 140, 295, 237,
  198,  55, 182, 212, 156,  79, 240,  33, 170, 267,   9,  70,  85,  89, 251, 121,  31, 136, 265,
  149,  24, 112,  99, 191, 104, 155, 273,  33,  54, 284,  98, 159, 211, 179, 262, 213,   8, 211,
    1,  45, 207,  89, 250, 113,  65, 199, 279, 256,  56, 302, 162,  56, 168, 150,  60, 202, 121,
  295,   9, 263, 229,  53, 223, 190, 155, 104, 127, 188, 121,  29, 269
,},
{  89, 273,  50, 168, 298,  58, 115, 115, 123,  70,  84, 283, 212,  33, 297,  91, 218, 249, 150,
   95,  18,  62,  76,  63, 279,  61, 225, 207,  91, 101, 129,  68,  53, 123,  32,  75, 118, 184,
  218, 104,  33, 171, 201,   8, 214, 134, 224, 199,  98,   5, 207, 148,  14,  80, 255,  62, 167,
  255,  23,  83, 113, 123, 110, 240,   6, 224,  51, 201, 134, 254, 121, 192, 223, 234, 171, 117,
  299, 227, 262,  81,  19, 236, 253, 178,  23, 166, 239, 194, 173, 294, 157, 119, 231, 287, 255,
   83, 293,  23, 277, 216,  25,   1,   3, 109, 281, 256, 163, 258,  46, 305,  23, 157, 152, 212,
  212, 114, 249, 113,  65, 143, 251, 299, 101, 187,   5, 263,  58,   1, 235, 102,  64, 112,  68,
   93, 129, 236, 290,   1, 296, 269, 219, 272,  73, 144, 300,  17, 279, 146,  50,   1,  94,  37,
  148, 225,  90, 199,  28, 103, 288, 154, 140, 199, 127, 230,  59, 190, 237, 302, 169, 257,  21,
  275, 207, 147, 281, 288, 120, 157,  44, 144, 135,   9, 241, 217, 193, 253,   3, 184, 236,  55,
  102,  44, 186, 205,  66, 164, 178, 185, 226,  66, 235, 290,  70, 282,  39,  72, 191, 193,  30,
   25, 158, 140, 230, 292,  15,  25, 272, 266,  78, 208,  75, 149, 223, 156, 129, 134,  93,  50,
  191, 210, 159, 187,  88, 191, 210, 205,  16, 220, 193, 212, 135, 110
,},
{ 114,   7, 261, 221,  15,  18, 253,  83, 171,  58, 109,  35, 237,  58, 121, 289,  19, 179, 129,
  190,  38, 246,  34, 102,  43, 198, 260, 137,  69,  33, 194, 237, 104, 299, 121, 289, 121,  19,
    7,  99, 305, 132,  88, 177, 296, 292,  62,  16,  95,  20, 206,  63, 287, 255,  46, 138,  71,
   41, 283, 220, 225,  65, 145,  99,  82, 122, 303, 220, 285,  34, 196, 272, 282,  44, 288,  24,
  211, 103,  57, 271, 191, 218, 297, 276, 277,  84, 230,  68, 227, 108, 205, 178,  64, 190, 151,
  155,  75,  34, 236, 264, 201, 140, 143, 183, 245, 161, 109, 228, 225, 163, 209,  10,  45,  79,
   35, 229, 221, 255,  32, 205, 105, 214, 116,  61,  33, 112,   4, 293,  45, 206, 127, 161, 156,
  142, 297, 127,  88, 154, 265, 150, 247,   2, 141,  74,  16, 129, 231, 243, 203, 170, 284, 149,
  139, 276,  52, 151, 150, 293, 211, 212, 131, 223, 190, 224, 234, 185, 251, 210, 236, 105, 113,
  218, 152, 280,  22,  61, 166, 282, 175,  62, 213, 284, 113,  74, 276, 203, 163,  63,  43, 115,
  236,   2, 286, 143,  42, 128, 176,  75, 111,  82, 253, 153, 161, 231, 279, 171,  19,  55,  97,
  116, 233, 190, 235,  14, 229,  92, 266, 175, 250, 120, 153,  17, 134, 289,  75, 143, 297, 226,
  219, 227,   2,  72, 272,  44, 164,   5,  58,  68, 239, 172, 123, 256
,},
{ 176, 219, 247, 218, 211,  89, 109, 279, 191, 243, 199, 168,  34, 247, 140, 281, 194, 185, 123,
  250, 102,  83, 192, 128, 195, 128, 209, 178, 134,   1,  15, 183, 131,  96,  32, 200, 290, 259,
  182, 238,  70, 167, 257, 261, 250, 271, 197, 231, 254, 120, 298,  16,  46,  72,  14, 237, 265,
  135,  95,  27, 143, 264, 239,  58, 189, 218,  77, 300,  75, 136, 273, 246,   7, 178, 192, 158,
  293, 140, 126, 184, 220, 202, 226, 144, 138, 285,  32, 273,  22, 299,  46,  92,  50, 270, 147,
    2,   8,  36,  72, 189, 257,  50,  63, 227, 226, 189,  31,  37, 274,  34, 241, 162, 101, 277,
  242,   2, 238, 101,  33, 302,  44, 231, 190, 302,  71,  42,  73, 216,  27,  11,  13,  29, 202,
  211,  53,  30,  17,  45,  93, 115, 283, 289, 166, 121, 178,  59, 147,  30,  24, 259,  36, 105,
  258,  35,  52,  60, 210,  69, 282, 196,  58,   6,  96,  92, 144, 170, 193, 177, 302, 288, 222,
  164, 222, 227,  17, 124,  45, 303, 229, 122, 217, 303,  46,  76, 122,  76, 161, 191, 120,   7,
  179,  87,  74, 225,  26,  30, 195,  87,  20, 228,  26,  51, 277,  11, 291,  95,   3, 283, 133,
  219, 254, 207, 132, 257,  46, 224, 184,  57, 188,  24, 299,  85,  10,  42,  67, 102, 260,  93,
  223, 113,  89, 207, 214, 231, 277, 273, 182, 246, 302,  45, 110, 159
,},
{ 282, 264, 157,  56, 195, 197,  22,  46, 159, 111, 291, 304, 135,  57, 190, 201, 216, 146, 179,
  125, 109,  52, 143, 224, 127, 237, 184, 266,  79,  39,  21, 266,  62, 174, 188, 183, 233, 239,
  112, 130, 202, 121, 301, 133, 214,  39, 206, 248, 103, 158,  84, 168,  69,  12, 101, 177, 130,
  228,  75, 243, 249, 202, 173, 131, 265,  72, 268, 285, 120,  70,  41,  81,  97, 259, 150, 200,
  132,  99, 285,  19,  36, 276, 159,  89, 195,  95, 104, 223, 290, 249,  95,   1, 166,  94,  79,
  142,  63, 256,  62,  56, 265, 186, 272,  72, 111, 220, 197, 111,  20, 111, 152, 225,  95,  82,
  130,  74, 299, 269, 143,  40, 208, 211,  53, 188,  18,  61, 290,   8,  34, 133,  89, 156, 154,
  175,  37, 145,  84, 133, 181,  55, 206, 134, 175, 120, 176,  62,  39, 268, 171,  30, 135, 269,
   18, 203,  11,   9, 165, 300,  13,  94,  26, 231, 113, 239, 215, 181, 127, 207, 143, 176, 158,
   63, 296, 241, 144,   6, 210, 268,  89,  15,  18, 117, 124,  53, 125, 276, 225, 164, 230, 160,
  277, 174,   7, 210,  48, 244,  92,  21, 114, 197, 222, 114, 152, 239, 149,  52,  77, 119,  94,
  168, 168,  10, 135, 244,  85, 188, 190,  41, 179,  98,  98, 204, 161,  44,  84,  37, 279, 282,
  301, 102, 164, 100, 288,  89, 245, 190, 281, 246, 293,  40, 148,  70
,},
{ 240, 174,  61, 210, 154, 268,  42, 197, 277,   6,  80, 204, 191,  37, 113, 157, 211, 247, 265,
   37,   5, 282,  90,  20, 295, 215, 252, 128, 234,  70, 154,   6, 261,  79,  89, 212, 296, 170,
  238, 120, 230, 265, 124, 202,  93, 152,  49, 269, 126, 165, 258, 104,  89,  27, 102, 194,  99,
  301, 190,   5, 138,  51, 216, 166, 170, 283, 206, 236, 171, 168,  61, 165, 222,  11,  98, 196,
  204,  91, 242, 207,  89,  51, 259,  62, 152, 178,  52,  51, 244, 137, 304, 220, 273, 112, 147,
  127, 109, 261, 252, 277, 186,  87,  81, 247,  19, 230, 266,  43,  90, 234,  22,  60,  70, 216,
   81,  85, 170, 247,  50, 260, 267,  17, 262, 195,  90, 114, 259, 300,  36, 183, 121,  67, 184,
  229, 249, 259, 302, 137, 301, 116,  41,  40, 246,  64, 206, 123, 254,  44,  81,  52, 238, 170,
  306, 239,  65, 301, 229, 222, 285, 160, 191,  23,   2,  91, 102,  44, 164,  54, 165, 186, 196,
   88, 208, 175, 301,   4,  40,  34, 112, 240,  31,  57, 239, 241, 258, 243, 135,  12, 158, 153,
   24,  18,  21, 175, 190, 227, 140, 166, 253, 134,   9, 114,   4,  87, 265, 233, 102, 130,  30,
   65, 105, 300, 210, 165, 176, 134, 146, 212, 282, 122,  63,  89,  27, 203, 132,  65,  57, 252,
   250, 296, 165, 304, 182, 260,  16, 282, 236,  35, 286, 168,  95, 225
,},
{ 289, 156, 289,  34, 218, 279,  11, 144, 172, 158,  16, 217,  82, 183, 217, 292, 233, 201, 169,
  291,  46, 276, 141, 199,   7, 227,  22,  72,  69, 227,  23,  40, 275, 206,  47, 210,  27, 247,
  101, 176, 266, 279, 165,  47, 205, 113, 228,  98, 140, 106,   4, 103, 179, 261,  97,  72,  31,
  232, 135, 272, 128, 291,  96,  40,  94, 184,  12, 147,  45, 106, 161,  21,  70, 121, 261, 202,
  165, 138, 134,  79, 125, 203, 106,  13, 111, 207, 281,  79, 272, 125, 248,  26, 261, 231,  85,
   82, 306, 263, 292,  44,  37, 184, 210, 198, 274, 248,  27,  78, 129, 120, 233, 121, 110, 130,
  147,  46, 262, 266, 179, 141, 266, 289, 159, 236, 187, 267, 268,  28,  83, 186, 276, 138, 157,
  140, 116, 217,  40, 275,  63, 114,  71, 253,  93, 262, 165, 233, 170, 292,  35, 159, 282, 197,
  267, 205, 234, 120, 131, 171, 108, 297,  99, 291, 186,  19, 155, 276,  99,  39, 226,  62,  31,
  278, 269, 148,  17, 158, 201, 176,  15,  93, 116, 266, 186,  23, 264, 111,  31, 174, 212,  64,
  286, 266, 206, 254,  23, 261, 112,  27, 210,  98,  56, 232, 199, 124,  39, 228, 306,  75, 129,
  178,  16,   3, 285, 131,  78, 180, 306, 129, 263,  33, 163,  56, 156, 162, 135,  49, 217,  36,
  193, 212,  38,   1, 129,  92, 135, 113,  79, 147,  32, 257, 279, 189
,},
{  34, 243,   7,  33,  53,  16,  14,  23, 123, 158, 105, 303,   4,  63, 150, 220,  12, 286, 246,
  154, 274, 114, 133, 208,  53, 306, 114,  55,  47,  14,  77, 136, 180, 106, 130, 296, 116, 256,
  275, 184, 139,  37, 195, 174, 246,  99, 140, 306, 137, 246,  69,  58, 166, 127, 197, 256, 107,
  155,  68, 253, 142, 146, 206, 292, 176, 204, 116, 294, 269, 236,  51,  66,  64,  22,  24, 201,
   90,  85, 125, 169, 268,  12,  65,  59,  91, 280, 183, 230, 105, 258, 120, 125,  85, 238, 282,
  276,  85, 288,  68, 105,  88, 109,  54, 296, 147,  12, 188,  41,  52, 277, 156,  46, 163,  99,
  158, 179, 121, 183, 258, 280, 232,  88,  89, 174, 217, 262, 249, 295, 165, 209, 215, 278, 275,
  206, 217,  40, 119,  91, 176,  41, 199, 114, 187, 131,   3, 114,  76,  30,   2, 297, 168, 223,
   82, 219,  78,  96, 100,  70, 284, 290,  37, 183, 256, 188, 171,  31, 138, 301, 294, 250, 116,
  149, 209, 280,   3, 253, 127, 217, 246,  85, 259, 252, 227, 287, 116,  30,  68, 162,  35, 219,
  188, 170, 252, 107, 200, 230, 103, 189, 285, 264, 143,  10, 242, 177,  10, 143,  56,  50, 111,
   20, 100,   4, 236,  59, 193, 241, 128, 304, 135,  17,  92, 108, 100, 208, 154,  53, 103,  52,
   11,  26, 290, 109, 161, 299, 294,  20,  53, 213, 255, 155, 252, 272
,},
{ 187,  88, 191, 134, 291, 170, 247,  80,  61,  46,  20, 302, 206,  53,  35,  13, 215, 150,  73,
   10, 214,  34,  95,  41,  19,   9, 145, 142,  71, 205, 110, 238, 292,  18, 302, 118,  86, 301,
  103, 271, 134, 261, 189,  91, 194, 277,  94, 262,  60, 106, 196,  59, 251, 187,  82, 304, 295,
  175, 174, 103, 152, 241, 139,  56, 119, 167, 137, 132,  44, 245,  87, 296, 149, 107, 256,   1,
  199, 264, 167, 164, 134, 107, 174, 267, 181, 253, 148,  56,  66,  28,  77, 211, 296, 112,  58,
  258, 139, 293, 290, 114,  40, 177,   8, 220, 169, 241, 296, 265, 205, 252, 168, 202, 277, 256,
  253,  27, 131, 147, 139,  46,  13, 174, 216,  18, 223, 169, 163, 244, 281, 244, 215, 226, 264,
   84, 169, 106, 115, 246,   7,  55,  48, 282,  58,  89,  88, 183,  18, 227, 277, 215, 193, 304,
   51, 125, 288, 240, 293, 225, 231,  57,  88, 192, 144, 267, 103, 103, 193,  21,  15, 119, 240,
  151, 230, 116, 250,  73, 236, 215, 295,  17,  77,  86, 191,  15,  31,  57, 254,  21, 165, 227,
  287, 164,  93, 168, 117, 264, 282,  66,  73, 275,  51, 197,  65, 121, 164, 275, 118, 183, 248,
  279, 205,  34, 211, 221,  93,  15, 262, 117,  30,  10, 188, 250,  43,  79, 164,  10,  43, 270,
   68, 167, 148, 220,  68, 175, 182, 122, 304, 176, 193, 164, 281,  60
,},
{ 118, 226, 221,  61, 218, 222,  81,  90, 278, 193, 151,  77, 249, 122, 101, 226, 197, 110, 252,
   39, 258, 143, 242, 165,  58, 226, 285,  97, 290, 151, 172, 141, 146, 175, 296, 191, 171,  32,
   37,  66, 269, 188, 132, 148, 276,  97, 154, 148, 289, 157, 104, 257,  79, 215,   1,  74, 281,
    3, 274, 114,  13,  70, 253, 133, 221, 266, 238, 285, 122, 129,  18, 281,  66, 163, 276, 120,
  136, 120, 255, 144, 224, 103, 224,  47,  14, 298, 260, 278,  74, 198, 119, 228, 181, 162, 289,
  143, 142, 221, 158, 255,  50,  19,  87, 162,  43, 271, 105, 164, 247, 213,  88, 133, 113, 293,
  299,  39, 197, 218,  47,  20, 109, 244, 130, 250, 241,  86, 251,  40, 268,  14, 146, 240, 250,
  109, 279, 140, 109, 292,  83,  39,  43, 125,  71, 226,  75, 218, 216, 110, 286, 175, 174, 223,
  248,  65, 226,  98, 297, 298, 256,  50, 184, 217, 215, 169,  18,  88, 220, 262, 292,   8, 180,
  180,  56, 214, 299, 130, 146, 129, 169, 249, 250, 242,  59,  72, 103, 176, 287, 203, 279,  99,
  242,  65, 296, 237, 107,  95, 131, 170, 221, 134,  70,  90,  15,  97, 231, 236, 274, 295,  19,
  267, 225,  55,  30, 149,  75, 135, 286, 237, 192,  25, 287, 268, 186,  79, 286,  60,  71, 283,
  111, 283, 221, 268,  71,  44, 244, 126, 293, 137, 298,  42, 255,  40
,},
{ 181, 144, 110,  32, 117, 172, 265, 181, 222,  59, 263, 189, 144, 193, 154, 126, 144, 127, 178,
  127, 102,   6,  77,  84,  74, 196, 103, 253, 298, 241, 129, 295, 182,  68, 258, 222, 124, 135,
  163, 217, 167, 305, 102, 207, 169, 109,  15, 190, 166, 149, 258, 247, 168,  55,  91,  98, 161,
  291,  69, 234,  54, 163,  78, 249, 243,  12, 211, 132, 176, 281,  80,  45, 230, 280,  71,  83,
  210, 288, 114,  35, 184, 101, 181,  37,  83,  92,  98, 142, 290, 162,  54,  15, 208, 194, 280,
  141, 168, 299, 131, 237, 110,  36, 266, 292,  44, 111,  78,  17, 152, 150, 206, 167, 176, 226,
  117,  54,  50, 255,  49,  70,  62, 263,  10, 255, 194, 252, 243, 169,  56,  90,  51, 265, 256,
  249, 239,  55, 142, 227,  81,   2,  31, 299, 189, 183,  12, 264, 240, 175,  47, 218, 250, 194,
  288, 155,  30, 304, 136, 198, 114,  33, 237, 270, 130,  27,   3,   8, 166, 266, 238, 185, 151,
  140, 219, 250,  29, 219, 281, 177, 303,  36, 302,  53, 224,  82, 233, 302, 227, 253,  68, 235,
  109,  94, 153,  85,  94, 297, 211, 261, 171,  57, 202,  96,  71, 241,  68, 279, 133,  85, 288,
  134, 231, 125, 257,  91, 154, 103, 111, 167, 287, 291,   5, 238, 123, 210, 217,  12, 203, 231,
  177, 152,  12, 301, 271,  55,  90,   2, 240, 284, 116,  95, 205, 299
,},
{ 148,  53, 290,  25, 205, 249, 102, 245, 216, 143,  45, 194, 237, 278, 248, 149,  81, 158,  52,
  203,  53,  91, 142, 170, 225, 292, 282,  48,  90, 185, 184,  43, 164, 259, 297, 150, 174, 254,
  293, 127,  74,  37, 138,  87,  80, 141,  64, 192, 125, 194,   6, 168, 142,  50, 264, 133, 142,
  159, 155,  77, 246,  24, 100, 263, 227, 162,  23,  48,  31, 267, 168, 136, 178,   3, 237, 171,
   65, 241, 105, 158,  27, 270,  24, 157, 214,   6, 132, 183, 201, 211,  68, 259,  19, 144, 109,
   64, 136, 198,  10, 238, 266, 297,  48, 225,  70, 276, 211, 157, 265, 110,  90,   6,  97,  92,
   77, 166, 236, 284, 166, 290, 123, 154, 187, 292,  82,  69, 282, 198,  43, 153, 144, 150, 139,
   72, 223, 161, 116,  57,  85, 220,  65, 164, 102, 228, 103,  97,  14,  64, 249, 122, 203, 246,
  181,  61, 162, 260, 235,  33, 112, 220,  57,  97, 226, 229, 183,   5, 238,  34, 148, 198,  95,
  159, 255, 303, 287,  45,  66, 152, 265,  84, 271, 280, 118, 158, 234,   9, 169, 111, 280, 261,
  233, 200,  15,  11, 175,  56, 151, 185, 138,  81, 289,  74, 284, 210, 124, 304,  54,  48,  25,
  265, 264, 251, 146, 122,  90,  87, 292,  12, 157,  83, 295, 199, 267, 241, 121, 149, 229, 171,
   68,  46,  22, 303, 239,  90, 230,  77, 102, 119, 104, 218,   1,  12
,},
{  85,  33, 141, 264, 226,   7,  47, 132,  39, 181, 164, 302, 122,  36,  42, 102,  63,  60, 117,
  168,   7, 223, 194, 156, 112, 205, 163, 211, 139, 106, 117,   6,  86, 202,  69, 152, 222, 286,
   17,  40, 188, 269, 134,   7, 124, 122,  55, 259, 136,  83, 255, 141, 172,  12, 197, 201,  67,
  145,  56, 143,  59, 291, 272, 283, 296, 195, 299, 114,  46,  48, 283,  84,  90,  58, 221,  87,
  198, 172,  55,  39, 170, 205, 232,  60,  45, 176, 253, 158, 248, 166,  45, 221, 253, 115, 118,
  126, 225,  91, 171,   3,  41, 139, 279, 263, 251,  29, 126, 246,  92,  21, 200,  83, 111, 223,
  162, 157, 200, 192, 264, 265,  57, 292, 268,  71,  91, 116,  24, 196,  80,  51,  72, 149,  32,
  108, 111,  33, 223,  90, 270,  30, 279,  19, 306, 197,  41, 129, 165, 278, 260, 290, 298, 209,
  112,  61, 204, 124, 210, 236, 162, 260, 184, 267, 163, 231, 302, 180, 274, 129, 211, 208,  26,
   83, 140, 129,  94, 263, 121, 106,  20, 133, 192, 304,  29, 217, 237, 263,  55,  36, 224, 144,
  264, 250, 165, 228, 183, 232, 275, 190, 216, 273,  40, 174,  99, 229, 232,  77, 181,  28, 138,
  213,  70, 234,  66, 195, 277,  37, 264, 287,  27, 156,  77,   4,   2,  90, 221, 223, 284, 277,
  262, 111, 241,  46,  89,  50, 288,  96, 234, 130,  82, 258,  52, 137
,},
{  75, 128, 219, 100,  26, 268, 208, 236, 185, 279,  37, 156,  94,  53, 207, 166, 297, 207,  78,
  111, 284, 157,  43,  98, 159, 293,  37, 299, 201, 117,  46, 285,  62, 264, 233, 230,  53,  68,
  113, 173, 148,  35, 174, 199, 148, 143,  10, 209,  29, 117, 191,  31, 289, 274, 232,  15, 215,
  178,  18, 226,  91, 189, 257, 289, 276,  33,  45, 289,  40,  61,  26, 245, 224, 255, 142, 197,
  165, 166,  44,  69, 176,   2,  27,  29, 214, 174, 105, 294, 107, 181, 164, 180, 306, 121,  74,
  133, 250,  95,  13, 219,  82, 254,  87, 252, 304, 269,   5, 193, 297, 274, 281, 248, 284, 168,
   50,  52, 187, 107,  66, 243, 240, 170, 212, 274,   2, 121, 293, 219, 128,  69, 124, 257,  81,
  113,  16, 142, 178, 182, 296,  77,  64, 112,  54, 137,  32,  82, 189, 109, 162, 242,  48, 213,
  163, 277, 133,  26, 116, 247,  97, 112, 156, 279, 253,  41, 169, 191,   2, 232, 231, 282, 291,
  196, 301,  83,  71, 127,   5,  66, 134,  48, 138, 185, 227,   8,  70,  82, 123,  46, 226, 104,
  255, 279, 183,  64, 145, 143,  46, 183, 109, 299, 291,  83, 178, 213, 122,  28, 131, 140, 288,
   33,  59, 188, 143,  37,  97, 158, 139,  79, 228, 297, 241,  55,  83, 207, 271,   4, 306, 218,
  267,  11, 265, 208, 110, 157,   8, 242,  72,  42, 296, 254, 256, 172
,},
{ 195,  64,  59,  51, 218, 258, 238,  24, 251, 195, 273, 139,  45, 283, 252, 161,  59, 303, 131,
    1, 167,  60, 303,  39, 290,  77, 286, 145, 273,  21, 268,  53, 185,  95,  99,  99,  34,  21,
   48, 273,  24, 180,  95,  36,  13, 136,  36,  42, 225,  41, 275, 284, 293,  63, 232, 250, 297,
  258,  32, 153, 275, 122, 162, 117, 148,  22, 257,  19, 158,  79, 188,  50, 302,  39, 105, 141,
  277, 266, 263,  19, 241, 169, 276, 236,  61, 181, 235, 273, 100, 117,  53, 208,  94, 147, 260,
  113,  87, 219,  15,  15,  56, 206, 303, 201, 113, 228, 268, 302,  80, 279,  29, 283, 218, 248,
  148,  71, 130,  68,  25, 257, 178, 104, 269, 289, 156,  80,  90, 186, 165,  38, 136, 298, 203,
   46,  58, 158, 212,  10, 165, 224, 104, 121, 203, 290,  15, 200, 238, 289,  53, 238, 104, 134,
   32, 285, 280, 100, 128,  28, 254, 274, 210,  96, 304, 120,  64, 126, 158,  77,   6, 170,  68,
  119,  26,  30,  55,  34, 193, 169,  16,  84,  61, 304, 169, 111, 117, 281,  25, 161, 233, 221,
  147, 294, 289, 166, 278,  41, 212, 298, 218, 202, 223, 280,  32, 106, 119, 267, 107, 270, 202,
   15,   1, 243, 197, 129, 212, 156, 239, 272, 294,   9, 211,  61, 199,   2, 125, 198,  97,  73,
  192, 167,  43, 302,   6, 164, 232, 134, 241,  64, 228, 252, 126, 261
,},
{ 237,  73, 136, 261,  48,  56,   9, 123, 302,  27, 268, 260, 108,  48,  62, 300, 286, 293, 102,
  198,  36,  27, 228, 147, 159, 162, 111, 200,  52,   7,  77, 234, 144, 244, 107,  92, 130,  14,
  162, 148, 295,  44,  64, 239, 150, 159, 261,  56,  52,  79,  63, 218,  64,  75, 267,  13, 196,
  132,  90,  78, 222, 256, 297, 228, 144,  66, 162, 164, 129, 144, 120, 203, 124, 148,  22,  66,
  191, 225,  58, 209, 280, 275, 110, 138, 256,   2, 104,  33,  75, 183,  37, 234, 231,  33,  42,
  246, 161, 106, 169,  93, 105, 287, 275, 144, 306, 219, 189, 185, 193, 299, 241, 107,  34,  42,
   82,  46,  43,  94, 247, 106, 178,  93, 281, 202, 292, 128,  99, 215, 229,  32, 195, 168,  34,
   66,  50,  70, 125, 107, 268, 120,  49, 178, 293, 197, 137, 120, 144, 147, 254, 254,  75,  81,
  136, 185,  95, 221,  87,  73, 301,  96, 105,  19, 150,  29,  96, 229,  67,  13, 166,  83, 113,
  114, 243, 202, 166, 147, 152, 142,  61, 215, 284,  88, 294, 250,  64,  57, 207, 279,  86,  38,
   56, 133,  70, 240, 223, 213, 276, 216, 128, 161,   1, 101, 133, 294, 124, 248, 278,   2, 232,
  300, 302, 116, 287, 265, 200,  57, 245, 207,  61,  42,  32, 252, 151, 110, 181,  41, 141, 220,
  287, 283, 187, 258,  99, 270,  19, 234,  95, 236, 257,  47, 172,  14
,},
{  48, 154, 278, 208,  35, 124,  25,  44, 292, 210, 205,   5, 176,  27, 182, 301, 302, 108, 194,
  135, 174, 132,  96, 142, 284, 238, 165, 284, 255, 173,  30,  74, 233,  86, 227, 296, 176,  56,
  198, 225, 168,  62, 106, 167, 231, 199, 161,  28,  93,   3,  99,  67,  18, 117,  93,  40, 243,
   46,  63,  76,  57, 121, 136,  50, 113, 209, 277, 217, 264, 200, 265,  22,  47, 291, 300, 154,
  251,  60,   8, 288, 223, 283,  26, 152, 212,   7, 239,  32, 160, 290, 194,  62, 227,  36, 105,
  113, 178, 262, 228, 212, 119,   8, 266, 270,  72, 207,  44, 281,  58, 113,  97, 284,  76, 181,
  226,  73, 188,  94, 173, 209,  90,  17, 226, 248, 121, 127, 229, 101, 282, 136,  91, 252, 235,
   49, 265,  33,  40, 197, 202, 255, 240, 200, 139, 148,  30,  65,  97, 145, 171,  46,  50,  82,
   27, 303,  96, 153, 265,  37,  70, 269,  54,  43,  96, 207,  63, 246, 287, 298,  66, 236,  87,
   99, 143,  96, 214, 138,  31, 301, 295, 214,  34, 169,  51, 256, 291, 149, 213, 103, 155, 132,
  195, 127,  41, 165, 236, 136,   8, 168, 201, 132,  62, 225,  79, 120, 115,  18, 258,  43, 107,
   42, 226, 267, 156, 293, 190,  87, 110, 188,  71, 111,  35, 153, 278,  98, 189, 300,  45, 197,
  275, 286,  50, 215, 213,  32, 194, 272,  59, 230, 244, 232,  58, 126
,},
{ 125, 222, 157,   5,  16, 105, 152,  33,  30,  78, 277, 294, 170,  61,   5, 184,  12, 235, 138,
  184, 226, 117, 139, 243, 147,  74, 265, 187, 165, 116,  73,   3,  65,  18, 240,  86, 131, 124,
  177, 151,  98, 220,   6, 112,  95,  58, 217, 213,  54, 266, 183, 135, 109, 188, 279, 199, 268,
  121,  39, 244, 194,  69, 269,  62, 243,  84, 266, 158, 196, 289,  61, 304, 153,  15, 124, 260,
  284, 300, 256, 236, 107, 250, 191,  97, 204, 120, 298, 205, 254, 253,  82, 112, 306,   7,  70,
  130, 115, 166, 132,   1, 139, 167, 126, 221, 236, 102, 167, 258,  59, 259, 137, 177,   5, 171,
  302, 145, 123,  33, 191, 138,  65, 176, 293, 236, 133, 171, 115, 247,  90,  59,  53, 297, 241,
   63, 305, 112,  70,  74, 131,  85, 107,  64, 156,  62, 180, 303, 165, 106,  54, 141,  52, 113,
  210, 302, 116,   4, 242, 122,  10,  89, 198, 110, 122, 302, 206, 185, 154, 217, 161,  82, 272,
  268,  53,  48, 204, 269,  15, 144, 143, 137, 120, 227, 143,  16,  11, 135,  18, 198, 215, 262,
   10, 220, 220, 282, 129,  67, 133, 264,  33, 237, 162, 236,  27, 269,  44,  82, 108, 292,  67,
  239, 297, 218,  13, 210, 232,  94, 257, 211, 192, 214,  48, 203,  80, 108, 195,  32,  29, 242,
   78, 266,  31, 302, 117, 224, 269,  15, 232,  46, 302,  19,  24, 258
,},
{ 139, 262, 272, 212, 182,  57,  60, 183, 209,  45,  69, 123, 281, 300, 206, 243, 177,  21, 121,
  176, 268, 197,  29, 133, 224,  24, 217, 120, 148, 202, 189, 237, 160, 268, 231,  39,  99,  83,
   94, 110,  81, 146,   3, 106, 140,  77,  51, 265, 237,  72, 196, 169, 221,  77, 125, 306,   8,
  179, 209,  88, 164,  87, 182,  59,   4, 169, 113, 227, 115, 101,  19,  97, 236,  29,  97, 276,
   73, 282, 292,  65, 187, 250,  47,  44, 145,   1,  58, 243, 221, 269,  61, 148, 290, 221,  62,
  282,  61, 222,  46, 135, 217,  18,  87, 297, 166, 122, 254, 152, 242,  32,  45, 140, 132, 258,
  141, 180, 262,  98, 217,  17, 194, 168, 171, 255,  59, 250, 278, 108, 166, 262,   6,   7, 216,
   35, 134, 211, 217, 125, 202,  23, 279,  39,  47, 203, 186, 125, 230,   8,  22, 168, 241, 181,
  302,  86, 153, 220, 157, 110, 286, 122, 236, 108, 301,  76, 183, 295, 289, 113, 185, 223,  68,
   14,  13, 107,   6, 302,  61, 261,  69,  68,   3,  62, 203, 276,  26, 174, 203,  75,  18,  54,
  173, 222, 235,  41, 296, 280,  17, 204, 163,  19, 123, 299,   6, 226, 128, 108,  47, 163,  78,
  118, 191, 266,  78, 299,  12, 167,  62, 303,  73,  17,  85,  85, 112, 112, 292, 239,  18, 140,
  203, 235,   7, 240, 306, 198, 183, 151, 167, 220,  18, 236, 134, 185
,},
{ 108,  29, 186, 127, 164,  46,  64,  62,  26,   2, 292, 168, 241,  22, 141,  53,  94, 237, 182,
  272, 122, 177, 122, 296, 211,  18, 261,  69, 167, 190, 177, 259, 158, 183, 153, 119, 228,  86,
  190, 159, 155,  94, 132, 158,  88,  20, 235,  64, 118,  50, 117, 205,  26, 110, 271, 305,  56,
  131, 254,  24, 271, 167, 124,  10, 184, 227, 260, 160, 145, 198, 143, 259,  53, 228,  64,  87,
  155, 162,  24,  42, 250, 117, 227, 295,  57, 122, 304, 203, 145,  14, 217, 194, 209, 235,  76,
  145, 129,  58,  36,  66,  40, 229, 201, 306, 135,  20, 112, 154, 250,  62,  38,  65, 147,  79,
   58,  44,  39, 300, 199, 285, 288,  62, 237,  20, 303, 225, 247, 129, 182, 187,  11, 211,  81,
  173,  99,  19, 297,  72, 262,  96, 293, 235,  28, 258, 211,  24, 150,   2,  62, 168,  16, 180,
  213, 294, 116, 130,  12, 198, 180, 214, 181, 250,  51, 199, 306,  60, 272, 118,   2, 189, 232,
  190, 156,  66, 134, 250,  41, 166,  68, 183, 198, 128, 209, 271, 138, 294, 218, 276, 103, 275,
  177, 256,  15,  65,  32, 177,  49,  81, 247, 172, 180,  13,  96, 207, 207,  43, 284, 209, 169,
  111, 105, 189,  49, 245, 207, 295,  56, 164, 304,  32,  78, 127, 297, 223, 213, 176, 248, 144,
  187, 124, 248,  70,  62, 232,  27, 215, 141,  87, 238, 192, 184, 184
,},
{ 280, 289,  48, 299, 139, 198, 121, 217, 178,   1,  17,  37, 292, 229, 292, 256, 167,  79, 120,
  221, 132,  68, 119, 132, 123, 109, 189, 298, 134,   3, 273,   6, 202, 229, 135, 181, 302,   1,
  136,  97,  71,  75, 251, 170,   9, 118, 134, 155,  24,  88, 269,  38, 164, 284, 215, 226, 214,
  102, 189,  70,  55,  40,  81, 167, 209, 205, 281,  18,  27, 201,  34,  83, 270,  55, 296, 220,
  194,  56,  73, 240, 226, 114,  46, 165, 215, 293, 123, 191,  74, 120,  27, 107, 102, 146,  41,
  132, 260,  53, 258,  31,  13,  37, 260, 223, 193,  18, 176, 137, 283, 295, 214,  33, 140, 237,
  129, 159, 156, 183, 198, 182, 294,  14, 275, 198,   8, 108, 149,  54, 264, 100, 173, 190,  39,
   15, 157,  51, 151, 103, 268, 135, 182, 304, 161,  52, 256,  98, 248, 207, 142, 179, 206, 108,
  172, 215, 133,  45, 182, 232,  27, 198, 276,  24,  34, 230, 295, 260, 296, 238,  69,   1, 110,
   48,   1,  66, 136,  73,  85, 245, 291, 193, 304,  90, 168, 192, 152,  71, 283, 123, 269, 269,
   14, 233, 231, 211, 144, 292, 158,  33, 147, 168,  55,  54, 294, 276, 135, 305, 306,  90,  54,
   84, 191, 259,  13,  84, 268, 213, 246, 184,  87,  84, 247, 221,  74,  39, 121, 242,  97,  63,
  209, 130,  44,   2, 268, 234, 198,  19,  64, 161, 236,  41, 205,  18
,},
{ 281, 261, 114,   9, 140, 149, 202, 166, 215, 279, 186, 249, 236, 144, 182,  73, 127, 289, 171,
  294, 234,  80,  69, 140,  45,  93,  69, 236, 281, 158, 208,   6, 224, 259, 251,  71, 289, 163,
  106, 217,  35, 210,  67, 208,  72,  72, 296, 273,  71, 268,  26,  11,  44, 276,  44, 274, 127,
   65, 101, 171,  43, 276, 105, 202,  63, 161, 257, 264,  15, 206, 225, 215,  14,  90,  75,  71,
  107, 201,  84, 281, 258, 186,  57, 100, 304, 158, 203, 162, 135, 175, 178, 103,  98, 246, 107,
  220, 220,  39, 166,  94, 196, 283,  10, 122, 262, 285, 100,  75, 193, 224, 123,  50,  37,  22,
   35, 249, 210,  90, 153, 193, 293,  87, 185, 101,  50,  59, 194,  20, 184, 276, 132,  27,  13,
  146, 227, 179, 144, 112, 269,  32,  70, 113, 210, 150, 232, 295, 200,  30, 194,  50, 136, 215,
  214, 299, 276,  76, 277,  30, 272, 249, 144, 284, 123, 195, 186, 137, 203, 286,  43, 159,  50,
   92, 173, 119, 213, 100, 187, 145,  47,  93,  48, 200, 174, 163, 157,  42, 140, 237, 139,  65,
  120, 193,  27,  90, 162,  76, 160,  63, 233, 196, 260,  36, 245,  58,   2, 218, 274, 267, 225,
   29, 252, 146, 135, 240, 163,  35,  18,  85,  53, 239,  75, 271,  79, 269,   9, 274, 291, 169,
   46, 120, 269,  80, 295, 138, 224, 304, 101, 106, 259, 160,  99, 102
,},
{ 262,  71,  88, 200,  29, 299, 274, 150, 257,  71, 304,  68, 251, 216, 287, 169, 263, 102,  94,
  236, 163, 144, 188, 188, 261, 182,  71, 233, 242, 110, 194, 230, 218, 240, 179,  93,  69,  13,
  144, 258, 275,   4, 267,  28,  62, 122, 262, 265, 104,  21,  19,  99,  45, 167, 144, 276,  20,
  306, 264, 306,  18, 272, 235, 279,  22,  98, 251, 263, 247,   6,  35, 125, 131, 222, 101,  28,
  147, 249, 155, 137,  76, 236, 170,  56,  69, 288, 262, 117, 254, 298, 299,  97,  52, 300,  25,
   98, 207, 298, 270, 260, 108, 191, 130, 149,  36,  67, 238, 244, 290, 268,  68, 217, 175, 187,
    3, 101, 231, 143, 227, 227, 208,  41, 135, 120,  81,  32, 137,  77, 245, 252,  48,  21, 252,
  210,  17, 147,  92, 230, 234, 262,  73, 293,  92, 250, 249, 146, 259, 295, 161,  82,  11, 187,
  304, 115, 133, 260, 265, 132,  52, 302, 250,  87, 231,  12,  48,   7, 121,  44, 102, 246, 232,
  255,  84,  23,  31,   9, 132, 220, 251, 153,  90, 175,  62, 248,  67, 250, 126,  84, 123, 211,
  244, 111,  49, 149,  17, 186, 249,  31, 173, 306,   1,  50,  95, 238, 245,  63, 247,  53, 111,
  288,  60, 304, 262,  91, 176, 173, 158, 129,  59, 198, 188, 211, 285, 263,  99, 262,  40,  85,
  175, 258,  89, 166, 103,  70, 286,   6, 257,  32, 252,  33, 284,  27
,},
{ 268,  80, 269, 183, 115,  44, 305, 188, 147, 255, 195,  38, 213,  29, 299, 112, 129, 139, 240,
   48, 102,  85, 299,  66, 211, 216, 122, 295,  54, 278, 264, 254, 250, 150, 273,  83, 255,  14,
   17, 112, 165,  23, 299,  49, 188,   3,  82,  10, 139, 163, 235, 246, 108, 213, 114,  79, 281,
  257, 151, 237, 112, 196, 216, 263, 123, 257, 176,  72, 105,  55,  42, 153, 175, 168, 252, 224,
   12,   4, 291, 160, 164,  16, 304, 251, 111, 137, 153, 167,  33, 252,  78, 106, 237, 268,  88,
  140, 230,  29,   7,  24,  47, 206, 304, 230,  54, 174, 190, 240,  21,  48,  10, 129, 223, 305,
  191, 183,  24, 132,  98,  66, 240,  51, 144, 181, 205,   4, 161,  97, 272, 263, 300, 136, 216,
  259, 221,  50, 133, 187, 172, 187,  11, 123, 152, 229, 213, 154, 299, 239, 122,  23, 171, 178,
   39,  34,  53, 201, 301,  37, 192,  78, 221, 262,  82,  12, 253, 118,  75, 106, 212, 237, 166,
  205, 289, 261,  90, 284, 180, 222, 230, 261,  89, 241, 301, 208,  42, 209, 200,  57, 108, 124,
  141,  52, 109, 298, 229, 222, 295, 260,  24,  93, 137, 126, 183,  48, 134, 216, 170,  35, 102,
  227, 233, 146, 118, 142,  56, 287,  34,  70,  86, 287,  31, 224, 305, 117, 218, 175, 182, 148,
  213, 195,   6, 143, 145, 215,  55, 138, 129,  13, 179, 138, 120, 283
,},
{ 137, 191, 211,  14,  88, 204, 141, 245, 293, 217, 213, 295, 182,   1, 194, 284, 284, 171, 221,
    8, 133,  69, 186, 271, 182, 251, 167, 264, 113,  22, 107,   6, 168, 174, 223, 256, 246,  31,
  181, 216, 297,  82, 136, 254, 282, 104, 175, 306, 122, 223,  41, 272, 238,  61, 226, 240, 211,
  275, 156, 175, 273,  22,   7, 157, 197, 187, 290, 301,  76,  71,  23, 210, 245, 108,  39, 245,
  170, 105,  69, 116, 136, 115,  92, 232, 168, 187, 257, 101,  37, 103, 277,  79, 118,  45,  13,
   54, 125,  13,  83,  21, 111, 301, 242, 181, 178, 136, 167, 120,  63, 202, 175,  24, 226, 278,
  165,  31, 115, 112, 172, 207, 225, 209, 130,  69, 276, 137,  94,  26,  26, 256, 118, 290,  65,
  278, 181, 294, 233, 185,  68, 282,  69, 103, 146, 269, 296, 161,  18,  78, 154,  40, 285, 159,
  139, 279,  55, 129, 301, 299,  86, 203, 150, 108, 130,  72, 173, 259, 194, 293,  59,  92, 274,
  190, 243, 234,  65, 138, 132, 100, 179, 187,  45,  23, 129, 103,  50, 291, 117, 159, 138,  73,
  118, 107, 122, 297, 261, 115,  91, 217, 198,  61, 175,  60,  76, 293,   4, 228, 155, 222, 162,
   33,   3, 293, 209,  20, 139, 162, 240,  44,  40,  88, 299, 306,   4,  45, 157,  14, 212,  86,
  273, 127, 112, 265, 264, 216, 126,  16, 131,  73,  87, 178, 163, 155
,},
{  49, 161, 202, 131, 231, 140, 102,  68, 296,  20, 258, 130, 286, 272, 125,  99,  43, 243, 281,
   82, 137, 231, 197, 111, 187,  26,  43,  43, 237, 115, 167,   8, 280,  96, 227,  13, 265, 260,
  270, 111, 262, 283, 286, 158, 297,  57, 170, 161, 299,  40, 269, 173, 119, 145,  41, 103, 155,
  173, 147,   1,  96,  10,  53, 145,  46, 193,  89, 263, 224, 270,  73, 166, 281, 230, 212,  97,
  210, 145,   5, 291, 271, 235, 187, 250, 218, 240,  26,  30, 301,  71, 159, 181, 155, 130, 272,
  207, 266,  81,  48, 274, 265, 287, 222,  77, 261, 288, 194, 133, 227, 186, 290,  59, 229, 165,
  210, 175, 112, 263, 263, 146, 293, 131, 300, 269, 159,  50,  93, 160,  88,  27,  54, 157,  45,
  253,  91, 234, 225, 153, 250, 253, 251, 140,  44, 273, 284,  69,  16,  51, 256,  44,  62, 209,
  219, 124, 105, 127,  46, 186, 200, 258,  45, 253, 193, 169, 273, 211,  24, 142, 200, 220, 224,
  119, 226, 304,  16,  62, 301, 137, 237,   9,  47, 241,  30, 103, 228,  92, 220,  62,  58, 121,
   35,   5, 141, 187, 165, 153, 104, 211,  29,  23, 171, 199, 255, 261, 219, 190, 251,  75,   3,
   32,  47,  76,  78, 100,   1,  94,  69, 201, 161, 155, 164, 301, 243,  97, 196,  93, 146, 218,
   59, 240, 113, 115,   8, 202, 164, 186,  74, 288,  30, 183, 234, 180
,},
{  47, 166, 253, 119,  76,  24, 180, 245,  48,  78,  28, 122, 278,  34, 109,  84,  37,  35, 242,
  179, 212, 231, 241, 100, 162, 194, 240, 206, 180, 170,  16, 260,  39, 236,   9, 201, 172, 103,
   82, 159, 105, 117, 203, 163,  99,   6, 302,  25, 242, 283,  34, 145, 233,  11, 201,  17,  34,
  200, 163, 274,  38, 157,  46,  35,  26, 180,  99, 226, 233, 172, 203,  41,  90,  16, 123, 111,
  195, 280, 118, 243, 164, 178, 279, 113, 105, 262, 261, 109,  84,  83,  37, 305,  91,  60,  47,
  220, 166, 205, 290, 250,  82, 202,  17,  70, 160, 260, 187, 105,  79, 251,   1, 185,  99, 277,
  294, 182,  71,  66, 270, 213,  28,  65, 306,  95,  17,  55, 296,  31, 232, 208,  40, 129, 229,
  194, 224,   4, 243, 142, 278,  39, 217, 175, 121, 241, 231,  60, 168, 292, 228, 257, 228, 152,
   41, 261, 120, 149, 298,  61, 279, 271,  25, 125,  15, 268,  36, 228, 255, 231,  34, 179,  96,
   44, 141, 178, 239, 270, 281, 287, 306,  99,  94, 235, 160, 287,  60,  49, 168,  67, 222, 167,
  166, 290,  94, 266,   4,  99,  61,  75,  62, 212,  22, 288, 267,  44, 284, 128, 187, 168, 197,
   60, 177, 211,  64, 199, 276, 127, 293, 301, 119, 146,  65,  97, 109,  44, 104, 191, 276, 252,
   48,  90,  95, 166, 282, 243, 102, 303,  85, 187,  40, 191, 149, 125
,},
{ 297, 205, 264, 238, 294,   9, 120,  32, 197,  16, 220,  70, 293, 103, 134,  72,  58, 202,  94,
  120, 184, 192, 255, 131, 161,  56, 155, 140, 105, 142, 178,  55, 273, 179, 150,   8,  30, 213,
  167, 184, 206,  64, 232,  92, 267,  76, 287, 261, 158, 265,  23, 289, 289, 158,  84,  82,  97,
  142, 176,  38, 240, 123, 182, 187, 302, 102, 200, 305, 154, 231, 134, 249, 227,  68, 189, 249,
  162,  56,  31, 198,  61, 125,  38,  40,  72, 272, 251, 276, 300,  52, 247,  19,  89, 170,  45,
   45, 183,  81, 154,  38, 219, 115, 168,  82,  85, 219,  79, 219, 221, 198, 114,  56, 281,  30,
   34, 104, 178,  22, 267, 150, 114, 279, 178, 121, 227,  13, 277, 270,  81, 213,  55, 220, 179,
   34,  63, 138,  87, 228, 135, 140,  14,  96,  68, 164, 263, 246,  52, 155, 287, 169, 146, 137,
  240,  19, 190, 287, 191,  27, 100,  81, 203, 217,  45, 195, 133, 235,  88,  15, 156,  45, 127,
  278, 281, 210,  22, 296, 243, 186, 140, 159, 303,  54, 102,  40,  61, 183, 170, 292, 144, 238,
  275, 164, 258,  87,  11, 214,   1, 237, 270,  10, 271, 180, 267, 129, 222, 127, 305, 172,  31,
  211, 101,  18, 305, 293, 253, 210,  52, 113, 227,  83, 237,  27,  66, 184, 245,  92, 139, 162,
  151,  61,  49,  38, 137, 232,   3, 190, 122, 172,  83,  58,  48, 133
,},
{ 149, 276, 157,  27, 240,  95, 175, 299, 256, 244, 172,  24, 193, 291, 148, 102,  91, 209,  29,
  254, 199, 175,  80,  52,  51, 144, 238, 110, 202, 180, 207, 303, 199,  29, 171, 257, 192, 248,
  119, 305,  67, 295,  39, 136,  16, 272,  95,  69, 152, 153, 148,  61, 231,  25,  22, 230, 118,
  207, 254,  43, 299,  48, 211, 138, 169, 152, 111, 262,  27,  61, 306, 124, 302, 125, 284, 215,
   11, 299, 297,  67,  24, 243,  62, 130, 129,   9, 221, 181, 101,  40,   3,  24, 106, 232, 240,
  259,  13,  68,  12, 102, 285,  65,  69, 274,  12, 219, 245,  32,  87,  75, 121,  62, 222, 296,
  243, 102, 225, 202,   5, 213, 305, 273, 161,  18, 119,  41, 205, 296, 139, 272,   6, 136,  89,
  168, 236,  55, 160, 157,  56, 165,  52,  67, 186,  72, 266, 193, 181, 215,  76, 153,  73,  59,
  238, 138, 248, 127,  91,  23, 152, 103, 296, 228, 181, 126, 211,  23, 172, 287,  58, 207,  83,
  301,  93, 266,  17,  63, 115, 277, 258, 212, 128, 285, 163,  48, 276, 101, 130, 103,  35, 274,
   41, 182, 211,  86,  49, 259, 262, 203, 248,   1, 144, 250, 278, 297, 117, 136, 222,  68,  95,
   68, 122, 229,  91,  55,  41, 254, 253, 278,  49,  88, 170,   5, 274,  23, 167, 301, 130,  57,
  224, 295, 150,   8,  71, 268, 124, 104, 216,  23, 248, 306,   9, 225
,},
{ 289,  65,  84, 130,  35,  58, 145, 277, 274, 137, 254,   2, 209, 185, 164,  20, 178,  81, 131,
   55, 263, 163,  34, 189,  39, 290, 258,  58,  51, 195, 133,  93, 265, 144, 304, 292,  72, 143,
  179,  57, 144, 116, 195, 269, 139,  36,  41, 144, 247, 132, 299, 300, 136,  96,  95, 299,  67,
  251,  41,  29, 166, 145,  93,  35,  66, 183, 188,  52,  71, 269,  54, 266,  29, 201,  68,  81,
  184, 252,  35, 134, 292, 138, 298, 123, 179, 184, 112, 248,  95, 289, 151,  32,  65,  64, 205,
  175, 131, 167,  99, 111, 169, 283, 188, 186, 301, 241,  16,  57, 118, 117,  74, 220, 112, 282,
  227, 208, 279,  14, 134,  96, 219,  20, 108, 135,  10, 296, 195, 281,  79, 289,  58,  23, 226,
   45,  55, 204, 143, 133,  83, 176, 120, 264, 120, 202, 173, 293, 240, 219, 206, 154,  76,  32,
  156, 137, 133, 303, 264,  33, 216, 164,  42,  89,  84, 198, 190,  78,  78,  47, 152, 262,  52,
  165, 175,  33, 108, 181, 260, 251, 258, 239,  88,  56, 107, 254,  71, 129, 196, 169, 303, 248,
  100, 283,  63, 137, 241, 120, 144, 149, 247,  93, 230,  60,  28,  91, 249,  80, 209, 195,  67,
  243,  19,  20, 214,  12, 275,  45, 119, 236,  22, 107, 129, 163,  72, 102, 262,  84, 146, 109,
  305, 186,  37, 293, 140, 288, 143, 221, 208, 127,  20, 219, 110, 103
,},
{  90,  95, 104, 219,  90,  24, 115, 249,  95, 255,  87, 183, 305, 249, 206, 190, 254, 228, 164,
    1,  10, 136, 254, 103, 254,  72,  27, 237,  46,  86, 123,  89, 283, 233, 304,   6, 296,  10,
  181, 182, 248, 206,   2, 273, 254,  39, 270, 103, 175,  40,  16, 153, 232, 197,  53, 245, 193,
   16, 160, 245,  28,  15, 227,  52,  88, 303,   3, 176,  86,  89, 304, 254, 127, 227, 179, 162,
  236, 207,  37, 236, 237,  29, 170, 300, 185, 211, 283, 284,  64,  76,  41,   6, 134, 275, 199,
  223, 201, 282,  12, 218,  83, 179, 282, 217,  51,  77,  28,  35, 241, 275, 122, 193, 277, 119,
   13,  95, 244, 106,  47, 293,  66, 109, 231, 238, 175,  46, 140, 122, 138, 250, 131, 280, 187,
  139, 303, 215,  71, 278, 196,  97,  94, 288, 306,  40,   4,  38,  58,  50, 264, 123, 232, 281,
  161,  47, 162, 165, 232, 247, 296, 156, 162, 156, 195, 306, 185, 241, 110,  89, 108,  53, 116,
  256, 181, 168, 209, 209, 117, 194,  39,  46, 245, 141,  25, 266, 139, 192, 268,   1,  90, 159,
  197, 118, 264, 126, 283, 193,  81,  95, 236, 101, 176,  36, 249,  42,  24, 127,  22,  37, 200,
  248, 181, 222,  95, 302, 140, 255, 106, 204, 288,  39, 209, 164, 135,  11, 135,  63, 245, 251,
   97, 188, 248, 243, 247, 283, 299, 272,   8,  39, 142, 165, 278, 254
,},
{ 213, 163, 218, 270,  22, 197, 251, 136, 289, 224, 239,  52, 194, 195, 268, 288,   7, 270, 230,
   61,  48, 129, 116, 141,   1, 240, 258,   8, 270, 180, 284, 244,  27,  64, 100,  49, 302,   6,
   59,  96, 194, 231,  59, 248,  84, 222, 163, 253, 248, 207,  52, 264,  33, 141,  85, 101,  76,
  103,  36, 213, 171, 213, 250, 263, 290, 127, 184,  36, 236, 190, 223,  61,  99,  43, 134,  74,
  273,  96, 261, 175, 183, 116, 248,  11, 283,  97, 169, 117, 176, 193, 144,  56, 186,  17, 134,
  303, 305,  16, 171, 222, 295, 209, 105, 279,  51,  53, 279, 206, 143, 193,  31,  25, 113, 181,
  168,  69, 303,  29,  92, 147, 222, 215,  66,  27, 128,  76, 168, 264, 285, 205, 224, 288, 136,
  196, 197, 170, 197, 237,  28,   4, 169, 246,  19, 219, 124, 145, 147, 120,   3, 262,  62,  52,
    3,  77,  55,  74, 130, 202,  61, 154,   8,   2,  18,  45, 265, 275, 153,   3, 305, 150, 301,
  169, 212, 277, 298,   8,  78, 145, 163,   8, 183, 176, 303, 125,  45, 190,  40, 267, 295, 179,
   69, 301, 247,  14, 185, 108,  70, 139,  86, 177, 103, 249, 207,  57, 303, 206, 133, 188, 100,
   86, 265, 160, 246, 160, 257, 195, 164, 256,  61,  11, 219,  36, 241, 226, 304, 145,   4,  33,
  284,  35, 171, 142, 216,  84, 176,  21, 167,  89, 228, 127, 233, 189
,},
{  34, 167,  14, 269, 289, 127, 239, 263, 115, 275, 171, 219, 146, 175, 162, 271,   8,  60,   8,
  215,  44, 116, 293, 183, 302, 300, 127, 291, 290, 215,  30,  90,  77, 165, 295,  42, 262, 224,
   34, 142,  59, 272, 147,  68, 140, 285, 249, 241, 292,  47, 170, 106,  20, 288,  77, 244, 136,
  200, 246, 154,  83, 189, 128, 139,  92,  93,  59, 159, 158, 120, 135, 128, 104,  51, 253,  74,
  269, 193,  83, 296,  57,  70, 285, 201,  89, 145,  73, 118, 143, 162, 188,  21, 115, 163,  68,
   18, 306, 287, 128, 291, 266,  60,  79, 191, 228,  96, 300, 293, 180, 291, 229, 151,  67, 102,
  209, 200, 144, 224,  21, 193, 238,  44,  15,  81,   8, 203,  58, 195,  94, 104, 234, 226, 118,
  185, 273, 121,  72, 248, 138,   6,  89, 212, 180,  57, 267,  73, 295,   7, 137, 265, 271,   3,
  244, 262, 257, 224,  54,  69,   8, 243, 201,  92, 274,  20, 197, 141, 137,  48, 258,  22, 204,
  112, 100, 223, 132, 227, 284,  94, 215, 233, 174,  12, 137,  97, 218, 118, 147, 171, 128, 302,
  303, 260, 287, 148, 267,  85, 257, 147,  90, 140, 222,  57, 259, 185, 250, 100,  34, 184, 224,
  298,   8, 253,  86,  20, 222, 113, 143, 162, 262, 122,  70, 164,  80, 293, 218, 222, 199, 146,
    8, 117, 113, 242, 302,  79, 286,  61, 268, 301, 197,  44, 122, 226
,},
{ 117, 273, 187,  36, 217, 244, 109, 190, 272, 121, 210,  48,  91, 198, 233,  73,  84,  73, 260,
  146,   3, 278, 265,  45, 114, 130, 173,  69, 214, 182,  60, 157,  30, 281,  66, 276, 170, 120,
  212, 130, 114, 201,   1, 187, 202,  10,  98,  84,   5, 115,  19, 103,  79, 130, 140, 272, 229,
   39,  51,  20, 122, 163,  50,  44, 300,   1, 166, 289,  19, 120,  12,  88, 285, 300, 268, 191,
  122,  84,  67,  68, 215, 237, 173,  42,  36, 192, 243,  51,  63, 149, 208, 153, 215,  81, 185,
   30, 236, 226, 239, 252,   9, 279,  28,  86, 169, 121,  34, 294,  41, 292, 144,  46, 133, 291,
   90, 283, 124, 134,  52, 197, 154,  95,  42, 184, 133, 239, 123, 178, 224,  40, 267, 277, 255,
   97, 152, 174, 163,  94, 115, 279, 145, 246,  21,  76, 168, 245, 228,  48, 219, 244, 305,  77,
  140, 133, 141,  53, 101, 124, 196, 237, 179, 165, 107,  10, 218, 294, 244, 182, 158, 160, 262,
  285,  10, 183,  22, 294,  21,  14,  64, 185, 118,  28, 248,   6, 101,  99, 268,  47,  99, 125,
  205, 265, 266, 154, 215, 266,  65, 224, 168,  23,  33, 154, 272,  93, 190,  30,  86,  56,  37,
  183, 156,  57, 197, 139, 125, 196, 223, 100, 291, 192,   9, 269, 189, 277, 121, 297, 155, 182,
   69, 255, 259, 258, 305, 273, 124, 116, 306,  79, 167, 232,  90, 125
,},
{ 297, 275,  64, 172, 211, 150,  33, 268, 142, 240, 263, 252, 219, 223, 298, 196,  47, 249, 132,
  138, 151, 290, 302, 155, 106,   8,  91,  73, 275, 176, 190,  99, 170, 170, 195,  65, 105, 211,
  184,   7, 177,  73,   9, 197, 291, 179, 291,  57, 217,  28, 162, 274, 247,   4, 203,  21,  45,
   30,  15, 233, 293, 207, 188, 191,   4,  69,  21,  65, 217,  17,  82,  58, 274, 263, 166,  87,
  242, 290, 142, 147, 193, 176,  97, 241,   1, 203, 181, 258, 242,  31,   6, 190, 244, 294,  66,
  183, 300, 151, 175, 294, 221,  42, 245,  93, 101, 228, 247,  66, 103, 160, 155, 199, 142,  64,
   48, 207, 279,  75,  28, 239,  98,  98, 208, 164,   9, 129, 154,  97, 228, 205, 194, 140,  20,
   60, 273,  66, 257, 148,  87, 284, 254,  24, 139,  64,  98, 183, 237, 215,  43, 160, 133, 214,
  165, 118,  62,   1,  95, 137, 163, 305, 169,  64,  85, 287, 182, 110, 154,   4, 107, 169, 108,
  137, 215,  79,  27,  79, 267, 233, 174, 224,  82,  78, 202, 128,  87, 224, 220,  85, 124, 115,
  233, 203, 233, 259, 206, 118, 168, 241, 112, 116,  82, 191, 133, 134, 271,  33, 207,  71, 226,
   51, 224, 304, 151, 119, 193,  59, 121,  43,  26, 255, 283, 278, 238, 264, 171, 109, 245,  41,
   81,  82, 214, 202, 229, 255,  33, 212, 242,  86, 282, 185,  89,  74
,},
{ 166, 253, 306,   6,  30, 218,  30, 218,  21, 182, 216,  57, 115,  54,  98, 114,  75,  71, 252,
  131,  55, 176, 260, 286,   2,  85, 287, 216, 276, 169, 166, 218,   6, 302, 124, 273, 202, 284,
  131, 210,  25, 305,   6,  71,  67, 243,  58, 112, 121, 265,  46, 227,  94, 264, 143, 275, 228,
  217,  60, 248, 122, 110,  99, 242, 241, 216,  44, 224, 155,  66, 218, 178, 286, 148, 277, 162,
  100,  32,  64,  42, 221, 165,  44,  12,  62, 176, 140, 239,  96, 282, 133, 182, 153, 222, 236,
  222, 306, 176, 138, 183, 256, 103, 238,  87, 151, 104, 224, 207, 228,  31, 101, 163,  79, 305,
  291, 132, 212, 110,  54, 178, 286, 168, 187, 209, 306,  14,   5,  33, 188, 175, 166, 276, 231,
  187, 147, 227,  39, 199,  80, 106,  85, 175,  81, 162, 190, 156, 193,  23, 298,  40, 222, 170,
  104,  39, 130, 237, 102,  50, 165, 257,  83, 236, 164, 167,  72,  10, 285, 147,  21, 170, 234,
   34,  71,  52, 274, 186,  36,   2,  33, 281, 276, 132,  14,  45, 257,  10, 303,  65, 219, 104,
  287,  82, 243, 165, 194,  97,  87, 255,  74, 177, 119,  38, 294, 152,  65, 237,  42, 149,  12,
   55, 230,  39,  33,  95, 205, 122,  76,  39, 289,  71, 218, 177, 240, 221, 243, 186, 174, 234,
  244, 295, 210,  55,   8, 138, 248, 230, 208, 210, 216, 106, 287, 109
,},
{ 286,  68,  29, 121, 220, 227, 174, 149, 240, 138, 296, 120,  17, 208, 264,  51, 305, 268, 287,
  180, 295,  13, 165,  29,  15,  25, 218,  77,  96,  12,  63,  33, 276, 300,  60, 214,   6, 196,
   50, 161, 278,  31,  86, 172, 228, 295, 127,  64, 115, 200,  26, 121, 161,  90, 141, 108, 136,
   25, 228, 258, 238, 147,   9, 303, 158, 155, 258, 231, 257,  28, 109,  69,  16, 117, 235, 296,
  177,  23,  31, 232, 151,  47, 178,  64,  18,  75, 245,  18, 241, 213, 258, 218, 281, 104,  37,
  109, 175, 281, 161, 100, 210,  49,  93, 221, 272,  60, 123, 107, 205, 263,  81,  63, 119, 149,
   71, 199, 185,  17, 133, 109, 185, 107, 129, 259, 302,  52, 296, 196, 138,  56, 130, 237,  74,
  282,   4, 212, 125, 161, 215, 220, 207, 230, 288, 202,  24,  68, 262, 135, 166,  82, 206, 123,
  232, 242, 289, 143, 141, 239, 224, 179, 237, 302,  68, 235,  37, 275,  23,  88, 143, 259, 245,
  125, 194,   1, 277,  56, 160, 297,  31,  62,  34, 192, 129,  69, 123, 239, 172, 195, 196,   7,
  208, 160, 199, 259,  90,  21,  14, 211, 204, 149,  86,  21,  86, 127,  96,  73, 271, 164, 199,
  287,  49, 111, 175, 299, 147,   5, 118,   5, 252, 152, 170, 261, 204, 244, 244,  95, 261, 303,
  114, 302, 301, 121, 209, 210, 248,   3, 249,  53,  53, 131,  82, 192
,},
{ 132, 288, 248, 227, 267, 122,  65,  40, 230, 294, 167, 110, 196, 178, 116,  77, 210, 276, 226,
  301, 114, 252, 126,  82,  22,   2, 110,   3, 305,  45, 152, 285, 107, 270,  23, 196, 138, 263,
   88, 300, 216,  21,  48, 139, 150, 286, 147, 177,  89,  57, 255,  37, 185, 230, 293,  54, 280,
  184, 219,  36, 277,  37, 124, 174, 217, 260, 198, 179, 199, 222, 284, 300, 254, 245, 228, 291,
  114,  47, 117, 203, 117, 236,  53, 140, 114,  24,  36,  47, 137, 295,  13, 250, 122, 282, 302,
    2, 229,  69, 156,  49,  18,  20,  68, 156,  23, 230, 116,  69, 295, 292, 168, 276, 208, 293,
   41, 123, 129,  95,   4, 182,  65, 126,  89, 115, 113, 232, 253, 148, 150, 266, 295, 210, 191,
  192, 292,  34, 283,  16, 192, 256, 243,  85,  46, 273, 280, 133, 235, 188, 201, 208, 135, 302,
  128, 154,  74, 295, 264, 157, 154, 136, 217, 220, 130, 148, 175, 296, 281, 121, 157, 182, 270,
   53, 128,  20,  34, 200,  44, 186,  27,  68, 255, 255, 167, 178, 105, 280,  54, 193, 161, 169,
   55, 173, 214, 230, 248,  81, 148,  24,  93, 215, 107,  88, 114, 127, 172, 265, 254, 162,  69,
  137, 237, 183, 221,  38,  16, 220,  74,  38, 245, 236,  56, 119, 179, 135, 231,  34, 106, 108,
  224, 188,  45,  71,  74, 255,   1, 253,  59,  83,  75,  61, 238, 109
,},
{ 286,  34,  64,  63, 134, 157,  78, 184,  62,  40, 101,  71,  70, 289,  81,  69, 268,  96, 185,
  154, 158,  72, 241, 202, 118,  45, 135, 207, 190,  41, 246,  19,  36,  94,  28, 113, 236, 132,
   29, 118,  61, 222, 109, 214, 296,  71, 170, 153, 180, 168, 125,  23, 278, 181, 107, 258, 222,
   77, 195, 110,  26, 302, 243,  21,  90, 131, 302,  78, 212,  72, 265, 135, 138,  85,  25, 247,
  306,  37,  46, 285,   5, 250, 249,  73, 146, 127,  93, 221,  49, 254, 271,  98,  42,  73,  97,
  175, 262, 204,  54, 118,  76, 118,  10,  51,  34, 239, 249, 306,  67,  23,  35, 130, 232, 278,
   59, 256, 176, 241, 118,  59, 189, 193,  87, 161, 208, 166, 207, 137, 253,  18, 221,  59,   8,
  242,   9,  50, 239,  98,  32,  25,  50,  81, 198, 167, 135, 158, 239, 177,  24, 292,  67,  36,
   57, 266,  97,  87, 199,  94,  24, 168, 116, 129,  52, 201,  18,  71,   2,  84, 117,  88, 257,
  161, 213,  58, 245, 123, 174, 305, 215,  56, 128, 171, 252, 222, 256,  87, 135, 253,  17, 256,
  273, 235, 290, 230, 155,  75, 305, 272, 280, 168, 124,   9, 136, 254,  71, 180, 299,  69, 212,
   37, 131, 118,  12, 180,  90, 123, 216,   3, 251, 108,  28,  99, 146, 183, 158,  83, 109, 235,
  295, 282, 194, 263, 225, 276,  58,  63, 272, 211, 233, 297,  37, 143
,},
{ 271, 118, 264,  10,  79,  77, 257, 282, 134, 131,  60,  68, 134,  54,  35, 132, 221, 248, 247,
  237, 172,  86,  97, 152, 176, 289, 273,  82,  89, 176, 254,  18, 250, 233,  30, 270,  50, 138,
  301, 212, 103, 159,  22, 262, 220,  29, 223, 268, 202, 140, 153, 122, 173,   8,  14,  47, 239,
  181,  52,  52,  49,  25,  85, 198, 184, 118, 203, 184,   3,  82,  58, 185, 252, 243, 278, 233,
  185, 174, 123,  27, 121, 233,  53,  64, 171, 256,  26, 147,  49, 118, 169,  22, 180, 265,  19,
  274, 226, 263, 266, 252, 252,  72,  57, 244, 105, 185, 140, 180, 171, 127,  21, 233, 230,  45,
  140, 296, 303,  61, 105, 300,  71, 233, 170,  35, 145, 255, 167,  52,  10, 246, 204, 255, 239,
  227,  16, 252, 226, 185, 257, 272, 242, 167, 187, 230,  62, 189, 252,   8, 159, 180, 138, 292,
  230, 162, 256, 207,  54,  83, 173,  48,  46,   9, 148,  86,  22,  59, 181,  59, 121, 218,  85,
  114, 216,  93,  49, 266, 210, 139, 267, 177, 115, 291, 122, 127, 268, 269, 277, 213,  39, 136,
  215, 143, 304, 142, 233, 297, 152,  79,  53, 277,  12, 263, 179,  69, 158, 304,  19, 245,  67,
  201, 246, 234,  88, 161,   6,  98, 160, 182, 105,  60, 190,  14, 233, 109,  47, 299,  80,  67,
  117, 219,  73, 173, 220,  45,  26, 252, 271,  94, 205, 175, 212, 225
,},
{ 289, 187, 233, 237,  18, 204, 127,  52, 257,  15, 141, 197, 253, 126, 234, 214, 208, 211, 170,
  273, 246, 136, 252, 206, 139, 108,  96,  93,  23,  82, 129, 140, 287, 195, 201, 151,  85,   1,
   69, 239,  51, 152,  59, 252, 265, 240, 105, 272, 139, 182, 286, 305, 197,  38,  78, 291, 191,
   65,  15, 134, 175, 202,  70, 216, 126, 198, 154, 144, 300, 245,  75,  18,  90, 151, 186,  75,
  202, 119, 217, 267, 252, 235, 288, 114, 113, 226,  52,  53,  61, 237, 229, 198,  63, 138, 238,
  261, 146,  73, 294,  58,  12, 250, 195, 174, 271,  27, 289, 259, 266, 201, 126, 120, 283, 290,
  283, 105, 166,  92, 300, 196, 306,  93,  68, 144,  27,  15, 102, 243, 142, 160,  32, 221,  38,
  195, 114, 291,  33, 199, 111,  70, 227, 147, 220, 203,  24,  89, 236, 290, 306, 237, 103,  97,
   82, 129, 157,   4,  37, 303, 276, 185, 294, 146, 172, 165, 150, 196, 114,  56, 231,  18,  63,
  167, 295, 156, 242, 213, 156,  39, 120, 248,  53,  43, 113, 213, 150, 121,  57,   9, 106, 252,
  269, 150,  24, 230, 297, 304, 182,  39, 123, 205, 199, 235,  41, 299,  21, 121,  70, 299, 244,
  215, 152, 144, 219,   9,  74,  10, 270, 143, 233, 163, 101, 183,  81,  61,  41, 271, 144,  59,
    8,  79, 268, 216, 305, 130, 227, 123,  49, 182,  91, 176, 286, 306
,},
{ 172, 273, 282, 184, 297, 188, 272, 278,  18, 132,  90,  94, 203, 193, 248, 195, 170, 133, 240,
   58, 187, 283, 153, 302, 262, 243,  42, 281, 111, 124, 190, 195, 162,  28, 262,  34, 145, 178,
  251, 218, 106, 265,  16, 249, 121, 108, 196,  12,  72, 296,  49, 198, 100, 259, 256, 160, 143,
  114,  48,  16, 289, 248,  79, 285, 290, 231, 161, 172,  93, 273,  39,  82,  73, 100, 184,  45,
  303,  14, 288,  69, 266, 186, 187, 285,  21,  65, 231, 101,  22, 243, 302, 293,  45,  55,  89,
  211, 222,  73, 152, 269, 100, 304,  98, 305, 223, 300, 193, 107, 290, 184,  40, 101, 188, 119,
  233, 174,  51, 272, 196, 215, 241, 164, 237, 180,  84, 280, 249,  58, 304,  39,  90,   6, 282,
   15, 115, 181,  30, 291, 258,  90, 193, 282,  84,  33, 193,  73, 288, 214,  69, 277, 120, 256,
   57,  92, 245, 109, 264, 216,  62,  59, 188, 123, 294, 146,  31, 227, 148, 251, 118, 226, 237,
   64, 143, 152, 199, 244,   2, 255,  50, 131, 239, 127, 243,  28, 232, 122,  66, 196, 281,  15,
  175, 242,  25,  83,  11,  62, 209, 102,  62,  35, 234, 183, 105,  20, 246, 204, 208,  21, 138,
  126,   1,   1, 185,  87, 124, 104,  72, 296,  65,  54,  10, 202, 225,  19, 165, 186, 183, 140,
   77,  30, 293, 266, 285, 244, 267, 187, 289, 149,   6,  27, 241,  70
,},
{ 240,  64,  70,  28, 282,  63,  33, 140, 202, 172, 101,   3, 288, 105, 249, 215, 205, 201, 252,
   98, 245,  53,  14,  30,  66,  43, 258, 293, 249, 102, 239, 175, 190, 179, 250, 286, 147,  82,
  177, 259,  11, 169, 268, 224, 209,  59, 118, 259, 197, 134,  89,  69, 119,  58,  42,  42,  82,
    7,  76, 285, 218,  91, 262,  72,  17,   1,  58, 129,  58, 141, 264, 163, 223, 294, 246, 230,
   49, 262, 157, 210, 139, 281, 169,  90,  41,   4,  22, 178, 122, 176, 298, 120, 258, 298, 108,
  137, 178, 113,  69,  60,  92, 229, 199,  73, 252,  35,  39,  39,  86, 197,  95, 255, 253,   2,
  118, 188, 270, 306,  53,   6, 135,  50, 215,  72,  82, 180, 171, 259,  86, 146,  27,  68,  34,
   50,  89,  30,  31,  83, 152, 193,  76,  27,  87, 280, 119, 140, 265, 293,  27, 257, 178, 155,
  293, 278, 261, 228,  22,  14, 201, 209, 156, 185, 201, 272,   9, 167, 210,  75, 209, 161, 246,
  167, 209,  22, 212,  59, 278, 133,  99, 201, 147, 278, 249,  53, 233,  43, 288, 160, 190, 204,
  186, 223,  89, 193,  63, 190, 265, 283,  27,  82, 154, 126,  73,  40,  46,  23, 254, 261, 239,
  109,  63, 133, 201, 215,  19, 173,  62,  94, 230,   8,  19,   1,  25, 267, 107, 146, 206, 156,
  108,  72,  93, 126,  41, 257, 171, 304, 233,  43, 189, 188,  82,  11
,},
{ 257, 109, 247, 302, 289, 254, 236, 214, 207,  42, 268,   4, 244,  27, 298,  64,  85, 109, 189,
  256, 123, 145, 173,  78,  28, 150, 155,  65,  95,  59, 142, 127, 240, 276,  56, 245,  45,  45,
   95,  73, 187, 113, 130,  20, 130,  94, 236, 220,   3,   5,  62, 136, 175,  51, 116,  61, 135,
    8, 194,  65, 115,  29, 216,  46, 179,  90, 101, 167,  76,  48, 258, 187, 172, 113, 238, 262,
  178, 275, 245, 250, 221, 251, 195, 202, 192, 262, 256,  97, 212, 269,  75, 208, 268,  39, 223,
   98, 259,  60, 165,  37, 212, 257,  59, 217, 148, 240,  51, 199,   5,  67, 126,  63, 121, 215,
   15,  89, 168,  25,  83,  67, 125, 162,   1, 211, 118,  62,  62,  41, 202, 298, 302,   6,  11,
  287,   9, 273, 138, 263,  48,  76,  68,  85, 106, 302,  83, 194, 100, 200, 268,  39,   9,  30,
  288, 183, 230, 175, 131, 202, 209, 132, 176, 195,  92, 180, 211,  83,  81, 238,   7, 264, 208,
  235, 124, 247, 163, 190, 231, 110,  12, 285, 300, 254, 227, 263, 151, 234,  34, 294, 238, 270,
  130, 176,  63,  54, 146, 192,   7, 224,  30,  74,  70,  23,  21, 304,   9, 182, 294, 179, 190,
    2,   7, 189, 296, 118, 178, 303, 105,  83,  31,  50, 156, 136, 153,  93,  44,  47, 193, 250,
  265, 173, 174, 115, 288,  98, 285, 304,  13,  54, 137, 279,  87,   2
,},
{ 270, 289, 226,  38, 182, 256, 118, 241, 282, 150, 199,  55, 299,  57,  90,  69, 152, 235,  51,
  106, 121,  49, 111,  73, 273, 127, 282,  92,  29, 200, 150,  10,  83, 144, 142,  83, 257, 166,
  159, 104,  32,  66,  78,  57, 282, 137, 182, 115,   6, 303, 271, 238, 239,  51, 229, 259,  50,
  289,  42, 192,  62, 276, 275,  93, 205, 276, 164,  65, 269, 130, 153, 244,  77, 152,  47, 213,
  113, 247, 244, 234, 252,  46,  40, 201,  81, 288, 252, 158, 159, 155, 139, 254, 207, 284, 137,
  277, 176,  98, 209, 215, 260, 242, 254, 146, 119,  90, 215, 108, 137, 169,  82, 176, 234, 142,
   22, 233, 197, 263, 124, 253, 284, 102, 181,  84,  24, 226, 208, 150, 226, 101, 131,  47, 191,
   57, 140, 182, 181, 236, 145,  90, 137, 265, 211, 173,  15, 292, 103, 144,  28,  19, 273,  10,
  110, 268, 258,  19, 269,  80,  70,  29, 126, 211, 206, 144, 141,  57, 179, 114, 114,  17, 133,
  206, 283, 103, 161, 159, 305,  33,  88, 297, 303, 152, 161,  90, 225, 207,  37,  63,  57, 113,
  117, 184, 119, 252, 185,   2,  75, 167, 178, 206,  16, 102, 283,  63, 103, 257,   8,  85, 194,
  119, 123,   2, 107, 253, 195, 118, 179,  53, 239,  82,  49, 261,  52, 277, 192,  61, 223, 201,
  214, 221,  52, 178, 284, 103, 131,  58, 279, 120,  99, 265, 149, 212
,},
{  69, 285, 104, 176, 212,  61, 269,  34,  81,  73, 214,  32,  11, 125, 288,  69, 187,  88, 227,
  156, 225, 259, 129, 256, 174,  22, 304,  51, 267, 107,  22, 280, 258,  38,  62, 241, 127, 189,
  277, 192,  56, 100,  40,  15, 199, 103, 255, 250, 149, 185, 255, 200, 104, 296, 192,  37,  14,
  103, 209, 137, 181, 243, 257, 131,  62,  49, 138,  32, 132, 160, 208, 204, 250, 106, 217, 160,
   76,  59,  31, 306, 139, 122,  91,  62, 269, 126, 149, 302, 283, 257, 190,  79, 148,  61, 234,
   28, 256, 302, 235, 290, 214,  63, 231, 266, 196, 111, 203, 117, 290,  22, 224, 163, 189,   4,
  253, 105,  15, 136,  12,  31, 230, 302, 274,  76, 217, 113,  45,  19, 112, 265, 205, 117,   9,
  155, 132,  58, 254, 131,   8, 299, 109, 143, 113, 252, 144,  65, 163, 162,  25,  36, 263,  72,
  201, 139, 236, 303, 159,  82, 210,  24,   7, 152, 149, 192,   1,  88, 102, 300, 171, 253, 253,
  228,  75, 206, 197,  44,  69, 193, 157, 212,  56, 272, 118,  68,  53,  21, 201,  41, 115,   8,
  166,   8, 282, 198,  16, 271, 187, 150, 203, 107, 198,  31,  32, 130, 247, 296, 233, 265, 140,
   36,  51, 207, 213, 154, 126, 282, 175, 193,  11, 119, 283, 127, 260, 302,  26, 152, 297, 150,
   69, 155, 289, 169, 286,  15, 224,  15, 171, 262, 285, 159, 300, 198
,},
{  21, 167, 202, 289, 269,  15, 105, 150,  12, 271, 266,   3,  72, 225, 222,  28, 185, 301, 179,
  299, 299, 267, 270,  53, 220, 151, 196, 207, 171, 224, 213, 155, 222, 271, 280, 279, 201, 133,
  116, 247, 124,  50,  12, 181, 165, 278, 219, 249, 247,  70, 117, 180, 266, 108, 112, 227, 176,
  217,  92,  11, 147, 156,  37,  53, 215, 148,   7, 258, 306, 259, 117,  50,  59, 112,  19, 198,
  145, 153,  60, 170, 197,   6, 109,  71,  56, 256,  57, 271, 300, 166, 281, 105, 287, 197, 246,
   54,  75, 281,  10, 273, 263, 114,  73, 248,  81, 287,  92,  13, 119, 255, 279, 262, 207, 119,
  238,  38,  52, 210, 113, 264,  24, 102,  34, 202, 290, 164, 138, 161, 221, 244,   3, 134,  12,
  265,  31,  67, 160, 132, 115, 175, 198, 271,  30, 299,  83, 266, 266, 221,  19, 241, 177,  55,
   10,  63, 196, 223,  92,  22, 215, 196,  44,  95,  13,  78,  15, 105,  75, 299, 304, 240, 178,
   55,  68, 145, 288, 108,  70, 115, 164, 128, 152, 140, 275,  63, 297,  71, 166,   2, 217,  20,
  211, 293, 198, 266, 273, 189,  47,  63, 201, 128, 198, 296, 290, 199, 186, 239, 262, 111, 215,
  172,  42, 170,  71, 254, 102,  19, 286, 246, 287, 148,  20, 240, 100, 256, 279, 174,  77, 168,
  270,  11, 149,  71,  15,  84, 212, 162, 303,  19, 112,  63, 183,  88
,},
{ 214, 201,  96, 216, 228,  45, 171,  18,  72, 267, 118, 104,  89, 133, 234, 277, 216,  31, 205,
  211, 192, 113, 306, 168,  37, 278, 126, 187, 158, 186, 237, 238,  61, 296, 208, 240, 193, 306,
  237, 205, 285,  19,  45, 177,  43, 166, 159, 114,  43, 246, 108, 186, 107,  29, 265, 264,  50,
  198, 178,   4, 186, 170, 235, 151, 295, 185,  27, 265, 141, 226, 274, 115, 122, 100, 278, 147,
   89, 111,  17, 190, 258, 172, 239,  66, 273, 289, 123,  43, 236, 248, 279, 175,  61,  70, 211,
  166, 109,  52,  83,  61, 261,  48, 289, 217, 234, 292, 108, 144,  48, 274, 301,  23, 111, 210,
  223,   6, 185, 241, 268, 225, 295, 240,  17,   2, 263, 130, 141,  19,  12,  75, 264, 142, 292,
  194, 244, 275,  10, 174, 159, 121,  96, 270, 289, 215, 258,  69, 253,  53,  21, 115,  99, 221,
  198,  51, 293, 122,  61, 304,  47, 277, 239,  49, 272, 152, 204, 300,  31, 299,  62, 130,   2,
   90,  18,  65,  45, 112, 256, 261,  68, 117, 306,  87,  39,  80, 233, 305, 306, 214,  12, 243,
   42, 131, 241, 225, 197,  77, 260,  26, 188, 270,  32,  71,  70, 296, 258,  46, 258, 276, 157,
  161, 277, 129, 246,  21, 265, 225,  89, 147,  49,  75, 104,  35, 228,  30,   7, 106, 243, 122,
  119, 176, 213,  18, 139, 164,   1,  48, 290,  99, 157, 218, 176, 157
,},
{  12, 270,  22, 114,   6, 247, 114, 103, 137,  49, 158, 129,  83, 299,  13, 217, 124,  18,  83,
  290, 205, 216, 207, 131, 279, 287, 202, 246, 124, 265, 115,   6, 161, 200, 215,  25, 261,  21,
   45, 176, 210, 150, 188, 301, 175, 132,  13,  24, 200, 261, 251, 109, 136, 197, 187, 285, 168,
  166, 104,  21, 229,  84, 140, 250, 199,  81, 161, 271, 290,  82,  26,  96,  76,  87, 138,   4,
  270, 133, 287, 228,  40, 182,  33,  96, 238, 134, 118, 105, 305, 213, 174,  55, 250,  89,  88,
  152, 149, 211, 236,  17, 221, 160, 273, 211, 199, 286,  18, 131, 189,  28,  70, 235,  92,  71,
  256, 144, 195, 121, 184, 105, 221, 178,  43, 239, 212, 145, 232, 295, 266, 219,  13,  48,  82,
  219, 167, 163, 114,  28, 121,  79, 151,  57,  30, 176, 250, 240, 140,  23,  59, 276,  64,  24,
   54, 163, 259, 154, 133, 202,  73,  39, 113,  70, 145,  56,   7,  88, 161,  12,  82, 233, 131,
  152, 174,  58,  68,  38,  83,  63,  69, 183, 302,  47,   1, 183, 167,  24,  37, 280, 183, 177,
   52, 290, 108, 188, 224, 252, 256, 233,  99, 189,  15,  88, 219, 297,  21,  78, 202, 276,  72,
  263, 296,  38, 139,  94,  79, 160,   8, 305, 113, 215, 150, 211, 195, 138, 280, 267, 107, 257,
   59,  42,  41, 220, 237, 199, 145, 141,  81, 247, 101,  74, 144,  11
,},
{ 257, 188, 146, 254,  68, 285, 113, 295, 170, 284, 145,  61,  63, 129, 185, 135,  87,  28,   6,
   87,   8, 105,  29, 271, 129,  56,  92,   9,  48, 241, 305,   3,  71, 247,  77, 210,  91, 159,
   34, 248, 104,   5, 111, 247, 207,  60,   2, 115,  75,   8, 189, 298, 215,  68, 255, 206,  71,
   94,  46,  93, 158,  40, 209, 231,  50, 272, 181, 270, 218, 280, 199, 256, 105, 273,  31, 154,
  259, 189, 116,  73, 239, 152,  96,  66, 198, 152,  79, 193, 139, 145, 112,  84, 203,  31,  14,
   78, 274,  31, 263, 204, 169,  79, 297, 291, 286, 187, 302, 178,  97, 170, 264,  38, 101,  54,
   84, 227, 124, 257, 205, 198, 224, 248, 129,  39, 285, 192,  27, 102, 238, 171,  68, 299, 298,
   28, 178,  44, 271,  39, 300,  45, 261, 160, 136, 245, 286,  18, 200,  75, 305,  71,  28, 223,
  157, 251, 115, 173,  57,   6,  90,   4,   6, 152, 284, 124, 302,  81,   2, 189, 251, 137, 280,
  120, 109, 212, 199,  46, 210, 222, 249, 255, 282, 102, 303,  15, 281, 168,  15,  43,  51, 263,
  103,  42, 130,  73, 141,  46,  69, 215, 287, 146, 177, 191, 290, 143, 266, 157,  42, 127, 205,
  142, 161, 115, 201,  56,  57,  56,  92,  29, 242, 240,  56, 267,  56, 263, 222, 220,   7, 151,
   59, 124, 144,  63,  75, 294, 227, 278, 157, 209,  34, 191, 280,  64
,},
{  44,  53, 248, 212,  98, 240, 231, 273,  15, 188,  89,  83, 291, 219, 303, 225, 188, 282,  14,
  113,  65,  96, 245, 206,  64, 227, 289, 225,  85,  31,  83,  72, 130,  69, 257,  20, 287, 279,
  123,  15, 164, 223, 113, 231,  35, 124, 113, 121,  21, 158, 231, 295, 217, 238, 238, 226, 161,
   87, 261, 289, 304,  91, 237, 264, 100,  84, 184, 257, 157, 104, 263,  58, 113,  79,   3, 152,
  298,  11, 118,  71, 137, 165, 154, 288, 185, 200, 139,  13,  28, 157, 283,   7,  52, 101,  97,
  207, 118,  34, 194,  21, 279, 208, 290,  11, 225, 272,   1, 284,  36, 126,  36,  22, 291, 159,
   18, 306, 306,  94,  48, 119,  81, 102, 242,  22, 195,  57, 259,  80, 189,  76,  46, 197,  79,
  235, 236, 188, 170,  30, 254, 109, 155, 118, 201, 131, 271, 220, 176,  73,  97,  12, 191,  60,
   20, 131, 195, 117, 111, 267,  80, 163, 119, 205, 197, 106, 104, 286,  83, 137, 212, 264, 243,
  216, 121,  51, 223,  71,  42,  14, 132, 159, 217, 151, 196, 217,  27, 231,   4,  22, 134,  42,
  279, 296,  60,  38, 274, 138, 293, 277, 278,  86, 132, 280, 222,  99, 158, 220, 115, 108, 300,
   82,  23,   1, 254,  53,  64, 286,  79, 270, 109,  32, 208,  39,  35,  33,  54, 152,  19, 263,
  227, 186, 243, 272, 252, 295, 122,  24,  92, 204, 114, 139,  22, 289
,},
{  26,  63, 228, 287,  64,  88, 236, 186, 275, 221,   3, 164, 191, 132, 266, 215,  47,  66, 190,
  147, 100, 117,  95, 224, 293,  94, 267, 242, 242,  61, 133,  43, 161,  73,  47,  14, 219, 119,
  174,  42,  77,  25, 231, 156,  22, 279, 253, 281, 205,  84, 220, 182, 289, 105, 171, 179,  18,
    3,  88, 279,   9,  83,  26, 116,  61, 148,  32, 201, 260, 285,  80,  82, 127, 293,  59, 228,
  265, 291, 290, 217,  53, 177, 222, 100, 149, 242, 290, 100,  69, 234,  99, 207,  16, 215, 140,
  225, 119,  32, 228,  51, 163,   9, 235, 121, 279, 133, 190, 102, 228,  95, 298, 200,  18, 102,
   54, 205, 255,  65, 124,  53,   8, 288, 238, 109, 170, 144, 278,  81, 257, 177,  44, 192,  67,
  279,  23, 214,  95, 209, 171, 183, 174, 224, 212, 212, 258, 232, 118,  87,  86, 189,  55, 182,
  261, 200,  70, 252, 192, 263, 227, 165, 217, 111, 106,  36, 150, 262,  36,  93,  25, 122, 215,
  261,  91,   3, 211, 259, 264, 289, 212,  23, 304,  14,  67, 201, 252, 137, 162,  50,   6,  31,
  191, 100, 195, 201,  87,  35, 270,  81,  77, 229, 301, 151,  89, 151,  66,  75, 251, 154, 280,
   18, 221,  68, 125,  27, 281, 297, 174, 240,  94, 264,  41, 184, 181, 147,  63, 208, 103, 254,
  280,   9,  47, 207, 286,  75, 305,  16, 249,  50, 106, 190,  81, 125
,},
{ 297, 184, 161, 213, 155, 304, 184,  88, 138, 243,  56,  45,  28,  16, 232, 229, 189, 212, 125,
   68, 152,  80, 141, 292, 285, 187,  55, 167, 141, 204,  69, 172,  56, 301, 294,  46, 150, 260,
  183, 276,  89,  36, 140, 120, 260, 306, 253, 212, 107, 228, 131, 168,  19, 214, 178,  52, 259,
  126, 286, 270, 245,  94, 108, 167,  76, 137, 168, 238, 129, 258, 247, 126, 268, 105, 159, 185,
  279, 126,  42,  63,  35,  14,  37, 290,  59,   9, 231, 305, 291,  37,  91,  81, 298,  95, 200,
  138, 188,  34, 288, 283,  20, 196, 282, 300, 136,  31, 259, 222, 218,  40, 265,  46, 296, 256,
  166, 171, 201, 206, 266,   4, 261, 259,  94,  53, 241, 166,  59, 252, 131, 238,  24, 224, 242,
  179, 148, 244, 297,  80, 202,  33, 158,  53, 117, 255, 234, 273, 224, 105,  82,  27,  78, 271,
  270, 239, 129, 237, 294, 228, 302,  29,  97, 102,  31, 286, 208,  42, 122, 103,  18,  36,  70,
   90, 191, 160, 154, 268, 232, 169, 142,  65, 227, 264, 188, 254, 282,  68, 258, 286, 127,  22,
  139, 189,  68, 188, 253, 297, 244, 139, 276,  25, 288, 152, 130, 258,  22, 216, 252, 236,  17,
  294,  59,  62, 162,  47,  81, 215, 222, 301, 166,  58,  48,   3, 153, 256,  41,  51, 156, 296,
  153, 293, 275, 297, 178, 236, 142,  86, 142,  29, 253, 124,  47,  65
,},
{ 179, 109, 149, 276, 304, 157, 182, 193, 149, 281, 280,  41, 269, 244,  68,   4,  19, 152, 169,
   37, 132, 203, 203, 268,  29, 279, 179,   3, 225,  23, 245,  77, 277,   6, 244,  97, 129, 245,
  281,  15,  18, 301, 280,  70,  39,  27,  96, 158,  11,  33, 277,  18, 292, 287, 166,  67, 155,
   45,   3, 221,  19, 105, 107, 255, 269,   5,  86, 226, 176,  42, 140,  99, 235, 232, 109, 114,
  101, 219, 193, 145, 128,  27,  64, 232, 195, 109, 298, 116, 171, 127, 110, 229, 202, 204, 210,
  113, 217,  21, 118,  71,   9,  74, 252, 193, 185,  93, 293, 116,  49,  22,  67,  48, 231, 211,
  277, 190, 304,  65, 200, 265, 149, 281, 109, 182, 269,  67, 306, 156, 278,  72, 183, 179, 250,
  202, 160,  91,  17, 105, 236,  32,  20, 267, 157, 299, 291, 119, 232, 119,  41, 125, 264, 264,
  108, 234,  67, 179, 222,  18, 236, 285, 141, 160, 306, 186,  93, 115,  92, 120,  64,  36, 230,
    5, 115, 276, 128,  24, 168, 244,  68,  41,  36,  22, 158, 187, 247, 260, 266, 126, 105, 209,
  115,  52,  25, 224, 301, 178,  25, 225, 179, 163, 289, 100,   6, 267,  19, 100,  87,  60, 263,
   12,  82,  50, 160, 146, 247, 280, 176,  67, 152, 135, 179, 237,  36, 192, 250, 133, 245, 109,
   47, 258, 198,  98, 110, 152, 234, 286,  41,  89, 110, 115, 197, 272
,},
{ 187, 233,  57, 276, 227, 114,  81, 248, 231,  72, 143, 170, 251,  11, 216, 238, 306, 157, 246,
  240,  97, 199, 184, 111,  79, 292, 118, 207,  19,  76, 119,  99, 233, 115, 202, 232, 194,   7,
   92, 277, 272, 140, 146, 176,  90,  70,  22, 218, 219, 287, 290, 267, 211,   6, 242, 273, 106,
  223,  64,  38, 120, 118,  98, 264,  82, 260, 245, 102, 283, 152, 200,  78, 182, 278, 159,  86,
  112, 275, 301, 232, 110, 274, 189, 266,  47,  50, 284, 171, 259,  94, 253, 201,  93, 229,  24,
  186, 283, 118,  23, 164,   6,  98, 280, 111,  66, 279,  70,  63, 280, 249, 220, 113, 279,  17,
   58, 146, 142,  23,  21, 295, 305,  91, 102,  38, 231, 221, 275, 301, 142,  50,  78, 194, 165,
   59, 165,  49, 166, 144,  21, 115,  39, 103, 211,  59, 256, 164,  23,  76,  59, 254,  21,  93,
   92, 151, 303, 229,  69,  40, 179,   9,  83, 296, 121,  10, 101,  25, 277, 282, 141, 196,  26,
  265,  86,  22, 246, 198,   7, 256,  15, 146,  33, 170, 268, 253, 238, 188, 177, 219, 129, 297,
  277,  91, 282, 248, 234,  58, 230, 295, 109, 169, 257,  36, 155, 192, 254, 284,  75, 214, 258,
  124, 197,  16, 257, 145, 180,  69, 301, 165, 100,  27, 306,  30, 172,  15, 148, 106, 123, 105,
  125, 203,  73, 128,  57, 124,  35,  62, 263, 164,  69,  19, 241,   5
,},
{  61, 267,  65, 302, 283, 298,  81, 247, 111, 242,   4,  71, 140, 244,  15, 104, 151,  67,  12,
  192,  56, 219, 114, 241, 138, 173,   8, 114, 117, 128, 150,  96, 296, 300,  87, 116, 262,  36,
  292, 268,  21, 123, 206, 117, 217, 261, 290, 180, 297,  48,  31, 116,  64, 208, 144, 139,  92,
  184,   1,  59, 184,  62, 119, 251, 201, 171, 138, 155,  50, 111, 261, 165, 110, 132, 113, 250,
  174, 131,  44, 120, 237, 133, 207, 204, 117, 287,  25,  39,  19, 270,  76, 240,  45, 133, 167,
  159,  74,  34,  30, 148, 261,  81, 244,  37, 173, 228,  63,  59, 215,  76, 133,  38,  80, 178,
  302, 296, 109, 226, 117, 139,  70,  94, 292, 156,  31, 194, 279, 188, 303,  43,  93, 208, 196,
  280, 152, 137, 126, 104, 156, 126, 114,  71, 111, 225, 109,  11,  90, 133, 260, 204, 225, 177,
  293,  42, 185, 236, 157,  95,  17,  36, 301,  17, 170, 251,  66,  23, 265, 206, 279, 166,  22,
   21,  78, 187, 114, 236,  25, 126, 201, 267, 191, 277,  91,  79, 158,  71, 156,  96,  87, 277,
   68, 105, 102, 294, 115, 181, 226,  16, 180, 242,  24,  30,  72, 260, 150, 260, 156,  13,  98,
  234, 273,  31, 118, 303, 184,  30,  66, 171, 248,  74, 178, 108, 127, 175, 109,  37, 239, 143,
   15,  15,  54,  83,  90,  55,  53, 235, 153,  70, 123,  82,   1,  93
,},
{ 275,  14,  28,  17, 248, 130, 114, 160,  32,  70,  21,  77, 127, 194, 257, 265, 205,  65, 133,
  297, 208, 299, 173,  69, 252, 290, 171, 302, 282, 241, 215, 152, 199, 130, 209, 268,  60, 209,
  118, 250,  50,  74, 184,  35,  20,  82,  55,  36,  53, 125, 137, 233, 147, 131, 196, 193,  88,
  192, 230, 215,  73, 149, 142,  79, 123, 260, 235, 306, 293, 105, 235, 224, 269, 101, 133,  25,
  229, 159,  71, 300, 213, 235, 299, 179, 257, 283, 129,  73, 159, 285,  58, 264,  40, 175,  85,
  222, 102, 109,  55, 206, 233, 121,  95, 145,  85, 239, 140, 104, 246, 166,   6,   2, 161, 289,
  260,   1,  99,  75,  71,  40, 252,  75, 210,   7, 210, 141, 229,  73,  41,  58, 106,  55,  61,
  186,  45,  61, 157,  78, 143, 267,  46, 218,  97,   3, 234, 157, 231, 294, 117, 194,  33, 118,
  213, 284, 306,  44,   2,  88,  97, 243,  64, 240,  68, 132, 126, 273, 189, 111, 273, 130,  61,
  236, 104, 176, 179, 235, 211,  28,  24,  99, 183,  63,  97,  14, 154, 306, 274, 123, 281, 261,
   70, 123,  64, 141,  92, 173, 113, 298,  26,  75,   1, 284, 147, 183, 277,  16, 151, 108, 250,
   20, 181, 194, 209, 114,  46, 157,  97, 104,  57,  10, 181, 302, 193,  60,  20, 132, 239, 304,
    4, 118,  68, 240, 113, 237, 208,  89, 147,  63, 167, 242, 177, 134
,},
{ 284, 270, 178, 147, 266, 186, 228, 142, 111, 204, 151, 179, 194, 185, 117, 264,  21, 124, 170,
   98, 155, 162, 170, 227, 240, 131, 231, 248,  39, 256, 198, 274, 274, 214,  55, 176, 151, 185,
  172, 107, 266, 232, 185, 205,  90, 182, 145, 237, 127, 198, 141, 263,  73, 128,  84, 260,  70,
  275,  14,  96,  14, 115,  53, 190, 294, 175, 306, 279,  79, 227,  79, 218, 222, 157, 284, 300,
  173, 247, 231, 255, 127, 154, 220,  87,  54, 242, 227,  10, 236,  24, 171,  78, 197, 191, 294,
   19, 229,  60, 268,  28, 104,  94, 227,  91,  26, 190,  99, 275, 248, 182, 250, 286, 100,  33,
  252, 130, 176,  17, 261, 102, 150, 246, 120, 245,  65,  78,  99, 292, 188,  28, 228, 213, 170,
   73, 161, 277,  37, 276, 154, 194,  56,  44,  64, 288, 115, 115, 200, 109, 129,  12, 215, 100,
  259, 101,  90, 291, 202, 269, 147,  10, 148, 260,  56, 175, 282, 246, 258, 251,  92,  22, 256,
  234,  75, 232, 247, 218, 265, 146,  89,  85,  77,  91, 279, 128, 231, 222,   1,  68, 208, 195,
  141,   4, 295, 140,  15, 268,   9,  88, 286, 152, 180, 303, 205, 198, 224,   8,  24, 270, 192,
   98, 145, 153, 226,  91,  54,  17, 138, 297, 118,  97, 250, 155, 200, 212, 246, 238, 258, 161,
   41, 126, 300,  29, 204, 305, 299,  42, 256, 255,   8, 147, 128, 263
,},
{ 200, 194, 152, 171,  24,  71, 108, 118, 181, 137, 127, 232, 136,  10,  27, 243, 170,  98, 172,
  154, 305, 248, 296, 221, 235, 211, 297,  82, 119, 185,  96,  32,  14, 237,  92,  75, 219, 252,
  133, 281,  88, 165,  81, 256, 274, 243,  88,  44,  33, 281, 179, 260, 146,  38, 203,   8, 195,
   59, 141,  58, 162, 156, 229, 303,  69,   2,  82, 177, 184, 119,  66,  80, 182,  48,  74, 220,
  201, 190,   8, 166, 211, 293, 191,  88, 293,  91, 155, 234, 181, 262, 121, 224, 100, 152, 184,
   27, 145,  87, 159,  89,  34,  58, 160, 155,  98,  74, 126,  73, 104,  17, 159,  71, 208, 252,
  288,  61, 210, 235, 295, 205, 240,  42, 135, 136,  61, 145, 243,   5, 213, 261,  18,   5, 134,
   79, 237,  39, 152,  30, 109, 151,  80,  20,  35, 125, 155, 122, 275, 153, 209,  81,  83, 193,
  182,  85, 293, 127,  65,  96, 103, 116, 142, 299,  18, 140, 112, 293, 283, 146, 216, 179, 141,
  300,  99, 230, 282,  28, 144,  16,  16, 266, 303, 263, 295, 223,  43, 227, 258, 284,  63, 195,
  184, 181,  30, 128,  21, 113,  79, 173, 179,  98, 200,  90, 109, 202,  15, 294, 152,  17, 247,
  219, 199, 255, 115, 251, 239, 146, 289,  54, 242, 224, 119,  89, 161, 235, 183, 179,  50,  82,
   32,  88,  25, 212, 302, 283, 193,  74, 285,  51, 186, 262, 244, 141
,},
},

//-----------------------------------------------------------------------------------------------
//Redundancy generating matrix for (306,178) Reed-Solomon code
//-----------------------------------------------------------------------------------------------

{
{ 259,  87,  85,  49,  94, 241, 203,  49,  81,  43, 221,  93, 220,  45,  98, 285,  87, 190,  80,
  276,  46, 173, 215, 156, 269,  47, 301, 189, 129,  40, 198, 134,  93, 256, 229, 116,  90, 216,
  129,   7, 139,  47,  61,  17, 261, 237,  62,  27, 175, 118, 234,  73,  28, 209,  78,  80,  34,
  130, 296, 150,  17, 271, 104, 112,   1, 265,  71, 173, 156, 143, 301, 162,  29,  75, 254, 140,
  254, 304, 219, 170,  14,  63, 139,   5,  34,  24,  82, 288, 233, 284,  13, 230, 246, 145, 171,
   45,  25, 165,  71, 264,  98,  64, 219, 230,  15,  55, 121, 210, 171,  75,  95,  98, 189, 124,
  204, 168, 263,  72, 230,  93,  66, 220, 272,  95,  89, 104,  23, 120, 270, 225,  85, 306, 261,
  205, 278,  81, 100, 189, 181, 276, 178, 179, 120, 266, 241, 103,  84, 104, 227, 148,  85,  50,
  179, 200, 194, 160,  47, 178, 236, 191,  89, 148, 224,  11, 187,  30, 284, 122, 135, 267,  91,
  294, 176, 221, 157,  11, 109,  93
,},
{ 141,  61,  10,  37, 195,  96,  86, 155, 214,  89,  27, 274, 291, 107, 256, 201,  87, 258, 262,
  267, 256, 171, 213, 294, 306,  35, 103,  72, 213, 165,  34,  73, 187, 262,  63, 272, 197, 223,
  240, 166,  40, 212, 194, 107,  37, 198, 170, 117,  31,  97,  83, 269, 221, 124,  95, 150, 172,
  151,  28, 124, 196,  46, 119,  82, 205,  86, 114, 196, 252, 254, 199,  17,  96, 250,  58,  73,
  123, 282, 102,  65, 244,  40,  96, 297,  97, 117, 282, 157, 160, 243, 265, 220,  83, 223,  84,
   58, 221,  20,  14,  63, 168, 217, 169, 119,  90, 218, 256,   3, 149,  85,   7, 306, 176,  55,
   62, 171,  67, 205, 279, 283,  91, 264,  35, 204,  83, 244,  94, 131,  56,  12, 148, 299,  19,
  292, 271, 136, 171, 178, 137,  61, 252, 247, 287, 298, 268, 303, 240, 239,  32, 176,  71, 130,
  119,  52, 129,  31, 233,  23,  22, 193, 179,  38, 104,  19, 210, 214,  40, 271,  90,  99, 134,
  110,  84, 160,  86, 259,  17, 162
,},
{ 206, 113,  16, 273, 222, 248, 133,  42,  76, 119, 279,  50, 302, 213,  19,  69, 173, 167,  17,
  152,  44,  38,   3,   4, 278, 245, 291,  21,  94, 246,   6, 252,  96, 214, 213, 128, 116, 191,
  245, 146, 273, 286, 270, 185,  23,  56, 111, 246, 223, 113, 244, 243, 200,   2, 173, 161, 132,
   49, 211,  75, 115, 197,   9, 150, 244, 155, 229, 203, 294,  86, 203,  41, 110, 273, 260,  20,
   83, 251, 148,  12, 184,  12, 147, 292, 279, 301, 200, 274, 142, 118, 200,  71, 162, 241, 295,
    6, 117, 242, 163, 109, 282,  98,  83, 282,  93,  97, 172, 199,  75,  19, 125, 226, 224,   2,
  254, 262, 104,  65,  11, 302, 230, 119, 120,  75, 193,  46, 286, 193, 277, 280, 274, 293, 215,
   73, 199, 192,  65,  89,  28,  27,  39,  85,  39,  92,  44,  69,  96, 203, 173,  62, 131, 189,
  270, 284, 166, 261, 277, 211, 187, 264, 182, 209, 100,  44, 227, 158, 172, 156,  37,  57, 105,
  177,  71, 274, 113,  26, 111,  40
,},
{ 229,   2, 136, 134,  42,  38,  79, 251, 212, 261,  56,   8, 254, 260, 142,  60, 172,  98, 297,
    5, 150, 210,  42, 103,  19,   9,   5, 176, 269, 159, 184, 147, 288, 205, 164, 248,  44, 160,
  132, 218, 180,   4, 270,  29, 187, 293,  80, 270, 185,  31, 263,  94, 135, 271,  52, 303, 293,
  113, 223,  71, 141, 210,  59, 191, 190,  99, 232,  88, 303, 181, 153, 236, 280,  40, 302,  27,
   49, 270, 108, 194, 265, 248,  46,  40, 117,  11, 204,  54,  77, 143,  24, 190,  87, 129,  20,
  253,  85, 270,  12, 285,  38,  79, 262,  73, 268, 144,  25, 283, 285,   5, 135,  54, 111, 272,
  180, 220,  37, 221,  55,  47, 179, 127, 254, 236, 258,  55,  45, 174, 248,  67, 303, 234, 295,
  126, 141,  62, 201, 257, 268,  16,  86, 138, 280, 241, 215, 173,  52, 265,  73, 260,  85, 289,
  288, 288,  62, 119, 299,  29, 134, 152, 140, 269, 266, 233, 156, 199, 159, 140,  30, 279,  13,
  199, 156,   8, 107, 246,  88, 147
,},
{   5, 124, 217, 278, 137, 164, 100, 221, 185,  86, 206, 219, 113, 115, 237, 285, 262, 165, 192,
   38,  13, 100, 194, 256,  43, 174,  48, 158, 105,   9, 100, 234,   3, 159,  98,  24, 277, 175,
   89, 240,  82,  28,  68,   6,  21,  28, 197,  58, 207,  32,  45, 249, 219, 158,  71, 146,  82,
   62,  31, 169, 114,  68, 148, 252,  31, 156,  98, 182, 302, 141, 220,  21, 201, 253, 231,   6,
  218, 222, 228, 231, 103,   9, 112, 167, 126, 268,  92, 174, 228,  73, 212,  64, 126, 219,  92,
  188, 244,  87, 269, 138, 262, 236,  37, 302, 129,  64, 125, 195, 246, 258, 155, 112, 207, 226,
  174,   9, 199, 183, 261, 218, 232, 284, 201,  97, 118, 196,  59, 186, 261, 167, 282, 156, 226,
   37, 161,  75,  26,  47, 155,   9,  87, 304, 279,  86,  56,   6, 241, 297, 171,  32, 168,  67,
  200, 216, 255, 250, 274,  63,  30, 274,  34,  99,  41,  41,  92, 268, 195, 287,  30, 290, 148,
  251, 283, 101,  62, 189, 305, 251
,},
{ 232,  45, 276, 236, 233, 149, 155, 119, 290, 233, 297, 217, 179,  49, 153, 241,  18,  60, 290,
   86, 225, 149,  33,  54, 235, 174, 203, 209, 302,  14, 280, 271, 245,  96, 229,  49, 203, 154,
   12,   4, 131, 213, 296,  37, 126, 257, 240, 220,  82,  46, 129, 255, 216, 181,  88, 196,  84,
  170,  64, 227, 138, 288,  77,  16, 196, 234, 171, 234,  42, 276, 170,  51, 239, 299, 151,  66,
  211,  79, 238, 225,  61, 259, 207, 139, 105,  10, 281, 235,  20, 288, 266, 226, 103, 295, 160,
   28,  16, 214, 102, 221, 176,  55, 252,  51,  76, 119,  42,  31, 136,  37, 157, 193, 273,  17,
  161, 283,  17, 158, 197, 272, 206, 192,  95, 100,  25, 127, 136,  93, 109, 248,  12,  31, 276,
  105, 126, 230,   1, 187,  42,  49, 172, 194,  31, 119,  98, 121, 214, 250, 172, 172, 184, 131,
  174,  52,  97, 198,  74, 130,  48,  79, 202,  35, 142,  39,   7, 254,  21, 117,  95, 121, 106,
  262, 219, 187, 212,  60, 225,   9
,},
{ 182,  94, 196, 103, 161, 253, 134, 289, 234,  63,  73, 213,  48, 277,  10, 262, 103, 193, 166,
   11, 193, 247, 242, 209,  19,  44, 120,  62, 142,  48, 261, 258, 187,  93,   8,  45, 245, 305,
   87,  75,  27, 247, 148, 142, 237, 110, 201, 176, 260, 223,   3, 172, 200, 255, 269, 194, 195,
   26,  71, 186,  73, 121, 303, 164,  25, 125, 259, 193, 103, 101, 222,  93,   5, 300, 129, 183,
  203, 184, 208, 233,  44,  14, 282, 252, 138,  14, 134, 110, 183, 120,  98, 187, 291, 180, 299,
  258, 253, 273, 239,  22, 182, 138, 184, 173, 186, 264, 287,  90,  35, 197, 278, 118,  52, 161,
   11, 138, 194,  51,  79, 113, 252,  37, 184,  29, 287,  40,  27, 295,  67, 292,  92,   3, 231,
  279, 151, 241, 209, 167, 281,  70, 116, 248,  46, 276, 139, 104, 263, 229, 144, 276,  16,  20,
  207, 132, 263,   2,   7, 141, 105, 232, 266, 306, 209, 241, 187, 277,  47, 198, 104,  42,  19,
  296,   4,  59,  65,   4, 120, 141
,},
{ 293, 169, 106,  44, 156,  65,  18, 289,  44, 157, 217, 292, 226, 253, 280, 285, 249, 184, 114,
   93,  50,  26, 169, 134,  70, 199, 119,  60, 138, 256,  29, 121, 170,  57, 147,  93, 148,   1,
   74, 153,  26, 207, 252,  89, 103, 191, 256,  17, 291,  13,  61, 165, 129, 197, 201, 190,  76,
  105,  10,  38, 127, 216,  49, 131, 305, 243,   5,  92,  85,   4, 176,  39, 191, 142, 195, 221,
   78,  87,  56, 232,  58,  24, 272,  66, 134, 145, 217, 218, 114,  10, 111, 293, 182, 167,  38,
  197,  99, 186, 153,   9,  25, 303,  10,  72, 139, 266, 133, 118, 255, 172,  84, 281,  58,  37,
   67,  60,  74, 215, 246, 298, 209, 265,  14,  71, 298, 215, 213,  62, 297, 171, 304, 258, 271,
  278, 181, 213, 219, 149, 207, 208, 301, 181, 283,  98, 180, 233, 282, 191,   1, 136, 288,   5,
   85, 163, 163, 105, 182, 238, 261,  20, 194, 258, 269, 225, 206, 119, 104,  57, 199, 297, 286,
   28, 245, 158,  92,  81,  23,  32
,},
{ 306,   7, 126, 139, 289, 193, 114,  51, 118, 192, 168, 123, 271, 131,  12, 190, 306, 189, 288,
   43,  30,  60, 152, 249, 146,  39,   7,  27, 197, 190, 145,  19,  27,  73,  17, 175, 210, 306,
  138, 298, 303, 302,  10, 182, 152,  12,  26, 199,  91,  76, 133, 248, 140,  63, 237, 305,  50,
  245,  60, 205, 275, 203, 167, 256, 163, 189,  59,  15, 172,  56, 119, 141,  46, 135, 288,  70,
   60, 289,  34, 277,  66, 232, 174, 125, 233, 288,   6, 223, 306, 299, 119, 103, 183, 217, 113,
  250,  76, 160,   2,   5,  75, 231, 250,   2, 245,  57, 147,  99,  64, 199, 142, 150, 189,  35,
  118, 224, 187, 229, 207, 152, 261, 188,  66, 291, 156, 249,  30,  62, 106, 129, 128, 272,  14,
   77, 271,  10,  36, 127, 108, 136,  71, 196,  30, 199, 135,  99, 158, 233,  87, 132,  93,  46,
  207,  38, 231,  64,  74,  45, 115, 233, 105,  18,  58,   7,  69, 245, 304,  17,  79, 147, 139,
  177, 134, 256, 270, 137, 192, 236
,},
{  31, 269, 112,  24, 219,  63, 209,  12, 133, 135, 158,  12, 160, 146, 234,  39, 153,  17,  35,
   33, 154,  27, 145, 128, 184, 186, 158,  96,  78, 120, 254, 148, 170, 271,  85,  70, 232, 224,
   50, 255, 253,  36, 269,  31,  71, 210, 215, 258,  54,   2,  40, 169, 102,  37,  51,  83,  40,
   30, 105, 155, 226,  68, 187, 197, 185,  75,  60,  56, 298, 150, 175, 283, 231, 247, 214, 172,
  149, 273,  90, 244, 204, 198, 187, 126, 167,  64, 299, 127, 258,  97, 297,  60, 136,  19,  49,
  295,  10,  27,  31, 292, 108, 136,  32, 191, 165,  24,  62, 280, 238, 265, 208, 245, 239, 288,
  287, 163, 278, 294, 170,  51,  71, 298, 217,  75, 112, 140, 151, 106, 233,  95, 234, 199, 161,
  195, 294,  46, 278, 125, 170, 160,  85, 256, 272, 178, 280, 190, 275, 142,  80,  17, 237, 227,
  231, 129,  79, 230, 104,  23, 174,  62,  54,  35,  78, 198, 238,  88,  36, 238, 256, 156, 133,
  141, 268, 100, 161, 103,  73,  36
,},
{ 114,  93, 259,  34,  31, 299,   3, 131, 165, 146, 109, 129, 257, 245, 297,  56, 101, 239, 134,
  147, 154, 242,  92, 235, 295,  34, 277, 208, 135, 290, 187, 166, 119, 176, 226, 270, 240,  26,
  263, 302,  40, 103,  83, 267, 217,   7, 293, 266, 111,   4, 137, 212, 256, 258,  82, 168,  79,
  115, 248, 286, 153, 158, 128, 228, 233, 208, 175, 148, 146, 227, 241, 174,  99, 168, 181,  35,
  106,  41, 175,  70, 134,  16, 290,  60, 122, 110, 253, 229, 226,  44, 258, 288,  13, 137,  35,
  134, 274, 117, 127,  18, 136, 263,  38,  23, 117, 303,  82, 254, 296, 175,   1,  52, 295,  98,
  264, 195, 114, 107, 285, 141, 278,   9, 266, 260, 209, 172,  47, 173,   2,  44,  85, 198,  78,
  173,  72, 140, 269,  21, 194, 282, 121,  82, 278,  24, 258, 304, 144,  28,  25, 189,   7, 195,
  224,  63,  52,   6,  80,  65, 230, 296, 196, 163, 117, 167, 176,  90, 181, 130, 186,  44,  55,
  279,  30, 242, 226, 250,  36,  44
,},
{  37, 258, 149, 266, 179, 197,  21,  10,  11, 215,  46, 210, 292,  88, 259, 250, 200, 172,  75,
  305,  22,  91, 185, 202,  98, 214,  77, 304,  51,  53,  99, 250, 267,  24, 121, 111, 239, 227,
  176, 264, 278, 266,  24, 217,  85, 207, 279, 253, 291,  84, 169, 279, 216, 242,   6, 225, 129,
  273, 245,  94, 113, 104, 129, 144, 272, 227, 262, 112, 258, 298, 270,   1, 222,  22, 292, 201,
  159, 281, 160, 287,  72, 143, 299, 203,  21, 257,  34,  31,  43, 135,   2, 247,  60, 253, 293,
  173,   6, 166, 171,  77,  32, 189,  75,  27,  69,  81, 101, 112, 103, 219,  57,  15,  79, 225,
  171, 288, 101, 212,  96,  79, 282, 134,   4, 148, 185, 180, 263, 108,  80,  78, 100,  41,  16,
  195, 125, 259, 242, 296,   3,  58, 132,  15, 143,   9, 190, 185,   9, 115, 192,  90, 245,  58,
   89, 121,   3,  31, 232, 237,  11,  38, 221, 261, 195, 294, 106, 268, 306,  23, 237, 268,  57,
   97,  41, 237,  89,  96, 134, 137
,},
{ 178, 290, 237, 108, 250,  40,  71, 287,  55,  69,  99, 200, 264,  10,   6,   8, 196, 135,  80,
  126, 160,  84,  74,  67, 215,  90,   6, 182, 171,   5, 163,  37,  97,  34,  83,  49, 161,  52,
   94, 214, 273, 270,  27, 204,  55,  12, 105, 294, 282, 186, 214,  39, 124, 298, 183, 221, 278,
  133, 301, 226, 274,  93, 230, 123, 281,  44, 130,  17, 301, 201,  90,  53, 290,  59, 129, 131,
    1,  55, 198, 118,  56, 107, 152,  63, 256, 239, 132, 194,  24, 269,  74, 198, 179, 277,  41,
   11, 221, 200,  69, 113, 302, 204, 106, 271, 240, 236,  80,  13, 207, 247,  33, 282, 120, 182,
  236, 162,  93, 141, 101, 250, 218,  29, 251, 125,  61,   4, 261, 125, 258, 205,  57, 270, 186,
  164, 213, 170, 144,  40, 226,  54, 191,  95, 184,  52, 177, 179,  27, 135, 207, 206,  69,  34,
   21, 166, 297, 126,  23,  58,  27,  83, 258, 235, 249, 167, 125, 225, 187, 135,  98, 283, 148,
  118, 263, 232, 256,  61, 293, 288
,},
{ 298,  60, 210, 227, 164, 276, 174,  61, 283, 159, 168, 174,  11,  23, 297, 117, 197, 270, 150,
   55, 173, 250, 297, 180, 175, 243, 204,  99, 187,  25, 234,  73, 112, 145, 288,  28, 181,  48,
   57, 268,  29, 301,  32,  11, 157, 157,  62, 206,  39, 189,  38,  55, 121, 144,  44, 198, 189,
  264,  35, 214, 210,  37, 266, 251, 104, 158, 230, 220, 123,  40,   8,  82, 116,  93, 145, 232,
  217,  58, 192,  38, 159,  87, 229,  57,  31, 107, 216, 186,  65, 154,  22,   2, 129, 187,  98,
  107, 150, 156,  79, 272,  93,   7,  34,  34, 293, 116,  86,  81, 141,  10, 284,  13,  68, 220,
  297, 114,  77, 260,  69, 176, 224,  29,  80, 288, 276, 234, 181, 130, 214, 281, 125,  76, 223,
  282, 101, 209, 112, 237, 285, 201,  49, 167, 271,  42,  78,  62, 118, 200, 120, 158, 126,  40,
   10, 212, 164,  20, 154,  18, 179,  82, 234, 209, 277,  40, 298, 169,  48,  18,  26, 244,  89,
   88, 151,  55,  12,  47, 139,  61
,},
{ 142,  79,  26, 129, 128, 129,  72,  93,  90, 143, 132,   8,  86, 300, 168, 183, 205, 121, 238,
  101,  98, 288, 164, 296,  11, 279, 184,  67, 293, 171, 130, 119, 220,  71, 299, 303, 299, 156,
  242, 177, 151, 133,  31, 148, 275, 185, 255, 174, 136, 176,  34, 193, 228, 283, 297,  12, 123,
  137, 207, 282,  23, 163, 241,  37,   5, 305, 191,  38, 219, 250, 288,  66,   9,  86, 237,  89,
   69,  34, 216, 124, 278,  11, 277, 227, 289, 267, 197, 285, 277, 197,  26, 237, 272,  71, 180,
   80,  97,  84, 189, 219, 110,   6, 165, 249,  28, 271, 129,   2,  74, 111, 279, 122, 183, 264,
   77, 107, 193, 171, 168, 216, 211, 136,  43,  42, 191, 173, 102, 133,  22, 124, 247,  64,  33,
  141,  48, 130, 169, 282, 226, 236,   7, 223, 119, 226,   7, 221, 274,  15, 232, 245, 124, 106,
  214, 237,  73, 100, 124, 267, 292, 164, 292,  52,  58,  27,  88, 286, 301, 122, 271,  42, 269,
  217,  79, 124, 115,  69, 249, 286
,},
{  87, 157, 136, 225, 304, 286, 164, 271, 234, 108, 107,  21, 300,  62,  84,  16, 198, 206, 283,
  275,  56, 149,  71, 265, 173, 252,  98, 206, 121,  67,   4,  79,   8,  63, 174,  12, 255,  61,
  210,  95,  21,  85,  80, 288, 193, 210, 111, 302, 183, 114, 174,  36, 219, 137, 180, 152, 219,
  156,  61, 127, 232, 165, 128,  38,  16, 273,  42, 242, 139, 286,  69, 263,  71, 276, 278,  60,
  281, 132,  40,  23, 137, 183, 162, 172, 127,  92,  80, 289, 304, 146, 231, 108, 290, 297, 164,
  156, 169,   9, 128, 171,   3, 301,  12, 247, 241, 101, 186,  17,  95,  34, 265,  63, 144,  35,
  278, 233, 110, 216, 253,  57,  58, 196, 257, 197,  15, 156, 304,  38, 296, 209, 181, 268, 109,
   26, 136, 189, 179, 191, 165, 263, 182, 239, 159,  59,  77, 300, 299, 239, 160, 194, 302, 302,
   31,   5, 154,  90,  34,  70, 223, 272, 137, 254, 260, 134,  91,  72, 155, 195,  50, 190, 280,
  235, 205,  43, 204, 191, 236, 138
,},
{ 130, 120, 221, 144, 303,  99,  56, 172,  90,  28, 213,  47, 295,  63,  78, 118,  49,  16, 194,
  303, 176, 291,  40, 109, 240, 212,  38,  85, 202, 115,  68,  76,  19,  31,  44, 218, 152, 284,
   57, 255, 243,  60, 214, 277,  80,  50, 170, 153, 199, 196, 171, 117, 216, 203, 156, 168, 239,
   46, 173, 192,  17, 176,  88, 234, 176,  53, 247, 277, 280, 225,  72,  14, 274, 290,  23, 257,
  114, 174, 268, 168, 113, 235,  24, 238, 259,  62,  49, 221, 208, 200,  98,  43, 286,  38, 256,
  234, 229, 221, 290,  27, 187, 239, 130, 131, 168, 156, 221,   1, 283,   7, 250, 281,  50,  64,
  250, 130, 301, 222,  28, 193, 262,  25, 278, 166, 199, 245, 260, 286, 151,  32, 273,  43,  60,
  155,  15, 262, 174, 166, 302, 185, 267,  17, 221,  27, 161, 169, 226, 222, 251,  15, 258, 141,
  137,   1,  68, 130, 129,  38,  96, 179, 274, 299, 159, 243, 152, 240, 275, 106,  98,  56, 161,
   21, 270,   3, 219, 187, 190, 176
,},
{ 148,  92,  37, 249, 110,  46, 215,  84, 306, 290, 242,   3,  85, 233, 119, 197,  80,  26, 281,
  264, 110, 231,  63, 173, 175, 223,  77, 146,  71, 181, 272,  13, 173, 253, 118, 198,  94, 100,
  270,  61, 159, 226,  51, 136, 163,  40, 217,  10, 253,  91, 242, 125, 133, 160, 116, 114,  12,
   94, 259, 171, 114, 128,  60, 152, 103, 152, 269, 302, 103, 274,  90,  33, 206, 273, 172, 103,
  139, 200,  36, 102, 176, 149, 139, 290,  82, 185,  65,  82,  91, 151,  32,  54,  52,  18,  48,
  194,  29, 104, 130,  90,  83,  92, 101,  86,   8,  24, 269,  34,  11, 282, 149, 306,  82,  77,
   49,  39,  61,  79, 178, 125, 143, 300,   5, 113, 173,  83, 302, 197, 221, 148, 256,  97, 236,
  221, 270, 149,  56, 282,  94,  65, 199, 150, 261,  66,  77, 176, 217, 110, 264, 204, 239, 155,
   24,  32,  68, 291, 113, 143, 129, 249, 186, 227, 120, 253, 306, 213, 183, 257, 227, 119, 108,
   22, 297, 177,   5,   6,  30, 287
,},
{  39, 250, 234, 285, 211, 202, 284, 156, 306,  60, 168, 224, 208, 106, 115, 252, 299, 271, 268,
  287, 265,  27, 229,  13,  12, 156,  36, 288,  22, 192, 212,  48, 302, 272, 278, 254, 240,  72,
  283, 130,  44, 140, 234,  18, 135,  28,  28, 291, 194,  42,  16,  10, 179, 251, 135,  51,  48,
  175,   7,  22, 138, 220, 197, 276, 132,  22, 267, 186, 252,   6,  87, 227,  67, 241, 105, 135,
  242, 199, 118,  13, 129, 144, 132,  39, 224, 216,  80, 138,  27, 244, 198,  37,  46, 222, 282,
   69,   1, 106, 219,  69, 279,  31,  10, 106,  93, 136,  60,  60, 298,  46, 224,  31, 210,  58,
  295,  66, 305, 156,  84, 160,  33,  41,  79, 254, 175, 242, 237,  51,  16,  19, 290, 276,  96,
  127, 187, 185, 298, 267,  39, 100, 189, 303, 206, 160, 158, 166,  31, 286, 175,  67,  39, 160,
  259,  15, 143, 245, 272, 237,  28, 300,   4, 296,  45, 207, 197,  13,  59, 199,  13, 106, 141,
   61, 186, 175, 107,  92, 282,  12
,},
{  38, 162,  42, 208, 185,  33, 182, 258, 207, 208, 256,  56, 101, 134,  54, 158,  68, 123,   3,
  203, 225, 192, 151, 259, 171, 269,  84, 155, 301, 195, 112, 285, 243, 304, 257, 135, 106,  69,
   85,  60, 263, 301, 258, 131,  80, 216, 158,  45, 242,  75,  87, 278,  39, 231, 266, 174, 152,
   73,  43, 272, 226,  13, 240,   6, 288, 242, 260, 194, 216, 126, 241, 189, 268,  46, 219, 250,
  113, 206,  64,   9, 181, 271, 277, 192, 140, 205, 279, 159, 171,  58,  93, 195, 226, 251, 125,
  208,  62, 139,  37,  10,  17, 126, 203,   7, 286, 139,  53, 124, 270, 277, 265, 172, 150, 163,
   50, 162, 152, 248, 153, 279,  31, 217, 235, 298,  94, 195, 211, 142, 221, 260, 118, 278,  31,
  100,  86, 238, 157, 110, 290, 281,  87, 188, 208,  21, 289, 166, 253,  51, 247, 109, 166,  25,
  159, 203, 194, 221, 195, 259, 306, 171, 140, 245, 221, 177, 302, 250,  44, 295, 284, 147, 277,
  292,  24,  75, 217, 239, 172, 170
,},
{ 129,  92, 183,  83, 224,  17, 159, 223, 213, 149,  17, 102,   2,  76, 216, 305, 212, 133, 215,
  259,  41, 163, 209, 269, 246, 179, 170, 286, 288,  40,  85, 174, 131, 169, 245,  22,  85, 293,
  202,  47,  51, 271, 233,  78, 293, 153,  11, 143,  16,  40, 252, 217, 126, 264, 290,  51, 121,
  148,  45,  62,  92, 246, 194, 246, 176, 209,  32, 198,   5, 273,  27, 151, 207, 124, 246,  73,
  143, 217, 289, 106, 240, 146, 262, 206, 139, 229,  23, 119, 166, 252, 119, 204, 263,   9, 156,
  100, 160, 175, 236,  95,  92, 152, 209,   7, 101, 119, 140, 141,  29, 126, 156,  40,  67,  47,
  152,  59,  50, 112,  52, 306, 140, 284, 100, 114,  78, 275, 114,  42, 299,  96, 281, 255, 133,
  190,  82,  41,  46,  52, 180, 239, 148, 124,  19, 299, 160, 300,  17, 127, 266, 233, 130,  70,
   62,  82,  27,  71, 229,  62, 162, 234, 258, 126, 257, 249,  39, 183,  24, 215, 220, 238, 267,
  216, 126, 140,  56, 245,  42,  18
,},
{  57, 160,  87, 144, 240, 264, 294, 120, 146,  66, 136, 156,  71, 198, 305, 127,  29, 255,  38,
  271, 166,  85,  42, 254, 199, 171,  71, 195, 152,  87, 227,  41,   6, 134, 300, 184, 107, 289,
  159,  21,  93, 283, 141, 232, 171, 261,  41, 190, 223, 298, 261,  31, 107, 204, 133, 195,  49,
    5, 257, 289,  61,  58, 276,  61, 264,  34, 259,  76, 243, 123, 165, 180,  59,  22,  91,   3,
   40,  89, 168, 279,  51, 146, 192,  45, 204, 264, 170, 295,  15,  59, 179, 268,  27, 110,  17,
   45, 243,  60, 225,  76,  17,  16, 103,  51, 277, 170, 148, 236, 149, 151, 301,  78,  65, 150,
   35, 106, 188, 118, 261, 191, 266, 109, 268, 275, 181, 108,  75, 125, 297,  51,  91, 263,  41,
  139, 282,   5, 306,  71, 240, 236,  66, 300, 135, 202,  32, 172, 277,  47, 222, 167, 228, 109,
  222, 285, 197, 144, 303,  56,  12, 223, 301, 159, 167, 148, 238, 272,  76,  71, 189, 114,  34,
   33,   7, 113, 203, 254,  58, 181
,},
{ 215, 147, 195,  53, 273, 267, 167, 260,  45, 254, 157,  84,  66, 234, 130,   7, 217,  35, 306,
  260,   1, 165,  11,  34, 130, 110,   6, 203, 212,  24,   6, 228, 296, 292, 138, 113, 203, 214,
  306, 198,   6,   4, 272, 148, 195,  88, 124,  16, 244,  91, 286, 273, 187, 175, 200, 184, 209,
  247, 163,  84, 296, 299, 155, 286, 242,  30, 298, 258,  68,  31, 265,  15, 210, 126, 253, 257,
  234, 111, 125, 238,  50,  95, 131, 176,  59, 250,  63, 108, 102, 150, 263,  57, 279, 177,  54,
  180, 272,  22,  17, 117,   8, 242,  52, 288,   3, 101, 274,  90, 180, 216, 154, 233, 210,  98,
  234,  50, 124,  19, 303, 209, 164, 176, 221, 271, 113, 278, 280, 305, 182, 191,  86, 217, 226,
  306, 109, 207, 299, 131, 290, 155, 219, 230, 223,  82, 229, 255,  26,  67, 303, 301, 202,  68,
  273, 196,  94, 299,  55, 286,  99, 199,  61,  73, 179,   9, 225, 142, 100,  54, 253,  10,   7,
  137, 268,  98, 286,  45,  28,   6
,},
{  19, 123,  43, 182,   3, 184, 257, 154, 132, 303,  45, 101, 176,  29, 208, 305, 222, 129, 208,
  120, 229, 118, 227,  26, 113, 105,  74, 219,  56, 145, 291, 196, 172, 297, 131, 220,  39, 271,
   67,  41, 111, 288,  63,  67, 179,  82, 153, 286, 145,  31, 267, 110, 134, 213,  29,  66,  81,
   68, 181, 142, 186,  80,   2, 213, 292, 297, 149, 108, 273,   5, 302,   9, 189,  46, 115, 172,
  246, 216, 197, 224,  15, 121,   8, 161,  73, 203, 128, 256, 278, 271, 228, 108, 305, 228, 282,
   17,  23,  34, 141,  66,  91,  85,  21, 204,  71,  26, 213, 306, 195,  16, 172, 128, 139,  33,
   94,  14,  93, 249, 171, 247, 298, 256, 273, 177, 191, 123, 109,  79,  83, 304,  87,  80, 248,
  228, 132, 288, 193, 205, 296, 104, 302,  65,  29, 284, 300, 233, 145,  36, 201, 270, 197, 195,
  221, 245, 132, 133, 274, 202, 167,  17, 119,  28, 189, 245, 210,  98,   4, 218, 250,  13, 249,
  236, 272,  59, 119,  45,  85, 279
,},
{ 116,  39, 199, 206,   6,   9,  26, 113,  35, 156, 255, 204,  81, 144,  48, 210,  18, 121,  38,
  155,  60, 297, 238, 157, 169,  25, 273,   1, 291, 164, 127, 223,  48,  65,  25, 260, 156, 131,
   36, 178, 140,  23, 115, 201, 127, 297, 188,  11, 298, 218, 233,  65, 247, 115, 178, 245,  35,
  125,  69, 279, 280, 273, 238, 243, 185, 240, 151, 217,  38, 260, 173,  64, 118, 238, 302, 186,
  121,  23, 224,  42, 139,  93, 220, 175, 130,  15,  56,  46, 179,   1, 214, 235, 281, 236,  45,
  250, 238,   8, 195, 117,  85, 141,  93,  28,  91,  66,  15, 166, 123, 244, 119, 191,  55,  44,
  154, 302,  18, 226, 256,  23, 241, 278,   8,  69, 141,  42,  93, 126, 194, 230,  73, 115, 140,
   34, 119,  13, 251, 120,  49, 243,  32, 202,  82, 256, 290, 179,  30, 303, 127,  48,  39,  25,
   95, 147,  32, 257,  45, 202,  41,  38, 288, 273, 203, 188, 228, 291, 128, 272, 122, 142, 228,
  306, 220, 224, 268, 118,  63, 244
,},
{ 261, 161, 210, 182, 117, 173, 114,   9, 229,  89,  48, 229, 159,   9, 110, 206, 255,  21, 300,
  149,  20, 213, 260, 234,  95, 278,  96,  32, 163, 227, 277, 281, 197, 191,  67,  85, 116,  56,
  293, 209,  17, 249, 171, 272,  29, 239,  75,  22,  38, 232, 212, 239, 143, 281, 113,  50, 252,
  134, 204, 136, 129,  92, 168, 243, 180,  68,  65, 304, 213, 239,  24,  98,  79, 305, 200,  78,
  148,   3,  41, 259,  81, 161, 239, 212, 182, 153,  68,  25, 103,  93, 103, 153,  87,  49, 208,
  280, 210, 281, 140, 141,  83,  44, 159,  32,   4,   3, 118, 293, 138,   3,  92,  85, 257, 225,
   86,   8,   4,  87, 165, 230, 163, 196,  27, 163, 295,  36, 128, 208,   1, 141,  94, 136, 250,
  119,  19, 235, 160,  10,  76, 160,  81, 114,  10, 209, 116, 248, 106, 232, 124,  13, 219, 266,
  107,  82, 205,  83,  59, 190,  70, 288, 264, 174, 283, 124,  73, 180, 205, 117,  56, 186, 242,
  126, 270, 112, 157, 189,   5,  37
,},
{  66, 103, 236, 181, 283, 131,   9,  85, 243, 285, 284, 112,  80, 289, 258, 217,  48, 224, 218,
   74,   9, 281, 186, 199,  56, 299,  56,  28, 200, 108, 185,  16,  38, 152,  68,  61,  38, 126,
  224, 245, 133, 221,  50, 186, 105, 202,  77, 153,  50, 106, 294, 150,  47, 201,  97,   3,  80,
  150,  34, 228, 151,  25, 256,  14, 280, 161, 239,  19, 243, 285,  17, 185, 250,  91, 186, 161,
  266,  37, 124, 191, 163, 263,  85, 117, 242, 149, 117, 286,  50, 173, 267,  17,  45, 233, 236,
   31, 284, 175, 145,  84,  83, 302, 165,  73, 280, 197, 182, 213, 173, 150, 141,  34,  17, 240,
   98, 162, 222, 212,   1, 229, 216,  14, 129, 165,  79, 152, 273, 270,  67,  37, 216,  57, 276,
  160, 274, 253, 251,  92, 260, 157, 299, 257, 256,  28, 223, 243, 286, 270,  35,  74,  88, 227,
  135, 139, 199, 292, 287, 198,  19,  76, 204, 214, 173,  76, 289, 262, 250, 114, 200, 111, 176,
   68, 191, 158,  88, 257, 231,  69
,},
{  65, 236, 135, 240, 220,  27,  16,  13, 148, 140, 184, 254, 249, 115, 297, 275,  80, 264, 218,
  228, 178, 280,  73, 205,  33, 229, 192, 203,  26, 197, 262, 221, 293, 203, 296,  90, 131, 206,
  124,  93,  12, 306, 132, 302,  82, 187, 182,  98, 255, 210, 288, 112, 240,  39,  57,  91, 200,
  147,   5, 253, 173, 123, 140,   2,  83, 145, 148, 203,  38, 286, 178, 143,  37, 206, 118,  22,
  188,  59, 105, 188, 236, 212,  30, 123,   7,  56, 281,  34,  92, 305, 149, 173, 106, 226,  59,
  271, 221,   3, 162, 248,  92, 201,  63,  71, 187,  84, 257, 243,  39, 129, 258, 149, 181, 284,
  194,  24, 196, 278, 118, 278, 178,  46,  55, 237, 166, 194, 204, 264, 173, 242,  69, 147, 260,
  299,   1,  30,  92,  91, 301, 270, 159,  63, 248, 190,  79, 269, 206,  94, 276, 116, 106, 161,
  298, 120,  17, 187, 158, 289, 211, 304,  77, 285,  13,  11,  85, 210, 210,  72, 219, 203, 250,
  200, 239,  90, 246, 233, 103, 201
,},
{ 176,  53, 129, 160, 100, 155, 306,  41,  23, 195,  46, 150, 266,  84, 165, 173, 263, 202,  73,
  127, 264, 260, 208, 115, 242, 270, 251, 113,  37,  84,  85, 180, 187, 173, 182, 280,  67, 260,
   40, 303,  95, 249, 287, 172, 266, 134,  62,  83, 275,  27, 273, 225, 214, 190,  60, 173, 171,
  235,  85,  69, 293, 305, 151, 241, 203, 237, 294, 230, 245, 230,   1, 198, 139,  69, 298,  14,
  114, 199, 177, 198, 239,   5, 214, 114, 203, 226, 267, 146, 203,  74, 155,  22, 192,  86, 213,
  201,  77, 230, 152, 115, 298,  62,  12, 243,  16, 190, 152, 101, 230,  71, 190,   1,  70, 238,
  150, 192,  83, 239, 151,  84,  36, 190,  72, 116,  13, 194, 212,  71, 195, 269, 135, 175, 111,
   20, 303,  11, 175,  13, 246, 210, 129, 219, 237, 296, 125, 213, 268, 234, 285, 245,   9,  25,
  221, 281, 125, 249, 117,  17, 140, 227,  80,  46, 180,  75, 144, 282, 192, 172, 191, 161,  74,
   93, 271, 145,  26,   1,  38,  69
,},
{  65,  39,  85, 133, 199, 151,  40,   3, 104, 227,  94,  16, 287, 301,  92, 182,  36, 172, 196,
   83, 231, 228,  52, 227, 256, 108, 163,  91, 111,  34, 238, 121, 150,  45,  10, 204,  43, 235,
  258, 216,  70, 268, 160, 232,  68,  41, 114,  83, 185, 128, 209,  91,   8, 206,  46,  54,  63,
  238,  90, 304,  14, 265, 113, 204,   3,  68, 224, 258, 249, 288, 123, 127,  50,  95,  96, 134,
   41, 214, 267, 241, 243, 288,  79, 252,   4,  17,  51, 184, 259, 151,  50,  61, 111,  66, 219,
  248,  84, 103, 217, 255, 123, 109, 130, 225,  50, 127, 250, 213, 234, 186, 179, 198, 148,  30,
  192,  76, 226, 139, 145, 121,  33, 173, 231, 180, 117, 128, 246, 203, 281,  63, 301,  66,  71,
  134, 168,  59, 157,  15, 222, 256, 212, 200, 210, 171,  40, 171, 176,  76, 240,  59, 277,  82,
   96, 206, 159, 113, 115, 119,  30, 118, 228, 161, 152,  18,  84,  65, 230,  14, 277, 194, 300,
   98, 264, 170, 233, 171, 154,   8
,},
{ 230, 147, 105, 170, 271, 285, 240, 125,  37, 141, 153, 224, 241,  33, 164, 223, 264,  21, 198,
  255, 144,  80, 106,  72, 230,  18,  60, 140, 202, 124,  83,  82, 251,  49,  35,  17,   3, 236,
   39,   7, 100, 139, 142, 296, 171, 122, 230,  23, 255, 208, 158, 179,   8, 145, 216,  72,  19,
  182, 150,  62, 133,  33, 176,  88, 212, 281,  22,  73, 278, 165, 240, 191,  52,  36, 285, 295,
   17,  17, 124,  92,  46, 133, 172, 119, 217, 196,  59, 206, 206,  75, 255,  48, 187,  43, 206,
  272, 141, 176,  57, 180, 118,  21,  19, 128,  38, 183, 174,  88,  46, 220,  25,  42, 175, 219,
  127,   1,  31, 188, 137, 275,  35, 258, 200,  70, 278,  28,   5, 285, 214, 239, 129, 293,   5,
  176, 209, 202, 245, 134, 235, 281, 145, 109, 239, 189, 257, 250, 229,  87,  50, 196, 125,  63,
  286, 161, 223, 211, 182,   4, 165,  23, 216, 184, 111, 240, 286,  17, 188, 285, 173, 264,   1,
  196, 278, 190, 198,  14, 122, 284
,},
{ 183,  71,  34, 206, 157, 254, 221,  34, 104, 276, 277, 163,  76, 127, 235,  56,  64, 192,  23,
  297, 118, 156,  47, 202,  25,  70, 156,  11, 243, 203, 175,  71,  92, 196,   1, 130,  96, 254,
   32, 185, 187, 247, 271,  58, 126, 246, 231, 223, 296, 304,  45,  14, 149, 113, 193, 218, 211,
   99, 128,  77, 285,  40,  97,  56,  65, 257, 183,  34, 169,  59, 303, 198, 138, 169,  27, 135,
  286,  86, 199, 205,  77, 132,   6,  57, 258, 279, 152, 189,  66, 121,  83, 184, 223, 229, 101,
   92,   4,  30,  78, 125,  75, 181, 203, 255,  90,   1, 163, 256, 146, 163, 184, 227, 300,  86,
  132, 254,  92, 217, 117, 147, 292, 194, 142, 164, 172,  35, 113,   8, 215, 258, 126, 152, 123,
  202, 229, 188,  51, 196, 269,  27, 178,  19, 112, 261, 172,  37, 160, 293,  85,  23,  83, 203,
  244, 291, 304, 227,  51,  79, 102,  70, 125, 189, 251, 165, 237, 210, 239, 145, 250, 172,  13,
  300, 139, 107, 263, 252, 270, 132
,},
{ 111,   1, 239,  55,  27,  41,  34, 242, 288, 254, 283, 273,  38, 183, 169,  94, 181, 277,   7,
  229, 229, 236, 292,  70,  98,  89, 199, 237, 154, 304, 244,  57,  67, 114,  31, 270,  37,  57,
   90,  35, 113, 251,  10,  59, 126,  96, 141, 111, 298, 215, 185, 164,  26, 107, 278,   8, 101,
  179, 182, 280, 172, 138, 260, 145, 188,  47, 112, 301,  57,  11, 188, 197,  35, 214, 234,  87,
  200, 197, 136, 228, 211, 104,  60,  52, 247,  49,  51, 100, 245, 100, 302,  50, 114,  22,  83,
  208,  15, 294, 192, 235, 167, 234, 231, 170,  86, 289,   9, 253, 110, 222, 116, 226,   1,  90,
  305, 204, 279,  79, 184, 113, 263, 167, 179,  95, 246,  85,   1, 296,  36, 136, 119, 301, 220,
  167,  58, 176, 187, 132, 142, 168, 191, 167, 202, 226, 145, 260,  73,  73, 171, 280, 191, 236,
  192, 242, 111, 241, 291, 215, 224, 140, 152,  13, 285, 168, 289, 206, 244,  72, 159, 189, 211,
  139, 200, 146, 262, 180, 211, 266
,},
{ 126, 228, 200,  72, 192, 277,   7, 174, 298,  60,  96, 154, 156,  35, 156, 150, 211,  66,  67,
   50, 185, 197,  17,  36,  93,  13,  28, 125, 167,  49, 168, 276, 235,   9, 242, 187, 264,  84,
  294, 110, 169,  28, 206, 234, 103, 233,  10, 262, 304,  65, 138, 262, 244,  53, 286,  68, 149,
  297,  16, 172, 197, 113, 172, 273, 104,  68, 206,  80,  45,  27, 257, 300, 236,  30, 238,  20,
  111,  16, 121, 227, 268,  84, 238, 162, 193, 184,  64, 216,  64, 267, 181,  82,  95,   2,  72,
   80, 104,   4, 146, 113, 208, 306, 158,  11, 169, 287, 240, 302, 303, 105,  11,  89, 152, 136,
   15, 171, 166,  90, 166,  55, 170, 146,  67, 275, 130, 280,  63, 300, 278,  21,  28, 160,  38,
  104, 128, 114,  67, 113,  79, 185, 238, 220, 159,  41, 169, 220, 193, 107, 283, 243, 172, 290,
  265, 281, 270, 305, 156,  54,  56,  68, 175, 224,  39, 141, 176, 287, 228, 154,  63, 264, 142,
  130, 291,  42, 156, 118,   9,  82
,},
{  55, 199, 137, 227, 105, 306,  38,  34,  62, 140,  69,  47,  81, 162,  89, 194, 223, 134, 179,
  288, 138, 249,  21, 222, 297, 263, 135, 176, 265,  70,  14, 104, 227,  44,  60, 237, 199, 170,
  224, 254, 149,  32, 118,  65, 146, 196,  98,  75, 183, 156, 219, 291, 102, 190,   2,  92,  93,
   64,   9,  36,  31,   8,  45, 146,  48,  37,  57, 270, 285, 105, 149,  33, 222, 246, 289,  52,
  279, 172, 168, 246, 147, 215, 123,  34, 187,  12, 154,  41, 288,  20, 105,   7, 299,  12, 209,
   78, 288, 126, 300, 304, 167, 237, 151, 291,  13,  74,  78, 268, 202,   6, 220,  65, 237, 189,
  286, 283, 247, 237, 223, 117, 248,  97,  39, 182, 205,  62,  17,  79,  29,   1, 237, 253,  72,
  270, 182,  16,  25, 215, 219, 300,  45, 180, 236, 174, 155,  19,  47, 125, 301, 139, 152, 281,
  232,  87, 225, 189, 168,  16,  65,  61, 305,  31, 172,  20, 125, 180, 243, 101, 172, 160,  51,
  304, 133, 300,  22, 137, 153, 267
,},
{  78, 259, 176,  19, 151, 289, 168, 227, 171, 184, 203,  33, 150, 123, 233,  48,  91, 298,   4,
  191, 290, 279, 245, 228, 207, 259, 196, 250, 235, 200, 132, 180,  68, 118,  94,  25,  14, 155,
  229, 251, 220, 111,  48,  52,  63, 183, 172, 246, 136,  68,   6,  62,  92,  31, 140, 179, 267,
  112, 197, 149, 277, 243, 146, 170, 106, 193, 267, 198, 170,  91,  38, 116, 101, 292, 217, 215,
   23,  92,   8, 122, 300,  83, 181, 230, 209, 148, 109, 300, 238, 287, 114, 115, 298,  25, 233,
  251, 306, 135,  49, 178,  68,  63,  73, 161, 305, 269, 146, 274, 182, 272, 197, 291, 180, 189,
   11,  13, 201, 130, 247, 187, 240,  44, 269, 230, 306,  36,  63, 129,  24, 239, 285, 277, 251,
  161, 202,  12,   7, 140,  36, 231, 241, 253, 292,  34,  51,  26,  36, 185, 255, 214, 116, 301,
  182, 214,   2, 272, 151, 109,  93, 100, 185, 218, 281,  39, 215, 153, 179, 275, 227, 237, 204,
  264,  18, 196, 160, 196,  75, 117
,},
{ 217, 126,  73,  76, 272, 104,  94,  68, 187, 290, 253,  32, 292, 196, 230, 115,  96, 217, 141,
   61,  47, 269, 260,  77,  80, 180, 171, 205, 300,   3,  34, 153,   9, 241, 202, 158, 117, 112,
  205, 127, 243, 193, 187, 195, 196, 162,  69, 261, 152, 127, 123, 258, 268, 292, 254, 290, 166,
  127,  53, 248, 296,  56, 131,  49, 287, 104, 211, 246,  30,  16,   3, 265, 132, 280, 231,  19,
  154, 286, 234, 250, 225, 303,  75, 152, 217, 254, 225,  35, 238,   3, 273,   8,  39,  71,  77,
  279, 106, 270, 153, 237, 285, 188, 205, 274,  74, 293, 304, 156,  19,  54,  28, 304, 300, 259,
  111,  19,  84,  29,  24,  76, 234, 192, 247,  25, 205, 194, 271, 288,  98, 254,  53, 168, 114,
  290, 145, 162,  46,  16, 134,  93, 181,   1, 171, 100, 294, 129,  30, 231,  35,  72,  28, 133,
   61, 250, 194, 302, 245, 101,  91,  29,  75,   2,  24,  33, 121,  41, 225,  24, 106, 152, 139,
  218, 287,  87, 145, 219,  55, 211
,},
{   3, 154, 255, 281, 262, 161, 264, 302, 274,  50, 257, 228,  95, 270, 305, 193,  52, 276, 212,
   47, 250,  17, 198,  20,  41, 173, 142, 140, 101, 144,  29,  64, 128, 300,  54, 118, 114, 257,
    8, 147, 291,  29, 170,  90,   6, 162,  43, 240,  39, 183,  74, 176,  26, 159, 172, 249,  96,
  273, 262,  82, 151,  68, 203, 124, 260,  21,  42, 181,   6, 117, 285, 108, 244, 300, 149, 299,
  195, 135, 138, 185, 134,  10, 160, 209, 265,  62,  57, 207,  78, 297, 290, 297,  31, 241, 233,
   55,  28, 230, 208, 290,  39, 281,  40, 229,  62,  13,  36,  99,  11, 187, 144, 137, 273,  62,
   16, 254, 252, 233,  53, 306, 187, 297, 175,  30,  77,  45, 135, 110, 156, 295,  76, 149, 286,
   82,   4,  44,  79,  15, 139,  40, 197, 189, 147, 116, 296, 230,  47, 177, 236, 256, 201, 140,
  141, 202,  46, 184,  88,  42, 163, 175,  81, 296, 295, 196, 194,   4, 100, 179, 265, 262,  12,
  159, 207, 254,  58,  10, 193,  30
,},
{  95, 157, 248, 190,  31, 124, 111, 199, 276,  29, 233, 284,  74, 217, 140, 259,  40, 226, 220,
  203, 199, 221,  20, 273, 108, 223, 300, 286,  19,  73, 251,  58,  91, 133, 109, 157,  55, 147,
  136, 218,  19, 166,  17,  66, 245,  55, 180, 239, 271, 202, 142, 115,  95, 156,  43, 116,  41,
    5, 250, 157, 285, 299, 118, 186, 154, 228,   2,  13, 256, 305, 244, 233,  57,  38, 245,  51,
  244, 105, 258,  19, 298, 182, 189,   3,   1,  64,  66, 101, 136,   2,  73, 129,   2,  83, 152,
   48, 191,  66, 211, 146, 160, 117,  97, 186,  65, 177, 266, 196,  10, 112, 274,  14, 281,   2,
   42, 144, 162, 263,  72,  80, 137,  33, 168, 262, 244, 127, 121,  51, 228, 152,  82,  46, 304,
  296, 133, 285, 281, 223, 226, 130, 161,  41, 105, 145, 285,   9, 294,  97, 233,  71,  43, 166,
  291,   1, 189, 241,  59, 209,  61,  60,  82, 223, 262,  11, 280, 173, 235,  76, 238, 293, 229,
  236, 220,  83,  52,  81, 210, 220
,},
{ 185, 201, 130, 283, 301, 247, 269, 146, 213, 219, 143, 124, 178, 150, 287, 212,  58,  88,  20,
  154, 192, 191, 243, 263, 202,  10, 131, 128, 115, 223,  39, 259, 256, 230, 165, 148,   2, 297,
  283, 141,  98, 228,  78,  73,  77, 195, 187, 287,  57, 136, 106, 238, 135,  25, 124, 144, 228,
   90,  41,  94, 213,  40, 154, 198,  99, 124, 191, 301, 256,  95, 213, 272, 166, 286,  44,  38,
   57, 198,  86, 204,  29,  36,  62,  61, 115,  62, 298, 184,  92, 295,  99,  18, 217, 281, 249,
  228,  22, 265,  29, 268, 216, 118,  98,  42, 109, 192,  88, 109,  55, 239, 136,  37, 149, 238,
   60, 162, 288,  38, 208, 270, 171,  31,   8, 192, 194,  99, 275, 119, 200, 301, 125, 169,  57,
  275,  56, 147, 181, 109, 133, 160, 301, 245,  39, 295,  54, 227,  69, 149, 303, 251,  44, 298,
  250,  83,   8,  84, 143, 230, 246,  22, 299, 100,  76, 226,  13, 126,  25,  59, 304,  34,  51,
  132, 274,  27, 239,  16, 115, 101
,},
{  64,  69, 190, 167, 260,  82, 181, 306,  38, 258, 129,  19, 240, 118, 224, 214,  96, 214, 186,
  266, 195, 166, 109,  35, 109,  37,  18, 186, 263, 164, 266,  65, 135,  17,  27, 215,  28,  21,
  125,  69,  58, 240, 249, 260,  32,  68,  10, 151, 156,   2, 131, 111, 303,  61, 228, 222, 201,
  157, 207, 148, 276, 261, 106, 107, 299, 155, 234, 165,  93, 270, 103, 304, 131,  66, 152,  62,
  211,  61, 213,  64,  83, 252, 260, 260, 118,  83,  55, 221,  78, 225,  73, 304, 304, 126,  53,
  189, 297, 109,  68, 291,  35, 233, 133, 303,  22, 138, 133, 115, 188, 262,  10, 210,  92,  86,
  273, 143,  16, 192, 243,  84, 182, 287, 180,  86, 278, 260, 273, 115,  66, 207, 290,  24, 128,
  193, 109, 255, 116, 236, 277,  72,  25, 267,  85, 196,  76,  19, 115, 135,  51, 208, 240, 182,
  264, 188,  29, 204, 226,   8, 120, 196, 108, 204,   6, 266,  79, 280, 259,  67, 186, 255,  15,
  273, 102, 184, 227, 122, 280, 298
,},
{ 125, 202, 225,  56, 242, 240,  97,  47, 191, 265, 111, 213, 188, 142, 157, 115,  45, 228, 108,
  158, 159, 173,  73, 240,  70, 300,  91, 159, 253, 210, 224, 288, 149, 287, 105, 211,  19, 233,
   88,  62,  46, 249, 305,  96,  60,  48, 124,  74, 111,  15,  45,  88, 166, 264, 280, 122, 223,
  259, 256,  85, 302, 293, 246,  19,  98,  63, 130, 212, 296,  34,  17, 180,  43,  70, 236, 120,
  232, 238, 239, 218, 245, 130, 229, 215, 261, 209, 266, 226, 273, 285, 108, 152, 239, 227, 122,
  262, 271,  40,  84, 148,  23,  73, 104, 212, 168, 141, 277,  85, 111, 127,  21,  49,  44, 204,
   92, 296, 232, 289, 271,  20, 104,  44, 295, 246, 206, 263,  53, 114, 141, 190,  56, 299, 131,
  125, 147, 301, 276, 257, 142, 249,   5, 256, 108, 147, 176,  70, 184, 100, 241, 254,  57,  97,
  106, 306, 284, 124,  88, 159,  33, 243,   9,   4,  30, 214, 118, 116, 180,  82,  80, 239,  50,
  132, 224, 262, 306, 128,  62,  57
,},
{  27, 172, 135, 255, 195, 164, 145, 127,  59, 186, 275, 193, 166, 297, 202, 131, 162, 130, 183,
  183,  17, 196, 148,  62, 223, 293, 265, 119, 144,  77, 137, 187,  63,   5, 139, 270, 122,  51,
  218, 180,   3, 269,  42,  46, 237,  61, 205, 128, 225,  83, 152, 215, 149, 106, 105, 235, 218,
  265, 246, 210, 133,  92,  81, 183,  76, 160, 119, 167, 201, 158, 306,  41, 298,  20, 119, 234,
  169,  61, 134, 105,  95, 152,  71, 207,   4,  94, 278, 104, 306, 190, 105,  17,  52, 215, 150,
  231, 152, 159,  96,  89, 208, 294, 276,  13, 146, 233, 284, 274,   8,  88,  16,  81,  77,  51,
  166, 151, 244,  38, 198,  46,  98,  57, 198, 184, 100, 301,  39, 139, 154,  72, 123, 306, 133,
  150,   7, 159, 168, 304, 136, 217, 264,  77,  35, 227,  69, 214, 253, 279, 145,  81, 187, 144,
  169, 147,   5, 194,  40, 103, 103, 175,  97, 156, 185,  43, 128, 293,  33,  73, 102, 256, 207,
  230,  33, 234,   1,  12, 201, 144
,},
{ 149, 275, 132, 130, 283, 208, 231, 140, 125, 111,  82, 159, 252, 199, 287, 104,  72, 199, 291,
   17,  53,  62, 149, 201, 116, 237,  43, 158, 275,  71,  38,  92,  71,  87, 132, 265,  29, 219,
  207, 305, 241,  17, 150,  34, 176, 288,  86, 102, 154,  25,   9, 226, 256, 159, 286, 266, 219,
  211, 216,  49, 202, 168,  25, 245,  20, 168, 253, 164, 220, 224, 215, 302, 226,  46,  63,  17,
  277,  44, 283,  54, 279, 264, 213, 177, 191,  83, 236, 305, 193,  64, 220,  69, 136,  56, 279,
  183, 147, 273, 252,  44,  79, 214, 209, 240,  24,  84, 158, 131,  31,  63, 260,   6, 281, 127,
  262, 105, 262, 174,   2,  82,  33, 157, 236,  63, 106,  33, 236, 127,  30,  12,  32, 286, 129,
  181, 272,   5, 130,  61, 273, 277,  61, 252, 165, 271, 240, 165,  30, 186, 118, 274,  41,  19,
  132, 111, 146,  20, 208, 191,  10, 284,  97, 226, 177, 234, 262, 150,  51, 102, 172, 175, 159,
  177,  93, 236, 124,  50,  51,  85
,},
{ 218, 176, 132, 306, 138, 199, 271,  98, 271,  96, 169,   5, 132,  86, 240, 259, 131, 258, 245,
  112, 243,  22, 224, 208,  41, 120,  34, 144,  71, 298,  16,  69,  15,  34, 211, 168, 240, 276,
  132, 188, 147, 245, 290,  60, 115,  59,  32, 232, 241,  53, 267,  74, 150, 215,  35,  25,  86,
  217, 197,  72, 266, 212, 105,  28,  23, 134,  63, 222, 223,  95,  21, 170,   4, 154, 146, 297,
  117,  22, 239, 304,  16, 108, 106,  24, 304,  82, 299, 156, 155,  80, 248, 122, 103, 181, 162,
  113, 159,  50, 168, 281,  85, 300, 102, 111, 287,  94, 238, 202, 237, 266, 156, 301, 107,  76,
  275, 113,  49, 242,  76, 232, 166,   6, 252,  22, 260,  43, 146, 305,  52, 121, 176, 254,  60,
   55, 172,  96, 216, 231,  96,  94,  57, 233,  14,  57, 187,  92, 244, 274, 140, 111, 131, 300,
  191, 247,  23, 238,  24, 295, 296, 281, 174,  90, 232, 191, 165,  49,  37, 290, 218, 149, 235,
  282,  94, 151,  73, 138, 105, 281
,},
{  20, 105, 115,  86,  11,  12, 140, 225, 141,  74, 183, 207, 118, 190, 301, 198, 146, 103,  20,
  130, 144,  43, 265, 159, 275,  47, 276,  32, 167, 259,  62, 216, 107, 113, 220, 265, 284, 150,
  299, 257, 258, 153, 194, 155,  28,  93, 289, 251, 287, 243, 109, 211, 267, 242,  29, 104,  62,
   83, 196, 288, 244, 281, 271, 263,   2, 194, 130, 170, 157, 189, 251, 107,  30, 203, 304, 190,
  140, 195, 161, 117, 247, 220, 178, 283,  61, 294,  99, 179, 238, 139,  49, 101, 173,  17,  33,
  220,  77, 167,  46,  58, 189, 263, 132, 262,  28,  85,  18, 304,  54, 129, 252,  64, 299, 260,
  298, 205,  29,  19,  95, 114,  51, 279, 302, 238, 164,  12,  59,  96,  39,  35,  60, 202, 222,
  256, 195, 215, 259, 214, 130, 288,  71,   8, 183, 159, 238, 272,  57, 303, 205, 283,  50,  59,
  251, 210, 115, 161, 244,   1, 299, 242, 116,  10,  99, 253, 241, 306,  33, 242, 157,  30, 239,
  266,   4, 181,  60,  94,  67, 143
,},
{ 197, 181, 287,  61,  20,  90, 183,  86, 142, 150,  56, 281,  46, 106,  82, 225,  52, 300, 184,
  192, 261,  16,  88, 162, 251, 242, 110, 287,  59,  54,  22, 190,   7, 182,  11, 230, 241, 165,
  177,  72, 179, 225, 280, 169,  24, 149,  56, 159, 102, 276, 242, 110, 224,  68,  37, 110,  54,
  232,  45, 156, 263,   8, 110,  16,  99, 136, 216,   2,  67,  37, 252,  85, 263,  10, 299,  62,
  286,  18, 198, 218, 277,  46, 142, 279, 233, 116,  47, 145,  35,  19, 156,  90, 281,  32, 217,
   21, 111,  33, 189,  37, 257, 131, 266, 173, 258, 218, 196, 269, 197,  34, 206, 144,  75, 225,
  267,  69,  53, 194,  60, 193,  35, 197, 186,  72,  71, 300, 231,  27,  24, 286, 217, 224,  71,
   65, 100, 112,  86, 270,   2, 302, 261, 187, 283, 153, 238, 231,   4, 193, 222, 186, 158, 139,
  175, 300,  15, 277, 128, 217, 286, 289,  75,  97, 114, 137, 285, 233,  87, 287, 206, 270, 149,
  222, 260, 293, 221,  98,  24, 165
,},
{  62, 123,  84,  83, 221, 182, 122, 286, 250, 176,  82,  51,  48, 103,   5, 136, 151,  88, 299,
  288, 107, 255, 186,  40,  32,  24, 173, 288,  82, 212, 182,  28, 185, 188, 206, 117,  37, 269,
  267, 104, 289, 259, 159,  15, 254, 140, 248, 213, 176, 231, 204,   7, 125,  18,  44,  36, 194,
   14, 259, 235, 198, 156, 283, 170, 181, 230, 185, 210, 261,  23, 275, 273, 265,  51, 168,  67,
  220,  98, 234,   4,  72, 234, 263,  46,  56, 202, 138, 289, 215, 231,  15,  38, 156, 260,   3,
  274, 155,  13,  82, 155, 243,  72,  40, 148, 192, 123, 228, 155, 240, 292,  52, 105,  15, 273,
  115,  50, 177, 267,  76,  55,  31, 109, 255, 204,  21,  39, 104,  76,  62,   2, 189,  52,   2,
  126, 192, 264,  34, 264,  49, 106, 200,  17,  32, 272,   8,  41, 276, 279, 194,  82,  89, 119,
  202,  19,  75,  13,  50,  26, 168, 180, 238, 242, 217,  87, 292,  16, 122, 262, 151,  53, 242,
  153,  97, 192, 103, 194, 277,  19
,},
{   9, 180, 203,  94,  27, 195,  48, 132, 290, 146,  77,   7, 240, 289, 123, 201, 254,  77,  73,
   17, 241,  17,  42,  80, 239,   4, 217,  80, 283, 228, 290, 272, 260, 137, 241, 261, 292, 150,
  264,  93, 289, 261, 190, 175,  62, 152,  90, 147, 161, 269,  72,  56, 232, 105, 272,  29,  68,
  208, 112,  39, 251, 128, 290, 262, 189, 304,  44,  95, 104, 215, 216, 283, 210, 155, 272,  65,
  288, 163, 268,  87, 270,  41, 112,  51,  78, 205, 225,  84, 111,  85, 171,  87, 107, 148, 132,
  244, 135, 220, 134, 186, 175, 231, 242, 112, 126,   9, 273, 227,  27, 130, 255,  72,  12, 222,
  158, 237, 135,  10,  32,   1,  81, 220,  58, 218,  53, 155, 169, 235, 294,  39,  82, 170,  99,
  213, 189, 196,  15, 248,  19,  74, 111, 224, 148, 174, 246, 123, 102, 103, 294, 243, 162, 118,
  143,  11,  21,  45, 292,  55, 212, 113,  29, 287, 200, 119, 263, 248, 193, 291,  64,   5, 247,
  302, 120, 305, 105,   5, 116, 202
,},
{ 128,  84, 158, 277,  48, 203,  63, 122, 223,  73, 273, 136, 239, 120, 130, 284, 276, 259, 273,
  258,  99, 189, 160, 240,  79, 216,  20,  20,  43,  74,   7,  35,  24,  89,  38,  34,  21,  23,
  113, 143, 234, 266, 303, 247,  93,  44,  89,  18, 192,  51, 259,  82, 186,  84, 204, 161, 143,
  233, 135,  19,  96,  40, 260, 196, 157, 301, 217, 299, 293, 132, 231,  91,   1,  10, 194,   1,
  104, 296, 193, 224, 152, 102, 182, 201, 165,  14, 191,  71, 179,  70, 255, 274,  45, 232, 306,
   12,  75,   2, 133,  44,  27, 209, 261,  38,  72, 184, 198,  20,  78, 134, 286,  96, 182, 193,
  292,  17, 252, 250, 113,  91, 132,   6, 211, 214,  83, 185, 196, 156, 129,   1,  17, 187,  88,
   64, 188, 280, 134, 125, 277, 204, 111,  43, 211, 155,  43, 176, 206, 234, 214, 104, 221, 131,
   50,  19, 210, 106,  22,  22, 142, 112, 285, 146,  99, 273, 132, 183, 207, 277, 238, 273, 274,
   77, 242, 247,  91, 178, 226, 175
,},
{ 196,   3, 223, 137, 149, 164, 116,  42, 175,  73,  66, 277, 261, 132,  78, 271, 159,  63, 137,
   67,  19, 288,  53, 137,  37,  15,  87, 246, 184, 289,  33, 125,  39,   2, 254,  76, 127,  60,
  187, 110, 215, 170, 196, 208, 179, 123, 149, 209, 250, 273, 170, 140,  70, 228, 226,  82, 278,
  175, 150, 290, 231, 243, 127, 212,  64, 175, 139,  99, 276, 144,   3,  30, 254, 232, 252, 134,
  243, 193, 246, 164, 218, 125, 174, 136,  11,  67, 242, 243,  15, 145, 196, 288,  37, 246,  71,
  199,  89,  92, 147, 283,   2, 175, 159, 294, 207, 180, 176, 108, 166,   2, 181, 244,  15,  85,
  281, 220, 299, 265, 283, 117, 282, 257,  21, 258, 132, 170, 219,  13, 128, 208, 140, 149, 119,
   44, 208, 241, 281,  53, 179,  71,  40, 122, 167,  97, 271, 262, 140, 293,  49,  19, 243,  68,
  142,  52, 199, 273,  42, 165, 184, 104,  30,  90,  50, 182, 149, 163, 149,  67, 263, 299, 234,
  148, 177, 235,  92, 174, 219, 230
,},
{  12, 251, 212, 134, 267,  12, 190,  27, 252, 241, 248, 273, 222, 173, 261, 237,  19, 265,  43,
   68, 209, 206,   4,  14, 300, 102, 170, 270, 137, 174,  86, 153,  25, 282, 175, 225, 207,  73,
  258, 262, 152, 280,  78, 115,  66,  43, 261, 219, 242,  67,  61,  75, 133, 248,  55, 206, 227,
   92, 101, 266, 209, 240, 217,  99, 135, 228, 234,  19,  60,  10, 299, 116, 253,   5,  15, 217,
  224, 167, 215,  50,   7, 279, 167,  96, 281,   5, 200, 170, 108, 251,  65, 292,  73, 231, 280,
  290, 116, 278, 151,  81, 105, 293, 197, 255,  60, 270,  73, 277, 142, 224,  55,   3, 120, 291,
   34, 239, 231, 281,  54, 183, 254, 227, 189,  74, 159, 106, 241, 189,  99, 302, 110, 217,   7,
  298, 128, 111, 216, 157, 238, 110, 180,  72,  92, 254, 267,  15, 241, 114,   6,  12, 228,  77,
  100,  92, 157, 159,  31, 151, 106, 213,   5, 300,  34, 124, 212, 295,  92, 272, 110, 273,  46,
    7, 104,  45, 119, 166,  70, 119
,},
{ 121, 234, 235, 210, 268,  88, 223, 188, 149, 150, 138, 263,  51,  51, 169,  99, 152, 218, 268,
   38,  16, 227,   3, 148,  97,  60,   2, 250, 271, 292,  97,  68, 168,  96, 210, 164, 190, 123,
   74, 170, 225, 219, 171, 259, 167,  25,  53,  97, 168, 162, 283, 152,  30, 137,  13,  58, 261,
   40,  11, 145, 140, 223,  29,  37, 218,  49,  81, 252, 163, 192, 217, 236, 190, 275, 145,  97,
   50, 174, 133, 183, 181, 136, 242, 148, 151,  67, 246,  88, 267, 134, 263, 112,  94, 136,  11,
  109, 195, 103, 131, 253,  77,  46, 259, 244, 198, 158, 240, 196,  57, 164, 170,  51,  83, 140,
    7,  71, 222, 203,  21,  69,  55,  32,  53, 135, 227, 255,  80,  92,  84, 165, 286, 298, 269,
  149, 224, 250,  38, 296, 206, 233, 109, 298, 230, 125,  75, 244, 187,  30, 111, 119, 303,  38,
  195, 261, 153, 163, 226,  30, 298, 117,  59, 118, 247, 115, 273,  98,  14, 181,  66, 262,  50,
   34,  75,   1,   1, 200, 243,  85
,},
{ 218, 148,  91, 102, 218, 184, 151,  90,  12, 120, 208,  61, 236, 192,  92, 141, 126,  31, 264,
   89, 264, 292,  82,  62, 295, 101, 164, 103, 163, 294, 237, 128, 298, 131, 220, 246, 139, 130,
   36,  55,  12, 229, 185,  81,  33,  50,  76, 199, 236,  67,  97,  41,  76, 296,  13,  59, 185,
  259,  26, 174,  55, 150, 160,  32, 122,  25, 251,  50,   4,  38, 296, 172, 245, 118,  68,  72,
  197, 102,  62, 154, 145,  10, 285,  53, 275,  42, 283, 166, 245, 154,  11, 165, 146, 139, 242,
  152,  85,  98, 305, 160, 294, 298, 241, 161, 291, 268,   5, 284, 302, 292, 257, 211, 152, 185,
  288, 165,  15, 202, 105, 251, 153,  28, 127, 146,  25, 164,  61, 149,  17, 175,  22, 201,  72,
  195, 140,  48, 154, 139,  24,  27,  13, 281,  60, 122,  41, 234,  16, 124, 291, 104, 283, 255,
  210,   3, 173, 245, 167,   6, 135, 262,   7,  52, 124, 261,  46,  60, 292, 253, 297,  43,  15,
  173, 258, 133, 145,  15, 255, 166
,},
{  14, 231, 136, 243,  49,   7, 112, 303,  28,  89, 273, 296,  48,  31, 189, 124, 154,  45, 110,
   30,  50, 124,  63, 190, 201, 115,  26, 224,  27,  49,   6,  70, 216, 121,  77, 135, 143,  76,
   54, 277, 104, 139, 224, 244, 120,  79, 211, 260,  84, 176, 229, 242,  84,  79,  43,  92, 177,
  275, 275,  59, 233, 219, 222,  25, 198, 211, 145, 111, 158, 103, 270, 172,  74, 108, 223, 283,
  177,   6, 230,  38,  22, 165,  59, 194, 171, 268, 146, 199, 162, 111, 163, 123, 170, 270, 281,
   37,   4, 152, 218, 228, 157, 173, 119,  46, 195, 211,  92, 174, 119, 165,  98, 254, 271, 167,
  279, 239, 229, 301,   7, 193, 155, 140,  51, 240, 184,  97, 298,  26, 147, 220, 163, 163, 240,
   25, 293,  78,  70, 214,  99,  97, 103, 255, 246,   8, 218, 254,  56,  88,  45, 299,  92, 294,
  190, 254, 279,  24,  65, 243, 193, 220, 300,  15,  89, 108, 296, 114, 233, 282, 252, 104, 106,
    6, 224, 104, 100, 129, 303,  36
,},
{ 114,  76, 221,  58, 250, 129, 254,  34, 149,  41,  63, 244, 234, 133, 182,  11, 186, 240, 162,
  222, 151, 138, 189, 153,  50,  51, 206,  76, 263, 239, 116, 225,  41, 222,  76, 262, 305, 244,
  115, 306,  62, 261, 186, 222, 123,  56, 162, 262, 113,  34,   4,  94,  22, 240, 124, 160,  88,
  252, 186, 149,  57, 165, 279, 263,  61, 221,   4, 233, 201,  87, 194, 269, 295,  11,  42,  44,
  217,  69, 215, 210, 235, 141, 257, 239, 190, 114, 150,  76, 298, 255, 272, 154,  76, 171, 286,
   59,  16, 111, 252, 205,  72,   5,  75, 110, 279,  26, 269, 284, 190,  56, 208, 249, 304, 130,
  143, 187, 190,  58, 292, 285, 113,  93, 108,  94,  67, 244,   4,  13, 229, 265, 210, 127,  42,
  252, 209, 139, 301, 120, 283, 211,  58, 100, 277, 305,  88, 242, 208, 116, 278, 154, 289,  50,
  291,  22, 177, 206, 181,  26, 143,   8,  47, 102,  97, 178,  86, 148, 207,  20, 230,  40,   3,
  252, 202, 198, 230, 189,  62, 274
,},
{  49,   6,  34, 139,  26, 279, 184, 172, 124, 265, 116,  64,  45, 284, 276, 294, 210,  56,  56,
  264, 239, 275, 104, 260, 179,  34, 249, 109, 117, 171, 152, 299, 226, 189,  33, 239,  55, 238,
  285, 191,  17,  46,  90, 239, 205, 284, 159, 192,  13, 210, 294,  51,  91, 186, 122, 247, 266,
   96,   1, 148, 202,  17, 110, 267, 230, 219,  27, 128, 304,  87, 285,  67, 233, 276, 225,  27,
  258,   9, 210, 131,  55, 305, 159,  92,  38,  12, 171, 163,  62, 136, 133,  50,  18, 203,  54,
   29, 155,  97, 224, 136,  41, 109, 146, 160, 229, 306,  24,  93, 167, 171, 298,  44, 152, 203,
  152, 125, 104, 270, 143, 293, 256, 221,  20,  43, 227,  12,  99,  35,   6, 172, 223, 243, 110,
   31, 288, 299, 216, 204, 287,  78, 170, 291, 131,  95,  27,  66, 233, 153, 300, 306, 112, 174,
  283, 138,  67, 116, 190, 140, 220, 287, 141,  75,  78,  41, 147,  17, 293, 172, 170,  15, 107,
  125, 277, 277, 236, 174, 276,  63
,},
{  46,   4, 142,  51, 228, 166, 174, 201,  56,  70,  66, 142, 109, 117,  11, 118, 249, 207, 184,
  252,  92,  86,   5, 108,  15,  70, 270, 183, 254, 181,  58, 305,  18,  83, 187, 280,  76, 155,
   76, 112,  45, 215, 205, 240, 104,  93, 199,  18, 165,  79, 216, 288, 280,  57, 188, 250, 240,
  167,  17, 241, 298,  83, 122, 105,  23,  40,  87, 181, 132, 103,  16,  53,  52,  46,   7, 142,
   65,  69, 298, 175,  92,  33, 159, 167,  85,  15, 266, 202, 106, 148,  34, 194, 198, 250, 231,
  126,  69, 112, 272, 278, 170,  82,  91, 207, 184,  10, 254,  53, 121, 287,  16,  25, 285, 289,
  161, 298, 116,  35,  24, 169, 153, 301, 165, 172, 124,  25, 233, 291, 160,  59,   1, 160, 108,
  131,  46, 172, 152, 150, 248, 176, 240,  88, 176,   4, 235,  69, 139,  31,  25, 107, 135, 192,
   92, 296,  80,  16,   7,  45, 272, 280,  61, 255,  65, 157, 156, 195, 103, 304,  81, 106, 222,
  209, 161,  78,  37,   8, 287, 302
,},
{ 240, 225, 193, 204, 195, 251,  72, 236, 103, 148, 193, 215, 270, 191, 241, 121, 297, 220, 114,
   32,  22, 148, 239, 146, 298,  87, 100, 246, 152,  54, 112,   2, 147, 273, 166, 221, 137, 224,
  124,  41,  31, 117, 217, 120, 163, 147,  90,  64,  64, 189, 137, 158, 148, 156, 281,  95,  80,
  204, 222, 188, 156, 171, 177, 176, 100, 233, 299, 143,  15,  31, 133, 127, 215, 291,   4, 228,
  100,  80, 202,  62, 105,  84, 259, 134, 304, 272, 219,  54, 265, 221,  83, 112, 192,  87,   9,
    6,   1, 165,  64, 180,  95, 157, 215, 169, 132, 216,  19, 125, 119,  53, 119, 140,   1, 279,
  190, 242, 211,  63, 113, 173, 146, 281, 169, 304,  34, 218, 217, 247, 169, 263, 248,   6,  83,
    4, 276, 255, 286, 128, 166,  96, 207, 266, 102,  74,  27,  27, 263, 233, 124, 206, 296, 192,
  218,  13, 247, 201,  88,  38,  93, 238, 142, 242,  56,  10, 143,   6,   3, 107, 243, 281, 265,
  287, 250, 284, 214, 289,  77, 129
,},
{ 255, 104, 138,  67,  50, 277,  36, 253, 247, 124, 106, 217,  44, 242, 246, 166, 292, 247, 102,
  106, 133, 235, 253, 101, 156, 221, 234, 228,   2,  93, 115, 206,  26,  15,  35,  87, 165,  64,
  287, 106, 166, 261,   4, 261,  19,  36, 163, 196, 228, 243, 289,  37,  86,  93,  87, 163, 183,
  272,  13, 231, 232, 117,  79, 196, 305, 208, 182, 205,   5,  42, 178, 155, 184,  66, 208, 258,
  145,  20,  87,  28,  26, 250, 209, 290, 222,  23, 105, 224,  25,  61,  56, 281, 225, 170,  42,
  288, 161, 103, 114,  43, 235,  62, 164, 106, 262, 166, 168,  93,  80, 277,  28, 174, 268,  33,
  193,  65,  92, 289, 261, 137,  91, 282,  64, 144, 119, 249, 115,  40,  79,  29, 176, 119, 212,
  126, 254, 287, 261, 107, 145, 158,  33, 273,  89,  32, 156, 113, 118, 171,  44, 182, 119, 299,
  258, 230, 172,  11, 124,  25,  89, 172,  53, 200, 280, 247, 187,  22, 109,  84,  23, 302,  47,
  123, 273, 208, 275,  98, 228, 101
,},
{  64, 139,  93, 175,  44, 138, 211,  73, 145, 292,  34, 289,  26, 291,   9, 173,  50, 141,  38,
   41, 147, 107, 153,  45, 254, 298, 229, 289,  56,  51, 136, 141,  82,  94, 119,  85, 274, 184,
  199,  73,  23,   1, 282, 186, 220,  10, 158, 127,  65, 173, 238, 294, 102,  12, 296, 185, 220,
  112,  82, 120, 106, 280, 183,  32, 297,  54,  11, 156, 304,  19,  50, 269,  14,  84, 239, 226,
  124, 149,  35,  65, 214, 249, 167, 100,  40, 190,  16,  28, 118, 158, 146, 261, 260, 134, 249,
  289,  50, 248, 213,  69, 117, 252,  77,  62,  86, 291, 107, 195, 172, 287,  48, 102, 229, 205,
   68, 276, 226, 303, 187, 137,  49, 207, 124, 142, 230, 185, 116, 262, 294,  86,  18,  75,  78,
   41, 267, 146, 256,   9, 275,  84,  23, 306, 113, 246, 120, 121,   1, 184,  73, 256, 171, 257,
  265, 196, 176,  61, 153, 296, 222,  39, 258, 265, 106, 163, 100, 147, 155, 151, 211, 281, 283,
  269,  93, 183, 101, 158,  55, 104
,},
{ 227, 209,  76, 277, 127, 241,  67,  88, 208,  12, 251, 189, 144, 101,  45, 177,  11, 162, 172,
  191, 220,  26,  56, 106,  84, 230, 288, 237, 197, 225,  74, 257, 296, 304, 271, 210, 235,  20,
   92,   6, 100, 306, 205, 208,   7,   1,  11, 203, 214,  57, 256, 155, 136,  41, 142,  20,  37,
  232, 196,  25,  46,  46,  44, 165, 136, 227,  70, 197, 109, 133,   9,  13, 215, 139,  98,  63,
  240, 119, 207, 216, 293,  12, 276,  73, 259,  80, 122, 189,   7, 182, 282, 120,  57, 297, 112,
   17, 126,  18, 264,  39, 130,  19,   3,  51,  87, 280, 288, 150, 173, 297,  36, 109, 110, 231,
  238,  41, 305,  39, 277,  35, 247, 211, 251, 180, 188, 301, 121,   9,  98,  55,  23, 221, 203,
  215,  95,  95, 108, 264, 106, 121, 176, 219, 199, 147, 136,  87, 261,  72, 153, 115, 193, 152,
  146, 189, 110, 238,  37, 245, 280, 131,  85, 300, 229,  22, 270, 150, 211, 256,  69,  42, 228,
  159, 153,  52, 240,  17, 135, 210
,},
{  51,  77, 253, 235,  62,  82, 198, 226, 213,  28,  65, 133,  32,  77, 112,  30,  27,   1,  77,
  109,  27,  17,  47, 274, 108, 130, 198,  68,   4,   1,  53, 277, 139,  24, 195,  71,  76, 159,
   94,  27,  31, 146, 222,  91,  65,  43, 127, 155, 113, 127,  77, 236, 202, 125, 150,  57,  99,
   14,  71,  75, 218, 161,  89, 232,  68, 219,  94, 174, 108,  53, 101, 259, 270,   1,  61,  26,
  292, 224,  59, 295,  86,  15,  37,  98, 152,  80, 108, 123, 306,  89, 149,  76, 204, 114, 288,
   45,  48,  85, 192, 137,  50,  62, 266, 104, 131, 278, 209, 180, 141, 266, 292,  47, 196,  55,
   91, 213,  11,  75, 140, 159,  80,  90, 229, 246, 143, 231, 219, 147, 221,  70,  99, 120,  78,
  273, 265, 220, 219, 195, 206,  43,  47,   5, 245, 185, 102, 276, 228, 304, 157, 226, 159, 255,
  288,  87,  98, 247, 284, 270,  71, 173,  94, 158,  62,  83, 303, 123, 232,  43,  55, 265, 118,
  261, 279, 206, 173,  94, 189,  17
,},
{ 105, 302, 294, 165, 298, 168, 156, 110,  68,  23, 101, 111, 189, 183, 208,  45, 281, 187, 133,
  164, 277, 205, 295, 243, 242, 293,  28,  34, 112,  70, 297, 182,  16, 193, 233,  18,  66,  64,
  203, 213, 241, 216, 262, 204, 230, 103, 176, 279,  60, 277, 114,  90,  98,  71, 223, 282,  21,
  160, 134, 165,  57, 220,  87, 151, 249, 275, 198, 272,  63,  83, 258,  92, 138,  10,  21, 292,
   46, 241, 263, 186, 226, 236, 229, 122,  62, 253, 246,  92,  93, 222,   3,  68, 267, 213, 258,
  132, 163,  90,  64,  75, 268, 217, 101, 185,  52, 145, 186,  95,  17, 188,  39, 116, 190, 155,
  146, 184,  79,   7, 301, 186,  53, 136, 109,   2, 224,  69,   8, 110, 132,  55, 287,  82, 259,
  186,  87, 107,  78,  55, 202, 293, 306,  20, 203, 162, 291,  11, 169, 154, 172, 217, 136,  88,
  228,   4,   8,  55, 125, 240, 291, 248, 151, 154, 282, 249, 192, 199,  39, 157, 189, 296, 277,
  204, 183,  45, 112,  53, 105, 235
,},
{  79, 288,  15, 143, 151, 138, 288,   5, 111,  42,  75, 159, 235,  19, 188, 257, 228, 109, 260,
  216, 229, 101,  75, 115, 216, 235, 111, 235, 263, 302, 243, 166, 240,   4, 283, 170, 292, 171,
  293,   6,  29, 234, 122, 266, 139,  51, 244,  74, 266, 160,   7,  77, 223,  93, 288, 296, 290,
  178,  31,  79, 169, 193, 100,   5,  79, 203,  75,  22,  92, 205, 208, 260, 153, 264, 142,  72,
  117, 262, 130, 303,  99, 295,  52, 176, 130, 176, 182,  79, 201, 214, 207,  21, 162, 265, 181,
   88, 174, 256, 197,  90,  80, 265, 106, 119,  26,  83,  29, 109,  63, 143, 102,  44,  16, 165,
  203,  23, 282, 114,  25,  52,  39, 177, 200,  23,  41, 104, 255, 271,  11, 203,  75,  52,  17,
  235, 125,  88, 275, 285, 224, 285,  64,   5, 283,  85,   2, 243, 103,  49,  81, 261, 237, 220,
   94, 257, 158, 154,  48, 203, 133,  47, 287, 240, 297, 104, 293, 181,  13, 158, 261, 306, 191,
  292, 119, 235, 100, 241, 187, 163
,},
{ 158, 138,  21,  20, 115, 138,  71, 293,   7,  59, 146, 191, 100, 202,  29, 286,   9, 191, 255,
  119,  39, 184, 148,  22,  61, 202, 178, 218,  79,  29,  34, 288, 282, 216, 184, 157, 104, 195,
   15, 206, 252,  15,  46, 130, 136,  88,  26,  40,  48, 159, 234, 240,  36, 213, 220, 127,   5,
  297, 227, 228,  87, 134, 260, 243, 168, 294, 110,  30, 276,  69, 148, 212,  75,  98, 221, 244,
   29, 242,  40, 210, 129, 237, 234, 253, 192,  51,  34, 155, 297, 136, 184, 243, 209, 158, 201,
  148, 172,  53, 163, 249, 100,  74,  43, 142, 108,  88, 158, 182,  45,   8, 278, 112, 151, 273,
  261, 264, 219,  45, 150, 141,  65, 287, 305,  28, 101, 108, 169, 167,  73, 153, 243, 219, 229,
  276, 113, 127, 117,  75,   9,  83, 134,  76, 224,  47,  72, 213, 120, 170, 210, 259, 301,  98,
  232, 152, 258, 143, 140, 204, 296, 259, 125, 158, 219, 248, 192, 271, 116, 251,  59, 188,  96,
  221, 122, 223,  38,  51, 202, 303
,},
{ 192, 117, 105, 132, 258,  72, 247, 182, 276, 142,  96,  81, 232, 227, 117, 117, 245, 170, 178,
   72, 242, 268, 245, 138, 174, 180, 226,  36,   9, 226, 158, 112, 223, 179, 221,  27, 104, 161,
  293, 294, 264,  64,  78, 285,   7, 109, 147, 225, 261, 190, 144, 249, 128, 121, 208, 207, 298,
   99,  34, 241, 160, 231,  25, 119, 239,  29,  10,  32,  20,  11,  93, 114,  96,  82,   3, 275,
  149,  41, 287, 281, 154, 184, 295, 214, 117,  96,  30, 110, 144,  82,  84, 185, 180, 243,  88,
   21,  48, 126,  76,  28, 164, 151, 119,  44,  82, 195, 218, 239, 112,  52, 242, 193, 277, 269,
   71, 203, 133, 238,  46,  85, 184, 106, 120, 232, 286, 299,  16, 303,   8,  94, 120, 247,  96,
   23,  85,  96,  34, 282, 272, 133, 292,  32, 210,  81,   4, 274, 184,  11, 183, 232, 226, 101,
  303,  46, 297, 232, 262,  42, 181, 146, 210, 147, 183, 175, 114,  72,  56, 242,  18, 219, 131,
  148, 131, 159, 209, 301, 229, 137
,},
{ 178, 138,  96,  64, 116, 119, 253, 206, 227,  27,  26, 250, 135, 257, 145, 173,  63, 180,  78,
  229, 234, 304, 251, 127, 151, 166, 279,  24, 210, 270,  29,  96, 266, 297, 238, 149,  77, 224,
   28,  24, 303, 256, 132, 258, 123, 241,   7, 162, 254, 156,  13,  14,  94, 210,  62, 116, 260,
  302, 127,  15, 114, 140,  50,  19, 256,  11, 239,  72, 221, 270, 110, 183,  96, 240, 189, 149,
   75,  45, 265, 245,  50, 189, 193,  59, 267,  28, 278, 190, 103,  63,  21, 280, 117,  90,  31,
  113,  69, 242,  29,  18, 253,  29,  68,   8, 257, 249, 194, 130,  27, 256, 173, 160, 298,  73,
  280,  62,   8, 173, 127, 200, 224, 238, 223, 241, 145, 105,  73, 185, 146, 133,  73, 290,  85,
  244,  41, 130, 288, 139, 212,  16, 266, 255, 201, 119, 249, 300, 116,   3, 103, 197, 211,  15,
   64,  73, 222, 113, 224,  88, 139, 253,  59, 224, 135, 155,   6, 233, 298, 192,  10,  64,  99,
  192,   7,  15, 178, 181, 191,  76
,},
{  36,  36, 151, 136, 147,  12, 197, 293, 222, 118, 245,  33,  85, 178,  30,   8,  31,  74, 120,
  178,  41, 181,  66, 134,   2,  39,  17, 214,   4, 180, 275,  82, 103,  74, 202, 151, 235, 222,
  204, 253, 150, 191, 287, 196, 139,  22,  41, 217, 261,  12, 134,  35, 300,  14, 305,   2, 244,
    9,  80, 168,  79, 141,  62, 273,  95, 134, 188, 186, 262,  37, 121, 142, 238, 270, 203,  84,
  112, 154, 111, 291,  81, 233,   8, 266, 187, 249, 120,  62,  92, 197, 130,   2, 249,  85, 192,
   74, 171,  22, 112, 138,  98, 205,  95,  49, 227, 139, 235, 190, 232, 201, 108, 253,  95, 205,
  227, 154,  95, 261, 154, 134, 304,  59,  34,  75, 251,  67,  11, 290, 136,  54, 146, 304, 171,
    8, 189,  57,  55, 223,  80,   5,  36,  55, 165, 155,  15,  95, 237,  38,  63, 299, 210,  20,
  111, 221,  81, 102,   1, 244, 218, 226, 263, 255,  56,  50, 245, 137,  20,  53,  14,  40, 226,
   32,  60, 225, 281,  93, 176, 198
,},
{  13,  70, 288,  29,  21, 280, 296,  75,  60, 140, 282, 239, 306,  92, 241, 279,  42, 197, 257,
  122,  76, 218,  78, 254, 285,  98,  79, 292, 275, 249,  88,  98,  76, 136, 287, 145, 165,  23,
  283,  55, 145, 246, 296, 276, 298,  94,  18, 168, 176, 293, 294, 159,  53, 237, 108, 181, 287,
  196, 287,   1, 157,  12, 164, 134, 164,  68,  70,  58,  67,  25,  77, 269,  51,  45, 214, 293,
   28, 132, 229,   1, 300, 275, 125,  77, 244,  27, 214,  42, 146, 143,   8, 234, 204, 101, 173,
  199, 112, 299, 265, 194, 201, 183, 280, 199, 256,  65, 151,  63, 278,  39, 284, 171, 221,  87,
   73,  28,  38, 229,  58, 148,   1, 270, 190, 117, 198, 274,  16, 132,  25, 171, 306, 255,  99,
  237,  99, 263, 209,  23, 142,  82, 251, 173, 176,  29, 288, 147, 149, 260, 162, 202, 244, 286,
  157, 108, 258, 140, 198, 247,   1, 275,  42,  95,  92,  85, 236,  45, 188, 230,  74,  76, 252,
  108, 189, 224, 304,   3, 185, 170
,},
{ 129,  67,  91,  22,  45, 160,  99,  30,  30,   2, 256, 128, 185, 281, 174, 185,  26, 107, 289,
  206, 267,  14, 235, 196, 241, 293, 306, 281, 118,  14, 139, 150, 251,   2,  77,  52,  95,  45,
  156, 245,  46, 153, 178, 116, 131,  64, 196,   3, 139, 281, 163, 117,   7, 278, 296, 200, 128,
  283, 168, 306, 128, 177, 193, 170, 304,  85, 165,   8, 176, 124, 233, 294, 287, 214, 245,  68,
  186, 132, 215, 271, 232, 265, 266,  54,  24,  26, 152,  54,  49, 227, 204, 119, 302, 294,   6,
  148, 151, 225,  89,  16, 276,  29, 266,  84, 293,  89,  66, 239, 275, 134, 225,  59,  66, 118,
   76,  82, 223, 305,  33, 211,   9, 254, 153,  69, 204,  72, 193, 154, 289, 207, 192, 136, 110,
  258, 219,  54,  71, 104,  93,  91, 256, 288,   4, 267, 168, 299, 305,  23, 168, 148, 223, 148,
   16,  80, 239, 135, 148,  65, 150, 236,  55,  28, 107, 120, 254, 117, 126,  52, 155,  28, 196,
  191, 249, 305, 205,  25, 113,  31
,},
{  47,  63, 246,  75, 173, 148,   6,  83,  85, 135,  99,  69, 194,  45, 249, 106, 119,  83, 131,
  249,  97, 104, 232, 159, 246, 163, 107,  25, 289, 130,  12, 302, 270, 205,  40, 296,  79,  37,
   53,  66, 256, 275, 202,  91, 225, 110, 144, 112, 209, 113, 167, 277,  64,  39, 240,  13,  26,
  167, 249, 213, 219, 240,  24, 288, 201, 230, 137,   2, 239,   4, 245,  36, 272, 156, 106, 287,
  267,  93, 167, 266,  91,  36, 276, 114, 187, 154, 112, 177, 216, 257,  16, 273,  70, 192,  69,
  173,   2,  47, 277, 291, 291, 111,  64,  28, 242, 156, 156, 129,  14, 144,   9, 193,  85, 226,
  302,  65, 253, 306,  67, 153, 108,  75,  90,  28,  65,  51, 171, 229, 235, 203,  79, 161, 245,
   18, 280, 274,  84,  97, 189,  53,  83, 279,  17, 268,  63, 291, 140, 152, 306, 151,  20, 238,
  171,  76, 261, 287,  57, 140,  13, 238, 232,  38, 218, 141,  84, 263,  18, 224, 246, 143,  86,
  100, 121,  39, 260, 239,  27, 233
,},
{ 175,  56, 220, 304, 180, 145, 169,  64, 229, 280,  52, 278,  60, 241, 161,  35, 115, 181, 303,
  276, 222, 189, 158,  47, 208, 145, 300, 243, 303,  92, 214, 227, 174,  53, 144,  52,  83,  59,
    8, 149, 218, 155,  59, 172, 118, 186, 127, 295,  56,  73, 296, 291,  47, 255, 100, 153, 260,
  230,  60, 201, 183, 120, 219,  25, 214, 239, 195, 229, 124,  95, 141, 230,  39, 248,  87, 184,
  218, 182, 158, 174, 151,  34, 188, 213,  54, 253, 226, 290, 127,  76, 216, 188, 182,  85, 125,
  116, 165,  72,  12,  82, 100, 160, 176, 236, 146, 163, 105, 273,  62, 297, 175, 125,  22, 119,
  173, 150, 251, 144, 171, 246, 181,  99, 209, 121, 196,  44, 191, 194, 204, 163,  53, 153, 188,
  118,  15, 119, 242, 220, 211,  27,  82,  38, 302, 288, 240, 116, 215, 119, 239,  99,   1,   4,
  193, 107, 149,  87, 186,  86, 175,   1,  99,  25,  40,  18, 118,  13, 123, 200,  58, 136, 163,
  127, 277,  38,  87,  60, 155, 206
,},
{ 243, 291,  67, 183,  20,  92, 211, 132, 172, 184,  63, 176, 162, 120, 167, 234, 151, 266,  83,
   57, 235, 248, 271,  59, 201,  66, 137, 245, 108, 254,  49, 188,  44, 106, 256,  94, 172,  64,
  231, 222, 232,  76, 134, 184, 213, 127,  64, 163, 119, 111,  78, 291, 226, 121,  52,   2,  96,
   24, 113, 260,  19, 135,  54, 266, 231, 158, 129, 221, 130, 110,  87,  50,  64, 139,  75,  69,
   11, 214, 167, 180, 295, 235, 117, 297, 156,  86, 260, 303,  89, 301, 298,  11, 209, 273,   6,
  185,  47,  78, 269,  57,   8,  83, 145, 278, 256, 117, 222,  78, 194, 162, 219, 101,  70,  85,
   84,  90, 296,  40, 246, 295,  27,  65, 257, 131,  35, 130, 177,  44, 247, 197, 174, 154, 194,
   52, 284, 123, 150, 187,  52, 272, 162, 116, 198, 145, 200, 275, 228, 149, 217,  27, 110, 170,
   38, 255, 161, 260, 252,  14, 196, 225, 222, 194, 119, 157, 165, 158, 187,  81,  73, 107, 155,
  248, 157,  60, 145, 204, 103, 279
,},
{ 116, 263,  60, 230,   7,  26, 241,  67,  13, 196, 136, 222, 156, 130, 139, 169, 254,  50, 175,
   30, 304, 303,  61, 201, 202, 113, 234,  64,  10, 216, 236, 288,  40, 244, 141,  78,  30, 264,
  136,  35,  14, 144, 210, 272, 244,  24, 233, 229, 175, 192,   6, 183, 121, 207,  86, 268, 278,
  140,  25, 211,  91, 106, 293, 295, 238, 179,  12, 197, 151, 117, 278, 156, 159, 113,  88, 146,
   18,  95, 222,  12,  95,  66,  27, 284, 266,  98, 246, 178, 226, 119, 244, 305, 184, 140,  90,
  281,  99,  32, 239, 245,  76,  58,  91, 152, 165, 251, 106, 175, 202, 243, 265, 238,  28, 282,
  206, 292,  94, 122,  47,  98, 289,   7, 124,  53,  95, 193, 100, 194, 159,  87, 273, 202, 214,
  287, 250, 165,  86,  77,  31, 306, 200,  62, 133, 118, 151,  79,  72,  79, 240,  64, 103, 245,
   70, 271,  42, 286, 172, 180, 160,  67, 189,  69,  62, 118, 140, 246, 188, 148, 292, 272,  15,
  212, 232, 109, 269, 144, 222, 262
,},
{  11, 192, 122,   4, 298, 214, 101, 185, 106, 227,  75, 249, 146, 280,  18, 208, 245, 300, 134,
   35, 109, 194, 145, 102,  69, 236,  76,  18,  92,  52, 209,  39,  94, 186,  70, 140,  19, 134,
  292, 128, 227,  48, 162,  59, 193,  17, 304, 246,  29,  84, 100,  98, 151, 233,  74, 170, 273,
  261,  21,  29,  60, 176,  31, 165, 250, 286,  54, 209, 238, 163,  80,  49,  79, 161,  42, 235,
   75, 153,  64, 247, 303,  23, 258, 109, 289, 107,  92, 180, 131,  33, 148,  25, 287, 106, 120,
  214,  77,  42, 214,  25, 133, 266,  27, 179,  91, 146,  25, 173, 155, 204, 266, 153,  22, 281,
    5,  14, 123, 231, 210, 160, 198, 213,  47, 147,  39,  20,  79, 226,  17, 165, 253,  11, 123,
  199,  57, 289, 270, 177, 221, 198, 278, 127, 188, 136,  18, 121, 290, 304, 302,  27, 230,   2,
  172, 280, 137, 210,  13, 144, 305, 161,  53, 283, 120, 181, 299,  18,  53, 224, 213, 250, 168,
  293, 274, 111, 105,  81, 151,  28
,},
{ 191, 298, 116, 266, 180, 292,  65, 245, 304,  82, 275, 223, 269, 178, 261,  16, 188,  39,  84,
  187,  95,  41,  74, 215, 266, 157,  68, 149, 253, 291,  70, 277, 187, 201, 151, 248, 204, 234,
   62, 181,  29,   8, 221,  24, 306,  75, 218, 139, 234, 263, 189, 302, 268, 170, 268, 165, 201,
  229, 260, 230, 198, 280,  18,  97, 193, 302, 125, 293, 279, 251, 302,  11, 247,  30, 212, 278,
  286, 298, 145, 219,  25, 225, 231,  91, 140,  40, 254, 174, 257, 101,  90, 141, 159,  49, 289,
  152, 300,  92, 188, 238,   6,  83, 258,  20, 292,  96, 157,  72,  49, 106, 101, 247, 226, 117,
  160, 104,  10, 297, 224,  51, 166, 218, 154, 251, 183, 188,  50,  62, 111, 177,  89, 225, 258,
   30,   1, 176,  19,  36,  26, 274, 270,  71, 110, 268, 130, 139,  17, 132, 213, 148, 258,  95,
  102, 246, 186,  12, 298,  85, 305, 127, 197, 206, 108, 121, 198, 218, 295,  92,  13,  14,  35,
  111,   2,  15, 209, 106,  63, 299
,},
{  77, 109, 232,  31, 128,  94, 203, 287, 211, 267, 156, 145, 305, 216,   8, 130, 241, 203,  13,
   25, 126, 246, 163,  54, 212, 197, 205,  91,  38, 240, 242, 226, 147, 288, 211, 144, 142,  11,
  123,   6, 297, 267, 134,  85,  85, 252, 193,   2, 274, 211, 233, 219,  78, 131, 160, 242, 200,
   82,  10, 288,  94, 179,  62,  43,  89, 222,  41, 276, 273,  56, 299, 234,  86, 261, 147,  13,
   88,   3,  81,  13, 107, 135,  34, 191, 126, 255, 305,  99, 152, 134, 304,  92,  15, 227, 216,
  236, 259, 208, 138, 225,  68, 108, 173, 260, 207, 159,  49,  12, 239,  63, 267, 238, 270, 155,
   20,  44, 149,  48, 299,  94, 137, 248, 191,   8, 153, 272,   4,  11,  51, 153, 111,  97, 286,
  153, 262, 274, 297,  42, 123, 274,  78,  66,  32, 131, 182, 227,  81, 106, 158, 257,  82, 165,
  198,  37, 229, 134, 250, 102,  39,   5,  29, 241, 256,  20, 160, 265,  95, 240, 240,  26, 207,
  139, 238,  76, 294, 121, 155, 240
,},
{ 146,  81, 247,  19, 180, 252,   1, 297,  79,  93, 196,  65, 141,  53,  97, 254, 134,  98,  62,
  248,  13, 201, 270, 149, 144, 133, 292, 129,  44, 121, 175, 167, 135, 187, 295, 114, 254,  99,
  271, 268, 210, 218, 171, 223,  97, 170,  89, 226, 250,  43, 190, 254, 185, 197, 124,  19, 113,
   86, 205,  91,  70,  50, 272, 233, 283, 140,  70, 116, 262, 209, 151, 190, 133, 280, 128, 284,
  187, 289,  66,  50, 303, 184,  32,   6,  62,  53, 287,  43, 145, 158, 184, 244, 188, 124, 129,
  271,  96, 256,  56, 256, 106,  78, 171, 113, 176, 206,  34, 101, 221, 126, 145, 148, 162, 251,
  302, 123, 229, 237, 295, 208, 277, 133, 137, 273, 185, 246, 266, 253,  34,  19, 291, 178, 109,
   59, 254,  54,  21, 221, 195,  51,  14,  58,   8,  16, 255,  35, 125, 174, 247,  66,  88, 109,
  145, 306, 240, 254,  55, 297, 254, 136, 182, 244, 276, 133,  78, 299, 271, 210,  98, 157,  69,
  157,  13, 167, 302, 171, 186,  64
,},
{ 305, 188, 302,   6, 202, 254,  43,  67, 262,  68, 115,   8,  23, 258, 185, 224, 296,  14, 306,
  227, 122,  33, 146, 123, 173,  82,  56, 108,  96, 148, 206, 155, 286, 248, 107,  44,  41, 263,
   66, 105, 261, 148, 131,  31,  42, 222, 147, 282,  67, 127, 283, 257, 204,  53, 277,  25,  46,
  144, 303, 288, 258, 222, 259,  72, 297,  51,  79,  90, 276, 204, 132,  81, 204,  21, 265, 185,
  269, 302, 183, 201,  25,  37, 177,  45,  33,  63,  82, 299, 219, 208,  69, 168,  24, 258,  16,
  246,  29, 218, 195,  67,  81, 211, 279, 155, 152,  12, 275, 273, 300, 109,  66, 277, 271, 116,
  106,   2,  70, 232, 221, 107, 134, 235,  42,  77, 136,  87, 183, 271,  34,   5, 240, 227, 304,
   28,  45, 219,   7, 144, 139,  53,  84, 111,  63, 147,  90,  93, 192,  27, 273, 202, 287, 218,
  206,  51, 135,  42, 192,  88,  51, 198, 306, 137, 151,  59, 128, 156,  55,  97, 254, 301, 148,
  158,  62,  35,  84,  85,  86, 305
,},
{  96, 131,  18, 204, 125,  27, 155, 252, 212, 176, 240, 236, 182, 240,  62, 229,  50, 223, 161,
   61, 135,  83, 217, 141, 199,  79,  94, 292, 157,  16,  59, 245, 276,  81,  97, 182, 171, 223,
    5,  52, 134, 167,  26,  97, 123, 182,  98,  93, 239, 138, 273, 137, 201,  93, 204, 117, 264,
   93, 166,   3, 254,  23,  14,  35,  70,  74, 216,  40,  85, 297, 216, 115,  23,  54, 127, 292,
  291, 275, 171, 150, 173, 206,  66, 167, 284, 292, 206, 120, 140, 265, 182, 223, 290,  41, 223,
  233, 196,   6,  76, 281, 178, 260,  80, 126, 125,  42,  77, 162, 238, 150, 226, 177, 206,  23,
   15,  77,  90, 233,  79,  35, 282,   1, 305, 159, 206, 235,  41, 250,  38, 198, 142, 242,  12,
  201,  86, 190,  19, 243,  89, 201,   4,  33, 178, 145, 279, 191, 232, 291, 187, 284,  32, 187,
  167, 113, 277, 122, 255, 143, 230, 283,  20,  10, 303, 129, 299,  68, 202, 118, 134,  27, 119,
  174, 113, 234,  28,  62, 174, 207
,},
{ 195, 299, 227,  30,  14, 278, 296, 167, 134, 210, 180, 150,  33, 287, 264, 113, 125,  84, 205,
  191,  66,  27,  73, 274, 257, 104,  65, 228, 286, 148, 171, 167, 155, 157, 206, 163,  85,  61,
  217, 226, 274,  39, 207, 168,  92,  62, 122, 161,  92, 105,  70,  34, 100, 177, 275, 186,  94,
  158, 272, 209, 145, 170,  61, 173, 242, 279,  35, 108,  97, 214, 283, 287, 285, 198, 135, 249,
   66, 284, 172,  56, 285,  13, 121, 180, 144,  33,  74, 264, 152, 291, 193, 207, 183, 219, 133,
   21, 189, 274, 274,  78, 305, 225, 157, 105, 161, 151, 222, 260, 254, 106, 167, 250,   4,  86,
  192, 100, 179, 258, 258, 296, 189,  79, 124,  15, 162, 244,  84,  14, 266, 256, 294, 242, 237,
   81,  31, 275,  14, 153, 256, 119, 207, 217,   6, 287, 298, 110,  80, 270,   2, 123,  73, 251,
   93, 122,  54, 241,  27, 261, 182, 164, 286, 263,  21, 124, 156,  62, 219, 282, 126, 143, 137,
  191,  73, 117, 191, 156, 214,  84
,},
{ 266, 135,  71,  45, 251, 303, 138, 114, 217,  62,  47,  10, 210, 129, 230, 258,  53, 121,  50,
   57,  64, 169, 281, 283, 152, 214, 214, 284,  12, 269, 202,  68, 304, 169,  52, 126,  48, 116,
  152, 191, 236, 231, 251, 100, 295,  45,  51, 241, 125, 180, 113,  62, 237, 157, 282, 241, 279,
  269, 155, 285, 102, 191,   3, 259, 257,  91, 103, 138,  11, 136,  17,  76, 267, 138,  44, 229,
   95, 121, 260,  23,   4,  51,  23, 234, 273,  11, 167,  13, 188,  62, 155, 172, 302,  83, 154,
  229, 279, 234,  98,  39,  21, 155, 201, 136, 137, 176, 184,  56, 195, 107, 104, 110, 162, 289,
   30, 182,  88,  87, 237,  88,   7, 249, 209, 122, 123, 302,  27,  33, 283, 132,  28, 210,  62,
  265, 101,  81,  79, 233,   7, 108,  28, 200, 166, 246, 269,  47, 105, 220, 304, 154, 202, 282,
  244,   8, 147, 293, 198, 243, 130, 262, 272, 131,  45,  24, 175, 220, 279,  29, 263, 143, 112,
  273, 239, 217, 104, 194, 102,  44
,},
{  37, 103, 191,  78, 190, 110,  25, 145, 301, 267, 269, 148, 173,  41, 143, 183,  95, 124, 264,
  221, 239,   1, 112,  84, 146,  71, 257, 241, 127, 237,  78, 265, 169, 209, 114, 244,  95,  35,
  266, 153, 167, 155, 152,  78, 225, 285,  10,  11, 266,  98,  38, 255,  66, 223, 212, 118, 202,
  166,  92,   1, 112,  53, 162,  19, 303, 251, 145,  40, 248, 163, 179,  84, 124, 190, 262,  64,
   46, 270, 240,  65,  25,  13,  27, 243, 195, 101, 242, 252, 134,  97,  20, 144, 251, 235, 239,
  292, 101, 171, 288,  48,  53,  74, 274, 190, 182, 101, 281, 214, 212, 118, 296, 118, 137,  92,
   55,  54,  88, 186,  76,  31, 229, 170, 244,  91,  47,  94,  86,  88, 247,  52, 188, 291,  28,
  179, 217, 288, 183, 106, 215, 178, 265, 229, 261, 204, 105, 196,  59,  76,  77,  62, 210, 253,
  176, 141, 255, 126, 212,  48, 189, 245, 187,  30, 163, 222, 270, 267, 129, 121, 136,  38, 156,
  154,  35, 139,  64, 281,  78, 203
,},
{  80, 199, 166,   7, 126, 300, 181, 148,  10, 127,   1, 114, 293,  98, 287, 282,  38, 290,  93,
  111,  42,  53,  52, 159,  45, 170,  81, 249,  26, 265, 214, 264, 110, 254,  32,  23,  94,  42,
  127, 152, 126, 191, 258, 226, 257, 137, 284, 272, 231, 274,  15, 121, 106, 127,  93, 181, 266,
  190,  82, 149,  75, 172, 289, 180, 222,  66, 235, 266,  87, 112, 173, 216, 138, 306, 176, 131,
   50,  51, 212,  59, 144, 227, 293, 121,  84, 155, 169,  69, 273,  70, 280,  46,  41, 214, 257,
  164, 148, 133, 155, 155, 294, 151,  16, 300, 165, 295, 104, 238, 236,  87,  62, 235, 110, 135,
   59,  82,  25, 275, 212, 228, 228,  67, 126, 188,  45, 283, 158, 193, 252, 179, 115, 292, 163,
  198, 125,  82,  19, 175,   9,  62,  86,  69,  29, 227,   7, 138,  56, 295, 107,  35, 125, 229,
   57, 252, 227, 193, 150, 120,  64, 280, 199, 145,  66, 247, 115, 220, 203,  28, 203, 305,  91,
  280, 270,  76,  82, 148, 304, 230
,},
{  12, 135, 101,  77, 137, 296,  19,  92,  51,  76, 302, 208,  59, 205, 227, 139,  30, 144, 270,
   24, 253, 229,  76,  13,  15, 110,  18, 264, 140,  16,  62,  27, 164,  46, 120,   3, 154,  40,
  240, 202, 194, 191,  99, 177,  84, 121, 275,  47, 305,  48,  62, 227, 114, 284, 261,  73,  19,
   80, 116, 198,  68,  84, 146, 261, 103,  79, 125, 115, 227, 128, 267, 286, 132, 196,  89, 141,
  221, 281,  73,  16, 209, 205, 269, 215, 266,  78, 288,  97, 241, 202, 297,  69, 138, 235, 248,
  169,  81,  30, 192,  89, 284, 278, 173, 112,  66, 228, 188, 205, 272, 294, 140, 191, 111,  79,
   84,  17,  93,   7,  64, 112,  58, 173, 306, 179,  89,  19,  47, 128, 279, 119,  81, 192, 150,
   35, 282,  28,  57, 202,  53, 247, 171, 118,  39, 116,  90,  58, 117,  30,   8,  70, 244, 266,
  261,   7,  50, 187, 258, 259,  61,  93, 181, 162,  89, 140, 277, 261, 149,  19,  71, 213,  52,
  171, 236, 138, 267, 156,  44, 204
,},
{  32, 261, 283, 273, 219, 181, 263, 191,  38, 227,  31, 240, 266,  29, 242,  37,  81, 108, 193,
   86, 198, 240, 188, 279, 243,  86, 114, 199, 178,  11, 191,  75, 272, 198,  98, 145, 250,  10,
  261, 133,   7, 265,  48, 190,   3, 233, 182, 257, 135, 124, 199, 218, 106,  77, 232,   3, 255,
  137, 292,  16, 289,  92, 117, 276, 158, 131, 134, 112,  11, 234, 132, 159,  62,  82, 129,  98,
   74, 223, 135,  62, 109, 167,  10,  61,  90, 250, 228,  96,  44, 154,  91, 246, 212, 246, 121,
  218,  50, 278,  85,  16, 126, 139, 132, 122, 102, 234,  45,  48,  91, 222,  26, 177,  65, 233,
  250, 279, 251,  45, 263,   2,  68, 116,  94,  38, 222, 122, 106, 274, 255, 129, 267, 184,  18,
  218, 259, 228, 166, 238, 286, 176,  26, 154,  38, 271, 160, 226,   2, 150, 288, 114, 218,   6,
  249, 230, 287, 148, 258,  37, 204,  36, 136, 287, 115, 184, 220, 257, 174, 170, 236, 200,  50,
  163, 156, 191, 238,  55, 288, 289
,},
{ 250,   1, 266,  15, 116, 179, 211, 302, 268, 185, 240, 199, 271,  70, 107,  24,   6,  38, 203,
  137, 179, 154,  54, 143,  42,  11, 194,  89,  26,  72, 131, 235, 243, 269,  67, 159,  60,  46,
  144, 135,  87,  82,  88,  49,  97,  35,  38,   3, 177, 160, 210, 113,  21,  28, 208,  20,   5,
   64,  28,  48,  17,  16,  62, 250, 258, 300,  81,  90,  67, 200,  35, 286, 251, 247, 115,  65,
  131, 128, 272, 145, 117, 203, 121, 227,  63, 272,   2, 263, 200, 151, 227, 249, 116,  58, 238,
  232,  75, 150, 228, 245,  94, 202, 188, 290, 159,  33, 205, 256,  40, 276,  47, 104, 152, 289,
  245, 296, 150, 183, 203, 124,  42,  99, 132, 226, 278, 192,  15,  95,  19, 196, 134, 285,  91,
   12, 126,  29, 270, 141,  50, 230,  42, 181, 143, 162, 231, 148, 249, 279,  55,  80, 119, 239,
  161,  26, 115, 170, 223, 124,  87, 143, 276, 235, 246, 224, 195, 294,  57, 127, 196,  35,  97,
  284,  65, 169, 128,  40, 242, 149
,},
{ 216,  12,  79, 199, 206, 106,  33, 144,  91, 228, 265, 282, 130, 222, 243, 206,  93,  72, 292,
  189, 237, 168, 261, 273,   7, 291,  38, 111, 276, 153, 102, 142, 277,  12,   6, 159,  61,   9,
  233, 266, 277,  29, 268, 165, 256, 105,  63,  70, 290, 260,  28,  35, 294, 155, 291, 155, 174,
   34, 267, 274, 125, 179, 162, 172,  92, 140, 134,  70,   2, 191, 227, 227,   2,  67,  25,  99,
  150, 298, 217, 121,  82, 294,  38, 252,  74, 262, 210, 241, 289, 150, 246, 113,  63, 231,  56,
  189, 273, 100, 291, 268, 111, 113, 291,  74,  69,  65, 256, 181, 254, 163,   2, 220,  21, 208,
  292, 103, 187, 133,  69, 245, 134, 280, 103, 165, 286, 117, 242,  89, 108,  81, 274, 292, 185,
  243, 296, 222, 193, 187,  94,  36,  43,   4, 255, 174, 152, 228,  77,  88,  25,   3, 158, 201,
  201, 182,  74,   9, 112,  36, 290, 302, 203, 224, 148,  43, 150,  60, 244, 122, 287,  69,  86,
    2, 106, 145, 230, 232,  10, 284
,},
{ 183,  57, 206, 180, 186, 189,  42, 134, 123,  23,  57, 275, 134,  16, 117, 135,  47,  21,  74,
   84,  52, 249, 135,  50, 226, 154, 122, 296, 214, 277, 204,  90, 152, 222, 271, 101, 238,   5,
  112,  72, 139, 117, 161, 184, 302,  24, 214,  56,  36,  32,  97, 191,   5,  92, 203, 293, 294,
  254, 287, 194, 190,  32, 243,  42, 149, 137,  42, 146, 166,  90,  22, 185, 174, 119,  58, 182,
   90, 219, 173, 298, 106, 168, 167, 230,  84, 136, 218,  33, 101, 204, 158, 175, 288, 105, 289,
  249, 228, 162,   2,  52, 163, 174, 295, 220,  36,  32,  45,  31, 239,  64, 127, 204, 171, 239,
  121, 112, 194,  66,  62,  79, 262, 293, 164,  67, 267,  43, 202, 245,  19, 152, 275, 297, 122,
   75, 296, 275,  71, 144,  15, 193, 240, 224,   7, 277, 157, 239, 138, 141,  86, 305, 197, 236,
   75, 206,  18,  78, 156,   9, 134, 195,  97, 176, 291, 202,  40,  74, 282, 201,  87, 286, 125,
   78, 252, 242, 218, 284, 181,  20
,},
{ 268,  81, 222, 265, 218,  94, 258, 101, 219,  62, 145,  75,  70, 113, 134, 291,  33, 163,  86,
   68,  83, 135, 251, 185, 211, 245,  34, 218, 113,  93, 246, 121, 108,  53, 197, 135,  59, 260,
  129, 252,  89, 158, 109, 194, 185, 130,  36, 140, 179, 247, 107,  22, 137, 194, 117, 268,  52,
  131,  34, 217, 227,  84, 270,  27,  62, 230,  22, 125, 196, 263, 277, 192, 151, 139, 287,  95,
   43,  30, 301, 196, 271, 138, 185, 267, 296, 257, 241, 145,  88, 255, 157, 153, 183, 118, 148,
  268, 135, 151,  47,  63, 170, 215, 256, 290, 213, 215, 303, 254,  74, 204, 122, 245, 300, 195,
   21, 104, 153,  99,  61,  80, 171,  57, 207, 222,   5, 198, 196, 146, 119, 221,  10, 255, 298,
  231, 109,  74, 126, 167,  80,   9,  69, 136, 168, 108, 185,  68,  77,  69,  76, 283, 163, 276,
  132,  84,  95, 148,  97,  32, 124, 270, 133, 294,  51, 204, 258,  26, 228, 266, 138, 208, 264,
  172, 221,  67,   5, 131,   8, 199
,},
{ 272,  82, 111, 149, 244, 285, 274, 185, 256, 180, 140, 232, 261, 122, 274,  54, 105,  82, 119,
   57,  12, 126, 247, 288, 298,  47, 279, 191, 101,  91, 199, 203, 208,  90, 188, 256, 239,  63,
  143, 294, 283, 232,  17, 115, 250,  70, 188, 190, 274,  22, 149, 205,  68, 283,  59,  73, 280,
  134,  91, 105, 223, 124, 211, 147, 226, 300, 237,  65, 162, 102, 297, 280, 130,  33,  30, 210,
  293,  60,  17,  54, 219, 221, 169, 259, 279, 160, 304, 144, 155, 116,  79, 184, 294, 180,  70,
  200,  24, 121, 158,  86, 224,  12, 202, 283, 205, 106,  41,  34, 206, 263,  75, 283,  95, 109,
  267, 297, 251,  52, 126, 148,  13,  50, 153,  78, 127, 132, 170, 130, 151,  72, 251, 118,   4,
  262, 293, 264,  19, 283, 267,  51, 126,  78,  70, 298, 175, 113, 206, 204, 113,  56,   6, 289,
  285,  22,   8,   7, 291, 214,  25,  65, 175, 113,  48,  91, 270,  88,  54, 253, 115, 160, 204,
  133, 198, 299, 303,  45,  25,  95
,},
{  45, 248, 175, 161, 176, 114, 229,  17, 205,  43, 299,  72, 256, 238, 222,  26,  30,  42,   7,
  244, 129, 176, 289,  24,  55, 158,  91, 121, 166, 217, 174,  35, 135, 275,  48, 156, 210, 190,
   38, 194, 298, 143, 194,  97,  43,  47, 127, 297, 237, 125, 148,  23, 102, 275,  18, 291, 233,
   43,  10, 219, 185, 180, 180, 106, 242, 227, 291,  94, 149, 239, 146,  30, 272, 194, 217, 129,
   87,   8, 296, 203, 156,  64, 225,  30, 112, 103, 275,  34, 175, 119, 123, 132, 222, 254, 154,
   47, 119,  42, 112,  64, 186, 164, 248, 255, 173, 211, 242,  36,   8, 270,  78, 175, 125, 209,
  148, 263, 108,  30, 105,  58, 278,  37, 102, 275, 244, 183, 168, 211, 299,  36, 165, 156,  46,
  138, 270,   6, 247, 168, 286,  85,  76, 246, 119, 166, 168, 136, 111, 262, 279,  51, 149, 151,
  102, 251,  32, 165, 174,   9, 223,  57, 231, 113, 210, 172,  50,  50,  52, 285, 184, 306, 209,
  197, 275,  10, 171, 120, 269, 264
,},
{ 222, 295, 277, 217, 110, 251, 288, 271, 218, 198,  57, 291, 129, 163,  15, 247, 276, 149, 286,
  112, 108,  58, 141,  28, 123, 183, 109, 253, 100, 288, 299, 245,  27, 179, 252, 279, 277, 132,
  169,  44,  50, 119, 283,  77, 233, 290, 144, 194, 140,  75, 194,  79,  47,  18, 298, 262,  57,
  169, 209,   7, 102, 198,   6, 276,  63, 206, 244, 220, 140, 140, 190, 241,  11, 117,  17,  30,
  259, 216, 108,  47, 215, 210, 227,  10, 103,   1, 261, 171, 146, 243, 174,  57, 299, 127, 269,
   61, 200,  85,  59, 119, 148, 197, 264, 182, 224, 264, 227, 115,  51, 160, 176, 162,  30,  12,
   33, 292,   6,  82, 271,  97, 290,  28,   7,   8, 132,  70, 115, 227, 267, 141,  65, 208, 292,
  134, 157, 164,   4, 102,  60,  84, 106,  54, 305,  40, 241,  37, 208, 244,  18,  55,  80, 148,
  129,  98, 198, 213, 293, 195, 299, 299, 221,   7, 305,  44, 113, 295, 118,  25,   6,  62,  77,
  154, 304, 289,  13,   5,  38, 261
,},
{  59, 211,  69, 172, 191,  76, 123, 183, 229,  82, 163,  77, 302, 208, 260, 106, 236, 132, 153,
  177, 145, 132, 299,  26, 241, 110, 152,  11, 152, 102,  83, 275, 265, 224,  83, 135, 130, 165,
   31, 154,  97,  37,  76, 115,  44,  76, 201, 130, 126, 238,  56, 213,  19, 257, 114, 302, 233,
  217,  61,  63, 146, 223,  19,  73, 230, 153,  10, 268, 105,   9, 109, 106, 135, 245,  99,  24,
   12,  90, 273, 270,  17,  80, 263, 304, 288, 227, 220, 214, 198, 283, 259,  32, 100,  76, 243,
   41, 139, 285, 196, 195, 216, 274, 254, 122, 106, 150, 224,  84, 231, 285,  88, 273,  64, 159,
  145, 287, 167,  71, 247, 291, 131, 301, 103, 242, 212, 260, 240, 121,  87,  48, 222, 111, 175,
   72, 240, 115, 169, 213,  65, 258, 185, 161,  60,  42,   6, 108, 164,  29, 240, 271, 136, 236,
  203, 139,  77, 206, 200,  87,  84, 109, 196, 167, 141, 106,  38, 268, 125,  32, 262,   4, 174,
   61,  40, 269, 128, 121, 210,  58
,},
{ 286, 193, 229, 148,  98,  47, 184, 202, 276, 267,   6,  31, 250, 149,  59, 212, 240, 204, 167,
  197,  82,  48,  15, 137, 278, 204,  69,  62, 125,  16, 227, 180, 143,  70, 305,  57, 136,  71,
  279, 130, 234,  60, 198, 141, 210, 282, 295, 232, 149, 216, 302, 299, 302, 168, 176, 149, 125,
   98, 193, 165, 128, 207, 115,  68, 131, 250, 280, 220, 106, 110, 275, 295, 253, 187, 241, 237,
   20, 145, 205,   2, 161, 294, 160, 246, 127, 145,  71,  39, 220,  92, 116,  91, 178, 221, 170,
   90, 263, 192, 105, 158,  46, 244,  82,  86,  71, 226, 107, 124, 178, 283, 269, 246, 183, 195,
   18,  65, 191,  45, 210, 115, 128, 304, 113,  87, 185, 104,  59, 139, 124, 243,  66, 164, 206,
   92, 232,  26,  82,  79, 273, 109, 144, 129,  60, 138, 205, 147,  68,  56, 301, 228, 289, 273,
  180, 137,  32, 147, 169,  86, 267, 110,  52, 184, 265, 165, 207, 243, 162, 140, 187,  91,  63,
   34, 138, 271, 165, 152, 303,  78
,},
{ 247,  11,  69,  60, 112, 169, 224,  15,  73, 253,   6, 199, 306,  76, 118, 185, 244,  17, 304,
  205, 101,  68, 240, 210, 243, 260,  43,  75, 300, 175, 110, 241,  66, 156, 126, 143,  16,  99,
    2, 211, 227, 216, 213, 296, 237, 276, 206, 252,  67, 143,  48, 163,  27,  26, 112, 276,  38,
  134, 161, 227, 263,  83,  30, 255, 146, 232, 262, 266, 108, 208, 256,  17, 101, 270,  44, 109,
   94,  93,  35, 264, 173, 163,  84, 243, 135, 157,  94, 124, 100, 268, 185, 250, 245, 129,  51,
  303, 198, 239, 204, 128, 127, 126, 134, 216,  28,  63, 147, 216, 261, 195,  18, 238, 252,  31,
  143, 228,  10, 281, 179,  96,  44,  96,  30, 155, 275,   8,  56, 209,  16, 175, 119, 295, 260,
  232, 286, 103, 151,  88,  75,   4, 178, 291, 279, 239, 209, 257, 252, 198, 263, 179, 104, 198,
  113, 123, 226, 232, 129, 238,  74, 122, 298, 237, 157, 202,  15,  91, 291, 161, 232, 137, 128,
  277, 254, 184, 237, 102,  58, 189
,},
{ 138, 112, 112, 120,  20, 225, 161, 275, 281, 218, 270,  84,  27, 215, 178, 258,  50, 235,  94,
  278, 303, 256, 179, 252,  89, 223,  47, 152, 203, 185, 143, 262,  12, 251, 150, 253, 268,   9,
  227,  97,  80, 207,  79,  49, 198, 208,  21,  90, 171, 265, 161,  30, 236, 232,  32, 189, 255,
   48, 204, 267,  63, 213,  91,  15, 137, 190, 143, 110, 278, 119, 302, 174, 279, 154,  77, 102,
  223, 141,  39, 237, 147, 107,  32, 108, 222,  66, 305, 187, 260,  51, 269,  61,  80,  20, 213,
  267, 116,  69, 150,  59, 230, 250,  72,  10, 288, 292, 214, 234, 300,   7,  37, 120,  40,  49,
  212, 274, 201, 110, 157, 257, 290, 179, 235, 179,  91, 283,  57,  18, 277, 175, 276, 237, 197,
   16, 277, 245, 276, 260, 220,  49, 183, 239, 253, 205,  45,  28, 169, 260, 121, 298, 280,  37,
  259, 152, 256,  73, 212,   1,  20, 254,  58,  26, 207,  87, 240, 159,  42,  17, 195,  40, 144,
  127,  78, 271,  78, 167, 134, 136
,},
{ 226, 304,   6,  22,  10, 254, 203,  71, 239, 296, 188,  24, 225,   7,  35, 256, 117, 102,  63,
  176,  87, 192,  24, 212, 303,  34,  21, 270, 197, 117,  97, 254,  16, 137,  81, 269, 213, 172,
   54, 258, 274,  25, 214, 242, 240, 195,  44,   9, 251, 255, 161, 265, 154, 109,  95, 167, 208,
  129,  87,  35, 123,  79, 235, 280, 151, 258,  22,  32, 143,  78, 224, 230, 127,  41,   7,  83,
  262, 122, 146, 134, 299, 119, 284,  98, 127, 109, 166, 177, 254, 202, 284, 235,  54, 152, 251,
  193, 290, 145, 208, 135, 186,  31, 255,  38, 208,  93, 170, 223, 158,  62,  33, 164,  36,  19,
  163,  35, 123, 169,  76, 218,  23, 124,  24, 261,   3, 113,  34, 106, 205, 177,  69, 140, 121,
  140,  63, 241,  30, 192,   9, 302,   4, 274, 288, 203, 132, 238,  93, 191, 125, 294, 192,  19,
  128, 136, 134, 219,  18, 167, 169, 208,  78, 231,  97, 168,  38,  22, 101,  56, 264, 281, 136,
  218, 117,  48, 133,  39, 255, 195
,},
{ 157, 306, 301,  44, 239,  34, 236, 241, 209,  28, 104, 210, 251,  97,  83,  43,  29,  20,  45,
  158, 243,  52,  58,  51, 170, 258,  92,  36, 251,  15,  45, 132, 276, 202, 277, 290,  13, 274,
  153, 191,  40, 229, 254, 152, 175,  98,   5,  90,  57, 236, 142, 274, 199,  78, 276,  38,  43,
   77, 133, 172, 280, 164,  97, 278, 168, 250, 288, 294,  59,  91, 136, 193,  52,  16, 144, 291,
  186, 291, 154, 140, 101, 304, 208,  31, 281, 202, 135, 145, 176,  67, 281,   5,   6,  85,  34,
  123, 156, 230, 175, 112, 211,  79,  63, 283, 200, 188,  49, 289, 105,  47, 167, 109, 179, 270,
  196,  74,  51,  41, 197,  98, 194, 250,  53, 129, 117,  21, 300, 102, 259, 179, 174, 181,  73,
  186,  11, 201,  93,  45, 182, 104,  14, 218,  35, 275, 227, 262,  40, 111, 248, 127, 291, 118,
  233, 139, 205,  20, 174,  37, 137, 267,  64,  80,  10,  93, 100,  55, 142, 252, 286, 139, 220,
   57, 154, 232, 270, 129, 111, 277
,},
{ 212,   3, 212,  59, 294,  70,  84, 301, 267, 147, 152,  77,  57, 129, 227, 129, 196, 162,  76,
   54,   6, 272,  49, 290, 270, 295, 131, 255, 157, 279, 215,  16, 105, 271,  86, 174,  46, 287,
   88, 250,  12, 165, 241,  51, 304, 126,  80, 116,  59, 201, 277, 101,  48,  69, 194,  25, 246,
  134, 100, 238, 276, 132, 114, 114, 248, 200, 269,  10, 219,  67, 271, 188, 244, 258,  71, 242,
   39, 276, 168, 273,  27,  53, 125,  58, 239, 175, 198,  91, 216, 252, 291, 135, 300, 261, 174,
  219, 294, 118, 249, 237, 242, 133, 263, 224, 140,  85, 242, 196,  71,   4, 267, 297, 272, 143,
  290,  68, 166,  40, 202, 170, 267,  41,  72, 273, 222,  67, 252,  77, 291, 263,  85, 204,  26,
   63, 135,  37, 271, 256, 141, 191, 290, 170, 302,  37, 106, 207, 198, 297,  55, 106,  33,  19,
  274,  66, 152,  10, 145,  53,  18, 240,  53, 229, 114, 294,   9, 121, 131, 166, 193, 258, 172,
  303, 303, 278, 127, 247, 236,  84
,},
{ 266, 152,  82,  30, 280, 276, 237, 209,  44, 195, 291, 289, 137, 153,  72, 221,  69, 192, 128,
  235, 234, 109, 219, 259, 168, 227,  98,  43,  39, 140,  26, 112, 153, 119, 166,   6,  59,  77,
   71,  62, 260, 276,  70, 134, 178, 257, 115, 199,  80, 147, 209, 269, 304, 105, 174, 160, 118,
  114, 131, 113, 131,  15, 272,   5, 198,  97,  24,  65, 220, 258, 177,  64, 168,  97, 104, 165,
   88,  94, 252,  19, 221, 100,  63, 238, 151, 106,   2, 137,  15, 126, 116, 270, 230, 200, 196,
  270, 170,  32, 249,  14, 180,  92, 109, 242, 256, 155, 118,  76, 131, 231,   2, 210, 209, 250,
   87, 280,  56,  74,  19,  32, 188,  20, 171,  70,  74,  55, 157, 201,  39, 157,  35,   1,  24,
   54,  83, 185, 148, 183, 110, 300, 100, 283, 119, 235,  19, 162, 202,  31,  24, 207, 185, 242,
   12, 189,  91,  84, 274,  54, 229,  98,  41, 205,  11, 117,  38,  73,  31, 248, 147, 210, 227,
    1,  44, 140, 265, 130, 193,  66
,},
{ 209, 175, 236, 246,  94, 222, 166,  94,  29, 119,  45, 289,  73,  37, 174, 155, 130,  22, 253,
  231, 201, 293, 177,  77, 207, 200, 138, 292, 268, 223,   7, 274, 110, 164, 190, 147, 113, 193,
  302, 226,  26, 292,   4, 271, 168, 163,  51,  55,  83, 193, 241, 115, 275, 283,  34, 235, 255,
  102,   2, 207,   7, 211, 125, 296,  71, 189, 178,  83, 230, 141, 169, 124, 136, 206, 283, 134,
   44, 197, 119, 113,  22,  81,  64,  86,  26, 200, 299, 283, 165,  32,  63, 253, 235, 283, 127,
   96,  78,   8, 113, 174,  35, 106, 117, 246,   4, 202, 159, 163,   3, 169,  54,  23,  97, 104,
  206, 123, 139, 203, 211,  17,  90, 279, 166, 301, 111, 184,  38,  95, 215, 153, 241, 276,  35,
   46, 289, 210,  31,  35, 156, 213,  75, 248, 221, 176, 177,  63, 180,   5, 277, 275, 291, 108,
   83,  11,  99, 213, 116,  49, 280, 248, 139, 292, 253, 123, 179, 176,  90, 101, 255, 270,  76,
  290, 258, 201,  64,  70, 263, 191
,},
{  42, 248, 139,  78,  87,  75,   6,   8, 215, 260, 271,   2, 250,  72,  28, 270, 194, 194, 259,
  165, 114,  88, 220, 194, 187, 281, 282,  11,  64, 233, 280, 120, 231, 193,   2, 242, 145, 231,
  272, 104,  66, 100, 277, 181,  81, 306,  32, 296,  17, 210,  65,  62, 244, 284, 138, 271, 282,
  218, 150, 101,  77, 192, 120,  27, 180,  31, 242,  65, 100, 220, 223, 104, 137,  32, 214,   7,
  142,  85, 274,  47,  24,  82, 228,  98, 133,   5, 205,  47, 271,  70,  59,  92, 268, 300,  95,
  126, 266, 279,  61, 189, 165, 286, 183, 146,  41,  71, 288,  52, 282, 206, 201,  45, 203, 142,
   79,  59,   8,  76, 232, 168,  36,  51,  41, 198, 108,  20, 279, 240,  89, 210, 117,  50,  86,
  201,  33, 103, 276, 211, 222,  68, 134, 187, 143,  65, 157, 202, 143,  89,  75, 301, 239,  17,
  220, 215, 225, 266, 287,  37, 303, 228,  55, 163,  96, 205, 228,  76,  81,  60,  98, 290, 152,
   49, 136, 103, 102,  16,  13, 220
,},
{ 185, 148, 221, 174, 189, 303, 220,  41,  22, 158,  67, 162, 203,  19, 142, 100,  69, 242, 295,
  193, 154, 106, 110, 156, 123,  89, 189, 110, 147, 268, 199, 288,  11,  63, 225,  41,  87,  80,
   60, 277, 291, 275,  12,  26, 192,  31, 131, 139, 114, 189, 114, 161,  82, 174, 252, 239,  76,
   24, 254, 301, 157, 139,  47, 200, 247, 150, 301, 234,   1, 246, 128, 251,  37,  59,  38,   7,
   13,  96,  66, 220,  57,  69, 269, 100, 210, 194, 239,  16,  38, 123, 167,   4, 180, 240, 159,
  171, 100,  33, 242, 118, 259, 123, 267, 128,  69, 168, 289, 131, 218, 204, 230, 271, 180, 160,
  200, 199, 203, 191,  21, 123, 259, 237,  26,  65, 130, 270, 168, 277,  82, 162, 183, 204,  61,
   57, 268,  47, 306, 104, 121, 156, 239, 218, 185,  26, 281,  99, 262, 305, 295,  93, 274, 187,
  101,  12, 222, 120, 168, 151,  74, 264, 160,  73,  16,  60, 207,  74, 235, 212, 288, 201,  48,
   55,  87, 250, 259,  66,  50, 211
,},
{   3, 122, 277, 122,  53,  78, 156, 121, 247, 192, 125,  42, 225, 181, 128, 105,  37, 249, 237,
  201,  75, 124,  35, 177, 120, 216,  51, 158,   6, 298, 294, 229, 263, 302, 183, 141, 304, 227,
  283,   2, 134,  77, 252, 222, 144, 158, 219, 302, 224, 145, 136, 167, 236, 280,  54, 247,  45,
  183, 159, 283, 204, 236, 286,  40, 104, 288,  88, 271, 301,  88, 208, 233, 230, 205, 235, 106,
  183, 301, 255,  17, 104, 149, 233,  96, 213,  55, 304, 221,  59,  97, 103, 191,  27,  75,  95,
  137, 227, 224, 278,  72, 227, 255, 282, 291, 223,   8, 218,  84, 293,  79, 294,  32, 240, 249,
  224,  36, 125,  45, 215, 303, 234,  15, 220, 116, 117, 277, 211,   7, 145, 279, 291, 279,  15,
   29,  78, 167, 271, 275, 227,  27, 260, 247,  57, 130, 222, 217,  17, 102,   3, 209, 222,  79,
  195, 242, 115, 212, 213, 272, 213, 158,   9,  74,  59, 188, 221,  90, 133, 189, 146, 137,  61,
   68,  44,  54, 221, 124,  40,  25
,},
{  28,  29,  98, 274,  16, 245, 241, 153, 304,  94, 191, 301,  16, 122, 175, 192, 131, 182, 100,
   76, 123, 102, 280, 251, 148,  67,  66, 171,   6,  85,  29, 267,  98, 216, 194,  13, 242, 178,
   75, 151, 100,  81,  67,  63, 300, 236, 173, 280,  72, 104, 162, 119, 253, 242,  81, 212, 176,
  225, 215, 225,  94, 225,  73,  16,  65, 282, 221, 115, 180, 192, 245, 267,  37, 263, 108,  51,
    9, 108, 250, 207,  60, 144, 247,  51,  25, 199, 263, 136, 213,  98, 115,  20, 201, 275,  52,
  299, 148,  54, 157, 124,  66, 292, 204, 199,  52,  63, 270, 249,  61,  19, 305, 288, 152, 270,
  130, 126, 164,  83, 269,  84, 111, 208,  61, 139, 192, 261, 238, 141,   3, 244, 255, 266,  50,
  228, 225, 261, 211,  84, 195,  66, 179, 130, 177, 260,  15,  34, 168, 161, 251,  19, 185, 244,
  256, 283, 180, 124, 159,  58,  32,  76, 234,  25, 148,  27, 258,  50, 129, 113, 187,  67, 263,
   43, 170,  43, 295, 189,  86, 216
,},
{  70,  93, 276, 244,   9, 189, 192,  80, 150,  75, 245,  17, 236, 219, 107,  28, 257,  33, 270,
  158, 188,  37, 185, 206,  25, 169, 306,  59,  98,  50, 180, 115,  93, 134, 253,  76, 112, 234,
  105,  52,  89, 121,  56,  55, 258, 223, 120, 172,  12,  79, 300, 273,  27, 268, 205, 169, 188,
   12, 305,  73, 213, 300, 278,  12, 232, 203, 268, 135,  41,  61, 124, 239,  84, 273, 174, 262,
  269, 282, 134, 130, 161, 160,  82,  99,  27, 297, 105, 150, 116, 157, 143,  61,  45, 207,  64,
  255, 173, 176,  40,  79, 109,  75,  11, 150,  62, 266, 104, 194,  38, 297, 277, 290, 281, 227,
  126, 192, 139,  59,  29,  95, 218,  46,  16,  12,  22, 245,  10,  63, 131,  97, 184,  39, 154,
  122, 104, 222,  64, 204, 191, 253, 139, 161, 262, 224, 126, 159,  65, 221,  73, 291, 266, 240,
  226, 169, 128,  49, 145, 232,  72, 150, 266, 274, 210,  68, 202, 291, 301,  79, 108, 143,  75,
  218, 298,  14, 185, 215,  94, 219
,},
{ 233,  89, 288, 262, 261, 291, 131, 178,  13,  50, 275,  43, 305, 267, 191, 201,  47, 115,  54,
  235, 101,   7, 151, 272, 173, 187,  83, 252,  66, 262, 125,  54, 220, 283, 244, 176, 138, 138,
  241, 103, 100, 251, 279,  95, 112, 278, 293, 200, 122,  66,  56,  16, 265,  55, 158, 226, 247,
  107,  59, 306, 112,   4,  51, 246, 231, 244,  95,  87, 222,  44, 282, 297, 143, 238,  25, 134,
   14, 226,  44, 217, 126, 143, 208, 256, 177,  64, 142, 242, 215, 298, 241, 165, 210, 179, 202,
   95, 204,  82,  68, 140,  51,   3, 144,  33,  58, 134,  56,  44, 189, 192, 226, 249, 236, 114,
   81,  78,  73, 250,  81, 134, 120, 199,  56, 252, 162,  80,  63, 195, 249, 286, 292, 272,  96,
  227, 218,  37,  18,  10, 240, 156, 246,  44,  39, 186, 199, 272, 135, 123, 200, 250, 179, 164,
  145, 125, 289, 170, 211, 138,  33, 149, 300, 136, 210, 163, 190,  18, 166,   3, 172, 251, 117,
  298,  80, 191,  13, 138, 140, 199
,},
{ 272,  47, 119, 215, 241,  21, 164,  58,  26, 281, 128,  55, 229,  50, 121, 111,  15,  96,  71,
   25, 179, 144, 119, 188,  78,   9, 221, 240, 135,  44,  61,  82, 141, 202, 111, 303, 280, 142,
   21,  99, 134, 243, 110, 285, 151, 304,  29, 140,  27, 272, 275, 154,  62, 104, 227, 114, 238,
   22,  67, 130,   5,   9, 131, 235, 138, 162, 251, 138, 124, 128,  78, 285, 235,  25, 129, 255,
   25,  31, 213, 104, 240,  76, 174, 282, 268,  41, 111,  45, 252, 243, 122, 268, 306, 207, 131,
  254, 158, 190,  89, 107, 301, 200, 297, 171, 255, 258, 267,  94, 303,  71,  63,  80,  99,  45,
  186,  50, 225, 279, 277, 168,  67, 306, 295, 234, 157, 289,  52, 304, 200, 202,   9,  93,  21,
   60, 289,  66, 289, 175, 110, 211, 273, 255, 285, 169, 253, 127, 103, 262, 167, 180, 280, 305,
  173,  35,  49, 201,   6,  21, 131, 281,  54, 280, 197, 250, 229,  20,  46, 191, 159, 194, 247,
  293,  17, 158, 120,  53,  32, 227
,},
{ 156,  66,   1, 190,  63, 302,  52, 235,  25, 270, 100,  56, 261,   6, 192,  39, 212, 165, 143,
   95,  29, 154, 136, 226, 158,   2, 182, 144,  51,   5, 168,  86,  10, 230, 302,  41, 164, 192,
  260,  75,  31,  58, 275, 285, 281, 225, 256,  18, 262, 104, 279, 268,  63, 227,   4, 274, 157,
  276, 288,  40, 305, 122, 285,  74, 155, 121,   8, 226, 245,  43, 301,  12, 114,  68, 274, 288,
  197, 265,  10, 121, 212, 112,   8,  81,  18, 190, 235,  96, 132, 250, 124, 142, 236,  65,  35,
  215,  96, 159,  36, 152, 249,  93, 179,  10, 199, 153,  95,  45, 229, 136, 146, 205,   3,   3,
  303, 254, 193, 298, 299, 205, 107, 273,  36,  63, 175, 126, 291, 276, 194,   6, 156,  89,  89,
  199, 231, 256,  48, 212, 124, 134,  93,  75, 172, 188, 230, 302, 161,  72, 215, 300, 134, 271,
  107, 137, 172, 143, 125, 195, 175, 201, 222, 187, 166, 238,  26, 285,  18, 110, 136, 289, 282,
   59,  28, 143, 185, 161, 236, 267
,},
{  78,  53,  43, 190, 114, 247, 164, 241,  65, 147,  26,  64, 159, 303,  77, 151, 243, 287,  35,
  155,  97, 170, 150,  36, 211, 120, 242, 297, 203, 293,  67,  27,  50, 208, 280, 267, 125, 120,
  251, 287,  41, 300,  74, 209, 283,  11, 201,  97,  79, 147, 261, 122,  69, 299, 177, 181, 142,
  176, 102, 121, 281, 210, 260, 103,  34, 300,  44, 149, 126,  51, 283, 268,  80, 184,  39, 200,
  259,  10, 101, 271, 175, 148,  78, 115, 256, 286, 287,  74, 293, 131,  37, 134, 126, 269, 286,
   77, 136, 250,  82, 221, 223, 145, 236, 189,  24, 148, 225, 291, 266, 299,  20, 217,  13, 262,
  132,  30, 172,  76,   1, 263,  21, 210, 138, 227, 187,   6, 127,  96, 221,  97, 290, 196,  87,
  178, 131,  61, 247, 163,  33, 136,  75, 301, 187, 277,  65, 101,  12, 299, 202, 128, 277, 283,
  172,  89,  52, 219, 105,  66, 272, 210,  18, 135, 130,  33, 126,  54, 284,  50, 236, 201,  26,
  188,  80,  91,   3,  52,  99, 200
,},
{ 224, 286, 168,  19, 263, 115,  16, 140, 170,  69, 139, 206, 163, 256, 255, 282,  52, 175,  16,
  282, 145,   6, 190,  36, 111,  94, 148, 281,   2, 221, 290, 158, 207, 288, 265, 148, 154,  38,
  132, 116, 150, 231, 220,  97, 219,  98, 131,  75,  99,  40, 283, 125, 196, 117, 242, 213, 227,
   47, 125,  16, 144, 142, 134, 249, 303, 230,  71, 260,  35, 175,  79, 141, 235,  37,  22, 102,
   38, 273, 216,  24,   1, 188,  11, 157, 161, 144, 108, 171,  10, 298, 275, 294, 214, 268,  85,
   76, 165, 287,  21,  78, 173, 129,  44, 186, 119, 279,  95, 166, 107, 223, 265, 279, 256, 253,
  231, 269, 133, 143,  26, 181, 262, 120, 271, 104, 221, 111,   1, 181,  64,  92, 212,  90, 206,
  256, 211,  60, 106, 286, 137, 280, 124, 263,  48, 276, 278,  96,  16, 243, 263,  23, 243, 146,
  164, 262, 207, 124, 102,  93, 295,  97, 204, 146, 113, 181, 286, 293,  59, 124,  34, 218, 288,
  189,  83,  72, 177,  54,  55, 279
,},
{ 116, 244,  55,  24, 150, 269, 264, 179,  21, 194,  21, 298, 186, 131, 275, 257, 302, 258,  84,
  270, 222, 213, 126, 120, 179,  23, 262,  75,  46, 110, 203, 222,  10, 100,  16,  87,  84, 246,
  110, 243, 215,  62,  58,  51, 157,  30, 204, 296,  87, 172, 242,  81, 262, 177,  82, 151, 182,
  271,  48, 223, 154, 231, 300,  68, 221, 251,  84, 139, 190,  22,  36, 148, 250, 284, 293,  93,
   51, 122, 281,  61, 246,  79, 287, 178, 126, 103, 304,  26,  94,  40, 241, 282, 160, 145,  85,
   53, 297, 150, 141, 304,  97, 223, 137,  51,  73, 114, 268,  48, 290, 156,  19, 284, 206, 161,
   67, 132, 273, 266, 150, 185, 175, 242, 179,  67,  68,  72,  81,  18, 296, 211, 168, 240, 150,
  299, 147,  92,  23,  33, 130,  84, 208,  24, 280, 275, 282, 157, 200, 174,  27, 110,  99,  71,
   46,  90,  49,  25,  36,  30, 239, 166,  61,  51,  14, 112, 164,  60,  16,  20,  28, 233, 126,
   38, 173,  35, 281, 176,  72, 214
,},
{ 166,   7,  14, 103, 185, 148, 117,   5,  14,  13, 210, 275, 100, 299, 227, 172, 148, 131, 186,
  204, 290,  97, 173,  47, 277, 106, 274, 184,  51,  10, 116,  21, 169, 148, 293, 280,   6, 258,
  222,  73, 210, 142, 222,  12,  31, 220,  97, 149, 292, 165, 207, 207, 240, 166, 291,  10,  59,
   65,  66, 220, 177, 125,  76,  15, 282, 136,  95, 266,  60,  92, 273,  13, 214,  29, 301, 167,
  110,  23,  17, 128, 294, 220,  46, 129,  86,  43, 152, 229, 154,  84,  59,  34, 122, 183, 206,
  198, 184, 302, 301, 149,  93, 285, 118, 237, 191, 177, 220,  79, 109,  69, 224, 115, 206,  33,
  223, 100, 233,  24,  59,  97, 187, 284, 120, 247,  79, 220,  82, 280,  82, 247, 288, 261, 220,
  119, 233, 289,   2, 252,  85, 250, 108, 139, 223, 102, 273, 220,  20,  45, 246,  78, 187,  54,
    2, 173, 161, 212, 259,  60, 186, 282, 178, 112,  95, 219, 220, 137,  50,  29,  52,  64,  59,
  107, 248, 189, 170, 179, 170,  19
,},
{   9, 284,  87,  24,  47, 159,  14, 127,   9, 217, 221, 135, 157,  34,  12, 116, 290,  74, 116,
  211, 157, 200, 191,  67, 246, 249, 299, 181, 179, 197,  88, 206, 253, 121, 201,  41, 148, 119,
  253,  48, 258, 182,  73, 238,  59, 236, 170, 303,  97,  78,   6,  59, 125, 220, 113, 276,  42,
   73, 163, 153, 236, 107, 259,  55,  34,  98, 257,   5, 160,  14, 285, 281, 257, 104, 250, 198,
   81,  53, 193, 177,  87, 263,  98, 141, 161, 235,  66,  98,  51,  24,  24, 131, 103, 114,  55,
  140,  59, 249, 116,  98, 169,  81, 148, 190, 215,   8,  20, 219, 258, 306,  32, 244,  22, 106,
  225,  38, 185,  66,  96, 291, 123,  69, 233,  83,  96, 213,  43, 213, 191,  59,  20, 269,   1,
  124, 182, 237,  40, 216,   7, 110, 255, 132, 270,  58,  76,  81, 281, 154,  60, 295, 158, 216,
   78, 118, 175, 131, 184, 264, 246, 131, 131, 227,  70, 304,  88, 176,   7, 219, 138, 213, 258,
  119,  74, 149, 102,  72, 101,  95
,},
{  45, 292,  70, 137,  51, 224, 103,  64, 147, 103,  29, 153, 159, 134, 134,  71,  92, 227, 306,
  241, 283,  14,  56, 275, 141, 106, 293, 141, 156, 295, 280, 231, 138,  13,  79, 169, 302,  99,
   94, 304,  52, 118, 144, 153, 166, 163, 293, 279,  43, 255, 204, 187, 263,  25, 262,  38, 129,
  112, 256, 291, 233, 193, 163, 154, 150,  35,  89, 114,  89, 237,  58,  18, 273,  14, 288,  42,
   75, 103, 289,  72, 279, 239, 267, 266, 301, 292,  43, 103, 129,  15,  31,  77, 169,  63,  88,
   32,  59,  77, 240,  22, 198, 109,  10, 201,  80, 221, 144,  15, 193,  15, 121, 132,  86, 136,
  145, 221, 156, 271, 119,  28, 114, 147, 121,  48, 249, 152, 249,  84,  75,  76, 152, 232, 197,
  135, 132, 202, 220, 189, 219, 132, 135,  68, 173,  59, 235,  37,  79,  30, 229, 305,  81, 303,
   29,  44, 128,  25, 298, 209, 273, 278, 297,  69,  17, 194, 263, 175, 140, 238, 150,  22, 262,
  251, 261, 193,  21, 226, 296,  33
,},
{ 258, 153,  27, 152, 169,  22, 169, 185, 281,  31,  28,  28,  45, 109, 298,  22, 179, 222, 104,
  204, 224, 159,  48, 292, 249, 157, 215,  83, 100, 248,  75,  97, 230, 297, 202, 223,  69,  62,
   58,  18, 286,  68, 289,  91, 170,   5,  60, 263, 221, 253, 302, 157, 190,  99, 143, 139, 239,
  121,  56, 294, 238, 273, 248, 175, 187, 299, 229, 272,  43, 203,  39, 185,  54, 292, 107, 303,
  135, 283, 269,  66, 227, 209, 221, 125, 160, 172, 235,  30, 117, 291, 137, 253, 213,  42, 180,
   38, 243, 285, 271,  49, 186, 161, 275, 232,  82,  53, 223,  13, 132, 212,  80, 285, 229, 187,
  114, 163, 304,  76, 186, 118,  57,   6, 220, 186, 222, 304, 297, 218,  91, 132, 118, 119, 249,
  208,  99,  42, 125,  10,  22, 117, 173, 209,  37,  48,  30, 257,  46, 134, 153, 201,  40, 196,
   70, 182, 306, 189,  41,  32,  15, 129, 145, 269,  93,  73, 225,  25,  30, 175,  88,  58, 262,
  140, 226, 186, 155,  77, 139, 295
,},
{ 269, 135,  54,  53, 252,  40,  42, 195, 134,  72, 142, 140, 151, 119, 161, 255, 206,  48, 183,
  169, 266, 297,  35,  18, 134, 299, 229,  96,  70, 234,  21,   2, 209, 228,   5,  38,  64, 240,
   49, 281, 192,  29, 257,  85,  29,  89, 182,  43,   5,  33, 208,  40, 128, 138,  84, 104,  38,
  214, 253,  98,  90,  56, 253, 132, 163,  77,  61, 302, 242, 169, 275, 244, 144,  75,   7, 269,
   18, 171, 111,  71, 205,  85,  76, 161,  24, 179, 109, 156, 304,  86, 135, 140,  64,   8, 139,
  254,  45, 105,  47, 173, 101,  32, 296, 278,  52,  36, 136, 159, 110, 153, 300, 132, 166, 276,
  195, 247,  77,  54,  79, 298, 247, 180, 119,   1,  39, 202,  28,  85,  48, 154,  33, 130,  57,
  245, 249,  48,  70,   6, 294,  87, 130, 174, 304, 222, 226,  22, 170,  26, 173, 219, 102,  54,
  197, 126,   3, 228, 239,  54, 270, 179, 289, 211,  37, 268, 285, 172, 301, 101,  90, 261, 194,
  111, 177,  30, 144,  23, 304, 251
,},
{ 232,   2, 287,  73,   8, 264,  31,  61, 264, 182, 283, 153, 100,  87, 157, 165, 295,   4, 173,
   77,  49,  95, 230, 202, 304, 265,  21,  83, 240, 286, 198, 192,  13, 302, 298, 263, 217, 248,
   77, 271, 172,  16, 297, 226, 205, 265, 301, 205,  67, 151, 130, 111,   7,  90,  68, 209,  42,
  126, 216, 142,  67, 264,  65, 121,  76,  59,  92, 197, 162, 216, 198, 106, 155, 242, 280, 149,
  167, 186, 187, 108, 208,  54, 283, 103,  99, 215, 192, 252,   2,  57, 279, 149, 179, 233, 256,
   75,  82,  15, 120, 306, 211, 201,  48,   3,  52,  42,  14,  42, 100, 208,  52,  31, 293, 283,
  211, 304, 255,  36,  68,  90, 286, 207, 298,  18, 236,  48, 142,  62,   8,  35, 306,  89, 250,
  243,  27,  11, 281, 231,   1, 188, 250, 237, 208, 144, 234, 291, 230, 179, 208, 174,  64,  65,
  161,  49,   7, 253,  52,  95,  39,  12, 107, 290, 254,  35, 234, 140, 232, 223, 216, 181,  77,
    1,  79,  81, 141, 142,  59,   8
,},
{ 230,   7,  68,  65, 211,  94,  46, 116,  95, 301, 108, 106,  71, 153, 257, 288, 247, 280,  30,
  232, 138, 205, 280, 250, 205,  66, 217, 305, 194, 253,  28,  42,  15, 219, 292, 305,  62, 103,
   52, 133, 155, 241, 197, 126, 165, 259, 147, 210,  70,  90, 181, 100,  28, 144, 100,  94, 174,
  161,  38, 188, 278,  86, 175,  40, 129,  47,  13, 248, 217,  78, 168, 266,  31, 141, 125, 172,
   32, 143,  96,  12, 220,  98, 245,  16,  68, 291, 257,  40, 274, 125, 161, 277, 275, 111,  66,
    2, 275, 174, 276,  83, 169, 109, 111,  46, 123, 185,  89, 159, 182,  86,  47, 222,   8,  57,
   73,  20, 259, 217,  34, 198,   4, 204, 234, 137, 116, 147, 232, 181,  73, 273, 101, 298,  28,
   48,  11,  61, 197, 258, 144,  60,  77, 147, 276, 187, 230, 137,  42, 141, 153, 164, 240, 157,
  269, 226,  66,  59,  15, 248, 141,  32, 110,  63, 240,  35, 303, 167, 263, 287,  75, 203, 295,
  280, 181,   5, 109, 229,  93, 189
,},
{ 138,  95, 108, 119,  25,  17,  86,  97,  75, 240,  11, 186, 241, 287, 255,  90, 153, 238,  50,
    4,  23, 293,   9, 292, 129, 185, 160,  19, 126,  79, 221, 180, 120, 200, 213, 112, 123,  55,
  231, 147,   2, 135, 104,  33,  28, 136,   4,  31, 129, 268, 108, 163, 173, 233, 150, 177,  73,
  184, 231, 144,  24, 228,  94, 160, 229, 173, 265, 168, 260, 228, 172,  86, 221,  84, 255, 183,
  286,  79,  89, 298, 202, 154, 274, 269, 302, 306, 132,  43, 176, 225, 126,  37, 107,  50, 195,
  282, 122, 146,  85, 131, 185, 292,  55, 294, 118,  80,  29, 176, 243, 235, 235, 149,  24, 112,
  238, 204, 300,  52,  93, 112,  85, 139,  36,  76,  73, 124, 196, 194, 249, 232,  67, 219, 200,
   91,  93, 277, 234, 306,  83, 118, 239, 138, 109, 202, 300,  49,  49,  50,  64, 188, 265, 173,
  218,   1,  52, 220,  39, 194,  30,  14, 275, 145,  33, 170,  73, 140, 118, 296,  14, 190, 210,
  294,  81, 198, 206,  39, 261, 171
,},
{  81, 279, 201, 198, 229,  98,  39, 176, 133,  60, 270, 257,  45, 261, 160, 177, 231, 101, 103,
  275, 195, 134, 218, 283, 241, 184,  80, 244, 281, 212, 167, 110, 119, 302,  63,  94, 152, 219,
   10, 200, 277,  57, 128, 248, 149,  31, 300,  16, 177,  45,  65,   4,  39, 300,  63,  15, 158,
  199, 145,  93, 288,   8, 206, 212,  24, 108,  34,  69, 135, 153, 123, 244, 133, 152, 231, 249,
   23,  80,  74, 301, 236, 230, 284, 208, 250, 108, 206, 260, 283, 234, 299, 160,  44,  35, 126,
  215, 259,  93,   7, 100,   4,  77, 287,  89,  96,   6, 202,  20, 252, 174, 209, 108, 233,  45,
  305, 108,  48,  25,  86,  32,  39, 251, 294,  10, 252,  51,  66, 147,   7,  42,  31, 203,  28,
  257,  44, 129, 185,  11, 250,   1, 163, 148,  89, 159, 275, 107, 291,  27, 185, 198, 294, 219,
   82,  34,  19,  89, 275,  84,  26, 149, 190, 102,  74,  72, 219, 291, 198, 104,  49, 235,  94,
  136, 304, 111,  29, 245, 258, 200
,},
{ 224, 289,  87, 177, 271, 230, 174,  15, 105, 137,  52, 143,  49, 142, 213,  58,  78, 163, 137,
   43, 265, 104, 154, 104,  51, 124, 212, 119, 256, 299, 209, 258, 290,  50,  52, 238, 288,  65,
  231, 182,  63, 160, 284, 151, 258, 271, 151, 174,  18, 138, 181, 236,  78,  87, 243,  99,  61,
   63, 148,  59, 116, 149, 239, 195, 105, 220, 186, 250, 262, 184, 181, 288, 211,  90, 297, 294,
   87,  37, 286, 304,  31, 249,  93,  56, 254, 138, 237,  90, 196, 288,  71, 249, 240, 186, 158,
  223, 303, 103, 171,   3,  52, 217, 283, 237,  19,  44, 260, 143, 143, 209, 140, 161, 147, 166,
   14, 135, 211,  19, 282, 266,  31, 138,   5, 260,   4, 176,  46, 120, 115, 185, 157, 138, 213,
  197, 290, 280, 174, 224, 292, 190, 296,  44, 202, 178, 160, 306,  22, 215, 298,   6,   6, 163,
  100, 172, 152,  91, 279, 263,   6, 158, 143,  11,  80, 125,  18,  79, 296,  38,  88,  31,  15,
  257,  31, 296, 197,  80, 248, 131
,},
{ 159, 262,  65,  59, 211, 221, 114, 146, 188, 212, 230, 262, 105, 111,  86,  94,  96, 101, 205,
   67, 236, 210,  25,  21,  38,  68, 259, 104, 133, 277, 142, 264, 161,  56, 270, 205,  55,  33,
   79, 227, 278,  80, 169,  55, 265, 298, 104,   4,  74, 126,  92, 227, 220, 134, 174, 285, 255,
  206, 157, 150, 137,   5, 265, 175,  19, 129,   4, 131, 117, 268,  12, 220,  96, 212, 208, 217,
  105,   1, 175, 145, 296, 302,  38, 134, 212,  21, 135, 204, 220, 253, 149, 115, 240, 201, 176,
  220, 121, 121, 194,  64, 254, 147,  48,  20,  53, 163, 238, 140, 133, 144,  67,  84,  53, 120,
  181, 225, 204, 126,  63, 185,   9, 300, 158, 170, 253, 120, 119, 109, 185, 118, 268,  26, 252,
   52,  82, 156, 179,  66, 296, 222, 176, 106, 107,  50, 128, 145, 258, 138, 173,  38,  89, 109,
  280, 205, 105, 236, 108, 265, 172, 160, 151, 190, 190, 293,  62, 264, 136,   7, 224,  67, 286,
  154, 288, 124, 294, 103, 237, 151
,},
{ 120,  95, 203,  96, 131,  69, 174, 145,  97, 234, 120, 151,  19, 146, 173, 141,  30, 235, 208,
  129, 259, 264, 133, 249, 116,  74,  83, 247, 242,  33,  89, 114, 185, 135, 251, 287, 287, 129,
  171, 215,  33,   7,  81, 280, 170, 133, 143, 190,  27,  86, 155,  63, 157, 158, 246, 281, 200,
  237,  80,  89, 261, 227,  52, 292,  19, 124, 105,  32,  48, 220, 283, 221, 301,  62, 191, 165,
  196, 266, 221,  57, 110, 292, 108, 179,  49, 152, 123,  29,  82, 124,  67, 188, 114,  31, 234,
  217,   4, 169,  97, 148, 126,  94,  60,  87, 136,  69,  14,  20, 173,  99,  60, 129,  72,  50,
  224,  68,  28,  24, 165, 291,  20,  73, 234,  74, 101, 300, 216, 126,  48,  83,  59, 117, 141,
  200, 278,  33, 213, 167,  74, 220,  84, 189, 113,  56, 215,  24, 242, 305,  31, 110, 286, 271,
  122,  87,  27,  12, 272, 277, 289, 155,  91,  88, 244,   9, 286, 294, 168, 138, 130,  17, 300,
  165,  21, 196, 192, 113, 291, 158
,},
{  91,  51,  17, 270, 212, 141, 215, 241,  49, 137, 154,  78, 220,  68, 280,  74,  72, 271, 288,
  222,  29, 270, 157, 221,  78, 174,  47, 166,  60, 115,   3,  78,  72, 109,  91, 159,  78,  31,
  249,  49,  73,  91, 128,   4,  73, 162, 105, 111, 210, 251, 218,  23, 189,  23, 202, 299, 127,
  171,  34, 141,  12,  99,  81, 249, 143, 137, 290, 116, 120, 231, 193,  91, 198, 178, 284, 207,
   80,  29, 177,  65, 120, 240, 150, 284,  25, 157, 214, 191,   3, 132,  29, 181,  67, 306,  33,
  283, 176, 286,  28,  57, 282, 107,   5, 174,   1, 230, 153,  38,  22,  50,  66, 194, 212,  16,
   47,  59, 177,  45, 138, 123, 281,  89,  69, 201,  14, 262, 250, 142, 113, 293,   5, 208, 217,
  296, 223, 182, 176, 296, 214,  88, 100, 122, 115,  82,  66, 218,  95,  96, 252,  83,  32, 204,
    2, 101,  39, 133,  70, 152, 111,  74,  95, 143, 175, 140,  83, 114,  37, 103, 285, 257, 273,
   88,  36, 248, 135,  88, 143, 249
,},
{  21, 264,  33, 245,  37,  49,  33, 136, 148,  11, 213, 286, 212,  66, 217,  21, 247, 104, 236,
  244,  10, 126,  80,  12, 276, 115, 215, 137,  52, 196, 297, 213, 210, 267,  28, 117, 158, 137,
  224, 150, 276, 110, 237,  63, 216, 142, 250,  74,  92, 120, 187, 282, 241,  40, 104, 167, 169,
  262, 195, 237,  76, 258, 207,  32, 191, 123,  10,  80, 278, 115, 272,   7, 251, 146, 182, 146,
  211, 254, 221, 141, 174, 150, 160, 167, 154, 168,   6,  88, 185, 109, 299, 197,  35, 253, 212,
  186,  61, 123, 159,  66, 206, 254, 299, 173, 225, 188, 273, 253, 251, 277,  66, 215, 284,  81,
  157, 127, 155, 299, 213, 270, 286, 108, 277,  85, 258, 122, 156,  44, 139, 264, 275,  63, 113,
  300, 136, 130, 215, 266, 236, 170, 202, 156, 223,  37, 226, 232, 258, 203, 131, 264,  65, 202,
  260,  68, 208, 276, 170, 184, 279,  85, 131, 107,  45, 151,  39, 185, 220,  22, 255, 149, 198,
  106,  11, 112,  45, 111, 213, 275
,},
},

//-----------------------------------------------------------------------------------------------
//Redundancy generating matrix for (306, 92) Reed-Solomon code
//-----------------------------------------------------------------------------------------------

{
{ 120, 225,  21, 239, 154, 213, 130, 266, 135, 141, 210, 257, 114, 119, 174,  73, 186, 188,  42,
  259, 272, 207, 247, 217, 291, 216, 102,  64,  75,  18, 160, 152, 250, 136, 210, 208, 241,  36,
  296,  96, 169, 186,  57, 164,  10, 283, 150,   7, 181, 265, 220, 103, 248, 166, 130, 152, 303,
  232,  35, 181,  89,   1, 304, 274, 200, 189, 134, 152, 189, 184, 203, 187,  89, 210,  44,  79,
  185, 235,   8, 266,  25, 108, 163, 151, 184, 177, 203,  19,  91,  28, 226, 138
,},
{ 289, 163,  53, 154,   1,  76,  40, 305, 169, 252, 263,  64,  25, 265, 185, 117, 260,  35, 151,
  172,  34, 287, 216, 107, 158,  13, 170,  31, 283, 103, 301, 260, 268, 291, 258,  56,   3, 297,
   53,  36,  86,  49,  70, 278,   9,  75, 107, 195, 118, 218, 232,   5, 250, 131, 300, 230, 214,
   84, 150, 146, 183, 227, 201,  48, 244, 187, 261, 234, 139, 100, 261, 221, 189, 211, 142, 201,
  128,  73, 111, 183,  32, 193, 191, 125,  62,  50, 254,  62, 297, 271, 209, 236
,},
{  76, 278, 207, 276, 272, 228,  56, 188, 237, 289,  78, 129, 259, 172, 191, 221, 112, 113, 123,
  182, 201,  73, 249, 159,  15, 172, 139, 231, 232, 233, 102, 254,   9, 129, 117, 226, 137, 210,
  157, 298,  10,  81, 300,  92, 182, 178, 170, 224, 238,  30, 255, 287, 203, 130, 111, 253, 207,
   13,  55, 193, 274, 112, 133,  88, 277,  26, 190, 214,  16, 276, 116, 185,  42,  15, 157,  59,
  267,  21, 119, 259, 250,  39, 286, 215, 262,  82,  66, 133,  48, 151, 189, 235
,},
{ 263, 147, 301, 191, 240, 286,  78, 245, 292, 216, 212, 301, 210, 287, 231, 154,  30,  84, 159,
  202, 246,  33,  95, 282,  83, 120, 196, 136,  50, 164,  72, 210,  60,  41,  52, 184,  66,   1,
   81, 306, 103, 126, 275, 158, 293,  68, 123, 280,  86, 192, 154, 207, 237, 224, 287, 219, 234,
   81, 256, 224, 232, 202,  21,  53, 117, 177, 202, 298, 114, 276,  89, 160, 224, 272, 224, 302,
  247, 232,  59,   1, 301, 149, 276, 159, 168, 105, 202, 233,  28, 181, 150,  77
,},
{  30,  89, 229, 284,  76,  63, 165, 298, 202,  97, 115,  46, 176, 163, 177,  19,  47,  77, 248,
  147, 270, 221,  18, 226, 278, 137, 299, 212,  78, 208, 204, 110, 119,  94, 247, 104,  14,  75,
   75, 105, 118, 303, 217,   9,   7, 287, 259,  48,  95, 229, 247, 103, 269, 125, 103,  18, 218,
  292,  13,  71,  16,   2, 278, 243, 103, 241,  57, 240, 115, 160, 250,  59, 259, 123, 283, 167,
  118, 229, 234, 279,  84,  21, 113, 237, 205, 289,  79, 130, 179,  35,  84,  31
,},
{  36, 251, 126, 270, 146, 232, 102, 122, 185, 275, 160, 100, 203, 181,  31, 291, 259,  42, 151,
  295, 290, 240, 203, 298,  37, 220, 229, 134,  81,  22, 256,   4, 185,  37, 157, 248, 207, 209,
   41, 288, 125,  51, 228,  82,  12, 184,  25, 169, 133,  21, 295,  63, 116, 196, 164, 210, 201,
   42, 149,  98,  67,  47, 216, 176, 303, 129,  97, 164, 266, 293,   6, 214,  55,  15, 259, 276,
   69,  35, 170, 191, 133,  55, 162, 189, 108, 166, 135,  54, 188, 126, 287,  64
,},
{   5,   7,  60,  72, 302, 270, 263, 241, 166, 306, 207,  30,  28, 144, 265,  98, 222,  11, 274,
  149, 204,  30,  84, 276, 195,  46, 301,  27,  22,   5, 131, 160,  40, 293, 276, 268,  15,  55,
  119,  45,  52,  56,  15, 286, 108,  11, 267, 166,  87, 208, 286, 133, 278, 302, 227,  68, 261,
    6, 133,  67, 268, 131, 162, 253,  82, 119, 109,   1, 287,  69,  84,   1,  77, 294,  68,  96,
  143,  66, 240,   2, 256, 291,  49,   2, 299,  77, 264, 123,  45, 138, 161, 216
,},
{ 132,  99, 245, 108, 180, 260, 106,   3, 236, 229, 230, 152,  94, 251, 274,  69,  57, 306, 180,
   37, 264,  94, 271, 292, 197, 187, 281,   3, 263, 226, 181, 114, 128, 251, 217,  75, 134, 116,
  135, 286,  16,  11,  88, 134, 297, 143, 176, 244, 273, 225, 143, 123, 283, 215, 138, 210, 125,
   25, 198, 240, 257, 177,  97,  95, 166,  75, 205,  92, 301, 121,  16, 259, 191,   1, 281, 247,
  146, 248, 259, 287, 183, 252, 194, 123, 143, 156,  24,  70, 131, 260, 141, 190
,},
{  82, 209,  98, 219, 203, 126,  93, 298, 172,  10, 219, 247,  15, 293, 155,  22, 104, 165, 304,
  270, 141, 298,  53,  56,  15,  99, 226, 161, 131, 306, 233, 203,  29, 180, 241, 134, 122, 220,
  175, 262, 161,  51,  96, 241, 192,  35,  92, 278, 250, 275, 273,  65, 272, 202,  48, 160,  64,
  304, 228, 204, 265, 140, 221, 274,  27, 157,  54, 227,  83, 263,   9, 241, 284, 181,  72, 248,
   92, 281, 233, 144, 125, 134, 215,  26,  85,   3,  44, 257, 168, 232, 220, 266
,},
{ 299,  67, 269, 123,  45,  66,  15, 239, 289, 224, 303, 120, 178,  48, 220, 232,  71,  71, 285,
  123, 170, 250, 302,  59,  98,  62, 215,  58, 156,   7, 193, 141,  84, 286, 166,   2,  77, 181,
   57, 230,  87, 210, 170, 126, 138, 255,  25, 112, 225, 130, 158,  41,  28, 220,  91, 263,  17,
   69,  97, 175, 239, 224, 263,  39,  56, 260, 189, 269, 153, 214, 229,  17, 276, 270, 219, 210,
   31, 281, 260,  72,  40, 302, 205, 164, 157, 196, 276, 186, 210, 248, 176,  88
,},
{ 122, 144,  73, 118, 167,  62, 147,  91, 146, 110, 284, 201,  21, 212,  10, 197,  22,  37,  83,
   52, 113, 273, 189,  57, 186,  72, 135,  14, 211, 205, 272,  61,  37,  79,  39,  50,  27, 175,
  134, 216,  59, 184,   7, 173,  85, 175, 254,  27,  76, 213, 149,  12,  68, 207, 301, 266, 218,
  171,  79,  61,  25,  20, 267, 122, 140, 110,  79,  57,  16,  74, 272, 107, 174,  29, 151, 110,
  219, 142,  64,  29, 123,  27, 217, 292,  85,  76, 254, 106, 212, 218, 181,  40
,},
{ 195, 219,  63, 116, 138,  91,  43,  42, 272, 260, 221, 126, 156, 176, 111, 167, 269, 174, 182,
    5, 187, 104,  22, 273,  31, 230, 161, 239, 251,  10, 158, 212, 237, 258, 190,  70, 173, 239,
   42, 290, 222, 131,   8, 120, 266,  46,  35, 227, 206, 238, 110, 278, 108, 261, 188, 241, 106,
  288,  36, 258, 244,  65, 207, 175, 140,  25, 251,  19, 249,   8, 212,  77, 290, 285, 254, 241,
  142, 102, 155, 266, 108, 145, 100, 117, 284, 104, 214,  93,  62, 104,  48, 175
,},
{ 124, 274, 210, 136,  50, 266, 123, 236,  28,  80, 170,  67, 121, 105, 233, 299, 175,  13, 156,
   71,  20, 186,  42, 236, 236,  70, 274,   2, 163,  24,  73,  49,  61,  91, 168,  57, 186,  26,
  156, 264,  86, 230, 282, 157,  28,  57, 201,  32, 281, 224,  56,  22,  84, 300, 293,  79, 155,
  182, 273,  90, 176, 112, 154, 265, 177,  59, 143, 142, 245, 214, 228,  88, 302, 200,   3, 264,
   74, 129, 274,  41,  36, 281, 119, 123,  82, 252,  17, 162,  54,  50,  51, 252
,},
{ 154,  29,  40, 266, 262,   1, 177, 229, 179, 255, 196, 157, 244,  23,  52, 209, 200, 273, 159,
   33, 154, 301, 109,  80, 195,  22, 293, 131, 175,  94, 127,   2, 114, 256, 207,  87,   3,  48,
   17,  95, 179, 294, 165, 165, 221, 120,  96, 123, 208, 135,  97, 224, 197, 164, 211, 222, 299,
  289,  99, 142, 107, 121, 277, 127,  10, 220,  57,  72, 185, 256, 101,  74, 105, 111, 236, 263,
  220,  43, 303,  73, 201, 236, 219, 103, 134, 171, 139, 200,  69,  49, 207, 136
,},
{  49,  54, 122,   2,  27,  65, 182, 127, 169,  14, 264, 150,   4, 157,  48, 156,  24, 287, 152,
   78, 185,  62, 123, 149,  53,  99,  79,  94, 200, 167,  57, 230, 232, 190, 265, 251,  14, 294,
   87, 179,  54, 301,  64,  58, 297,  27, 258, 127, 179,  22, 276, 290, 182,  55,  38,   7, 292,
  230, 137, 155, 273, 243,  20,  87,   4, 233,  24, 160, 295,  35, 234,  52, 205, 114, 262, 235,
  249, 252, 210, 253,  96, 153, 300, 186, 260, 260, 149, 267, 296, 193,  85, 248
,},
{ 288, 282,  43, 143, 126,  47,  70, 145, 144, 139, 211, 144, 178,  44,  22,  39, 234, 291, 265,
  221, 301, 252, 225, 214, 172, 203, 221, 294, 274,  59, 244, 299, 216, 190,  80, 273, 154,  39,
   22, 256,  32, 132,   8, 212,  82, 178,  80, 152, 193, 201, 243,  32,  87, 212,  60, 280, 243,
  112,   7, 203, 123, 214, 113, 125, 260, 212,   2, 266,  61, 184,  31, 253,  20,  95, 281, 206,
   65, 199,  87, 173,   6, 171,  53, 294,  75, 255, 256, 256, 117, 179,  60, 232
,},
{ 210, 298, 242, 231, 259, 115, 121,  75, 151,   7,  46, 277, 190, 156, 195,  73, 211, 256, 211,
  181,  83, 126, 147, 221, 186, 243, 228,  26, 195, 152,  32, 203, 276, 147,  97, 137,   4, 217,
  250, 190, 168, 204, 155, 295,  76,  40, 287, 169,  85, 273, 279, 193, 159, 224, 286,  19, 273,
   35, 250, 247, 282,  48, 132, 132, 168, 207, 293, 268, 213,  76,   2, 128,  25, 234, 172, 189,
  146, 246, 213,  92, 140, 195, 226,  87,   2,   1,  73,  59, 185, 166, 114, 148
,},
{ 261,  47,  29,   2, 305, 162,  14, 193, 100, 143,  80,  14, 264, 303, 120, 254, 278,  98,  25,
  168, 220,  19, 149,  28,   2, 226, 296, 183,  74,  96, 193, 117,  56, 142, 220, 181, 193, 113,
  124,  29,  28,  66,  44, 174, 240, 208, 136,  95, 248,   9, 291, 173,  57, 167, 123,  64,  41,
  225, 303,  22, 218, 123, 218, 160, 260, 203,  84,  71, 303, 122,  34,  48,  99,  98, 299, 198,
  246, 235, 202, 285, 108, 160,  66, 163, 303, 103, 266, 122,  19,  31, 151, 276
,},
{ 271,  40,  10, 295, 140, 149, 123,  57, 306,  27,  80,  95, 164, 259, 128,   6,  14, 283,  24,
  285,  25, 250,  37, 176, 217,  60, 134, 154,   7, 130,  48,  86,  42, 138,  79, 219,  78, 305,
  147, 218,   9,  95, 141, 179, 171,  63, 163, 226,  10,  15, 250, 168, 160, 130, 128,  16, 188,
  217,  61, 218,  26, 187, 216,  13, 100, 234,  40, 284,  45, 125, 276,  70,  52,  36, 269, 306,
  296,  22, 294, 245, 124, 137,  19, 297, 292,  35, 257, 291,  64,  72,  86, 171
,},
{ 258,  64, 254,  48, 227,  30, 275, 173, 117, 164,  18, 126, 248, 251, 234,  24, 191, 234,  97,
  105, 133, 117, 121, 304, 203,   6,   3,  26,  85,  15, 167, 252, 163, 273, 129,  35, 292,  94,
  266, 292, 259, 194,  18, 248,  47,  58, 232, 132, 170, 196, 181,  57, 210, 302, 256,  25, 253,
  257,  62,   5,  87, 197, 288,  99, 136, 184, 123, 244,  61, 195, 147,  18, 246,  43, 192, 270,
   13, 264, 162,  37, 222, 172,  73,  52, 140, 166,  57, 129, 195, 247,  36,  45
,},
{ 181, 252,  88, 264, 224, 295,  47, 272, 108,  15,  97, 224,  37,  77,  99, 142, 105,  55, 282,
   86,  65, 238, 180,  62, 198,  99, 298, 120,  24, 281, 154, 253, 143, 143, 206, 279, 135,  70,
  213, 288, 222,  33, 303,  30,  84, 195,  54, 240, 295, 122, 272, 211, 165,   5,  12,  35, 152,
  255, 297, 225,  19, 132,  62,  31, 196,  45,  74, 209, 153,  52, 120, 273,  32, 179, 181,  63,
  306, 150,  10, 159, 241, 170, 139, 114,  43, 123,  91, 298, 233, 227, 286, 106
,},
{ 133,  85,  22, 248,  10,  84, 260, 306, 153,  11, 171,  16,  28,  64, 101, 162, 210,  78, 209,
  106,  60, 210,  18, 157, 208,  69, 166,  21,  88,  90,  49, 302,  44, 130, 299, 150,  37, 267,
  132, 258,  89, 290, 242, 188, 169, 303, 131, 182,  85, 141, 110, 138,  97, 262, 277, 160, 225,
  184, 281, 142, 142, 125, 121, 248,  48, 275, 127, 222, 288,   9,  80, 294, 190, 188, 238, 266,
   25,  42,  77, 269,  46,  23, 256, 181, 277,  78, 151, 263, 120, 131, 237, 178
,},
{ 177, 273, 139, 198,  30, 163, 199,  23,  83,  77, 244, 174,  46,  27,  29, 201, 114, 211, 186,
  261,  16,  66, 275, 269,  72, 281, 112, 199, 170, 222,  19,  89, 287, 306,  56, 176,  68, 305,
  151,  28, 254,  41, 305, 269, 126, 195, 294, 149, 165, 284,   5,  24,  74, 173,  70,  10,  62,
   76, 274, 264,  20,  13, 205,  80, 236, 227, 181, 167,  94, 191, 224, 210, 172, 116,  38, 178,
   40, 103, 238, 147, 114, 236, 179, 118,  84, 162, 293, 156, 190, 192, 142, 241
,},
{  62,  63, 115,  22, 165,  94, 179, 142,  16, 294,  32, 167,  18, 174, 209, 123, 205, 293, 202,
  284, 115, 169,  35,  75,  97, 245, 303, 186, 161, 210, 100, 118, 167, 214, 261, 143, 234, 148,
  110, 262, 233, 258, 270, 226, 223, 175, 119, 139, 176, 174, 193, 268, 234, 170, 189, 169, 274,
  100, 222, 301, 223, 261, 211, 234,  81,  42, 286, 280, 280, 230, 301, 162, 169, 127, 282,  43,
  248, 187, 189, 181,  32,  47, 223,  37, 254,  68, 272, 267, 290, 184,  12, 244
,},
{ 115,   9, 275, 101, 144, 254, 193, 306, 233,  36, 265, 112,  46, 196, 264, 215,  71,  27, 103,
  156,  33, 275, 265, 179, 162, 304, 266, 262,  66, 255, 261,  41,  25, 195, 185,  51,   3, 115,
  227, 202,  53, 181,  44,  69, 210, 200, 242, 292,  95,  59, 129, 151, 301, 214, 269, 130, 114,
   87,  44, 178, 220, 160, 143, 141, 221, 147, 196, 227,  39,  47,  28, 186,  81, 140, 118, 217,
   54, 179, 297,   9, 141, 289, 216, 227, 111, 155, 173, 303,  60,  61,  68, 221
,},
{ 118, 106,  45, 290,  58, 246, 126,  35,  55,  80,  89, 267, 132, 250, 275, 126, 183, 174,  99,
  240,  96,  37, 216,  23,  20,   6, 128, 288, 259,  53,   3,  83,  31, 302, 248, 103, 201, 284,
  140, 260,  97,  21, 191,  62, 130, 125, 194, 254,  76,  23, 173, 174,   6, 147,  86,  91, 167,
  117, 147, 135, 199, 134, 111, 218, 133, 238, 289,  18, 244, 179,  88, 217, 207, 134,  40,  78,
  271, 106, 105, 139,   8,  63,  86, 124,  60, 239, 196,  74, 152, 108, 273, 173
,},
{ 191,  54,  55, 254, 223,  67,  18,  94,  58, 195, 184,  35,  34, 150, 266,  10,  69, 165,  72,
   84,  18, 295,  95, 303,  18, 241, 153, 148,  62, 303, 103, 204,  46, 227,  99,   6,  44, 289,
  223, 170,  25,  40,  58,  12, 257, 276, 287, 177, 253, 178,  15, 186,  98, 173, 226, 287,  13,
   86,  32, 146, 182,  65, 229, 235, 127, 288,  88, 183, 173, 148, 300, 204, 264,   4,  71, 199,
  155,  95, 262,  73, 166, 272,  18, 114,  28, 288,  53, 106, 160,  84, 217, 201
,},
{ 174, 287, 284, 202, 201,  56, 102,  66, 213, 155,  39, 265, 231,   7, 126, 203, 249,  96,  11,
  248, 110, 180, 208, 118, 157, 147, 174, 123, 180, 303, 228, 262, 106,  59,  71, 155, 248, 219,
  227, 178,  62, 264, 138, 173, 180,  38,  33, 159,  25, 100, 190, 149, 300,   1, 208,  78,  97,
  288,  60, 187, 229,  76,  76,  43, 218,  48, 206, 247, 104,  10, 120, 126, 287, 108, 252, 293,
  237, 112, 168,   3, 186,  77, 186, 283, 258, 300, 260, 188, 284, 262,  74,  18
,},
{  11, 233,  51, 288, 211,  44, 247, 285,  40, 295, 251,  60, 168, 224,  69, 212, 174, 256, 238,
   68, 232, 152,  21, 123, 137,  54, 141,  98, 245, 197, 113, 201, 157,  98, 155, 131, 195, 282,
   21, 113, 150,  33,  62,  20,  46,  55, 282, 159,  40, 190,  69, 202,   8, 218, 192, 181,   6,
  282, 304, 248, 254, 247,  22,  96, 266, 243,   4, 179, 272,  39, 287, 109, 193,  76, 286, 139,
  246, 169, 256,  44, 146, 288, 248, 141, 218,  67, 270, 295, 291, 174,  32, 102
,},
{ 267, 243, 226, 176,  32, 140, 103,  56, 240, 300, 225,  63,  22,  26, 166, 147, 150,   9, 242,
  254, 182, 163, 172,  51,  26,  65,  20, 222,  73, 239, 246, 267, 220, 214,  28, 188, 153, 183,
   81, 296, 159,  88,  14, 212, 119,  54,   5,  75, 201,  54, 219, 137,  17,  55, 277,  39,  80,
   31, 168,  39, 116,  49, 248,  33, 234, 203,  96, 158, 116,   6, 176,  20, 284, 123, 266,  55,
  282, 270,  64,  65, 138, 110,  29, 300, 182, 159, 204,  59,  60,  77, 201, 293
,},
{ 162, 187, 256, 257, 169, 120, 162,  63,   8, 108, 123,   4,   2, 198,  46,  65, 306, 281,  35,
  300, 130,  47,  82, 204, 275,  72, 172,  45,  93, 128, 148, 267, 144, 158,  37, 186, 191, 263,
   30, 272,  79,  11, 211, 174,  72, 148, 103, 214, 304, 175,  44,   5,  42, 149,  77, 298,  95,
  209, 155,  90,  21, 102,  91,  96, 303,  44, 169, 117, 275, 303, 234,  14,   2, 107, 121,  81,
  228,  62, 158,  24,  22, 161, 284,  64, 180, 160,  80, 245,  13, 282, 290, 111
,},
{ 119, 270,  62,  76, 159, 173, 121, 216,   5,   2,  86,  99,  71,  10, 171, 167, 142, 298,  31,
  233,  99,  82, 141, 223, 270, 305,  35, 215,  81, 249,  82, 135,  80, 197, 136, 100, 228, 196,
  270, 248, 304, 156, 198, 302,  56, 171, 220, 266,  43, 247,  35, 118, 210,  48, 150,  64, 161,
   59, 103, 291, 145, 132,  76, 112, 192,  99, 182, 156, 220, 130, 118, 115,  69, 287,  79, 294,
   47, 218,  29, 212,  36,  37, 141, 160, 226, 179, 282,  40, 215,  51, 194, 258
,},
{ 260, 146, 162,  17, 205, 160, 250, 288,  48, 157, 150,  80,  39,  73,  80, 278, 263, 140,  82,
  234, 106,  87, 259, 253,  86, 124, 219, 276, 224, 120,  84,   2, 165, 170,  38,  75, 264, 306,
  121, 171, 256,  93, 126, 144, 119,   4, 189, 184, 300, 259, 212, 207, 246,  58, 125,  70, 260,
  152, 186, 137, 228,  96, 279, 158, 136, 141, 287, 102, 105, 107,   7, 165,  52, 217, 280, 199,
  132, 198, 133, 196, 215, 270,  32, 110,  47, 149,  56, 272, 186,  71,  29, 186
,},
{ 216,  51,  61, 101, 110, 220,  87, 299, 224, 179, 228,  60, 101,  69, 202, 150, 183, 233, 277,
   57, 171, 233, 286,  97,  40,  45,  62, 150, 104, 195, 101, 112, 145, 287, 241,  44,  79, 206,
  102, 171, 291, 161, 257, 237, 162, 260, 274, 263,  80, 163,  41,  29, 285, 115, 292, 153, 247,
  125, 215,  82, 113, 107, 152, 281, 211, 292, 198,   8, 258, 252, 104,  98, 141, 123, 112, 238,
  225, 248, 151, 182, 241,  41, 195, 181, 257, 120, 146, 213,   6, 175,  48, 216
,},
{ 132,   3, 289, 109, 209,  68,  56, 134, 294, 287, 103, 173, 124,  17, 199,   6, 109, 267,  95,
   40, 172,  61, 167, 187,  18,  32, 280,  71,  79,   1,  64,  84,  80,  49, 211,  40, 217, 180,
  286, 269, 142, 250, 193,  69, 248, 197, 118, 251,  63, 218,  98, 185, 179, 222, 258, 275, 210,
   11,  10,  15, 272,  22,  73,  85, 194, 204,  71, 181,   1,  92, 199, 279, 288,  65, 110, 291,
  288,  23, 134, 198,  56, 237, 251, 269,  15, 114,  67, 259, 221, 221, 178,  77
,},
{  30, 265,  85, 272, 301,  32, 254, 276,  91,  99, 186, 244,  48,  77, 214, 294, 206, 156, 124,
   83, 108, 147,  46, 298, 183,  72, 211, 296,  13, 237,  41, 102, 300, 114, 255, 263, 177, 226,
  254,   3,  81,  35,  34, 234, 225, 242,  81,  43,  66, 206, 273,  47, 247,  67, 101, 296, 274,
  268, 250, 132, 114,  42,  98, 295, 135,  11,  84, 109, 305,  47,  66, 169,  71, 187,  76,  53,
  107, 270,  25,  47, 281,  83, 201, 212,   8, 136,  88, 302, 205, 228, 124,  59
,},
{  19, 104, 276,  64, 148, 281,  27, 291, 259, 121, 209, 306, 216,   8, 212, 223, 216, 246, 178,
   55, 167,  41, 291, 262, 275,  33, 257, 303, 116, 154, 160, 106, 116,  35, 224, 247,  53, 152,
  191,  85, 150,   3,  21, 193, 210,  37, 189, 187, 284,  44, 292, 210, 250, 217,  62, 166,  60,
  147, 184, 184, 164, 173, 172, 300, 122, 234, 242, 149, 208, 109,  51,  47, 201, 181,  20, 132,
  223, 157, 128,  62, 294, 206, 183, 207,  16,  13, 140, 288, 145,  15,  54, 284
,},
{   3,  63, 235, 305, 206, 161,  54,  49, 256,  86, 203, 131, 140, 242, 304,  68, 243, 190, 201,
   54, 246,  11, 193, 212,  16, 219, 143,  13, 113,   9, 158,  41, 189,  58, 117,  45, 230, 146,
   98, 132, 189, 170, 227, 240, 270, 148, 271,  28,  15,  22, 203,  72,  32, 116, 297, 250, 258,
  250, 263,  12, 286, 141, 242,  10, 305,  73, 222, 123, 100, 274,  45,  48, 149, 283,  90,  45,
  175,  37, 280, 150, 101, 266, 141,  87, 273, 243, 256,  10,  37, 115,  36, 257
,},
{ 140, 112, 241, 258, 280, 301, 108, 262,  53, 267,  24, 247, 264,  23, 138,  31, 285,  53, 239,
  145, 269,  27, 248,  88,  91, 268,  31,  13, 254, 134, 298, 233, 128, 143, 303, 155, 275, 272,
   82, 210, 278,  99,  83,   9,  47, 242,  16, 228, 188, 273,  74, 272, 259,  21,  63,  65, 143,
   17,  35, 116, 167, 236, 291,  50, 141,  65, 127, 297, 190, 110, 255, 212, 203,  87, 232, 131,
    5,  91, 251, 181, 128, 227,  98, 266,  97,  19, 224, 227,  65, 172, 174, 197
,},
{   1, 257, 258,  46, 203, 182, 123,  13, 148, 200, 192, 305, 294,  68, 224,  90, 140, 174,  38,
  300,   4, 217, 180,  17,   6, 277, 100,  52,  52, 116,  33, 156,  56, 211,  68, 141,  47, 306,
  254, 267,  40,  80, 276, 156, 137, 231,  13, 167, 273, 203,  19, 103,   8, 112, 150, 228, 198,
  104, 158,  80, 150,  57, 259, 237, 154, 227,  61, 292,  76, 212, 191, 254, 246, 128, 159, 138,
   43, 250, 132, 156, 194, 221, 103,  66, 288, 275, 100, 283,  41,  55, 179,  37
,},
{ 142,  37, 113, 198, 218, 102,  80, 141,  96, 146, 295, 184, 225,  92,  59, 162, 218,  35, 193,
  104, 233, 295, 146, 227,  39,  16,  60,  12,  64, 104, 203, 131, 196, 176, 306,  89, 155, 151,
  206, 122,  73, 168,  40, 204, 219, 170, 255, 272, 110, 254,  54, 146,  69,  10,  10, 248,  80,
  186, 171, 101, 303, 187, 253, 266, 269,  86, 273, 159, 224, 130,  48,  49, 170,  34, 221,  12,
  229, 142, 239, 150, 160, 199, 112, 164, 120,  83, 111, 189, 273, 156, 128,  66
,},
{ 245, 256, 195, 230, 231, 154,  86, 137, 148, 192, 191,  65,  33,  97, 217, 272, 158,  39,  44,
   95, 250,  80,  19,  39,  92, 173, 301, 293,  50,  24, 226, 104,  53, 269, 221, 219,  31,  75,
   39,  95, 224,  69, 246, 119, 250, 170, 246, 103, 245, 101,  38,  98, 243, 280, 301, 218, 291,
   42,  40, 144, 142,  62, 296, 224, 265, 156,  27, 174,  46,  88,  20, 110,  90, 215, 175, 216,
  249,  82,  56, 296, 265, 227, 212, 254,  28, 136, 280, 137,  55, 279,  29,  26
,},
{  50, 262, 188, 269, 243, 243, 157, 248, 270, 130, 126, 119, 266,  57,  16, 273, 196, 134, 210,
   24, 106, 106,  55, 135, 237, 182,  62, 123,  94, 211, 193, 187, 157, 212, 203, 103,  38,  46,
   96,  79, 191, 148,  16, 212,  72, 240,  79, 121, 204,  74, 295, 260,  99, 261, 283, 262, 114,
  183,  31, 141,   2, 168, 291,  52, 205, 267, 263, 295, 176, 225, 147, 277, 275,  24, 131,  80,
  114, 219, 290, 218,  25,   3, 167, 147, 126,  25, 195, 160,  47, 169,  15, 240
,},
{ 249,  18,  83, 139,  82,  94, 129, 141, 106,  33, 182,  99, 156, 275,  65,  37,  91, 187,  83,
   49, 220,  52, 135, 252, 286, 194, 102,  72,  10, 116, 236, 140,  15, 255, 264,  82, 227,  82,
  169, 111, 115,   9,  13,  80, 156, 145,  14, 224, 274, 255,  70, 148, 222,  29, 147, 230, 223,
  227, 294, 184,  11, 242,  62,  46, 160, 129, 192, 210, 219, 128, 132, 205, 147,  20, 146,  57,
  272,  26, 297, 274,  78, 157, 134, 181,  99, 240, 239, 150, 203,  13,  70, 286
,},
{ 243, 129, 191, 283, 282, 214, 127,  69,  69, 215, 228,   4, 161, 113, 305,  67, 122, 134, 226,
  170, 170, 171,  84, 183, 281,  48, 201, 293,  32, 246, 133, 114, 109, 229, 143, 194, 240,  85,
    6, 302, 246, 200,  40, 253, 177,  46,  65, 174, 107, 235, 240,  56, 159, 113,  62,  25,   7,
  263, 106, 177, 157, 297, 305, 141, 144, 182,  78,  70, 232,  39, 163, 196, 178,  35,  17,  22,
  163, 249, 165, 237,  56, 266, 111,  33,   1,  66, 275, 147,  81, 229, 179, 242
,},
{ 182,  47, 299,   6,  97, 252,  53,  29, 197, 114,  73, 101, 269, 101, 162, 165, 257, 182, 167,
  276, 296, 223,  80, 101, 302,  56, 172,  32,  23,  90, 284,  77, 135, 172,  87, 131, 186,  49,
  186, 213,  62, 129, 179, 125, 217, 202, 120, 224,  75,  74,  57, 299, 207, 114, 259,   6, 285,
  277, 137,   7, 225,  92, 185, 301,  35, 139,  68,  22,  65, 245,  45, 288, 244,  36, 245, 101,
  277, 238,  36,  67, 147,  97, 109, 120,  46, 162,  72, 268,  65, 103, 275, 112
,},
{ 239, 208, 250,  51,  62,   7,  76,  66, 106,  25, 302, 306, 282,  89, 248,  49, 121, 130, 281,
   10,  40, 148, 257, 131, 151, 241, 121, 279, 143, 197, 204, 116, 140,  17,  53,  51, 107, 227,
   45, 193, 107,  18,  66, 127,  17, 292, 117, 290, 234, 283, 154, 234, 138,  72, 245,  91, 172,
  174, 206, 147, 151,  30,  63, 173, 290,  20, 104, 207,   7, 104, 263, 113, 125, 125,  52, 190,
  252, 195, 213,  49, 104, 270, 240, 136, 159, 222, 180,  51,  22, 131, 241,  74
,},
{ 284,   4, 227, 130,  88, 167, 110, 112, 232, 102, 215, 286, 146, 185,  71, 124, 305, 218, 168,
  106, 183,   8,   6,  44, 175, 171, 114, 252, 303, 247,  64,  93, 196,  73, 207,  95,  79,   8,
   27,  88, 112,  56, 245, 229, 253,  83,  33,  21, 176, 196, 292, 101, 166, 142, 175, 134, 102,
  148,   1,  92, 286, 225, 115,  77, 237, 154, 112, 300,  71, 115,  83, 286, 252,   8,   4,  65,
   65, 143, 173, 249,  57, 114,  52,  55, 244,  56, 201,  51,  31, 252, 277,  15
,},
{ 265, 282,  12, 128, 291, 213, 275, 109, 295, 198, 182,  79, 154,  89,  32, 245, 151,  55, 234,
   62, 195, 218,  29, 191, 111,  38, 166, 153, 149, 266, 191, 195, 159,  87, 153, 257,  26,   5,
  150, 239, 167, 139, 297, 249,  72, 200, 184, 138, 280, 160, 119, 302, 137, 200, 250, 306,  74,
  205,  59, 260, 199, 301, 180, 234,   7,   2,  15, 243,  65,  68,  90, 125,  86,  25,  54, 268,
   77, 213, 263, 172,  10, 142, 103, 168,  52, 136,  31, 179, 188, 144, 265, 198
,},
{ 121, 300, 142,  56, 227,  99, 165, 139, 130, 276,  26, 106, 240,  77, 157,  57, 233, 228,  82,
  247, 193,  43,   4,  15,  93, 206, 279, 251, 267,  29,  18, 201, 268,  71, 222, 199,  83,  93,
  283, 124, 238, 155,  66, 227,  80, 232, 121,  35,  57, 253, 126, 251, 286, 156, 152, 260, 128,
  267,  74, 285,  76,  90,  14,  93, 231, 282, 132,  25, 211, 271,  45, 276, 248, 221, 141,  39,
   58, 250, 262, 127, 210, 211, 181, 222,  67, 100, 113, 109,  84, 206,  70, 266
,},
{ 299, 106,  53, 167, 189,  90, 295,   4, 130, 182, 262, 234,  37, 273,   4, 234, 106, 200,  41,
  208, 147, 302,  47,  10,  57, 140,  15, 111, 246, 143, 223, 233,  82, 218,  57, 290, 142, 142,
  237,  31, 256, 287, 274,  96, 124, 143, 222, 141, 289, 244, 136, 201, 214, 234,  45,  60, 117,
  133,  60,  21,  13,  35, 213, 139, 182, 157,   7,  40, 258,  35, 237,  53,   4, 234, 259, 279,
  129, 247, 229, 101,  23,  80, 282, 130,  46, 178,  66, 255,  62, 164, 150, 245
,},
{ 235, 164,  32, 278, 136, 184,  12,  74, 230, 291,  56, 292, 227,  27, 230,  83,  61, 116,  52,
  254, 229, 207,  31, 101,  81, 173, 263,  38,  66,  51,  47,   9,  83, 246,  92,  55,  84,  59,
  210, 118, 298,  83, 130, 237,  90,  77,  53,  95, 278, 130, 112, 197, 175,  53, 156, 138,   1,
  162, 112, 197,  29, 258, 221, 110,  19, 130, 138, 100, 295, 209,  36,   2,  61, 185, 269, 273,
  168, 295,  58,   8,  86,  81, 105, 130,  81, 124, 179, 116, 139, 168, 274, 190
,},
{  82,   5, 163,   6,  66,  82,  17, 204, 243,   4, 281,  73, 155, 119, 238, 285, 118, 169, 114,
  142,  51, 263, 166, 123, 131, 290, 212, 143, 166, 109,  58,  69, 231, 135, 236,   9, 102, 170,
  118,  30, 300,  26, 168, 283, 295, 135,  26, 155, 101, 280, 178,  34,  39,  94, 193, 178, 299,
  180,  58, 118, 222, 219, 302,  91,  42,  10, 109, 160,  91, 257,  97, 261,  27,  51, 256, 236,
  118, 303, 280, 250, 153,  37,  44, 244,  92, 248,  12, 105, 214, 240, 128,  92
,},
{ 295, 213,  95,  47,  52,  14,  69, 236,  37,  14, 290, 286, 123,  51, 163, 200, 205, 222,  42,
  303, 299,  61, 269, 175, 186,  48, 157, 267, 289, 287,  93, 227,  44, 156, 114,  31,  77,  37,
   79,  47, 228, 220,  51, 213, 282, 236, 120,  56, 229, 228, 258, 137, 132, 268,  81,  55, 117,
  153,  23, 132,  17,   7, 250,  29,  71, 238,  58, 278,  49, 134, 206, 109, 160,   6, 108, 156,
   64, 248, 118, 192,  94, 265, 297, 121, 287, 105, 197, 225, 188,  27, 156, 237
,},
{ 196, 202, 278, 250,  12, 185, 124, 176, 303, 298,  50, 106, 288,  82, 151, 272,  74, 246,  45,
   25, 297, 238, 270, 122,  67, 109, 276, 282, 236, 257, 139, 198, 226,  41, 192, 290,  46,  13,
  193, 113, 190, 102, 221, 237, 127, 120, 174, 244, 280,  99, 178, 109, 276, 178,  71, 186,  28,
  148, 159, 247,  42, 254, 217, 104, 151,  42,  68, 163, 249,  63,  46,  10,  19, 196, 303, 104,
  100, 192, 302, 225, 284, 209, 214, 165, 135, 177,  17,  95, 302,  70, 171,  13
,},
{  25,  51, 168,   8, 103,  18,  33, 205,  89, 294, 265,  14,  53, 300, 195, 179, 234,  62, 178,
   35, 184, 225,  72,  21, 221, 112, 207, 187,  29, 163, 188, 273,  71, 152,   8, 133,  46, 207,
  177, 213, 161, 152, 229, 204,  60, 122, 228, 265, 141,  41, 196, 289, 263, 285,  26, 205, 134,
  281, 296,  56, 176,  55, 215,  95, 248, 152, 249, 202, 164, 185, 246,  21, 246, 293, 154, 102,
   53,  85, 296,  76, 243, 153, 179,  28, 101, 287,  53, 264,  50,  52, 245, 123
,},
{  24,  70, 178,  93, 223, 207,  44, 209, 232, 240,  29, 255, 221, 261, 212, 271,  32,  26,   9,
  107,  28, 164, 213,  54, 202,  80,  71,  97, 202,  94, 195, 157,  16, 221, 194, 111, 304, 176,
   82,  12, 124,  14, 102, 139, 206, 178, 152, 168, 117, 194,  85, 278,  93, 112,   4, 302,  20,
  119, 288, 148, 258, 299, 300, 147, 135, 163,  56, 218, 117,  78, 287, 222, 223, 288, 179,  47,
  139, 100, 148, 165,  81,  19, 247,  25, 249,  75,  82, 241,  98, 117, 220,  27
,},
{ 170, 266,  23, 184, 260, 141,  33, 165, 170,  48,  77, 214, 263,  57,  47,  34,  74, 196, 239,
  248,  83,  91,  79, 239, 236, 201,  71, 264, 280,  74, 116,   1, 153,   4,  58, 284, 171,  48,
  186, 218, 277, 234,  18, 232, 102, 172, 237,  34, 143, 211, 301, 103, 220, 277, 245, 117, 194,
  144, 143, 263,  95, 285, 218,  23,  21,  19,  97, 169, 102, 173,  33, 117, 169,  60, 248, 163,
  130,  37,   9, 269, 226, 234, 122,  26,  81, 116,  30, 288, 242, 240,  79, 262
,},
{ 126, 176, 242,  13,   8, 192, 124,  36, 230, 272, 115, 178, 303, 127, 209, 139, 260, 210, 148,
  250, 288, 285,  28, 138,  38,  33, 216, 261, 266,  84, 242,  30, 110, 173,  71, 215, 184,  86,
  236, 164, 288, 196, 125,   6,  89, 261, 176, 229, 178, 191, 135, 271, 302, 118, 260, 159, 297,
  192, 104, 287, 249,  50, 113, 168, 233, 112, 129,  11, 260, 111, 248, 214, 103, 236, 229,  70,
  127, 300, 291,  12,  65, 278, 267,  81,  35,  98, 191,  96, 184, 210, 201,   9
,},
{ 159,   2,  58, 244, 171,  83, 134,  62,  23, 271,  13, 279, 283, 146, 158, 252, 278, 110, 281,
   23, 242,   2,  52, 139, 301, 140,  30, 178,  15, 121, 296,  75, 131, 106, 221, 101, 235, 201,
  294, 179, 150, 120,  95,  66,  96, 180,  76, 239,  16, 107,  22, 141,  47, 261,  60,  93, 123,
  236, 200, 198, 167, 258,  23, 123, 126,  92,  90, 269, 177,  74,  96,  89,  94, 151,  18,  19,
  200,  93,  65, 229, 237, 116, 210,  91, 202,  93,  83,  55, 301, 129,  95, 215
,},
{  12,  28, 219, 174, 198, 223,  96, 222, 229, 252, 292,   8, 229,  80, 102, 196,  25, 174, 237,
   92, 173, 232, 303,  43,  76,  77, 273, 282,  32, 201, 137, 127, 100, 206, 127, 119,  33, 300,
  292,  58, 288, 230,  95,  50,  67, 155, 195,  46, 165, 196, 129,  63,  43, 125, 274, 198, 154,
  269,  86, 126, 299,  75, 227, 296, 143, 237,  44, 228,  73, 134, 125,  84, 190, 115,  94, 118,
  191,  70, 278, 153,  78, 125, 163, 133,  48, 189, 144, 177, 279, 181, 213, 293
,},
{ 162, 239,  41, 250, 167, 286, 245,  56, 174,  97,  75,  71, 254,  98, 100,   1,  48, 156, 200,
  295, 275,  38, 151,  28, 267, 122, 184, 298, 153,  87, 110, 158,   4,  38,  29, 285, 122, 143,
  147, 176, 148, 140,  46, 255, 217,  96, 204,  97, 275, 139, 186, 222, 275, 175, 147, 295, 254,
  283,  86,   8, 108, 285, 117,  75, 259, 260, 203,  65,  38, 260,  55, 270,  66,  13, 113, 216,
  291, 278, 265, 238, 110, 101, 299, 198,  13,  26, 110, 185, 131, 194,  87, 123
,},
{  24, 207,  59, 273, 158, 271,   5, 114,  83,  18, 139,  65, 278, 155,  10, 176, 161, 147, 103,
  129, 288, 255,  26, 133, 209, 126,  81,  74,   6, 218, 119,  79, 208, 154,  80, 132, 149, 252,
   18, 289,  87,   1,  90, 263, 257,  28, 126, 144, 256,  21, 183, 268,  26, 124, 201, 116, 110,
  239, 290, 245, 210, 231, 223,  49, 115, 174, 164, 172, 287, 259,  55,  31, 165, 108, 206,   6,
  253,  31,  34, 134, 243, 193, 195, 145, 112, 294, 128, 298,  19, 198,  55, 176
,},
{ 244,  21, 219,  64,  54, 192, 126, 157, 235,  32, 138, 242, 174,  39,  79, 271,  63,  93, 171,
  251, 109, 187, 133, 150,  80, 157, 272, 293,  73, 104, 134, 162, 178, 198, 274, 155, 182,  38,
  158,  29, 254, 281, 209,  96, 181,  24,  26, 130,  72, 232,  59, 198,  15,  77, 286, 244,  26,
  111, 259, 218, 252,  79,  10, 248, 251, 223, 119, 207, 280, 129,  68, 118,  38, 285, 177, 295,
   24, 168, 211, 186, 236, 217,  23,  62, 294, 257, 103,  95,  43,  35,  64,  90
,},
{  55, 232,  69, 239, 109, 190, 226, 120,  27,  31, 205, 243,  64, 139,  42, 202, 126,  98, 189,
  149, 171,  12,   6,  15, 245, 179, 127, 199, 289, 158,  75, 306, 251, 138,  64, 267,  48,  45,
  276, 202, 196, 109, 192, 233,  75, 170,  16,  42, 149, 283,  77, 119, 107, 219, 111, 151, 191,
   30, 191, 278, 246,  35, 116, 110, 135,  69,   3, 291,  25, 262, 286,  13, 146, 211, 254, 226,
   60, 298, 274, 205, 287, 132, 151, 105,  44, 260, 107, 278, 303, 107, 113, 204
,},
{ 227, 212, 218,  12,  34, 274,   1, 151,  30, 240, 198, 136, 167,  87,  23, 198,  78, 103,  70,
  221,  70,  33,  52,  66, 128, 101, 111, 289, 149, 277, 256,  76,  37,  58, 305, 130,   4,  24,
  257, 212, 294,  72,  71, 185, 124,  91,  70, 216, 126, 177,  34, 213,  56, 201,  30, 112, 256,
  241, 109, 275,  14, 143,  37, 138,  79,   9,  82,   4, 165, 107, 229,  59,  56,   6, 284,  99,
  205, 108,  88, 199,  86, 215, 228, 255, 187, 233, 227, 299, 115, 182, 161,  21
,},
{  64,  40,  39,  18, 176, 209, 241,  61, 223, 228,  45,  69,  74, 210,  57,  21, 113,  35,  64,
  290, 100, 119,   1,   4,  37,  59,  94, 227,  22, 220, 260,  71, 107, 130, 170,  68, 279, 146,
  100, 124,  77, 209,  41, 138,  88, 234, 171, 217,  26, 165, 192,  48, 202, 165, 168, 152,  28,
  216,  55, 226, 302,  35,  80, 265,  40,  57,  60, 204, 289,  38,  72, 165,  86, 168,   9, 101,
  300, 228, 276, 148, 110, 205, 261,  22, 128, 220, 198,  12,  61,  89,  16, 296
,},
{ 215,  45, 116, 173, 166, 289,   7,  78, 111, 207,  67, 288,  43, 300, 138, 175, 124, 194, 187,
  285,  61, 279, 165,  70, 180, 117, 165,   4,  16, 131, 302, 123,  84, 146, 276,  31, 180, 190,
  267, 272, 107, 180, 196,  79,  28,  45, 119,  94,  68, 181, 201, 287,  83, 218, 270,  31, 196,
  239, 138, 213, 168, 291,  68, 136, 214, 110, 118, 230, 274, 107, 261, 164, 107, 232, 298,  61,
  215, 171, 140, 113, 180, 150, 254, 135, 147,  23, 136, 296, 239,  60,  59,  33
,},
{ 276, 272, 124,  21,  36, 134, 281, 189, 235, 159,  76, 259,  59, 286, 209,  91, 173, 188,  45,
  138,  51, 138, 141, 265, 156, 247, 106, 128,  23, 303, 192,  99,  84, 274,  15,  79,   2, 140,
  134,  58,  16, 105, 219,  82, 102, 157,  83,  43, 234, 217,  73, 223, 182,  35, 210,  67, 206,
  177, 166, 278,  80, 201, 192, 207, 289,   4, 234, 222,  20, 206,  52, 292,  31, 283, 149, 142,
   26, 295, 128,  15,  17,  60,   3,  18,  67, 155, 275, 149, 229, 242, 150,   8
,},
{  39, 234, 133, 194,  25, 205, 253, 260,  41, 135, 304, 290, 250,  90, 143, 179,  44, 142, 217,
  275, 165, 172, 272,  35, 137,  42, 142,   4, 114, 167,  48, 180, 257, 251, 112, 144, 165, 290,
   52, 288, 182, 276, 254, 303, 162, 217, 129, 139, 263, 205, 135, 283,  58, 282, 154, 198,  35,
  220, 150,  79,  69,  88, 177, 235, 272, 266, 155, 222, 199, 264, 295,  13,  83, 176,  21, 167,
   87,  64,  52, 107, 215, 267, 136, 290, 262, 255, 244, 120, 263, 146, 208,  26
,},
{  50,  56, 166, 207, 207,  37, 208, 108,  86,  23,  69, 232, 184, 274,   9, 199, 103,  20,   6,
  197, 286,  21, 147,  81, 233, 227, 238, 271, 112, 275,  29,   9, 233, 109, 185, 301, 270, 180,
    4,  92,  77, 106, 223, 220, 256, 152, 126,   4, 240,  92,  92,  50, 284,  76, 285, 115,  94,
  234, 209, 251, 244,  95,  10, 240, 216, 274,  66, 116, 224,  71,  16, 245, 178,  17,  92, 233,
   65,  57, 272, 214, 143, 260, 207,  71, 162, 259,   7, 124,  30,  70, 189, 112
,},
{ 239,  76, 259, 225, 263, 117, 168, 221, 185, 221, 211, 302, 106,   4, 114, 203, 155, 283, 119,
  156, 268, 138,  55, 198, 131, 172, 292,  38,  75, 286,  82, 168,  72, 115, 297, 149, 277,   4,
  176,  11, 293,  33,  43, 171, 112,  24,  67, 296,  14, 141, 172, 269, 196, 149, 207, 117, 281,
  290, 163, 219,  88,  49,  66, 305, 229, 201, 239, 205, 101, 263,  89,  84,  82,  59,  33,  37,
   77, 290,  32, 285, 251, 266,  96, 234, 110,  31, 277, 293, 185,  96, 208, 295
,},
{  95, 302, 131, 154, 219, 163,  92,  46, 136,  28, 157, 197, 162, 213,  65, 159, 120,  48,  86,
   81, 269, 240, 244, 214,  83, 302, 176, 138,  59, 166, 208, 100, 238, 282,  51, 257,  20, 152,
  136, 252, 132, 210, 270, 224,  51,  93,  66, 290, 273, 211, 264, 164,  56,  46, 124, 225, 165,
  260, 177, 140,  72,  76,  85, 155,  54, 110, 128, 257,  86,  42, 283, 301, 244,  18, 145,   6,
  273,  20, 194, 217, 292, 183, 152, 126, 175, 135,  51,  49, 122, 156, 147,  87
,},
{   2,  22, 287,  48,  44,  23, 114, 209, 125, 123, 185, 105, 291,  77,   1, 276,  70, 205,  18,
  208, 106, 165, 239,  89,  50, 148, 273, 218, 216,  90, 271, 231,  53,  97, 132,  34,  41,  82,
  116, 199, 219,  43, 257, 109, 173, 112, 249,  61,  73, 303,  10,  15, 250,  69, 304, 147, 184,
   87, 235, 267, 208, 159, 122, 284,  56, 226, 102, 151, 122, 130, 204, 281,  62,  94, 162, 264,
  137, 149, 102,   4, 243, 171, 242,  88, 170, 224, 297, 169, 291, 102, 170, 180
,},
{ 110, 285, 118,  20, 138,   9,  91, 102, 256,  24, 162,  88,  56, 221,  83, 247, 293, 140,  90,
  281,  48, 219, 110,   3, 279, 248,  88, 127, 210,  79,  32,   1, 102, 280, 136, 118, 127,  74,
  251, 204, 226, 236, 172, 305,  67, 151,  96, 281,  99, 188, 300, 130, 140,  44, 137,  34,  41,
  192, 247, 273,  16,  81, 233,  15,  58, 306,  93, 139,  94,  86, 137,  94,  30, 101,  32, 260,
  101,  71,  54,  90, 206,  35,  39,  99,  52, 102, 231,  33, 278, 112, 258, 143
,},
{ 275,  50, 218, 218, 245, 204, 179,  61,  66, 157, 275,  73, 119, 188, 236,  84, 136, 161,   6,
  287, 188, 177, 235, 134, 171, 160,  98,  30, 107,  21, 241, 278, 139, 209, 224, 101, 197,  56,
   36, 164, 118, 115,  98, 292, 200,  12, 111, 176,  69, 233,  27, 293, 289, 239, 214,  76,  76,
   61, 285,  35, 106, 159, 266, 119,  64,  69, 127,  32, 150,   4, 257, 169, 234, 281, 253, 277,
    6, 243, 294,  24, 288, 300,  12, 142,   9, 189, 273, 185, 152, 291, 195,  37
,},
{ 142,   4, 213, 158,  83, 144, 102, 197, 144,  64, 252, 267, 300, 224, 179, 174, 212,  31, 180,
   72, 220, 172, 106, 282, 156, 181, 250,  10,  42, 159, 108,  32,  11, 259, 304, 245, 115, 301,
  263, 211, 277, 246,  75,  26,  48, 233,  36,  63, 119,  50,  84, 154, 259, 291, 137,   5, 235,
   64, 128, 228, 258, 143,  48, 273, 151, 303, 115, 225, 271, 204, 147, 115,  85,  22,  67, 106,
   61, 105, 232,   5,  28, 293, 191,  73, 196, 111,  25,  55, 175, 267,  57,  82
,},
{  16, 172, 191, 163, 199,  50,  59, 117, 215,  40,  92, 143,  98, 234,  63,  25,  76, 278,  98,
  235, 272,   2, 164,  94, 198,  62, 256, 279,  20, 290,  78, 292, 270, 111, 287, 168,  52, 304,
   13, 153, 254, 179,   8,  15, 232, 229, 253, 303, 169,  52, 284, 241, 228,  56, 206,  14, 291,
  225, 171, 234, 158,  33, 204, 105,  95, 299, 239, 299,  66,   9, 272, 131,  45, 113, 253,  98,
  233, 297, 147, 247, 213, 288, 151, 293, 118, 281, 179,  48, 149,  15,  72,  14
,},
{ 145,  96, 159, 160, 170, 111,  28,  99, 165,  40, 217,   6, 204, 229, 214, 164, 173, 252, 252,
   40,  52, 100,  83, 132, 177, 152, 262, 231, 101, 272,  74,  57, 108,  25, 288, 129, 165, 249,
  150, 129,  63,  95,  56, 155, 155, 203, 180,  44,  74, 195,  62, 191,  29,  96,  34, 185, 265,
  162, 101, 249, 252, 172, 298,  49, 142, 285,  26, 218, 182, 186,  88, 127, 149, 222, 115, 131,
  232, 146, 102, 187, 290, 190, 114, 116, 106, 140,  53, 138,  94, 234, 109, 162
,},
{  99,  62, 121, 195, 241, 292, 295, 140, 172, 289, 290,  99,  54, 141, 173,  67, 210, 236, 302,
  151, 203, 123, 204, 239, 303, 171,  98, 192, 101, 254,  97, 138,  33,  36, 275, 214, 182, 164,
    2,  45, 184, 109, 119, 222, 240, 258, 250,  86, 201,  24, 223, 170, 150, 212, 280,  98, 151,
   88, 306, 258, 238, 107, 300, 171, 214,  60, 196,  90, 136, 211, 223, 296, 116,  92, 289,  19,
   15, 234, 214, 214, 246, 287, 194,  16, 145, 229, 177,  61, 144,  25,   6,  54
,},
{  33, 276, 275, 133, 222,  77, 251, 230,  62, 111, 270,  46, 115,  33,  20, 124, 287, 231,  48,
  166, 103,  22, 260, 256, 296, 301, 153, 177, 251, 152, 298,  16, 130,   9,  17, 148,  27, 284,
  184, 274, 268,  97, 117,  72, 148, 172,  69,  14,  36,  82, 238, 259,  54, 211, 171, 199, 189,
   92, 136, 256, 152, 292, 252,  53, 226, 289, 235, 115, 165, 248, 121, 190, 190,  97,  12, 257,
  185, 118,  52, 149,  29, 245, 186,  59, 128, 186, 139, 282,  63, 121, 256,  90
,},
{  55,  21,  17, 295, 178,  51, 111, 245, 100, 165, 284,  68, 175,  80,  36, 143, 286,  15,  20,
   26,  86,   6, 148, 142,  44,  88, 271,  80, 173,  29, 123, 163, 105,  90, 182,  10,  41, 197,
  215, 228, 134, 123,   8, 141,  51, 137, 164,  85,  33, 247, 234, 298, 168, 258, 245,  36, 146,
  193, 172, 155, 284, 242,  22,  45, 247,  44,  69, 100, 240, 147,  98,  66, 218,  56,  66,  61,
   22, 152, 224,  46, 250, 232, 179, 268,  41,  94,  36,   7, 183, 127, 199,  89
,},
{ 242, 125,  48, 105, 186, 101, 262, 146, 287,  62, 128, 132,  83,  21, 216,  86, 119, 133,  69,
   46, 288,  89, 192, 120, 253, 234, 263, 134,   1, 240, 147, 143,   2, 236,  53, 274, 276, 175,
  139, 163, 226, 110, 284, 175, 110,  64, 286, 173, 230, 286, 179, 191, 266, 206, 162, 265, 294,
  225, 238,  10,  94,  66, 282, 155,  39, 183, 304,  89,  36,  38, 101, 163,   5, 181, 288,  36,
  255,  61, 250, 259, 122,  38,   3, 110,  66, 137,  48, 192, 124, 219, 286, 201
,},
{ 174,  31,  48, 195,  52,  19, 136,   3, 265,  77, 213, 209,  21,  56, 304, 153,  18, 146, 286,
  245,  72, 143,   2, 215, 281,  75, 167, 233, 166, 242, 165, 306,  45,  15,  80, 109, 209, 144,
  113,  94,  55, 158, 208,  92,  36, 198, 128, 158,  21,  77, 298,   6, 305, 169, 241,  14,  75,
  262, 199,  86,  93, 295,  77,  96, 138, 267, 101, 156,  10, 180,  10, 234, 246, 156, 122, 203,
   74, 212, 134, 298,  65,  33, 259, 268, 254,  31, 109, 183,  63, 226, 209,  87
,},
{   2, 101,  16, 272,  85, 163, 277, 253,  82, 252, 234, 161, 303, 243, 151, 208,  64, 103, 116,
  101, 270, 275, 142, 154,  51,  39,  46, 209,   4, 197,  40, 188, 259, 211, 172,  63, 200, 271,
  108, 176,  61, 273, 205,  47,  41,  97,  47, 123, 248,  51, 183,  49,  92,  11, 120, 264, 280,
  304, 237, 289, 154, 180,  34, 276, 304,   3, 259, 124,  21,  54,  35,   8, 302,  96, 300, 241,
   27, 257, 294, 251,  17, 251,  92, 195,   5, 303, 193, 227, 118,  43, 240, 242
,},
{ 182, 113, 271, 138,  86,  55,   2, 179,  74, 127, 110, 107, 119, 243, 292,  11,  91, 124, 136,
  166, 227,  16, 184, 159, 273, 133, 163, 184, 246,  62, 235, 291, 209,  15,  69, 160,  55,   9,
   65,   8, 243, 251, 252, 290,  11,  66, 171, 206,  24, 215, 180, 242, 200,  47, 157,  64, 217,
  243, 178, 138,  30,  89,  68,  30, 170, 299, 196, 203, 119,  34,  60, 160,  56, 160, 306,  77,
  189, 102,  44, 196, 161,  58,  94, 101, 208, 166,   2, 186, 145, 140,  89, 173
,},
{ 191, 118,  62, 173,  71,  95, 134, 277, 202, 214, 231,  56, 181, 137, 259,  27, 261,  73,  22,
  121, 251, 119,  74, 271, 154, 187, 280, 183, 265, 290, 112, 129, 254,  98, 119, 134, 101, 143,
  255,  95,  80, 186, 288,  73, 178, 157, 228, 154, 205, 126, 207, 193, 166,  60, 126,  51, 293,
  136, 158, 177, 185, 203, 184, 192, 246,  18, 149,  90,  51,  23, 155, 176, 207, 160,  97, 158,
  154,  13, 258,  12, 223, 118,  13, 122,   5, 129, 287, 219, 272,  77, 249,  17
,},
{ 198,  25, 168, 134,  28,   8, 156,  51, 116, 143, 100, 302, 152,  55,  25, 272, 119,  80, 173,
  127, 140,  86,  20,  79, 306, 142,  79, 140, 230, 264, 247, 240,  81, 110, 291, 278, 240,  99,
  263,  45, 205, 172, 234,   6, 243,  77, 251,  40, 161, 105, 182, 116, 111, 225, 121, 254, 290,
  246, 117, 165, 155, 202, 152, 237, 215,  82, 147, 277, 233, 109,  97, 264, 154,  93, 294, 212,
  233, 158, 149, 175, 130, 217, 126, 124, 180, 251, 203, 303, 231, 134, 235, 139
,},
{ 102, 159, 181, 233,  50, 163, 272, 290,  89,  67, 168, 211, 184, 115, 295,  41,  31, 156,  85,
  255, 174,  55,  35,  97,   4, 244, 198,  72, 127, 276,  93, 192, 299, 258, 135,  38,   7,  25,
  105,  99, 204, 271, 113,   5, 168, 284,  51, 303,  25, 156, 292,  70, 204, 160, 182,  66,   5,
  303, 199, 102, 256, 294,  92, 170, 100,  84, 288,  92, 146,  21,  82, 302,  48, 179,  69, 223,
  139,  49,  42, 283, 273,  99, 156, 239, 219, 223, 224,  81,  58, 132, 234,  76
,},
{ 217,  10, 220, 232, 271, 274, 219, 226, 112,  60,  63,  52, 279,  18, 138,  10,  55, 197, 278,
  121,  51, 249, 100, 256, 109, 149,  14, 150, 246, 267, 156, 286, 158, 197, 254, 286, 241, 287,
  110,  33,  49, 218, 305, 297, 151, 186,  18, 276, 244, 210, 298, 138, 191, 233, 216,  68,  69,
  138, 200, 140, 112,  25,  66,  40,  20,  35, 137, 174,  27,   8,  99, 172,   5,  44, 146, 240,
  161, 193,  43, 303,  34, 192, 207, 273, 101, 163, 301, 133, 243,  37, 116, 284
,},
{   3, 261, 141, 249,  67, 284,  47, 241, 191, 246, 142, 292, 193, 305,   7, 301,  30,  29, 152,
  154,   5, 202,  94,  21,  10,  53, 259,  77, 267, 139, 271,  37,  62, 100, 279,  75, 269,  27,
  233,  51, 137,  69, 135, 217,  67,  89, 113, 164, 104, 289,  62,  78, 267,  57,   6,  97, 160,
  259, 254,  28, 242,  89,  94, 211,  45, 278,  23,  18, 125,  93, 251,  96, 274,  87, 260, 171,
  283, 282,   9,  65,  35,   6, 127, 111,  32,  21,  99, 171, 189, 213,  58,  12
,},
{ 212, 247, 206, 246, 255, 167,   2, 169,  19,  41,   3, 156, 125,  86, 244, 269,  77, 137, 226,
  190,  41,  33,  96, 242, 136, 146,  49, 106,  56, 176, 217, 253, 274, 159, 164,  12, 204,  87,
  202, 157, 237, 220, 139, 261,  30,  86,  47, 197, 187, 214, 166,  70, 291, 110,  82, 295,  49,
  181,  65, 277, 175, 254,  53,   5, 155, 164,  44,   5, 137, 184,  73,  39, 243,  31,   1, 287,
  242,  33,  71, 131,  58, 103, 120,  97, 170,   7,   1,  20,  35, 218, 162, 179
,},
{ 297, 270,  15,   7, 182,   7, 105,  31,  81,  84, 177, 263, 300, 243, 225, 110, 100, 266, 287,
  230,  65, 254,  38, 257, 141, 118, 291, 146,  23, 208, 265, 102, 181,  58, 295, 249, 171, 201,
  267, 194,  15,  68, 292,  23, 209,  32, 227,  72,  54,  37, 298, 183, 254, 226,  48, 274, 193,
  132, 306, 229, 244,  47,  24, 286, 193, 216, 204, 236,  66, 224, 295,  83,   6,  72, 232,  20,
  246, 248, 237, 100,   1,  49, 115, 133, 184, 232, 118,  25,  38, 135, 148, 304
,},
{ 254, 236, 207, 219, 159, 157, 231, 228, 240, 272,  68,  20, 228, 250,  28,   6, 166, 150, 140,
  124,  28,  58, 127,   1, 305, 107, 119,  99, 228, 276,  35, 116, 273,  80,  42, 285, 140,  63,
  234, 286, 301,  71, 204, 107, 300, 281, 196, 206, 143, 180, 298, 296,  53,  63, 143, 206, 286,
  111,  27,  70, 269, 241,  56, 123, 300, 240, 121,  55, 283, 128, 229,  41, 123, 297, 247, 302,
   79, 155, 224,  53,  25, 291, 174, 276, 195, 267, 237,  61,  59, 261,  71,  41
,},
{   8, 269, 176, 182,  86, 296, 268,  85, 237, 188, 286, 167,  89, 195,  16, 258, 264, 199,  30,
   14, 224, 226,  54, 121, 266, 258, 298, 287, 104,  45,  82, 127, 235,  16,  94, 281,  35,  81,
  226, 179, 154, 252, 259, 174, 210, 237, 291, 176, 259, 263, 297, 223,  26, 105, 174, 235,  42,
  281,  11,  80,  35,   3, 118, 238,  34,  67, 208, 213, 129, 152, 162, 221,   6, 137, 259, 109,
  212, 197, 176,  78, 157, 155, 220, 225, 145,  84, 301,  95, 108, 286,  10, 203
,},
{ 107, 247, 234, 187, 130,  38, 284, 234, 167,   2, 145, 267, 284, 300, 212,  99, 255,  53, 129,
  110, 277, 186,  19, 204, 250, 213,  88,  89, 162,  74, 290, 238, 222, 213, 280, 259,  84, 282,
  304,  66, 102, 151, 157,  88,  55, 250, 294, 177,  79,  22, 101,  23, 219, 261,  93,  23,  37,
  167,  18, 221,  34, 238,   8, 173,   7,  26, 253,  57, 205,  27, 223,  55, 175, 270, 166,  25,
  210,  25, 286, 142, 241, 284,  88, 173, 123, 157, 155, 167, 148, 266, 114,  87
,},
{   2,  34, 232, 151,  77, 241, 296,  94,   6, 154, 159,  93,  54, 199,  88, 116,  10,  33,  23,
  251, 135, 173, 185, 171,  40,   8, 184, 130, 167, 193, 179,   6, 191,  81,  63, 263,  43, 146,
  246,  60,  33,  13, 198, 303,  37, 116,  99, 289, 267, 109, 128, 159, 109, 232, 212, 116, 289,
  266, 142, 108, 289, 121, 284, 207,  74, 179,  18, 276, 229, 249, 189, 221, 123,  25, 107, 285,
  156,  86, 107,  96, 168, 120,  36,  24, 217, 172,  12, 273, 102, 128, 280, 147
,},
{ 141, 228,  51,  60,  71,  74,  10, 102, 291, 164,  17, 177, 273,  48, 296,  74, 135,  16,  67,
   28,  18, 171, 256, 156, 275, 171, 266,  75, 103,  50,  74, 112, 223, 228, 251, 246,  78, 116,
   64, 236,  36,  52, 103,  53, 238, 193,  62, 207, 187, 233, 214, 226,  82, 258,   1, 145, 142,
    9, 192,  40, 297, 129, 294,  38, 135, 227, 229, 258, 122, 261,   4,  48, 103, 293,  46,  54,
  157,  10,  34, 220,  87,  80, 135, 129,  56, 141, 234,  42, 142, 227, 194, 304
,},
{ 254,  80, 165, 255, 212,  46, 298, 133,   4, 175, 148, 167, 142, 223, 140,  77, 130, 185, 197,
  211, 133,  11,  44, 219, 204, 241, 172,  74, 157,  49, 184, 232, 283, 122, 212, 241, 137, 277,
  149,  83,  36,  92, 188, 225,  23,   3,  50,  41, 278,   6, 187, 212,  96, 198, 175, 159, 157,
   60, 211, 263,  80, 294, 138,  86,  52, 182, 132,  80, 305, 184, 266,  57,  88,  87, 161, 116,
  113,  66, 293, 157, 145,  70, 205, 296, 191, 139, 146, 177,  76,  58, 163,  87
,},
{   2, 181,  65,  82, 145,  16, 304, 108, 212, 298,  25,  96, 261,  57,  11,  44, 295, 215, 155,
   12, 236,  29,  10, 196,  55, 269, 212, 214, 152, 188, 154, 207, 185, 142, 279, 195,  25, 199,
  241, 212,  50, 254, 139,  27, 174,  84, 159,  45, 131,   1, 112, 245, 298, 109, 149, 198, 118,
   79,  35, 301,  24, 167,  33,  30, 294, 224, 174, 155, 252,  42,  39, 264, 125, 245, 231, 280,
  247, 296, 148, 103, 183,  24, 129, 141,  33, 240, 301, 264, 112,  56,  72, 196
,},
{ 188, 201, 306, 245, 180, 141,  15, 250, 166, 218,  13,  49,  29, 253,  84, 197, 274, 303, 158,
  264, 213, 284, 242, 176, 130,  25, 306, 169, 178, 303, 234, 167,  87, 132, 164, 216, 153,  20,
  192,  23, 180, 280,  67,  48, 145,  75,  12, 303, 216, 188, 141,  38,  40, 292, 108, 162,  28,
  154, 185, 206, 246, 220, 193,  12, 241, 191,  86, 187,  52,  90, 227, 158, 209, 147, 273,  58,
    7, 257,  22,  94,  91, 168,  44, 253, 286,  34, 118,  34, 294,  74, 144, 104
,},
{ 200, 256, 236, 295, 297, 228, 153,  49, 168,  94, 261,  32, 239, 125, 236,   1, 200, 178,  66,
   78,   1, 251, 184,  92,  47, 183, 195, 208, 294, 208,  58,  78,  72, 109, 175, 306, 106, 213,
  104,  45, 100, 183,  68, 238, 167, 105,  18, 126,  93, 146,  43, 108,  42, 112, 304, 259,  53,
  210, 110, 282, 252,  43, 215, 138, 243, 249,   5, 237, 195, 154,  19,  27, 204, 252, 118, 200,
  264, 194, 168,  56, 238, 271, 235,  91,  48, 274, 270, 252, 288, 136, 246,  67
,},
{  58, 232, 128, 285, 175, 139,  35, 169, 191,  98,  42, 288, 302, 230, 117, 215, 183, 209, 229,
  227, 189,  55, 222, 294, 248,  90, 263, 185,  14, 272, 183, 111, 250, 281,  57, 296, 182,  62,
   90,  89,   9, 282,  11,   4, 294,  94,  24, 180, 280,  42, 150, 190, 146, 112, 226,  50, 298,
  247,  99, 264, 105,  12, 149, 153,  30,  12,  17,  58,   6, 243, 247, 268, 157, 152, 130, 192,
    8,  45, 116, 184, 196, 106, 140, 221, 139, 241,  60,   8, 209,  15, 235, 282
,},
{  70, 266,  14, 293, 119,  69, 266, 139, 171,  43,  67,  64, 201,  90, 178, 134, 170,  88,  80,
  201, 181, 233,  20,  16,  80,  67, 303, 198, 152, 178, 263,  67,   1, 227, 250,  76, 104, 203,
   30, 146, 162, 271,  85, 209,  61, 280,  28, 156, 260, 102,  68,  31, 130, 294, 239, 110, 150,
   24, 293, 179, 188,  80,  87,  53,  65, 217,  39, 208, 245,  11,  80, 177, 192, 126, 280, 304,
  172, 273, 152, 220, 173, 259,  22,  49, 226,  12,  78, 199, 189, 123, 198, 162
,},
{  99, 294, 291,  50,  67, 241, 253,  71, 212, 295, 293, 256, 112, 138,  34,  31, 180, 233, 138,
  286,  57, 252,  30, 176, 187,  74,  13, 233,  68, 305,   3,  20,  43, 236, 170, 176, 129, 103,
  263, 232, 201, 208, 295, 251, 294, 164,  20, 241,   6, 210, 130, 176, 297,   6, 171, 303,  76,
  280, 168, 143, 168,  43, 208, 267, 218, 290, 128, 103, 126, 274,  48, 288, 166, 135, 193, 184,
  188, 174,  34, 264, 279, 170, 263, 231,  78,  42,  49,  86, 205, 120, 202, 143
,},
{ 275,  39, 227,  84, 275, 133, 104, 223,  35, 113, 239, 204, 287, 244, 153,  35, 227,  48,  99,
   28, 193, 186, 268,  54,  37,  68, 231, 262, 213, 186, 160, 249, 158, 150, 180, 135, 255,  58,
   65, 176, 146,  90,  70, 108, 146, 239, 124, 100,  29, 140,  49, 123,  28,  89, 176, 110,  38,
   96,  66, 263, 283,   4, 228,  94,   9, 229, 111,  67, 114,  36, 138,  80, 121, 110, 287, 131,
  237,  23,  90,   4, 155,  66, 147,  59, 141, 215, 213,   3, 205, 218, 203, 288
,},
{ 176, 298, 254, 291, 228, 219, 119, 269, 114, 119, 114, 268, 187, 175,   8, 301, 185,  32, 171,
   90,  79, 251,  98, 136,  51, 231, 279, 243,  65, 178, 216,  35, 104,  30, 151, 219, 161, 185,
  267,  83,  35, 296, 235,  24, 225, 295, 152, 298,  38, 213, 258, 241,  16, 251,  75,  51, 186,
  235,  45,   4, 107, 264,  61, 241, 285, 102, 139, 293, 160, 302, 170, 269, 231, 122, 195,  14,
  300,  70, 178, 255, 143, 252,  39,  41, 247, 155,  42, 159, 116, 287, 222,  37
,},
{ 142, 212, 154, 194, 156, 127, 117, 137,  45, 112, 214, 106, 188, 292, 166, 253, 122,  80,  51,
  237,  23,  63, 180, 145, 158,  61,  14, 191, 255, 117, 265,   7,  75, 224, 125, 172, 233, 265,
   85, 135, 196, 163, 256, 163,  87, 258,  12, 104, 241,  19,  64,  78, 207,  18, 149, 173, 210,
  174, 302, 295, 227, 144, 153,  68, 273, 217, 148, 237, 225, 214, 138,  28, 185,  19, 215,  48,
  105,  92,  59, 196, 259, 148, 143, 100,  95,  42, 298, 131, 149, 231,  53, 109
,},
{ 186, 107,  45, 110,  95,  41, 175, 253, 116,  64, 284, 290, 252, 265, 224, 141, 265,  45,  53,
   38, 106, 175, 277, 194, 243,  63, 127, 236,  77,  68,  58, 255, 241, 163,  89,  79,  39, 166,
  294, 111, 136, 208, 236,  19,  25, 234,  30, 161, 185, 268,  53, 239,  94, 188,  66, 139,  44,
   17, 305,  76, 172,  29, 124, 240,  71, 305,  87, 138, 269,  19, 237, 259, 212,  50, 210, 230,
  258, 239,  43, 195, 158,  58, 109,  24, 201,  47,  65, 220, 226, 131, 305,  52
,},
{ 100, 220, 278, 193, 136, 119,  47, 192, 212,  80, 239, 140,  78, 300, 103,  29, 296, 217,  80,
   13,  60, 125, 125, 202, 283, 116, 148,  78, 145,  92,  99, 287,  54, 252,  31, 160,  24,  69,
  208,  67, 303, 291, 102, 168, 232,   5,  52,  87,  56, 150,  42, 190, 241, 130, 194, 295, 238,
  135, 302, 200,  99, 224, 180, 250, 202,  75, 212,   9, 142,  13, 137, 137, 282,  80, 189,  20,
   26, 198,  41,  60, 267, 248, 245, 286,  75, 195, 165, 132,  40, 147, 217, 113
,},
{  52,  44, 137, 269,  96, 259,  73,  19,  97, 181, 171, 115, 128,  17,   7,  63, 171,  50,  51,
  182,  49, 119,  99,  86, 236, 131, 283,  12, 264,  30,  59,  83, 293,  72,  36, 203,  70, 101,
   54,   4, 130, 138, 285, 214,  70, 283,  70, 229, 278, 222, 143,  15, 277, 272,  84, 178, 150,
   52,  99, 186, 126, 212, 192, 135, 132,  69, 174, 196, 183,  58, 234,  85,  63,  66, 140, 213,
   49, 179, 181,  13, 122, 191, 247, 116, 202, 121, 109, 163, 284, 134, 204, 154
,},
{  60,  11, 208, 103,  39,  49,  17, 206, 240,  14, 286, 146, 172,  34, 104, 197, 156, 265,  71,
   27,  11, 306,  89,  54,  78,  37, 182,   8, 203, 273, 110, 135, 208,  54, 177, 140, 170,  88,
  249, 102, 242, 223,  13,  60, 219,  58,  51, 227, 166, 257,  25,  41, 139,  53,  30, 160, 176,
  266, 223,  36,  77, 280,  57,  22, 235,  73, 136, 250, 137, 275,   6, 174, 283, 168,  88,  26,
  152,  13, 183,   7, 179, 176, 119, 169, 208, 137,  69, 272,  55, 298, 247, 273
,},
{ 218,  85, 218,  64,  86, 165, 234, 183, 221,  51, 242, 144, 261, 117, 258,  78,  13, 211,  65,
  168, 296,  34, 197,  79, 291, 102, 253, 155, 221, 205,  52, 161, 231, 189, 282, 166, 235, 174,
  155,  55, 189,  58, 127, 270,  27, 114, 177, 120, 213,  59, 145, 207, 205,  21, 238,  81, 296,
  270, 304, 209,  80,  43,  75, 258, 283, 256, 122, 187, 271,  21, 127,  95, 218, 204, 207, 165,
  183, 144,  48,  42,  78, 191, 160, 204,  53,  23, 296,  37, 248,  24, 289, 160
,},
{ 166, 299,  68,  83, 144,  89,  89, 121, 293,  63, 188, 224, 271, 267,  20, 272,  59,   7, 177,
   60,  94, 260, 258, 226, 282, 160, 151,  55, 182,  31,  17, 119, 251, 194,  19,  99,  44, 162,
  256, 165,  79, 170, 275, 272,  28, 178, 168,  69, 222, 247, 261,  47, 284,  56, 252, 305,  55,
  269,  37,  99,  20, 240, 177,  14,  23, 130, 206, 189,  34, 239, 266, 268, 213,  48, 183, 260,
  293,  22, 196, 242,  51, 166, 176,  67, 172, 129, 268, 266, 168, 123, 265, 265
,},
{ 179, 233,  31, 161,  62, 101, 155, 276, 284, 204, 146, 139,  41, 185,  20,  24, 135, 145,  85,
   44, 302, 303,  17,  47, 284, 113, 174, 226, 282,  40,  65,  80,  57,  65, 277, 186, 108,  67,
   10, 215, 128, 249, 232, 141, 159, 115,  18, 181, 142, 144, 217, 233,  69,  66, 122,   8, 166,
  135,  27, 110,  45, 285,  59,  28, 210,  67,  28, 269, 233, 288,   2,  87, 214, 296,  42, 242,
  165, 247, 300,  76, 113, 120,  74, 281,  14, 106, 199,  84, 128, 220, 148, 302
,},
{  14, 282, 128,  64,   5, 225,  65,  53, 215, 193,  75,  89, 183,  60, 236, 269,  15, 116, 242,
   18, 219, 188, 296, 160, 127, 125, 217, 161, 158, 192, 161, 226,  58, 298, 243, 158, 209, 235,
  122, 144, 291, 119, 271,  26,  91, 279, 286, 290, 197,  45, 272,   9, 221, 160,  30, 283,  28,
  234, 267,  43, 279,  40, 300, 224, 256, 186,  11, 189, 245, 234, 194, 295, 256,  85,  76, 261,
  238, 218, 207, 198, 258, 187, 226, 240, 282,  50,  12, 104, 243, 295,  11,  72
,},
{  44, 250, 259, 144, 100, 298,  68, 183, 256, 236, 270, 159,   8, 155,   1, 273, 153,  43,  70,
  163, 261,  80, 166, 263, 236,  22, 101, 220,  35, 226,  46,  53, 113,  26,  68, 176,  11,  38,
   57, 280,  32, 175, 232, 106, 132, 205,  27, 176, 121, 243, 228,  13,  59, 200,   3, 229, 302,
  154, 298,  98,   4,  44, 131,  73, 195,  49,  10, 210, 289, 292, 114, 150, 256,  26, 183, 238,
   73, 273, 180,  18, 156,  52, 257,  46, 287, 132, 237, 152, 209, 110, 296, 123
,},
{  24,  89,  70, 184,  52, 204,  17, 244, 210, 100, 278, 260,  59, 216,  67,  77, 126, 252, 297,
  306, 156, 241,  68, 148, 137,  95, 288, 298, 235, 100, 258,  15, 103, 263,  68, 171,  40, 141,
  220, 199, 191, 192, 125, 142, 108, 250, 235, 274,  28, 174, 287,   3, 124, 215, 226, 279,  44,
  287, 161, 150, 300, 127, 289,  63, 113, 110, 260, 286, 125, 203,  87,  90,  45, 298, 219,  76,
  275, 120,  29,  49,  23, 239, 146, 103, 267, 261, 234, 118, 293, 276, 278,  78
,},
{ 150,  75, 192, 292, 223,  88, 213, 196,  29, 156, 209,  62, 249, 131, 280, 235, 156,  54, 151,
  237,  32,  31, 166, 109, 128, 100,  69,  61,   8, 104, 300, 141, 174, 273,  65,  21, 242,  85,
  204,  33, 180, 270,  33,  23,   1,  78, 284, 167, 270, 129, 142,  32,   6, 178, 224, 109, 274,
   27, 254, 157,  31,  71, 200, 171,   6, 119, 124, 143, 292,  48,  73, 244, 278, 154,  46, 241,
   77, 185, 130, 208, 157, 158,  59, 258,  26, 258, 131, 181, 155,  21,  98, 297
,},
{  28,  49, 172, 258, 287, 242,  16,   9,  74, 154, 205,  95, 150, 287, 233, 164, 217, 118, 248,
   17, 280, 111,  17, 145, 269, 117,   1,  43, 232, 135,  39,   8,  97,  42,  15, 134,  67, 189,
  195, 165, 185, 162,   7, 235, 230, 241, 113, 214, 199,  76,  78,  33,   8, 188, 106, 239, 149,
  103, 291, 286, 188,  21, 101, 223,  13, 265,   7, 139,  95, 294, 167,  45, 275,  20,  21, 177,
  233, 183, 105, 233, 265, 305,  63,  84, 260,  98,  70, 248, 192, 182, 217, 253
,},
{ 274, 158, 143, 160, 231, 144, 283,  81,  87, 135, 173, 142,  79, 171, 101, 282, 251, 196, 306,
   77,  65, 154, 281, 272,  88, 271, 135, 229, 291, 181,  91, 120,  16, 121,  61, 142,  14, 272,
  169, 230, 249, 272, 154,  54,   2, 298, 123,  42, 264,  11, 169,  42, 149, 254, 229, 187, 148,
  208,  55,  34,  85, 134, 183,  41, 168, 245,  90,  88,  64, 290,  77, 200, 151, 294, 100,  53,
   11, 130,  58, 170, 111, 266,  99, 198, 279, 219, 188, 272, 246, 215, 258, 133
,},
{ 303, 113, 188,   2,  73,   9, 242,  49, 230, 113, 128, 277, 261, 249, 288, 293, 153,  81, 256,
   62,  27, 273, 156, 284, 293, 265,  22,  51,  73, 229, 278,  45, 214, 298, 114,  95, 267, 197,
   37,  43, 296, 120, 178, 169, 156, 187, 293, 133, 169, 204, 106,  53, 177, 123,  45, 183, 269,
  304, 258, 182, 205, 218,  42,  92, 239, 131, 261,  44,  51, 283, 273,  81,  64, 144,   6, 169,
   98, 259, 273, 131, 118,  46, 148, 227, 110, 181, 202, 259,  95, 286, 187, 192
,},
{  15, 216, 154,  26,  98, 138, 102,  45, 181, 286, 216,  45,  61,  84, 194, 182,  86,  23, 163,
  250,  96, 168, 112,  68, 282,  13, 201,  30,  22, 152, 249, 297, 153, 231,  94, 140,  10, 118,
  234,  49, 256,  89,  12,  45, 247, 153, 129, 102, 194,  87,  78, 234,  84, 121, 216,  64,  29,
  298, 270,  12,  78,  90, 256, 153, 117, 301,  71, 280, 106,  74, 270, 258, 284, 167, 303, 131,
   77,  89, 260,  76,  19, 285,  28, 282, 250,  17, 168, 166, 232, 252,  84, 281
,},
{ 257, 305, 284,  80,  13,  86, 135, 247, 219, 199,  45, 288, 151,  37, 165, 138, 258, 110, 159,
  183, 239, 240, 193, 303, 177, 192, 124,  72, 229, 168, 290, 288, 244, 301, 297, 212,  14, 302,
   97, 194, 260,  25, 142,  46,  92, 257, 244, 254,   1,  58, 200, 163, 233,  66, 118, 255, 168,
  137,   2, 169, 154,  52, 168, 193, 172, 115, 194, 110, 278, 234,  15,  13,  93,  43, 251,  91,
  233, 107, 188,  98,  40, 281,  38,  93, 103, 253, 265, 288, 256, 118, 209, 180
,},
{ 110, 233,  94,  17, 170, 285, 154, 123, 294, 118, 238, 255, 239,  81,  43, 104, 155,  21, 302,
  115,  23,  45, 185, 264, 186,  68, 132, 285,  64,  92, 110,  20, 159, 164,  33, 283, 305,  47,
  164, 185, 221, 277, 154, 190,   4,  70, 241, 276, 292, 116,  55,  13, 288,  27, 134, 155, 149,
  176, 297,  40, 225,  27, 126,  61, 274, 115, 289, 231,  53, 242, 241, 212,  69, 132, 288,  42,
  235, 167,  12, 176, 300, 139, 149, 202,  57,  35, 260,   1,  90,  77, 274, 182
,},
{  43, 229,  64, 305, 108, 254, 306,  60, 133, 168, 270,  41, 127, 100, 128, 128, 186, 294, 297,
  162, 192, 243, 177,  76, 115, 202, 212, 114, 120, 270,  47, 144,  84,  44,   9, 128, 244, 103,
  194, 137, 243, 303, 213, 223, 168, 241,  47, 287,  62,  16, 246,  74,  20, 107,  48, 168,  41,
    7,  99,  83, 274, 100,  95, 260, 235, 288, 250,  16, 245,  78,  41, 198, 139, 221, 158, 237,
  249,  25,  88, 225, 121,   1,  26,   1, 227,  36, 141,  34, 292, 274,  71, 216
,},
{ 132, 137, 160, 112, 106,  66,  90,  46,  55, 196,  92, 215, 105,  43, 230, 239,  87, 270, 156,
   60, 277,  82, 177,  78, 304, 107, 130, 221,  43,  17, 139,  30, 112, 295, 275, 115, 301,  38,
  183,  54, 108, 202,  28,  25, 234, 203,  99,  24,  87, 200, 258,  83, 224, 264, 250,  31, 225,
  112, 199, 206, 273, 183,  66,  28, 173, 228,  67, 233,   9,  79,  25, 216,  81,  63, 208,  30,
  287,  47, 218, 135,  99, 117, 211, 100, 142,  84, 290, 254,  42, 200, 277, 100
,},
{  27, 221,  88, 114, 162, 223, 172, 288,  38,  33,  13,   4, 256,  32, 251, 162, 112, 160, 172,
  268, 244, 101, 222,  80,  13, 107, 176,  83,  46,   1,  53, 296, 163, 204, 112, 199, 269, 217,
  166, 266,  69, 288,  69, 157, 104, 290, 160, 185,  11, 185,  96, 120,  16, 246,  63, 100, 245,
   93, 235, 186, 203,  66, 190, 143,  73,  39, 120, 224,  99, 296, 117, 305, 213, 205, 165, 126,
  110, 148, 233, 109, 179, 154, 146, 268,  80,  36, 122,  41, 144,  79,  82, 262
,},
{ 126,  33, 197,  78, 245,  94, 206, 175,  46, 140, 100, 114,  93, 120, 184,  36,  81, 248, 112,
  183,   1, 139,  38, 281, 186, 117, 122,  59,  85, 157, 169, 274,  98, 183, 271, 269,  99, 184,
   98, 144,  29, 295, 179,  57,  14, 263, 294, 152,  22,  59, 109,  66,  12, 221, 229, 284, 280,
  243,  53,  72, 172, 158, 201, 140,  46, 164, 149,  34,   8, 108,  64, 298, 291, 280,  67, 294,
   90, 280,  95, 236, 212, 231, 187, 105, 277,  97, 111, 188, 244, 112,  40,  12
,},
{ 212,  63, 285, 302,  84,  38, 119,  21, 260, 203, 204, 114, 254, 293,  59, 139, 119, 188, 138,
  150,  70,  29,  33, 186,  89,  15, 113, 276,  38, 301, 235, 151, 204, 195, 247,   4,  91, 224,
   52,  22,  23, 112,  58, 305, 177,  33, 221,  71, 175, 132, 243, 117, 279, 162, 246, 211, 236,
  301,  49,  76, 219, 184, 122, 112,  84, 165, 237, 131, 153,  67,  88, 159, 138,  48, 194,  94,
   58, 147,  69, 217, 229, 280,  38, 157, 164, 252,  77,  32,  52, 273,  61, 161
,},
{ 286, 211,  67,  82, 229, 300,  92, 272, 266, 243, 243, 136,  48,  72,  63, 146, 306, 301, 196,
   85,  41, 241, 193, 279,  66, 174, 166, 286,  71, 173, 273, 147, 184, 303, 235, 272, 123,  54,
  295, 158, 215, 190,  79,  60,  73, 304, 237, 120,  47, 167, 247, 248, 135, 296, 216, 158, 181,
  134, 103,  25, 283,  73,   8,  28,  77, 120, 249, 149, 167, 305, 208, 109,  59, 178,  71,  19,
  100, 132, 207, 222, 251, 118, 121,  96,   2, 110,  86,  66, 254, 262, 126, 175
,},
{ 124,  58, 202, 140,  16,  50,  25, 285, 258,  74, 153,  89, 131, 304, 129, 251, 154,  50, 283,
   85, 100,  40, 179, 100, 242, 105, 218,   7, 210, 151, 236, 164, 303,  38, 213, 102,  81, 283,
  278, 210, 261, 223,  34, 228, 275, 171, 152, 234, 174,  65, 292, 159,  54,  20,  21, 107,  72,
  257, 119, 157, 250, 151, 162,  66,  30, 303, 238, 140,  68, 132, 218,  84,  27, 276, 203,  81,
  159,  87, 304,  93, 299, 117,  92, 144,  61, 277,  23,  34,  27, 242, 209,  23
,},
{ 304,  80, 234, 173, 305,   3, 277,   3,  13, 124, 299, 231, 255, 105,   8, 273, 231, 180,  95,
  100, 201, 256, 195, 258,  39, 298, 302, 155, 197,  10, 147,  48,  81,  54, 263,  85, 119, 295,
   30,  30, 106, 241, 306, 122, 151,  30, 244,   6,  99, 129, 213, 205,  30, 188, 247, 140,  15,
  189, 141, 291,  55, 273,  82,  17,  61,  79,   8,  50, 189,   2, 196, 221, 289, 252,  60, 178,
   38,  38, 271, 282,  54,  20, 182, 188,  78, 141,  34, 153, 285,  57, 221,   6
,},
{ 106, 119, 206, 133, 176,  48, 169,  31, 199, 245, 156, 306, 301,  48, 228, 139, 161, 131, 125,
  114, 197, 215, 203, 269, 162, 107, 296,  72, 298, 305,  49, 138,  13, 283,  86, 283, 303,  28,
  229, 299, 123, 301, 276,  62, 182,   7,   9, 286, 171, 154, 221, 217, 158, 105,  47, 238, 116,
  179,  92, 306, 211,  61, 255, 191, 296, 274, 269, 306, 263,  65, 299,  90, 141,  14, 209, 227,
   60, 220,  86,  25, 125,  88,  77, 167,  64, 219, 131, 148,  85, 146, 185, 128
,},
{  10,  48,  44,  98, 197, 117, 110, 140, 119, 134, 109, 203, 162, 183, 216,  55,   1, 279, 288,
  121, 239, 291, 210,  42,  63, 180, 269, 199, 155, 146, 216, 164, 210, 229, 147,   1, 124, 306,
  155, 237, 134, 292, 229,  85, 114, 180, 173, 291, 122,  14,  70, 204,  33, 223, 167, 162,  33,
   33,  54, 235,  32,  32, 291,  22,   3, 235, 234,  77, 245, 176, 261, 289, 123,   5, 120, 190,
  268,  54,  16,  57, 155, 134,  76,  64,  80,   2, 108, 107, 130, 292, 216,  43
,},
{ 248, 168,  30, 190, 273, 146, 181, 189, 112,  42, 261, 108, 193,  60, 297, 285,  71, 103, 243,
   66, 151, 237, 167,  24, 275, 141, 268, 258,  47,   8, 272, 305, 169, 225,  49, 188, 233, 137,
  140, 292, 136, 150, 287, 220, 208,   3, 183, 167,  92, 158, 264, 201, 123, 110, 287, 256, 297,
  185,   3, 162,  71,  75, 210, 100,  26, 148, 164,  16, 222, 175,   2,  13, 125, 250,  55, 140,
  163, 242,  91,  95, 211, 194,  82, 122, 301,  16, 135,   4,  29, 106, 186,  10
,},
{ 279,  42,  71, 271, 195, 254, 218,  78,   4, 294, 300,  68,  20, 155, 265, 106, 303, 109, 216,
   70,  23,  72, 251, 188, 171, 286, 240, 294,  87, 227,  73, 257,  42, 301, 176, 287, 142, 286,
   27, 179, 140, 154, 106,  85,  13, 275, 275, 253, 135, 286, 209,  66, 225, 248, 182, 272, 216,
  161, 228, 278, 131,  81,  45, 187, 258,  74, 260, 149,  64, 220,  56,  30, 289,  76,  76, 231,
  148,  57,  15, 295,  38,  63, 289,  57, 120, 229, 204,  18, 300,   2, 217,  31
,},
{  36, 193,  79, 112, 133,  44, 293, 175, 272,  77,  50, 285, 225,  25,  23,  72,  39, 298, 183,
  263, 213, 300,  54, 224, 306, 113,  71,  75, 163,  31, 275, 180,  25, 267,  57, 177,  83,  30,
  252, 240, 199,  73,  79, 278,  88, 190,  13, 185,  31,  61,  45,  25,  79, 152, 287, 289, 148,
   40,  18,   6, 274, 162, 295, 250, 247, 284, 237,  60, 175, 242,  66,  20,  26,  45, 212,  69,
  133,  65, 305, 279, 149,   9, 204,  58, 235,  81,  75, 179,  76, 247, 254, 197
,},
{   1, 153,  32, 191,  57,  35, 173, 198,  61, 112,   2,  24,  25,  29, 226, 282, 181, 235, 283,
  244, 122, 161, 146, 130, 142, 185, 252,  92, 114,  25, 237, 133,   3, 108, 192, 202,  69, 114,
   12, 130,  70,   1, 250, 152,  99, 272, 268, 164, 230,  46, 114,  74,  68, 239, 281, 145, 115,
  109, 181,  63,  40, 164, 185, 241,  47,  26, 280,  95, 146, 197,  16,  65,  54, 258, 117, 118,
  288,  71, 106, 210, 292, 242, 192, 172,  80, 106, 162, 134, 300,  66, 254, 117
,},
{ 225, 231, 154,  58,  96, 111, 202, 288,  29, 287, 122, 292, 161, 133, 125, 171, 247,  73, 237,
  193, 140,  88, 202,  54, 100, 240, 146,  65, 271,  71,  18, 215, 218, 258, 118, 275, 155, 290,
   55, 192, 255,  35, 223,  97,  94,  54,  16, 166, 158, 228, 305, 192, 232, 149,  99, 259, 291,
  243, 213, 175,  38, 157, 120,   8,   2,  56,  47, 258, 104, 184,   2,  98,  40,  64, 187, 150,
  273, 153,  86, 221,  65,  34, 279,  53, 210, 220, 218, 236,  36, 199, 106, 129
,},
{ 130,  85, 177, 285, 276, 250, 303, 132, 204, 105,  54, 119, 262, 162, 168,  25, 219, 246, 272,
  185, 283, 134,  23, 258, 139,  27, 197, 113, 223, 137, 142, 285, 230, 263,  25, 241,  50, 194,
   99, 159, 196, 303,  20, 196, 159,  68,  63, 305, 183, 266,  57,  84, 256, 156,  34,  59,  50,
  133, 153, 230, 297, 167,  77, 161,  20, 130, 150,   7,  79, 201, 276, 179, 220, 114, 214, 247,
   69, 195, 264,  16,  69, 182, 185, 110, 150,  18,   5, 213,   2, 271, 188, 102
,},
{ 267,  55,  78, 302,  29, 205,   2, 112,  87, 157,  35, 173,  81, 120, 104, 246, 270,  54, 232,
  288, 299, 214, 154,  53, 161,  67, 300, 278,  88, 217, 186, 296, 304, 287, 193,  58, 263,  38,
  300,  67, 205, 134, 284, 170, 295, 167,  18, 163,  40, 197, 295, 125, 206, 303, 215, 188, 265,
   75,  19, 195,  98,  92, 168,  88, 299, 264, 290, 304, 251, 120,  31,   9,  47, 150, 304, 290,
   83,  93,  90,  73, 110,  33, 230, 237, 151,  91, 155, 101, 285,  95, 298, 142
,},
{ 155, 289, 274, 246,  66, 189, 245,  13, 248, 154, 198, 303,  90,  94, 268,  32, 256, 257, 185,
  170, 230, 221, 290, 268, 237, 133, 122, 178, 183, 188, 219, 280, 184, 275,  21, 257, 203, 156,
   11, 117, 119, 215, 246, 240,  55, 264, 284,  91,  77, 216, 123, 185,  36, 139,  36,   2, 234,
   53, 133, 240, 246, 240, 280,  87, 244, 121, 258,  77, 126, 284,  88, 183,  60,  88, 258, 163,
  158, 297,   1, 101, 246,  96, 154, 182, 270, 111,  59,  90, 129, 270, 259, 246
,},
{  48, 245, 236, 124,  62, 274, 241, 290,  67, 243, 238, 178, 103, 199, 225, 113,  45, 147, 151,
   43, 156, 190, 197, 254,  16, 262,  51, 209, 208,   6, 252, 157,  73, 177,  52, 227, 292, 156,
  213, 295, 246, 132, 115,  66, 244, 291,  17, 164, 102, 183, 304, 287, 100,  41, 191, 281, 246,
  204,  67, 144,  30, 185, 116, 144, 167,  74, 236, 196, 214, 261, 181,  40, 280, 144, 167,  44,
  237, 252, 116,  46, 111, 105, 284, 153,  10, 218,   8, 128,  65, 263, 299, 130
,},
{ 250, 133, 212, 299, 189, 122, 289, 130,  34, 284, 220, 185, 262, 223, 101, 198,  40, 232,  81,
   51,  98,  50,  65, 163,  16, 159,  14,  82, 135,  92, 237,  57, 115, 254, 154,  76, 243,  60,
  261, 106, 161, 173, 174, 252, 138, 194, 143,   6,  55, 168, 232, 186, 292, 190,  56, 303,  68,
   13, 149, 265,  48, 160, 102, 124,  49, 177, 302,  41, 206, 188, 249, 238, 251, 257,  31, 306,
  148,  87,  64,   5, 226,  29, 112, 266, 127, 302, 206,  22, 292,  21, 171, 126
,},
{  77,  49,  16, 240,  55,  11, 231,  35, 255, 301,  35,  60, 120, 213,  43,  89, 302,  89, 305,
  173, 246,  85, 165,  84, 296, 216, 117,  96,  15, 254, 297,  48, 243,  59,   5, 267,  49, 174,
  209,  77, 217, 265, 294, 269, 284, 184,  60, 104,  94, 289, 258,   9, 120,  25, 299, 174, 106,
  135, 125, 237, 120, 174,  89, 242, 150, 224, 176, 113, 216,  58, 285, 172,  93,   2, 275, 161,
  284, 286, 174, 117,  85,  19, 305, 104, 118,  18,  92, 144, 129, 136, 253,  60
,},
{ 139,  69,  81, 234, 270, 248, 136, 227, 153, 119,   7, 105, 146, 199, 215, 125, 197, 223, 153,
  188, 222,  79, 169, 291,  45,  55, 196, 273, 298, 174,  30, 207,   5, 114,  72, 205, 298,  60,
  128, 136,  86,  18,   1,   3, 255,  72, 281, 173, 219,  30, 288, 298, 153, 256, 150, 209, 241,
  211,  86, 240,  51, 180, 301, 258, 269, 131, 282,  86,  94, 204, 265, 146, 293, 106, 186, 103,
  209, 262, 152, 170,  82, 118, 282, 155,  92, 300, 225,   4,  78, 274, 188, 244
,},
{ 115,  86, 281,  67,  49,  52,  40, 263,  11, 173,  90,  87, 291,  17, 289, 221,  73,  19,  33,
  107, 244,  75, 175,   6,  71, 252,  76, 155, 153,  85, 225, 278, 114,  33,  85, 169,  65, 179,
  139, 220, 234,  34, 111, 107, 294, 232, 139, 147, 129, 102, 292, 246,  24, 133,  48,  91, 154,
   54, 155,  42, 159, 295,  62, 231, 245,  28, 285, 223, 152, 168,   2, 150,  65, 264,  97, 121,
  114, 140,  65, 279, 130,  32, 287, 286, 229, 300,  98, 256, 104, 156, 158,  90
,},
{  55, 103, 134, 301, 112, 185,  86,  34, 133, 114,  39, 195, 216, 256,  20, 105,  76, 108, 115,
   11,  27, 147, 201,  57, 101, 170, 222,   3, 151, 238,  56,  90,  60,  74, 206,  78,  62, 235,
  110, 183,  80,  89, 252, 135,  86, 283, 224, 155, 166,  33, 254,  45, 155, 228, 167, 220,  38,
  158, 134, 174,  70, 249,  25, 162, 118,  63, 115, 150,  41, 134,  18, 254, 178, 238, 233, 146,
  193,  81, 246,  59,  73,  26, 273,  62, 268, 195, 150, 273, 157, 168, 234, 298
,},
{ 148, 179, 221, 132, 143,  37, 243, 148,  47,  92,  66, 182,  90,  66, 225, 284, 273, 226,  37,
  240,  19,   6,  73,  90, 201, 306, 173, 260, 249, 296,  26, 223, 296,  64,  26, 176,  58,  45,
   27, 167, 197, 248, 190,   4,  45, 302, 161, 161,  61, 237, 202, 248, 269, 196, 286,  27, 256,
   99, 150,  40, 294,  61, 276,  15, 204, 259,  85, 282, 291, 227, 149, 177,  67, 130, 149, 136,
   16, 227,   9,   1, 141,  22,  94, 142, 248, 210, 210, 286,  68, 212, 283, 220
,},
{ 305, 221, 194, 304, 242,  32,  86, 126,  69,  60, 242, 118,  88, 175, 278,  14,  66, 188, 256,
  222, 215, 123,   7, 228, 254, 136,  28, 131, 182, 218, 191,   3, 270, 130, 214,  43,  85, 303,
   81, 271, 200, 286, 201,  44,  55, 291, 146, 166,  71,  31, 131, 144, 162, 256, 245, 263,  68,
   27, 124,  60, 279, 207,  15,  77, 114,  32, 267,  62, 110, 247,  65, 151, 109, 217, 293,  30,
    5, 140, 145, 199, 282, 262, 270, 158,  98, 199,  48,  92,  44,  88, 198, 250
,},
{ 221,  67, 252,  79, 122,  74, 297, 274, 106,  14,  63,  22,  67,  59,  81, 108, 157,  95, 250,
  229,  68,  82, 166, 225, 219, 222, 155,  64, 154,  77,   1, 123, 182, 193, 133,  24, 121, 182,
    9, 135, 155,  36, 107,  63,  88, 195,  30,  54, 287,   9,  78,  93, 130, 217, 214, 177, 184,
   45, 181, 245, 206, 222,  71,  54,  36,  86,  69, 199,  34,  60,  35, 151, 297, 112, 165,  88,
  230, 118, 298,  26,   2, 266, 181, 259, 108, 140, 294, 193, 124, 290, 100,   7
,},
{ 226, 261, 214,  83, 236,  78,  63,  10, 298, 172, 256,  20, 206, 286,  49, 285, 182, 245,  82,
  221, 291, 289, 276, 150, 113, 196,  15, 296, 282, 280, 276, 144,  31, 213, 128,  54, 176,  66,
  105,  67,  90, 229, 128,  27, 133, 227,  17,  79,  93, 300,  14, 185, 294,  64, 206,  50, 149,
  273, 290, 220, 254, 213, 201, 147, 226, 131, 103, 212, 294,  94, 253, 116, 160, 232, 113, 104,
  155,  33, 174,  11, 201, 144, 179,  10,  12, 119,  26, 120, 216,  13,  30, 145
,},
{ 208,   2, 236, 178,   2, 114, 201, 258, 244, 174, 229,  67, 279, 269,  35, 196, 239, 119, 195,
  183,  58, 220, 185, 120, 286, 119, 250,  85, 119, 129, 148, 212, 168, 103, 270, 202,   1, 177,
    6, 210,  12,  44, 205, 269, 249,  30, 180, 111, 229, 143, 272, 213, 226, 111, 187, 142,  84,
   19, 129, 133, 231,  92,  85,  21, 289,   1, 220,  39, 294, 265,  57,  45, 127, 217, 165, 209,
  220, 153, 272,  62, 259, 204, 140, 277, 288, 196,  82,  18, 114, 285, 241,  85
,},
{  69, 299, 252, 289,  67, 301, 112,  93,  67, 256, 218, 277, 240, 263,  16, 100,  42, 255,   5,
  106, 278, 154,  32, 210, 295, 226, 193, 164,  13, 114, 221, 174, 279,  62, 147, 144, 118, 298,
  163, 184, 146, 165, 284,  23, 198,  51, 193, 161, 146,  36, 116, 124, 110, 214, 109, 213, 109,
  156, 231, 164,  23,   9, 144,  43, 136,  83,  32, 246, 140, 277,  21, 295, 242, 171, 273, 126,
  277, 240, 219, 164,  38, 229, 244,  81, 260, 290, 259, 162,  78,  38, 154, 305
,},
{  67, 233, 257,  81, 288, 255,  41, 194, 130,  92, 143,  11,  49,   2, 222, 177,  35, 280, 171,
  101, 176, 171, 274, 212, 242, 170,  22,  65,  14, 284, 101, 224, 288,   7, 256,  38, 276,  46,
   13, 278, 153,  81,  51, 263,   3, 246,  58, 179, 106, 230, 210, 217, 242,  85, 261, 112, 221,
  259,  86, 176, 293,  21,  15, 210, 257,  65, 122,  35, 175,  79, 178, 261, 117, 129,  83, 115,
   63, 114, 224, 301, 114, 129, 210, 249,  20, 213, 191, 221, 287,  22, 200, 185
,},
{  96, 247, 127, 264,  20,  90,  52, 131, 302, 120, 260, 103, 225, 267, 264, 219, 203, 124,  68,
  194,  73,  96, 123, 202,  15, 292,   6, 196, 125, 274, 105, 284, 117, 274, 175,  54, 108, 182,
  160, 274, 229, 179, 188, 305, 271, 168,  59, 125, 201,  11,  99, 231,  47, 252, 189, 137, 293,
  161, 287, 108,  63, 171,  80,  50,  63, 224, 295, 305,   2, 138, 180,  82, 148, 285, 287, 269,
  263, 251,  59,   7,  14, 139, 198, 208, 212, 223,   7,  22, 171, 248,  80, 249
,},
{ 101, 247, 257,  80, 235, 253, 225, 281, 283, 106, 220,  90, 245,  77, 306,  21, 176,  44, 144,
   89,  75,  40, 199, 124, 209,  74, 209, 285, 144,   2, 204, 192, 213, 211,  67,  84, 198, 169,
  206, 118, 296, 186, 250, 193,  32, 128,  64, 267,  65, 181, 145, 265, 276, 243,  80, 276,  62,
   38, 280, 227, 165,   5,  38, 152, 116, 153, 127,  75,  88,  75,  30,  79, 139, 248, 189,   3,
  284, 141,  94, 288,  92, 197, 202,  36, 281,  77, 115, 133, 270,  82,  34,  58
,},
{ 206, 257, 237, 304, 109,   2, 118, 303, 129, 172,   6,  83, 255,  86,  38, 242,  64,  28,  24,
  123, 208, 108, 244, 198, 117, 150, 157, 237,  30, 267,  72, 117, 263, 119, 111, 158, 247, 137,
  145, 248,  96,  32, 115, 245, 159, 175, 232, 163,  20,  85,  47, 286, 220,  80, 108, 300,  44,
   10, 226,  33, 170, 223, 138, 273,  86,  26, 250,  40, 292,  15, 183, 131,  22,  39,  37, 166,
  295,  99, 298, 172, 203, 216, 134,  57, 270, 109, 185, 296, 192,  52, 296,  56
,},
{ 273, 219, 205, 113,  25,  64, 221, 278, 188,  43, 266, 276,  20, 165,   6, 135, 220, 154, 231,
   99,   5, 134, 125, 116, 223, 240,  29,  57, 139, 117,  17, 295, 302, 204, 213,  93, 146, 114,
  135, 302, 195,  74, 154,  89, 191,  43, 286,  10, 168, 124, 125, 289,  52, 306, 299,  24,  76,
  142, 128, 231, 105, 226,  55, 132, 114, 232, 162, 166, 186, 158,  24, 217, 203, 116,  47, 163,
   88, 254, 240, 151,  37, 111, 134, 301, 230,  51, 118,  21, 173, 225, 121,  42
,},
{ 128, 206, 180, 112, 134,  68, 305,  34, 115, 277, 267,   8, 152, 106, 105,   2, 272, 134,  76,
   57, 164, 103,  70,  29,  58,  85, 226, 261, 137, 281,  83, 261,  50, 181, 121,  46,  84, 123,
  266, 176,  32,  25,  12, 288, 202, 104, 203, 273, 244, 246, 154, 153, 267, 270, 240, 236, 163,
  303,  77,  55, 285, 147, 100, 204, 243,  70,  27,  99, 122, 239,  88, 203, 271, 120, 122, 295,
  258, 134, 283,  53, 280, 275, 203,  29,  47, 296, 288, 302, 159, 121, 200,  84
,},
{ 256, 301, 128, 301, 154, 220, 243, 238,  15, 293, 111,  58,  67,  17, 293,  97, 276, 100, 285,
   35, 187,  53, 282, 185, 220,  89,  57,  76, 114, 114, 213, 264,  78, 115,  15,  94,  28,  38,
  120,  41, 250, 306, 208, 280, 207,  28, 117, 177, 127,  93, 306, 210, 109,  89, 138, 114, 207,
    3, 173, 238, 163,  62, 202,  91, 119, 155, 274, 208,  11, 228,  99, 139,   4, 105, 132,   4,
  178,  43, 192, 216,   4, 142, 152, 300, 135, 179, 156,  42, 271,  55,  71, 126
,},
{  77,  55, 184, 156,  57, 283,  22, 296,  56, 282,  44, 258, 300,  18, 144, 281, 201,  18, 173,
   70, 230, 174, 168, 301,  11, 113,  47, 139,   9, 233,  12,  24, 143,  22, 173, 128,  67, 266,
  187, 243, 152,  47, 120, 303,   5, 253, 201,  78, 265,  54, 183,  83, 144, 149, 198, 256, 224,
  274, 115, 261,  93, 289, 298,  35, 117, 294, 154,  85,  76, 170,  18,  22, 301,  62, 123, 262,
  289,   9, 130, 245, 296, 104, 111, 144, 152,  26, 276,  94, 149, 115, 287, 267
,},
{ 112, 287, 136, 141, 136, 133, 302, 127, 115, 249, 171, 202, 303, 145, 119, 294, 209,  49, 180,
  251, 242, 239, 118,  84,  20, 274,  24, 250, 209, 210, 280,  72, 155, 229, 218, 142,   5, 162,
   92,  31, 237,  80, 223,   7, 210,  44,  86, 228, 206, 103, 157,  54, 294, 258, 168, 258, 109,
  154, 102, 243,  78,  53, 102,  83,  17, 232, 153, 214, 200,  84,  32, 213, 146, 190, 144,  33,
  230,  99, 303, 235, 166, 274,  31, 211, 152, 133, 195, 130, 138, 257, 285, 293
,},
{ 162,  32, 300, 167, 134, 224, 155, 262,  79, 290,  72, 257, 141, 172, 165,  18, 146,  33,  75,
  238, 127, 107, 158, 150,   1,  66,  74,  49, 121, 264, 119, 301, 256,  93,  52,  69, 145, 115,
    9, 283, 121,  89, 203,  76, 174, 239,  93, 295, 150, 180,  93, 250, 266, 119, 280, 189,   7,
  238, 278,  24, 225,  64,  95, 257,  46, 134, 198, 174,  24,  80,   5, 177, 195, 276, 188, 266,
  206,  10, 294, 263, 192, 189, 141,  66,  91, 130,  54, 236,  84,  53, 163, 195
,},
{  68, 136, 136, 241, 111, 224,  93, 142, 185, 251, 102, 146,  76,  14,  25, 278,  62, 273, 241,
  232, 167, 275,  73, 107, 100,  62,   1, 274, 245, 254, 150, 287, 238,  67, 212,  88,  93, 104,
  119,   2,  82, 165, 152, 255, 184,  99,  17, 230, 285, 249, 100, 223, 104,  94, 295, 141,  23,
  118,   2, 268, 187, 113,  93, 107, 268,  61, 169,  59, 189, 292,  62, 244,  33,   7, 260, 243,
  115, 288,  35, 281, 226,  69,  46, 114,  27, 222, 112,  75, 175,  18, 222,  57
,},
{  86, 306, 105, 251, 116, 279, 266, 212, 162, 240, 248,  15, 197, 105, 108, 195, 135,  33, 211,
  268,  79, 300, 232, 162, 116, 132,  43, 272, 251,  43, 164, 218, 108,   8,  64,  95,  10, 303,
   91,  65, 118, 246,  37, 290, 211,  44,  53, 109, 109,  40, 202, 138, 237,  49, 136,  56, 220,
   46, 271, 188, 122, 244, 249,  54, 148, 296,  24, 237,  87, 239, 197, 283,  98,  30,  59, 158,
   43,   2, 130, 154, 171, 242, 150,  57, 164, 292, 127, 274,  43, 236,   6, 106
,},
{ 133, 297,  76, 265, 304, 283, 244, 218,  93,  65,  89, 167, 126, 224, 129, 171, 263, 108, 187,
   35, 242, 224,  80, 209,   1, 294, 199,  73, 240,  10, 118,   5,   9,  95, 164,   8, 160, 142,
   58, 136, 173, 186, 148, 229, 122, 123, 287, 181, 261, 262,  28,  68,  24,  27,  14, 284, 246,
  252,  72, 116, 105, 228, 233, 128,  71, 227,  71, 172,   9, 250, 267,  64, 200, 254,  89, 144,
  120,  86, 236,  82,  41, 260,  21, 192, 220, 199,  13, 299,  96, 248, 246, 205
,},
{  40, 208, 304, 258, 214,  68, 224, 128, 263, 140, 135, 277, 205, 268, 282,  51, 233, 121, 122,
  171, 228,   4, 204,  50, 306,  73,  21, 118,  98, 246, 268, 271, 293, 259, 165, 131, 293, 172,
   36,  90,  90, 235, 205, 305, 130, 114, 173, 187, 139, 247, 233, 267, 253, 284, 275, 167,  78,
  221,  59,  30, 248,   3, 227, 222, 297, 134,  67, 224, 235, 275, 113, 227, 196, 270,  64,  13,
    1,  96, 191, 120, 295,  77, 212, 276, 151, 279,  62, 224, 227,   3, 221, 292
,},
{  42,  42, 200,  96,  97,  89, 267, 225, 252, 297,  60, 271, 102, 262, 114, 108,  24, 176, 105,
  228,  82, 193, 290,  19, 290, 136,  78, 289, 221, 135, 302, 137, 205,  95, 179, 115, 200,  60,
   30, 131,  11,  63, 301, 201, 155, 183,  13,  68, 235, 155,  17, 223, 231, 219, 176, 144, 227,
  282,   3, 107, 230, 233,  48, 108, 292, 225, 273, 243, 152, 238, 300,  71, 120, 116, 224, 107,
    1, 160, 283, 192,  52, 210,  88,  96, 279, 259, 304,  84,  87, 114, 297, 300
,},
{  81,   2, 202,  62, 246, 141, 100, 247, 201, 186,  55, 103,  87, 190, 272, 217,  34, 243, 189,
  134, 166, 168, 306, 306, 131,   6,  36, 244,  71,  95, 243, 159, 229, 174, 160, 258, 270, 255,
  137, 279, 176, 244, 278,  74, 131,  16,  54, 271,  29, 222, 150, 217,  22, 297, 230,  33, 172,
  138,  37, 271,  98, 223, 254, 279, 243, 197, 208, 130, 148,  92,  45, 219,  62, 185, 115, 285,
   40, 198, 104, 263,  17, 217, 297, 259,  36, 268,  66, 171,  61, 198,  67, 252
,},
{ 154, 293,  75, 258, 188, 197,  52, 206, 190, 121, 302,  42, 280, 296, 137, 248, 118, 132,  82,
   66, 217, 140,  91,  37, 265, 224, 229, 200, 110,   2, 198, 172, 224, 117, 290,  79, 204, 132,
  246,  76, 194,  77, 179, 161, 138, 223,  55, 283, 140, 190,  95,  11,  85, 102, 208, 159, 253,
  306,  55, 213, 288,  43,  81, 227,  24, 286, 195, 137, 173, 159, 286, 198, 236, 178, 221,  68,
  241,   9,  65, 210, 116, 217, 155, 281, 270, 125, 155, 249,  78,  56,  48, 152
,},
{ 127, 277, 108, 177,  27,  22,   2, 267, 157, 132, 113,  70, 178, 255,  35, 181, 276, 143,  69,
  154, 272,  60, 230, 226,  61, 248,  71, 133, 241,  83,  69, 277, 104,  20, 109, 285, 178, 150,
  302, 102, 283, 222, 145, 240, 146, 174, 305, 198, 165, 203, 167,  94, 253, 143, 214, 287, 165,
  212, 100, 244, 233, 133, 201, 284, 234, 201,  85, 274,   7, 204,   8, 159, 218, 228, 112, 256,
  251,  42, 304, 280,  19, 261, 126,  82,   5, 158, 281, 280, 266,  36,  24, 148
,},
{ 261, 271,   8, 175, 251, 237, 228,  74, 292, 149, 205,  81,  57, 291, 219,  94,  79, 163, 219,
   26, 193, 208,  83, 111,   7, 101, 301,  26, 181, 142, 124, 154, 130, 277,  93, 193,  34, 287,
   57,  81, 247, 181,  62, 164, 185, 278, 270, 113, 277,  89, 221,  61, 265, 261,  42, 299,   2,
  117, 173, 179, 215,  74, 303, 229, 105, 269,  78, 170,   2, 223, 162,  54, 130, 291, 293, 138,
    6,  33, 305,  69, 296,  39, 132,  63, 298, 106, 116,  23, 240, 112,  21, 186
,},
{ 216,  52, 186, 254, 268, 266, 164, 277,  10, 116, 220, 115, 102,  87, 113, 289, 306,  49, 300,
  194, 270,  13, 100, 228, 205, 273,  39, 232, 161, 152, 123, 152, 297, 252,  41,  99, 197, 283,
   83, 107, 201, 152,  38, 173, 182,  19, 241,  37,   9, 140, 178,  38, 139, 134, 188,  70, 169,
  174, 180,  69, 155,  94, 130, 305, 282, 261,  19, 106,  19, 149, 220, 253,  30, 201, 186, 251,
  164, 122, 293,  47, 114, 122, 271, 281, 210,  64, 103, 273,  64, 229,  89, 208
,},
{  93,  45, 122, 164,  51,  57, 290, 232, 113, 173, 202, 258, 188, 294,  53, 254, 295, 114, 189,
  140, 282,  39, 120, 107, 277,   4, 306, 150, 175, 221, 276, 118, 269,  34,  31,  18, 186,  10,
  144,  96, 261, 207,  35,  73, 104, 102, 212, 162, 231, 176, 157, 112,  46, 283, 158, 183, 159,
  226,  86,  67, 161,  56,  84,  20, 153, 298, 196,  14, 122, 223,   7, 127,  38, 116, 143,  40,
   49, 231, 251,  54,  28, 167, 256,  58, 178, 186, 229,  64, 167,  55, 266, 242
,},
{ 182, 204, 215, 244, 285,  21, 203, 192,  53, 158,  31,  75, 216, 128,  36, 220, 137,  48, 147,
  239, 266,  28, 255, 137, 226,  52, 128, 137, 187, 233, 259, 220, 139,  25, 199,  19,  10, 302,
  111,  44, 163, 144, 186, 120,  37, 129, 176,  64,  63, 198, 305, 216, 263,   1, 122, 102, 136,
  122, 100, 294, 115,  96, 251,  80, 221, 148, 184, 140,   9, 135, 229, 132, 175, 203,  19, 227,
  295, 124,  18, 153, 271,  69,  10, 265,  71,  32, 192, 222, 289, 189, 101, 199
,},
{ 241, 135,  85, 191, 190, 306, 103,  26,  41, 175, 196, 212,  43, 258,  63, 134,  87,  95, 117,
  112,  28,  14,  61, 151,  23, 230,  88, 277,  19,  85, 145, 114, 236, 187,  63, 146,  86, 113,
  262, 181, 212,  30, 128, 280, 268, 173, 200,  34, 164, 301,  77, 233, 141, 141,  83, 284, 227,
  254,  26, 200, 199,   7, 113, 131, 277,  71, 105,  39, 297,  92,   8, 295,  37, 213,  56,  83,
  202,  89, 181, 148, 216, 273, 271, 280,  41, 296, 212, 289, 218,  28,  34, 240
,},
{ 249, 209, 263,  36,   4,  41, 192,  87, 191, 111, 227, 169, 249,  52, 266,  84, 259,  78,  44,
  263,   1, 281,  43, 258, 302, 287, 150,  98, 164,  41, 110,  92, 249,  27, 239, 249, 270, 130,
  236, 277, 217,  30, 202, 192, 224,  34, 254,  38, 187, 215, 297, 237, 195,  71,  27,  30, 245,
   33,  58, 179,  70, 132, 208, 175, 239, 201, 303,  52, 270, 249, 306,  66, 165,  89,  28, 289,
  275, 114, 167, 165,   8,  41,  97, 285, 232, 155, 203, 167,  25, 184, 236, 305
,},
{  67, 106, 167,  92,  35, 192,  88, 274, 124, 216, 305,  20, 248,  11,  11, 120,  19, 190, 301,
  140,  26, 201,  94, 223, 290, 177,  83,  22, 255, 128,  28, 113, 206, 284, 221, 130,  74, 198,
  152,  44, 246, 152, 223, 181, 172, 272,  41, 240, 290, 271,  82,  91,  48, 170, 118,  30,  38,
   88, 270,   3,   1,  68, 138, 274,  82, 168, 240, 306, 288, 209, 150, 239, 195,  52,   1, 177,
  226, 112,  98, 249, 115,  99,  22, 102, 224, 185,  56, 165, 292, 276,  39, 267
,},
{ 112, 277, 187, 124,  72, 111, 211, 193,  93,  10, 105, 156,  65,  93, 112, 161,  48, 174,  45,
   72,   5,  35, 145,  10, 249, 246,  88, 286,  92, 149, 175,  88, 244, 292, 173, 190,   7, 169,
   24, 303,  38, 174,  21, 110,  88, 211, 105,  68,  61, 128,  67, 260, 302, 162, 189, 178, 190,
  275, 223,  91, 127, 268, 188, 230, 256, 197,  27, 300, 114, 296,  71,  38,  56,  84, 134, 218,
  145,  36,  99, 203, 170,  93,  26, 122, 110, 205,  47, 217, 209,  93, 139,  45
,},
{ 181, 106, 301, 197, 300, 140, 128, 208, 128, 298, 250,   4,  67, 201, 248,  20, 242, 219, 222,
   34,  32, 110,  98,  86, 211, 145, 231, 205, 284, 288, 288, 261, 286, 224, 225,  16, 290,  92,
  288,  46, 233, 119, 283,  33, 253, 236, 207, 113, 231,  13, 204,  97,  61,  97, 179, 275, 305,
  192,   8,  79, 105, 172, 133, 238,  20, 165,  87, 113, 209, 105, 221, 197,  52, 296, 222,   5,
  254, 282,  89,  96, 100, 118,  60,  67, 113,  93, 130, 288,  14, 241, 132, 209
,},
{ 213, 235, 197, 211, 148, 302, 294, 155, 179, 125, 287, 238, 191,  71,  34, 155, 212, 238,  94,
   14,  87,   8, 157,  15, 119, 226, 280,  99, 223,  55, 265, 128,  14, 159, 213, 103,  37, 139,
  249,  90,  62, 118,  59, 175, 281, 149, 272, 135, 181,  49, 250, 241,  46,  64, 251,  19,  53,
  287, 139,  76, 260,   7, 159, 297, 286, 225, 234, 234,  11, 290, 166,   8,  71,  41, 282, 155,
  295, 249, 112, 116, 102, 261, 108, 305, 148, 266, 154, 110, 273,  33, 197, 116
,},
{ 105, 218, 215, 291, 269, 296,  32, 143, 158, 264, 232,  13, 261, 180, 300, 213, 241, 223, 198,
   52, 252, 153, 109, 155,   1,   1,  85,  29, 203, 162, 195,  91, 270, 133, 266,  88, 122, 222,
   91,  26,  46, 148, 283,  49, 107, 260,  50, 163, 255, 221,  88, 225, 151, 268, 101,  77, 169,
  256,  49, 259, 269,  69, 273,  15, 165, 106, 112,  60,  54, 172, 199,  61, 201, 178, 233, 236,
  125, 232, 256, 268, 253,  43, 135, 125, 159, 111, 175, 209, 228, 144, 154, 241
,},
{  62, 298,  60,  98, 258,  26,   5, 282, 136,  62, 219, 155, 164,  82,  55,  87, 217, 113, 214,
  296, 213,  98, 122, 216, 290, 174,  23, 159, 298, 243,  40, 294, 169, 197,  88,  46, 146, 202,
   27, 202, 231,  50,  70, 204,   3, 156, 184, 202, 190, 264, 130,  44, 128, 247, 284, 200,  34,
  207,  95,  76, 218, 203, 267, 302,  16, 278, 165, 211, 173, 190, 282, 137,  20, 156,  37, 238,
  306, 272,  11, 199, 153, 186,  30, 300, 261, 143, 221, 149,  36, 222, 271, 256
,},
{  20, 253, 148, 151, 226, 140, 150, 254, 151,   6,  97,   6, 174, 235, 111,  16, 118, 146, 120,
  206, 239,  94,  88, 107, 111,  19, 191, 136,  18, 301,  65, 270, 131, 294, 232, 225,  35, 152,
  149,  43, 179, 262, 213, 302,   1, 306, 181, 134, 181, 183,  96,  96, 290, 258,  64, 207,  97,
  175, 264,  74, 142, 167,  49, 108, 233, 201, 198,  88,  89, 306, 275, 262, 203,  55,  61, 306,
   13, 294, 171, 260, 152, 171, 162,   4, 126, 137, 228, 173, 113, 143,  55, 294
,},
{ 282, 165, 287, 111, 298, 220, 292,  69,  34, 160,  39, 133,  59, 162, 122,  83,  54, 130, 214,
  130,  47,   4, 260,  30,   8,  66, 228, 280,  82,  91,  63, 238,  90, 205,  20, 291, 162, 181,
  295, 129, 302, 217, 135, 230, 172,   6, 198,  90, 237, 113,  86, 292, 249, 281, 103, 237, 259,
  151,  27,  60, 145, 129, 206, 171, 271, 232, 301,  64,  87, 153, 123, 300,  26, 236,  97, 262,
   50,  28, 190,  90, 242, 283, 201,  41,  68, 281, 261, 288, 218,  56, 275, 103
,},
{  80, 125, 179,  37,   9, 133, 102,  60, 159, 128, 300, 108, 209,  36, 278, 273, 207,  77, 158,
  182, 209, 185, 271, 200, 224, 152, 134,  66,  23,  94, 300,  62, 200, 283,  38, 261, 247, 186,
  276,  52,  37, 119, 255, 142,  32, 156, 106, 305,   6, 209,  55, 257,  48, 155, 163, 102, 132,
  209,  72, 250,  17, 248, 127, 184, 202,  90, 219, 300, 190,   5, 186,  43, 257, 166, 163, 252,
  283,   2, 238, 265, 209,   7, 187,  97, 266, 186,   7,  69, 144,  32,   2,  60
,},
{ 139,  72, 157,  90,  67, 202, 258,  98, 178,  23, 141,  63, 194, 288,  38,  53,  74, 128, 141,
   41, 231,  42, 269,  90, 161, 290, 132, 290, 268, 182, 177, 210,  19,  71, 296, 238, 292, 258,
  140, 203,  61, 145, 162, 271, 128, 127, 253, 219, 113, 249, 208,  95,  94, 184, 280,  73, 169,
  237, 160, 187,  64,  77,  68, 296, 211, 183, 148, 129, 281, 178, 212,  47, 164, 270,  43, 298,
  300, 261, 175, 234, 230, 242, 270,  37,  85, 141,  86, 226,   3, 289,  84, 300
,},
{  81,  99, 232,  19, 240, 111, 213, 238,  74, 112,  88, 184, 186, 282, 298, 141, 286, 293, 141,
  170, 286,  10, 155, 285, 202, 184, 190, 298,  72, 142, 290,  34, 302, 295, 136,  68,  86,  40,
   28,  82, 248, 294,  53, 242, 201, 296, 305, 204, 180, 100, 244, 101, 201, 160, 195, 137, 101,
   80, 299, 121, 178,  57,  98, 299, 124, 116, 166,   5,  34, 221, 292, 131,  38, 229, 269, 104,
  231, 190, 205, 155,  59,  88,  22, 134, 284,  74, 255, 260, 203, 114, 242,  39
,},
{  75, 260, 304,  36, 192, 258, 269, 149, 284,  47,  13, 287,  25, 222,   7,  75,  27, 250,  89,
  111,  33,  70, 126,  22, 275,  30, 171, 230, 153, 160, 242,  78, 267,  80, 196, 266, 257, 262,
  225,  88, 226, 134,  61,   2,  18, 186,   6, 271, 202,  77,  84, 270, 256, 228,  11, 290, 288,
  246, 217, 297, 215, 217, 247,  39, 117, 127, 123, 261,   8, 149, 156, 217, 225, 246, 103, 280,
  258, 186, 195, 141, 209, 280, 305,  78, 249, 126,   9,  75, 125,  67,  25,  98
,},
{  94,  21, 169,  87,  85, 190, 104, 242, 178, 287,  58,  25, 100,  21,  82, 100, 190,  31,  68,
  297,  58,  57,  23, 209, 296, 260, 202, 303, 212,  75, 183,  95,  18,  87,  91,  11, 245, 101,
  105, 116,  72,  34, 194, 169,  61, 122, 150,  78, 203,  77, 147,  47,  14, 253,  74, 171, 205,
  306, 299, 149, 116,   6, 230,  83, 298, 219,  58, 283,  56, 234,  88,  62,  36, 236, 260, 170,
  297, 263,  49, 168, 135,  48, 290,  60, 304,  96,  65,  29,  90, 106, 111,  41
,},
{   8, 109, 268, 144, 261, 222, 301, 265, 251, 126, 301, 157,  94,  67,  94,   5,  51, 223, 218,
  249,  90, 256,  53,  17, 167, 249, 144,  63,   1,  29, 188, 275, 214,  68, 101,  23,  68, 186,
  264,  50, 291,  23, 222, 164, 272, 305, 132, 130, 131,  16, 194,  72,  84,  66,  57, 166,   7,
  200, 206,  45, 114, 157, 190, 105, 301,  65, 187, 150,  50, 232, 268,  80,  27,  50, 198, 122,
   80, 108, 284, 210, 272, 265, 284,  34, 236, 193, 130, 230,  76,  10, 162, 243
,},
{ 302,  37, 300,  15, 112, 137, 191, 162, 221, 130, 194, 124, 229, 153, 290,  27,  74, 299, 298,
  220,  33,  43, 105, 287, 120, 158, 168,  39, 175,  77, 227, 284, 239, 106, 136, 297, 256, 220,
  276, 260, 286,  53,  59, 164, 138, 273, 222, 298, 212,  56,  58,  49, 164, 205,  35, 153, 115,
  202, 109, 288, 182,  50,  42, 153, 199, 178,  85, 283,  27, 247, 134, 273, 217,  95, 304,  54,
  255,  83, 210, 145, 145, 114, 271, 137, 231, 267,  95, 142, 239, 126, 282, 233
,},
{  23, 230,  18, 113, 285,   7,  34, 155, 303, 225, 247, 210, 284,  19, 171, 107,  78, 284, 261,
  166,  47,  65, 185,  11, 243, 100, 285,  37,  15,  71, 210,  31, 204, 306, 223,  94, 269,  48,
  113, 233,  34,  30, 133, 203,  38,  72, 225,  11, 105, 250,  47, 111, 117, 160, 102, 146, 142,
  139,  68, 223, 149, 108, 272,  28,  89,  28,  86, 196, 112, 226, 268, 111, 134,  27, 216, 291,
  179,  57, 105, 174, 137, 135,  25, 149,  29,  27, 288, 224, 162,   9, 287, 201
,},
{ 174, 119, 153, 165,  60, 118,  42,  82, 274,  93,  69,  21,  99, 257, 302, 108,  39, 105, 130,
  130, 192, 209, 285, 208, 172,  65,  33, 255,  69, 256, 303,  62, 240, 217, 150, 279,  29, 137,
  293,  68, 125, 273, 128, 248,  64, 126, 136,  97, 166, 259, 262, 181, 225,  20, 195, 261, 263,
  110, 113, 223, 306,  43, 119,  86,  11,  10, 253, 245, 117, 256, 198,  94, 194, 285, 275, 131,
   22, 136, 130, 153, 287,  48,  49, 290, 293, 301, 306, 116,  95, 264, 306,  88
,},
{ 122,  19, 125,   2, 209,  77, 199, 118, 296,  95, 153, 274, 229, 133, 219, 279, 205,   5, 117,
  204, 120, 295, 148,  40,  28, 146, 138, 139, 101, 118, 214, 171, 265, 235, 277,  34, 304, 127,
   90, 145, 204, 222,  70, 131, 207, 101, 125, 138,  61, 154, 278, 116, 208,  97, 101,  63, 216,
  110, 120,  77,  73,  87,  86, 285, 187,  65, 136, 121, 299,  38,   7,  76, 251, 254, 166, 166,
  140, 133, 226, 206, 204, 274, 270, 136, 211, 212,  52, 136, 142, 103, 197, 170
,},
{ 138, 304, 212, 231,  87, 193,  73, 290,  43,  13, 183, 249,   6, 197, 241,  42, 278, 237,  84,
  246,  87,   5, 226, 198,  83, 215, 294, 273, 302,  91, 302, 266, 305,  53,  16,  25, 173, 284,
   99, 139,  17, 203,  88,  13, 296, 118, 120,  87, 208, 289, 100, 289, 217, 184,  93, 153, 304,
   53, 227, 190, 164, 243, 191,   2, 208,  82, 127, 188,  16, 265, 164, 176, 163,  32,  59,  88,
  302, 180, 265,  10, 158, 144,  47, 152, 102, 215,  31, 212, 256, 297, 148,  18
,},
{  11, 197,  68, 216, 240, 237,  77, 256, 264, 125, 109, 204, 152, 306, 259,  20,  13, 285,  72,
  141, 230, 129, 153, 141, 217, 287, 209, 218,  88,  12, 208, 275, 161, 297, 149,  76,  65, 207,
   86, 292, 111, 295,   1, 277, 193, 171,  55, 246, 275,  66, 258, 112, 148, 135,  68,  66,  81,
  182,  69, 108, 257, 182, 189, 211, 225, 233,  38, 100, 213, 258, 235, 153, 243, 259, 210, 253,
   41, 234,  17, 141, 153, 260,   8,   2,  87, 218, 185,  66,   8, 146,  67, 176
,},
{ 244,   8, 209,  73, 304, 274,  92, 229,  70, 213, 245, 212,   6, 220, 230, 213, 214, 252,   2,
  220, 121, 129,   7, 277,  88, 165, 126, 114, 217, 186, 235, 251,  67, 151, 110, 224, 126, 261,
  113,  97, 257, 305, 196,   7, 195, 267, 169,  59, 174, 251, 104, 273, 166, 199, 297, 111, 283,
   82, 202, 304, 115, 126, 268, 214, 106,  26, 178,  81, 208,  55,  67, 298, 160,  56,  21, 299,
  271, 263, 107, 169, 243, 127,  90, 182, 151, 232,  27, 152, 118,  24,  12, 102
,},
{ 267, 169,   1,  27, 124, 233,  26, 208, 184,  23, 143,  57, 174, 171, 162,   1, 151,  49, 238,
   18,  27,  52, 149,  37, 180,  16, 131, 207,  89, 211, 235,  82, 270, 124,  81, 143, 246, 114,
   60,  81, 143, 195, 286,  39, 106, 203, 217, 269, 101, 188, 280, 172,  88, 213, 258, 144,  10,
    1, 275, 244, 172, 217, 127, 279,  45,  43, 186,  25,  18, 249, 192, 107, 166,  90, 246,  97,
  135, 295, 158, 223, 263, 207, 175, 142, 223,  92,  62, 123, 224, 211,  51, 273
,},
{ 218, 292,  69, 164,  10, 250, 111, 192, 223, 302, 251,   1, 172, 119,  88, 136, 124, 206, 156,
   28, 287,  50, 250, 139, 274, 204, 232, 104, 113,  91, 297, 286, 178, 251,  45,  70, 238, 250,
  181, 173, 168, 266,  99, 236,   6,   1,  15, 286, 255, 301,  76, 155,  29, 277,  91,   2, 280,
  104,  39, 261, 288, 138,  12,  21, 233,  66,  92, 237,  46, 209, 101, 281, 151,  87, 129,  16,
  254, 127,  23,  17, 294, 275, 191, 260,  26,  38, 251,  30,  99, 193, 202, 271
,},
{ 285, 100, 150,  61, 146,  17, 175,  52, 244,  59, 110, 209, 195, 186, 302, 223, 194, 110, 229,
   42,  60, 203,  61, 113, 101, 173, 216,  77, 167,  79, 164,  44, 189, 194,  59, 232, 297, 170,
   32, 102, 229, 226,  56,  28, 183, 256, 127,  70, 217, 232,  56,  52, 130, 193, 202, 145, 146,
  217,  72, 277, 127, 252, 246, 279, 189, 183, 154, 146, 187, 176, 269, 123, 147, 266,  38,  48,
  110,  83, 146, 271,  38,  90, 240, 281,  83, 101,  98, 181, 131,  12,  39, 146
,},
{  21, 286,  96,  46, 134, 237, 270,  22, 114, 261,  19, 178, 275,  70, 109, 215,  56,  12, 102,
  282, 151, 196,  39, 122, 233,  16,  22,  43, 282,  32, 107, 252,  11,  90, 154,  34, 113,  27,
   99, 233, 216,  62, 259,  54, 260,  56,  52, 228,  94, 225, 117,  51,  34, 113, 139, 290, 175,
  248, 108,  96,  70, 273, 121,  33,   7, 153,  99, 242, 110,  35,  35, 248, 223, 107, 243, 213,
   42,  36,  23, 300, 237, 149, 249, 182, 129, 137, 267, 109, 266, 228, 159, 232
,},
{ 210,  31, 246, 284, 162, 123,   4, 275,  28, 284, 168,  85, 224, 253, 221, 160,  80,  78, 239,
   18, 144, 283,  91,  35,  94, 304,  41, 134, 251, 160,   5,  66, 229, 249, 304, 211,  72, 176,
  238, 267, 145,  81,  85, 239, 225, 218, 165, 141, 161, 174, 303,  67, 178, 171, 187,  98, 283,
  274,  79,  41, 175, 302, 191, 140,  76, 261, 234,  58, 189, 125, 160, 132,  20, 130, 184, 151,
  153, 223,  50,  28, 267, 119, 204, 283, 197,  55, 262,  70,  38,   8, 163, 247
,},
{ 168, 218, 306,  28, 254, 276, 305,   8, 157, 164, 271,  98, 306, 145, 251, 139,  52, 159,  14,
   49, 276,   4, 199, 272,  74,  28,  17, 192, 239,  92,  77,  95, 109,  51, 236, 104, 180,  61,
  222,   4, 258,  37,  38,  69, 253, 130, 121,  52,  26, 225, 175, 263, 230,  42,  46, 277,  31,
  178,  16, 271, 227, 115, 175,  22, 113,  95, 203,  17,  77, 201, 225, 299,  11,   7, 253,  49,
  103, 175,  50,  54,  63, 234, 163,  47, 295,  15, 155,  43, 136, 200, 263, 172
,},
{  71, 186, 146, 276, 114,  50, 225,   7, 203, 156,  58, 267,  58, 205, 294, 220, 203, 153,  15,
   47, 169, 268, 122,  69, 283,  79,  73, 280, 198, 265, 289, 126, 115, 169, 252,  93, 111, 232,
   11, 156, 214,  15,  17,   2, 254, 116, 142,  97, 177, 170, 304,  85, 246, 231, 298,  95, 203,
   25,  58, 141, 229,  92, 213,  25,  38,  79, 118, 252, 290, 104, 119, 154, 257, 212, 207,  26,
  248, 306,  16,  59,  56, 219,  26,  40,  74,  39, 240,  46,  38,  40,  83,  53
,},
{ 220,  23,  71, 226, 149,  44, 186, 201, 101,   1, 234, 171, 169, 225, 217, 172, 254,  36, 230,
  234,  34,  88, 158, 264, 142,  65, 266,  88, 264, 231, 149,  56, 175, 262, 247, 224, 279, 177,
  263, 187, 210, 248, 273, 113, 225, 210,  84, 206, 173, 100, 164, 237,  28, 141,  60,  65, 190,
  219,  38, 134, 253, 282, 240, 306, 187, 231, 120, 192, 138, 218, 118, 206, 266,  28,  88,  96,
    7, 116, 116, 299, 156, 254, 262,  47, 275, 245,  53,  19, 264, 294,  45,  29
,},
{ 103, 298,  18, 248,  87, 186, 130, 225, 125, 199, 258,  12, 100, 243,  52, 185,  40, 180,  26,
   66, 140, 204, 190,   4, 107, 266, 260, 280, 114, 172, 266, 259, 245, 128, 212, 139, 152,  95,
  165, 284, 176,  78,  59, 117,  96, 143, 262, 287, 236, 183,  33,  81,  61, 237, 227, 170, 256,
  164,   6,  68, 259, 282, 195, 204, 273, 142, 126, 230, 147, 255, 272,  15,  24, 216,  76, 230,
  242,  68,  41, 155, 103, 218,  69,  36, 164, 189, 299, 297, 202, 155,  94,  56
,},
{ 273, 116, 246, 201, 276,  42,  98, 290, 110,  39, 293, 221, 256,  10, 163, 149, 163, 130,  76,
  101, 255,  66, 221,  62,  29, 230, 145, 160, 182, 201, 229, 182, 137, 186, 222, 194, 127,  19,
   93,  15, 231, 154, 200,  33,  63, 287, 254,  40, 292,  33, 223, 275, 154, 147, 149, 143, 253,
   47, 282,  11, 140,   8, 114, 189,  45, 112, 278,  42,  69,  13, 264, 306,  87, 118, 224, 202,
  152, 201, 209, 201,  20,  11, 136, 236, 209, 252, 198, 135, 174, 235, 224, 147
,},
{ 141, 192, 133,  74, 121, 273, 118, 211, 180, 268, 209,   4,  94, 250, 107, 149, 168, 169, 164,
   81, 175, 291, 149, 192, 166, 160, 181,  36, 133,  65,  82, 162,  92, 174,  49,  98,   9, 200,
  244,  83, 298, 250, 244,  55, 275, 219, 233,  55, 245, 258, 138,  14, 198, 303, 223,  82, 169,
  280, 280, 180, 200, 287, 181, 175, 117, 198, 162, 211, 195, 101,  75, 123, 188, 257, 139, 171,
   74,   6, 149,  15, 192, 239,  26, 229, 268, 133,   7, 228,   4, 299, 301, 248
,},
{ 288,  67, 181, 154, 198, 141, 278,  81, 228, 150, 158,  89,  32, 134, 115,  98, 227, 128, 147,
  233, 304, 242, 147, 240, 215,   9, 282,  89, 216, 299, 142,  17, 148,  50,  64,  57,   1,  34,
  235, 106, 243,  69, 264,  85,  79, 156, 272, 127, 121, 267, 172, 201, 118, 228,   1, 158,  11,
  296,  57,  39, 148, 141, 157, 286,  41,  18, 274,  97, 112,  84,  97,  94,  91,  78, 117,  83,
    1,  24, 148, 112,  75, 267, 139,  20, 118, 263, 129, 114,  78, 194, 166, 141
,},
{  35,  85, 265, 110,  71, 145,  51,  23,  82, 154, 288, 169, 199, 233, 108, 277, 229,  26, 217,
  133, 210,  19,  71,  44, 133, 278, 269,  96, 226, 298, 141,  84, 269, 290, 188, 227, 268, 165,
   18, 263, 296,  67, 124,  56, 267,  72, 123,  31, 167,  32, 280, 266, 171, 192, 138, 250, 208,
  181,  12,  97,   1, 289,  25, 109, 242, 288, 185, 216,  37, 268, 156,  62,  56, 229, 142, 204,
   73, 287, 231, 200, 260, 260, 225, 247, 176, 208,  28,  45,  51,  35, 132, 283
,},
{ 190, 161, 195,  55,  98, 178,  95, 114, 160,  75,  26, 260, 196, 106,  48, 198, 111,  15, 246,
  141,  52, 154, 231,  82, 121, 168, 286, 268, 138, 101, 142, 177, 224,  75, 162, 108, 276,  18,
  122, 170, 198, 130, 234, 179, 123, 229, 156, 262, 292, 254, 278, 264, 147, 178, 142, 174,  39,
  166, 262, 273, 110, 284,  54, 203, 221,   4, 142, 221, 285, 226,   1, 273,  75, 235,  94,  88,
   62, 266,  95, 294, 214, 124,  32, 285, 129, 226, 248, 186,  10, 300, 137, 197
,},
}
};
